"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsSqlInit = void 0;
const sql = require("mssql");
const log4js = require("log4js");
const mssql_config_1 = require("../config/mssql.config");
const auth_mssql_1 = require("./mssql/auth.mssql");
const auditor_evaluation_plan_mssql_1 = require("./mssql/auditor-evaluation-plan.mssql");
const batch_mssql_1 = require("./mssql/batch.mssql");
const batch_error_mssql_1 = require("./mssql/batch-error.mssql");
const batch_schedule_mssql_1 = require("./mssql/batch-schedule.mssql");
const custom_field_mssql_1 = require("./mssql/custom-field.mssql");
const diarization_mssql_1 = require("./mssql/diarization.mssql");
const dictionary_mssql_1 = require("./mssql/dictionary.mssql");
const domain_mssql_1 = require("./mssql/domain.mssql");
const entity_mssql_1 = require("./mssql/entity.mssql");
const evaluation_tipification_mssql_1 = require("./mssql/evaluation-tipification.mssql");
const interaction_evaluation_plan_mssql_1 = require("./mssql/interaction-evaluation-plan.mssql");
const sentiment_mssql_1 = require("./mssql/sentiment.mssql");
const team_performance_mssql_1 = require("./mssql/team-performance.mssql");
const tipification_mssql_1 = require("./mssql/tipification.mssql");
const vcc_mssql_1 = require("./mssql/vcc.mssql");
const vcc_license_mssql_1 = require("./mssql/vcc-license.mssql");
const home_mssql_1 = require("./mssql/home.mssql");
const notification_mssql_1 = require("./mssql/notification.mssql");
const profile_image_mssql_1 = require("./mssql/profile-image.mssql");
const report_mssql_1 = require("./mssql/report.mssql");
const role_mssql_1 = require("./mssql/role.mssql");
const user_mssql_1 = require("./mssql/user.mssql");
const api_user_mssql_1 = require("./mssql/api-user.mssql");
const azure_subscription_mssql_1 = require("./mssql/azure-subscription.mssql");
const client_mssql_1 = require("./mssql/client.mssql");
const process_mssql_1 = require("./mssql/process.mssql");
const exception_mssql_1 = require("./mssql/exception.mssql");
const environment_mssql_1 = require("./mssql/environment.mssql");
const allegro_mssql_1 = require("./mssql/allegro.mssql");
const audio_mssql_1 = require("./mssql/audio.mssql");
const idatha_mssql_1 = require("./mssql/idatha.mssql");
const feeling_mssql_1 = require("./mssql/feeling.mssql");
const category_mssql_1 = require("./mssql/category.mssql");
const neuro_linguistic_programming_mssql_1 = require("./mssql/neuro-linguistic-programming.mssql");
const template_mssql_1 = require("./mssql/template.mssql");
const custom_template_mssql_1 = require("./mssql/custom-template.mssql");
const generic_template_mssql_1 = require("./mssql/generic-template.mssql");
const generic_query_mssql_1 = require("./mssql/generic-query.mssql");
const nlu_mssql_1 = require("./mssql/nlu.mssql");
const intent_mssql_1 = require("./mssql/intent.mssql");
const utterance_mssql_1 = require("./mssql/utterance.mssql");
const tag_mssql_1 = require("./mssql/tag.mssql");
const study_mssql_1 = require("./mssql/study.mssql");
const word_blacklist_mssql_1 = require("./mssql/word-blacklist.mssql");
const integration_mssql_1 = require("./mssql/integration.mssql");
const campaign_fulfillment_mssql_1 = require("./mssql/campaign-fulfillment.mssql");
const average_group_rating_mssql_1 = require("./mssql/average-group-rating.mssql");
const average_group_rating_norm_mssql_1 = require("./mssql/average-group-rating-norm.mssql");
const top_best_agents_mssql_1 = require("./mssql/top-best-agents.mssql");
const top_worst_agents_mssql_1 = require("./mssql/top-worst-agents.mssql");
const ability_mssql_1 = require("./mssql/ability.mssql");
const subgroup_mssql_1 = require("./mssql/subgroup.mssql");
const group_mssql_1 = require("./mssql/group.mssql");
const evaluation_format_mssql_1 = require("./mssql/evaluation-format.mssql");
const campain_mssql_1 = require("./mssql/campain.mssql");
const workgroup_mssql_1 = require("./mssql/workgroup.mssql");
const attentionlevel_mssql_1 = require("./mssql/attentionlevel.mssql");
const interaction_mssql_1 = require("./mssql/interaction.mssql");
const evaluation_plan_mssql_1 = require("./mssql/evaluation-plan.mssql");
const interaction_type_mssql_1 = require("./mssql/interaction-type.mssql");
const evaluation_mssql_1 = require("./mssql/evaluation.mssql");
const evaluation_review_mssql_1 = require("./mssql/evaluation-review.mssql");
const auditor_mssql_1 = require("./mssql/auditor.mssql");
const agent_mssql_1 = require("./mssql/agent.mssql");
const interactions_by_type_mssql_1 = require("./mssql/interactions-by-type.mssql");
const supervisor_mssql_1 = require("./mssql/supervisor.mssql");
const tenant_vcc_mssql_1 = require("./mssql/tenant-vcc.mssql");
const version_mssql_1 = require("./mssql/version.mssql");
const async_interaction_mssql_1 = require("./mssql/async-interaction.mssql");
const disposition_code_mssql_1 = require("./mssql/disposition-code.mssql");
const global_search_mssql_1 = require("./mssql/global-search.mssql");
const workgroupsupervisor_mssql_1 = require("./mssql/workgroupsupervisor.mssql");
let logger = log4js.getLogger('Sql');
function MsSqlInit(app, sqlOption) {
    return new Promise((resolve, reject) => {
        logger.info('Iniciando conexión a base de datos \'' + (sqlOption || mssql_config_1.MSSQL_CONFIG).server + '\'');
        console.log('Iniciando conexión a base de datos \'' + (sqlOption || mssql_config_1.MSSQL_CONFIG).server + '\'');
        let sqlConn = new sql.ConnectionPool((sqlOption ? sqlOption : mssql_config_1.MSSQL_CONFIG), function (err) {
            if (err) {
                let errMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
                logger.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                console.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                reject(err);
            }
            else {
                logger.info('Conexión a base de datos establecida');
                console.log('Conexión a base de datos establecida');
                resolve(true);
            }
        });
        app.set('sqlConn', sqlConn);
        auth_mssql_1.AuthMSSql(app);
        auditor_evaluation_plan_mssql_1.AuditorEvaluationPlanMSSql(app);
        batch_mssql_1.BatchMSSql(app);
        batch_error_mssql_1.BatchErrorMSSql(app);
        batch_schedule_mssql_1.BatchScheduleMSSql(app);
        custom_field_mssql_1.CustomFieldMSSql(app);
        diarization_mssql_1.DiarizationMSSql(app);
        dictionary_mssql_1.DictionaryMSSql(app);
        domain_mssql_1.DomainMSSql(app);
        entity_mssql_1.EntityMSSql(app);
        evaluation_tipification_mssql_1.EvaluationTipificationMSSql(app);
        interaction_evaluation_plan_mssql_1.InteractionEvaluationPlanMSSql(app);
        sentiment_mssql_1.SentimentMSSql(app);
        team_performance_mssql_1.TeamPerformanceMSSql(app);
        tipification_mssql_1.TipificationMSSql(app),
            vcc_mssql_1.VCCMSSql(app);
        vcc_license_mssql_1.VCCLicenseMSSql(app);
        home_mssql_1.HomeMSSql(app);
        notification_mssql_1.NotificationMSSql(app);
        profile_image_mssql_1.ProfileImageMSSql(app);
        report_mssql_1.ReportMSSql(app);
        role_mssql_1.RoleMSSql(app);
        user_mssql_1.UserMSSql(app);
        api_user_mssql_1.ApiUserMSSql(app);
        azure_subscription_mssql_1.AzureSubscriptionMSSql(app);
        client_mssql_1.ClientMSSql(app);
        process_mssql_1.ProcessMSSql(app);
        exception_mssql_1.ExceptionMSSql(app);
        environment_mssql_1.EnvironmentMSSql(app);
        allegro_mssql_1.AllegroMSSql(app);
        audio_mssql_1.AudiosMSSql(app);
        idatha_mssql_1.IdathaMSSql(app);
        feeling_mssql_1.FeelingMSSql(app);
        category_mssql_1.CategoryMSSql(app);
        neuro_linguistic_programming_mssql_1.NeuroLinguisticProgrammingMSSql(app);
        template_mssql_1.TemplateMSSql(app);
        custom_template_mssql_1.CustomTemplateMSSql(app);
        generic_template_mssql_1.GenericTemplateMSSql(app);
        generic_query_mssql_1.GenericQueryMSSql(app);
        nlu_mssql_1.NLUMSSql(app);
        intent_mssql_1.IntentMSSql(app);
        utterance_mssql_1.UtteranceMSSql(app);
        tag_mssql_1.TagMSSql(app);
        study_mssql_1.StudyMSSql(app);
        word_blacklist_mssql_1.WordBlacklistMSSql(app);
        integration_mssql_1.IntegrationMSSql(app);
        campaign_fulfillment_mssql_1.CampaignFulfillmentMssql(app);
        average_group_rating_mssql_1.AverageGroupRatingMssql(app);
        average_group_rating_norm_mssql_1.AverageGroupRatingNormMssql(app);
        top_best_agents_mssql_1.TopBestAgentsMssql(app);
        top_worst_agents_mssql_1.TopWorstAgentsMssql(app);
        interactions_by_type_mssql_1.InteractionsByTypeMSSql(app);
        ability_mssql_1.AbilityMSSql(app);
        subgroup_mssql_1.SubgroupMSSql(app);
        group_mssql_1.GroupMSSql(app);
        evaluation_format_mssql_1.EvaluationFormatMSSql(app);
        campain_mssql_1.CampainMSSql(app);
        disposition_code_mssql_1.DispositionCodeMSSql(app);
        workgroup_mssql_1.WorkGroupMSSql(app);
        attentionlevel_mssql_1.AttentionLevelMSSql(app);
        interaction_mssql_1.InteractionMSSql(app);
        evaluation_plan_mssql_1.EvaluationPlanMSSql(app);
        interaction_type_mssql_1.InteractionTypeMSSql(app);
        evaluation_mssql_1.EvaluationMSSql(app);
        evaluation_review_mssql_1.EvaluationReviewMSSql(app);
        auditor_mssql_1.AuditorMSSql(app);
        agent_mssql_1.AgentMSSql(app);
        version_mssql_1.VersionMSSql(app);
        api_user_mssql_1.ApiUserMSSql(app);
        supervisor_mssql_1.SupervisorMSSql(app);
        tenant_vcc_mssql_1.TenantVCCMSSql(app);
        async_interaction_mssql_1.AsyncInteractionMSSql(app);
        global_search_mssql_1.GlobalSearchMSSql(app);
        workgroupsupervisor_mssql_1.WorkGroupSupervisorMSSql(app);
    });
}
exports.MsSqlInit = MsSqlInit;
