"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetAbilitiesUsage = exports.DeleteAbilities = exports.DeleteScoreTipificationItem = exports.SaveScoreTipificationItem = exports.DeleteScoreTipificationQuery = exports.SaveScoreTipificationQuery = exports.DeleteScoreTipification = exports.SaveScoreTipification = exports.GetAbilityTitle = exports.GetScores = exports.SaveAbilityQueryEntity = exports.GetAbilityQueryEntities = exports.DeleteAbilityQueries = exports.SaveAbilityQuery = exports.GetAbilityQueries = exports.GetAbility = exports.DeleteAbility = exports.DeleteScore = exports.SaveScore = exports.SaveAbility = exports.GetAbilitys = exports.GetAbilityDetail = exports.AbilityMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
const score_model_1 = require("../../models/score.model");
const response_1 = require("../utils/response");
let logger = log4js.getLogger('Sql');
let sqlConn;
function AbilityMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AbilityMSSql = AbilityMSSql;
function GetAbilityDetail(vcc, id) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), id)
        .execute('GetAbilityDetail')
        .then((sqlResult) => {
        let rows = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(rows);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityDetail = GetAbilityDetail;
function GetAbilitys(vcc, search_criteria, search_expression, executionType = null, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('ExecutionType', sql.VarChar(50), executionType)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetAbilitys')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilitys = GetAbilitys;
function SaveAbility(vcc, id, title, detail, type, calificationType = null, executionType = null, binary, notApply, distribute, isCritical, acceptComments, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled, analysisType, language, isNegative = false, degradeScoreCard) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('Title', sql.VarChar(100), title)
        .input('Detail', sql.VarChar(500), detail)
        .input('Type', sql.VarChar(25), type)
        .input('CalificationType', sql.VarChar(25), calificationType)
        .input('ExecutionType', sql.VarChar(25), executionType)
        .input('Binary', sql.Bit, binary)
        .input('NotApply', sql.Bit, notApply)
        .input('Distribute', sql.Bit, distribute)
        .input('IsCritical', sql.Bit, isCritical)
        .input('AcceptComments', sql.Bit, acceptComments)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('Enabled', sql.Bit(), enabled)
        .input('AnalysisType', sql.VarChar(25), analysisType)
        .input('Language', sql.VarChar(50), language)
        .input('IsNegative', sql.Bit(), isNegative)
        .input('DegradeScoreCard', sql.Bit(), degradeScoreCard)
        .execute('SaveAbility')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbility = SaveAbility;
function SaveScore(vcc, id, idAbility, scoreDescription, scoreValue) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .input('Description', sql.VarChar(100), scoreDescription)
        .input('Value', sql.Numeric(5, 1), scoreValue)
        .execute('SaveScore')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScore = SaveScore;
function DeleteScore(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .execute('DeleteScore')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScore = DeleteScore;
function DeleteAbility(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), idAbility)
        .execute('DeleteAbility')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAbility = DeleteAbility;
function GetAbility(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), idAbility)
        .execute('GetAbility')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let ability = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(ability);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbility = GetAbility;
function GetAbilityQueries(vcc, abilityId, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetAbilityQueries')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityQueries = GetAbilityQueries;
function SaveAbilityQuery(vcc, abilityQueryId, abilityId, queryId, queryContent, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), abilityQueryId)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .input('QueryId', sql.VarChar(50), queryId)
        .input('QueryContent', sql.VarChar(1000), queryContent)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveAbilityQuery')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbilityQuery = SaveAbilityQuery;
function DeleteAbilityQueries(vcc, abilityId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .execute('DeleteAbilityQueries')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAbilityQueries = DeleteAbilityQueries;
function GetAbilityQueryEntities(vcc, abilityQueryId, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityQueryId', sql.VarChar(50), abilityQueryId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetAbilityQueryEntities')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityQueryEntities = GetAbilityQueryEntities;
function SaveAbilityQueryEntity(vcc, abilityQueryId, entityId, entityName, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityQueryId', sql.VarChar(50), abilityQueryId)
        .input('EntityId', sql.VarChar(50), entityId)
        .input('EntityName', sql.VarChar(50), entityName)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveAbilityQueryEntity')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbilityQueryEntity = SaveAbilityQueryEntity;
function GetScores(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .execute('GetScores')
        .then((sqlResult) => {
        let scores = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : []);
        let tipifications = (sqlResult.recordsets?.length > 0 ? sqlResult.recordsets[1] : []);
        let tipificationsQuery = (sqlResult.recordsets?.length > 1 ? sqlResult.recordsets[2] : []);
        let tipificationItems = (sqlResult.recordsets?.length > 2 ? sqlResult.recordsets[3] : []);
        tipifications.forEach(t => {
            t.tipificationQuery = tipificationsQuery.find(tq => tq.tipificationId === t.id && tq.scoreId === t.scoreId) || new score_model_1.ScoreTipificationQuery();
            t.items = tipificationItems.filter(ti => ti.tipificationId === t.id && ti.scoreId === t.scoreId);
        });
        scores.forEach(s => s.tipifications = tipifications.filter(t => t.scoreId === s.id));
        return Promise.resolve(scores);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetScores = GetScores;
function GetAbilityTitle(vcc, title) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('Title', sql.VarChar(100), title)
        .execute('GetAbilityTitle')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let ability = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(ability);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityTitle = GetAbilityTitle;
function SaveScoreTipification(vcc, scoreId, id, description, detail, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), id)
        .input('Description', sql.VarChar(250), description)
        .input('Detail', sql.VarChar(500), detail)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveScoreTipification')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipification = SaveScoreTipification;
function DeleteScoreTipification(vcc, scoreId, tipificationId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), tipificationId)
        .execute('DeleteScoreTipification')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipification = DeleteScoreTipification;
function SaveScoreTipificationQuery(vcc, scoreId, tipificationId, queryId, queryContent, acceptancePercentage, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('QueryId', sql.VarChar(50), queryId)
        .input('QueryContent', sql.VarChar(sql.MAX), queryContent)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .execute('SaveScoreTipificationQuery')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipificationQuery = SaveScoreTipificationQuery;
function DeleteScoreTipificationQuery(vcc, scoreId, tipificationId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .execute('DeleteScoreTipificationQuery')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipificationQuery = DeleteScoreTipificationQuery;
function SaveScoreTipificationItem(vcc, scoreId, tipificationId, id, secondLevelItemId, description, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('ID', sql.VarChar(50), id)
        .input('SecondLevelItemId', sql.VarChar(50), secondLevelItemId)
        .input('Description', sql.VarChar(250), description)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveScoreTipificationItem')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipificationItem = SaveScoreTipificationItem;
function DeleteScoreTipificationItem(vcc, scoreId, tipificationItemId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), tipificationItemId)
        .execute('DeleteScoreTipificationItem')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipificationItem = DeleteScoreTipificationItem;
function DeleteAbilities(vcc, idAbilitys) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('AbilityIDs', sql.VarChar(sql.MAX), idAbilitys)
        .execute('DeleteAbilities')
        .then((sqlResult) => response_1.responseSaveOrDelete(sqlResult.recordsets))
        .catch(err => response_1.responseError(err));
}
exports.DeleteAbilities = DeleteAbilities;
function GetAbilitiesUsage(vcc, idAbilitys) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('AbilityIDs', sql.VarChar(sql.MAX), idAbilitys)
        .execute('GetAbilitiesUsage')
        .then((sqlResult) => response_1.responseArrayGet(sqlResult.recordsets))
        .catch(err => response_1.responseError(err));
}
exports.GetAbilitiesUsage = GetAbilitiesUsage;
