"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetApiUser = exports.DeleteApiUser = exports.SaveApiUser = exports.GetApiUsers = exports.ApiUserMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function ApiUserMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.ApiUserMSSql = ApiUserMSSql;
function GetApiUsers(vcc, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetAPIUsers')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetApiUsers = GetApiUsers;
function SaveApiUser(apiUser) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), apiUser.vcc)
        .input('User', sql.VarChar(50), apiUser.user)
        .input('IsLocked', sql.Bit, apiUser.isLocked)
        .input('CreatedDate', sql.DateTime, apiUser.createdDate)
        .input('CreatedByUserId', sql.VarChar(50), apiUser.createdByUserId)
        .input('LastModifiedDate', sql.DateTime, apiUser.lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), apiUser.lastModifiedByUserId)
        .execute('SaveAPIUser')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveApiUser = SaveApiUser;
function DeleteApiUser(vcc, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('User', sql.VarChar(50), userId)
        .execute('DeleteApiUser')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteApiUser = DeleteApiUser;
function GetApiUser(vcc, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('User', sql.VarChar(50), userId)
        .execute('GetAPIUser')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let user = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(user);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetApiUser = GetApiUser;
