"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetAttentionLevels = exports.AttentionLevelMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function AttentionLevelMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AttentionLevelMSSql = AttentionLevelMSSql;
function GetAttentionLevels(instance, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetAttentionLevels')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAttentionLevels = GetAttentionLevels;
