"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InsertUserHistory = exports.ValidateUserLogin = exports.AuthMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function AuthMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AuthMSSql = AuthMSSql;
function ValidateUserLogin(vcc, userId, password) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Password', sql.VarChar(50), password)
        .execute('ValidateUserLogin')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.ValidateUserLogin = ValidateUserLogin;
function InsertUserHistory(vcc, userId, userRole, event, eventDate, eventDetail) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('UserRole', sql.VarChar(50), userRole)
        .input('Event', sql.VarChar(50), event)
        .input('EventDate', sql.DateTime, eventDate)
        .input('EventDetail', sql.VarChar(200), eventDetail)
        .execute('InsertUserHistory')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.InsertUserHistory = InsertUserHistory;
