"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateStatusEvaluationPlan = exports.GetEvaluationResultEfectivitySummary = exports.GetFiltersFromEvaluation = exports.CleanFailedEvaluationPlanData = exports.GetEvaluationPlanTipificationInteractionTask = exports.GetEvaluationPlanCognitiveInteractionTask = exports.GetEvaluationPlanAbilityGenericQueryTask = exports.GetEvaluationPlanTask = exports.DeleteEvaluationPlan = exports.SaveInteractionEvaluationPlanSample = exports.SaveAuditorEvPlanResult = exports.SaveEvaluationPlanCompleted = exports.DeleteAuditorEvaluationPlanByInteraction = exports.DeleteAuditorEvaluationPlan = exports.GetAuditorsEvaluationPlan = exports.GetEvaluationPlan = exports.SaveEvaluationEfectivitySample = exports.SaveEvaluationPlan = exports.GetEvaluationPlansAgent = exports.GetEfectivityPlansAuditor = exports.GetEvaluationPlansAuditor = exports.GetEvaluationPlansSummary = exports.GetEvaluationPlanAbilityEvaluationFormats = exports.GetEvaluationPlanScores = exports.GetEvaluationPlanAbilitiesQueriesEntities = exports.GetEvaluationPlanAbilitiesQueries = exports.GetEvaluationPlanAbilities = exports.GetEvaluationPlanSubGroups = exports.GetEvaluationPlanGroups = exports.GetEvaluationPlanByInteractionId = exports.GetEvaluationPlanByProcessId = exports.GetEvaluationPlanByName = exports.GetEfectivityPlans = exports.GetEvaluationPlans = exports.GetEvaluationPlansExpired = exports.EvaluationPlanMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
const score_model_1 = require("../../models/score.model");
const response_1 = require("../utils/response");
let logger = log4js.getLogger('Sql');
let sqlConn;
function EvaluationPlanMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.EvaluationPlanMSSql = EvaluationPlanMSSql;
function GetEvaluationPlansExpired() {
    return new sql.Request(sqlConn)
        .execute('GetEvaluationPlansExpired')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansExpired = GetEvaluationPlansExpired;
function GetEvaluationPlans(instance, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetEvaluationPlans')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlans = GetEvaluationPlans;
function GetEfectivityPlans(instance, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetEfectivityPlans')
        .then((sqlResult) => {
        let allevaluationRecordSets = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let efectivityPlansRecordSets = (sqlResult.recordsets?.length ? sqlResult.recordsets[1] : null);
        return Promise.resolve({
            allEvaluation: allevaluationRecordSets,
            efectivityPlans: efectivityPlansRecordSets
        });
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEfectivityPlans = GetEfectivityPlans;
function GetEvaluationPlanByName(vcc, description) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Searching if exists evaluation plan: ' + description + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Description', sql.VarChar(50), description)
        .execute('GetEvaluationPlanByName')
        .then((sqlResult) => {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Evaluation plan: ' + description + ' for VCC ' + vcc + ' exists.');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByName] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByName = GetEvaluationPlanByName;
function GetEvaluationPlanByProcessId(vcc, processId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Searching if exists evaluation plan with ProcessId: ' + processId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('instance', sql.VarChar(50), vcc)
        .input('ProcessId', sql.VarChar(50), processId)
        .execute('GetEvaluationPlanByProcessId')
        .then((sqlResult) => {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Evaluation plan processId: ' + processId + ' for VCC ' + vcc + ' exists.');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByProcessId = GetEvaluationPlanByProcessId;
function GetEvaluationPlanByInteractionId(vcc, interactionId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Searching if exists evaluation plan with InteractionId: ' + interactionId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationPlanByInteractionId')
        .then((sqlResult) => {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Evaluation plan interactionId: ' + interactionId + ' for VCC ' + vcc + ' exists.');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByInteractionId = GetEvaluationPlanByInteractionId;
function GetEvaluationPlanGroups(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanGroups')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanGroups = GetEvaluationPlanGroups;
function GetEvaluationPlanSubGroups(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanSubGroups')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanSubGroups = GetEvaluationPlanSubGroups;
function GetEvaluationPlanAbilities(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilities')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilities = GetEvaluationPlanAbilities;
function GetEvaluationPlanAbilitiesQueries(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilitiesQueries')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilitiesQueries = GetEvaluationPlanAbilitiesQueries;
function GetEvaluationPlanAbilitiesQueriesEntities(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilitiesQueriesEntities')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilitiesQueriesEntities = GetEvaluationPlanAbilitiesQueriesEntities;
function GetEvaluationPlanScores(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanScores')
        .then((sqlResult) => {
        let abilityScoreRecordset = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null;
        let abilityScoreTipificationRecordset = sqlResult.recordsets?.length > 1 ? sqlResult.recordsets[1] : null;
        let abilityScoreTipificationQueryRecordset = sqlResult.recordsets?.length > 2 ? sqlResult.recordsets[2] : null;
        let abilityScoreTipificationItemRecordset = sqlResult.recordsets?.length > 3 ? sqlResult.recordsets[3] : null;
        abilityScoreTipificationRecordset.forEach(ast => {
            ast.tipificationQuery = abilityScoreTipificationQueryRecordset.find(astq => astq.tipificationId === ast.id) || new score_model_1.ScoreTipificationQuery();
            ast.items = abilityScoreTipificationItemRecordset.filter(asti => asti.tipificationId === ast.id && asti.scoreId === ast.scoreId);
        });
        abilityScoreRecordset.forEach(as => {
            as.tipifications = abilityScoreTipificationRecordset.filter(ast => ast.scoreId === as.id);
        });
        return Promise.resolve(abilityScoreRecordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanScores = GetEvaluationPlanScores;
function GetEvaluationPlanAbilityEvaluationFormats(vcc, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilityEvaluationFormats')
        .then((sqlResult) => {
        let abilityEvaluationFormatRecordset = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null;
        return Promise.resolve(abilityEvaluationFormatRecordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilityEvaluationFormats = GetEvaluationPlanAbilityEvaluationFormats;
function GetEvaluationPlansSummary(instance, isAdmin, idAgent, idAuditor, campaigns, limitDate, evaluationFormats, modalities, completed) {
    let request = new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed);
    if (!isAdmin) {
        if (idAuditor != null)
            request.input('IdAuditor', sql.VarChar(sql.MAX), idAuditor);
        if (idAgent != null)
            request.input('IdAgent', sql.VarChar(sql.MAX), idAgent);
    }
    return request.execute('GetEvaluationPlansSummary')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Requesting error \'' + err.procName + '\': ' : 'Error on: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[evaluation-plan.mssql::GetEvaluationPlansMaster] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansSummary = GetEvaluationPlansSummary;
function GetEvaluationPlansAuditor(instance, userId, campaigns, limitDate, evaluationPlans, evaluationFormats, modalities, completed, userFuntion) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(sql.MAX), userId)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit(), completed)
        .input('UserFunction', sql.VarChar(50), userFuntion)
        .execute('GetEvaluationPlansAuditor')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAuditor = GetEvaluationPlansAuditor;
function GetEfectivityPlansAuditor(instance, userId, campaigns, evaluationPlans, completed, userFuntion, efectivityPlans) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(sql.MAX), userId)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('Completed', sql.Bit(), completed)
        .input('UserFunction', sql.VarChar(50), userFuntion)
        .input('EfectivityPlans', sql.VarChar(sql.MAX), efectivityPlans)
        .execute('GetEfectivityPlansAuditor')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEfectivityPlansAuditor = GetEfectivityPlansAuditor;
function GetEvaluationPlansAgent(instance, idAgent, campaigns, limitDate, evaluationFormats, modalities, completed) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAgent', sql.VarChar(sql.MAX), idAgent)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed)
        .execute('GetEvaluationPlansAgent')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAgent = GetEvaluationPlansAgent;
function SaveEvaluationPlan(instance, id, modality, dateFin, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, idEvaluationFormat, transcriptionLanguage, environmentId, description, enabled, filterByContent, filterByContentPercentage, evaluatePercentage, processAndEvaluate, filterByContentQueryName, filterByContentQuery, evaluationStarted, processId, status, evaluation_mode, batchScheduleId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), id)
        .input('Modality', sql.VarChar(50), modality)
        .input('DateFin', sql.DateTime, dateFin)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('TranscriptionLanguage', sql.VarChar(25), transcriptionLanguage)
        .input('EnvironmentId', sql.VarChar(100), environmentId)
        .input('Description', sql.VarChar(200), description)
        .input('Enabled', sql.Bit(), enabled)
        .input('FilterByContent', sql.Bit(), filterByContent)
        .input('FilterByContentPercentage', sql.Numeric(3), filterByContentPercentage)
        .input('EvaluatePercentage', sql.Numeric(3), evaluatePercentage)
        .input('ProcessAndEvaluate', sql.Bit(), processAndEvaluate)
        .input('FilterByContentQueryName', sql.VarChar(50), filterByContentQueryName)
        .input('FilterByContentQuery', sql.VarChar(1000), filterByContentQuery)
        .input('EvaluationStarted', sql.Bit(), evaluationStarted)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Status', sql.Numeric(2), status)
        .input('Evaluation_Mode', sql.VarChar(10), evaluation_mode)
        .input('BatchScheduleId', sql.VarChar(50), batchScheduleId)
        .execute('SaveEvaluationPlan')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveEvaluationPlan] Success request');
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlan = SaveEvaluationPlan;
function SaveEvaluationEfectivitySample(vcc, efectivityPlanId, evaluationPlanId, auditorId, sampleSize) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EfectivityPlanId', sql.VarChar(50), efectivityPlanId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('SampleSize', sql.Int(), sampleSize)
        .execute('SaveEvaluationEfectivitySample')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveEvaluationEfectivitySample] Success request');
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveEvaluationEfectivitySample] ' + errorMsg + '|' + efectivityPlanId);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationEfectivitySample = SaveEvaluationEfectivitySample;
function GetEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlan')
        .then((sqlResult) => {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Received result from SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Results from SP: ' + sqlResult.recordsets.length);
        let evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlan = GetEvaluationPlan;
function GetAuditorsEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('idEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('GetAuditorsEvaluationPlan')
        .then((sqlResult) => {
        logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Received result from SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAuditorsEvaluationPlan = GetAuditorsEvaluationPlan;
function DeleteAuditorEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('Eliminando asignaciones del plan de ev. ' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteAuditorEvaluationPlan')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlan = DeleteAuditorEvaluationPlan;
function DeleteAuditorEvaluationPlanByInteraction(vcc, idEvaluationPlan, idInteraction, interactionType, isDraft) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('IdInteraction', sql.VarChar(250), idInteraction)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('IsDraft', sql.Bit(), isDraft)
        .execute('DeleteAuditorEvaluationPlanByInteraction')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlanByInteraction = DeleteAuditorEvaluationPlanByInteraction;
function SaveEvaluationPlanCompleted(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('SaveEvaluationPlanCompleted')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlanCompleted = SaveEvaluationPlanCompleted;
function SaveAuditorEvPlanResult(instance, idEvaluationPlan, idAuditor, idInteraction, interactionType, idAgent, score) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('idAuditor', sql.VarChar(50), idAuditor)
        .input('idInteraction', sql.VarChar(50), idInteraction)
        .input('interactionType', sql.VarChar(50), interactionType)
        .input('idAgent', sql.VarChar(50), idAgent)
        .input('score', sql.Numeric(5, 2), score)
        .execute('SaveAuditorEvPlanResult')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAuditorEvPlanResult = SaveAuditorEvPlanResult;
function SaveInteractionEvaluationPlanSample(vcc, evaluationPlanId, evaluatePercentage) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('EvaluatePercentage', sql.Decimal(18, 2), evaluatePercentage)
        .execute('SaveInteractionEvaluationPlanSample')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveInteractionEvaluationPlanSample = SaveInteractionEvaluationPlanSample;
function DeleteEvaluationPlan(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteEvaluationPlan')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationPlan = DeleteEvaluationPlan;
function GetEvaluationPlanTask(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlanTask')
        .then((sqlResult) => {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Received result from SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Results from SP: ' + sqlResult.recordsets.length);
        let evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanTask] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanTask = GetEvaluationPlanTask;
function GetEvaluationPlanAbilityGenericQueryTask(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilityGenericQueryTask')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilityGenericQueryTask = GetEvaluationPlanAbilityGenericQueryTask;
function GetEvaluationPlanCognitiveInteractionTask(vcc, evaluationPlanId) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanCognitiveInteractionTask] getting vcc:', vcc, 'evaluationPlanId:', evaluationPlanId);
    let genericResult = {};
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanCognitiveInteractionTask')
        .then((sqlResult) => {
        let callCognitiveInteractions = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let asyncCognitiveInteractions = (sqlResult.recordsets.length > 1 ? sqlResult.recordsets[1] : null);
        callCognitiveInteractions = callCognitiveInteractions ? callCognitiveInteractions : [];
        asyncCognitiveInteractions = asyncCognitiveInteractions ? asyncCognitiveInteractions : [];
        genericResult.status = true;
        genericResult.description = 'OK';
        genericResult.data = callCognitiveInteractions.concat(asyncCognitiveInteractions);
        return Promise.resolve(genericResult);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanCognitiveInteractionTask = GetEvaluationPlanCognitiveInteractionTask;
function GetEvaluationPlanTipificationInteractionTask(vcc, evaluationPlanId) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTipificationInteractionTask] getting vcc:', vcc, 'evaluationPlanId:', evaluationPlanId);
    let genericResult = {};
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanTipificationInteractionTask')
        .then((sqlResult) => {
        let callCognitiveInteractions = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let asyncCognitiveInteractions = (sqlResult.recordsets.length > 1 ? sqlResult.recordsets[1] : null);
        callCognitiveInteractions = callCognitiveInteractions ? callCognitiveInteractions : [];
        asyncCognitiveInteractions = asyncCognitiveInteractions ? asyncCognitiveInteractions : [];
        genericResult.status = true;
        genericResult.description = 'OK';
        genericResult.data = callCognitiveInteractions.concat(asyncCognitiveInteractions);
        return Promise.resolve(genericResult);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanTipificationInteractionTask = GetEvaluationPlanTipificationInteractionTask;
function CleanFailedEvaluationPlanData(VCC, idEvaluationPlan) {
    logger.info('Limpiando datos fallidos del plan de evaluacion: ' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), VCC)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('CleanFailedEvaluationPlanData')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CleanFailedEvaluationPlanData = CleanFailedEvaluationPlanData;
function GetFiltersFromEvaluation(vcc, userId, campaigns, searchType, efectivityMode) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('SearchType', sql.VarChar(50), searchType)
        .input('EfectivityMode', sql.Bit(), efectivityMode)
        .execute('GetFiltersFromEvaluation')
        .then((sqlResult) => {
        let campaignsRecords = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null;
        let agentsRecords = sqlResult.recordsets?.length ? sqlResult.recordsets[1] : null;
        let dispositionCodesRecords = sqlResult.recordsets?.length ? sqlResult.recordsets[2] : null;
        let interactionTypesRecords = sqlResult.recordsets?.length ? sqlResult.recordsets[3] : null;
        return Promise.resolve({
            agents: agentsRecords,
            campaigns: campaignsRecords,
            dispositionCodes: dispositionCodesRecords,
            interactionTypes: interactionTypesRecords
        });
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetFiltersFromEvaluation = GetFiltersFromEvaluation;
function GetEvaluationResultEfectivitySummary(vcc, efectivityPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EfectivityPlanId', sql.VarChar(sql.MAX), efectivityPlanId)
        .execute('GetEvaluationResultEfectivitySummary')
        .then((sqlResult) => {
        let recorset = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null;
        return Promise.resolve(recorset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationResultEfectivitySummary = GetEvaluationResultEfectivitySummary;
function UpdateStatusEvaluationPlan(vcc, idEvaluationPlan, status, statusDescription = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('Status', sql.VarChar(50), status)
        .input('StatusDescription', sql.VarChar(50), statusDescription)
        .execute('UpdateStatusEvaluationPlan')
        .then((sqlResult) => response_1.responseSaveOrDelete(sqlResult.recordsets))
        .catch(err => response_1.responseError(err));
}
exports.UpdateStatusEvaluationPlan = UpdateStatusEvaluationPlan;
