"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveUserAccessToken = exports.SaveIdathaAuth = exports.GetUserAccessTokenByRealm = exports.GetIdathaAuthByRealm = exports.IdathaMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function IdathaMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.IdathaMSSql = IdathaMSSql;
function GetIdathaAuthByRealm(vcc, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Realm', sql.VarChar(50), realm)
        .execute('GetIdathaAuthByRealm')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let idathaAuth = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(idathaAuth);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetIdathaAuthByRealm = GetIdathaAuthByRealm;
function GetUserAccessTokenByRealm(vcc, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Realm', sql.VarChar(50), realm)
        .execute('GetUserAccessTokenByRealm')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let userAccessToken = (recordset && recordset.length > 0 ? recordset[0] : null);
        if (userAccessToken) {
        }
        return Promise.resolve(userAccessToken);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetUserAccessTokenByRealm = GetUserAccessTokenByRealm;
function SaveIdathaAuth(vcc, userName, password, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserName', sql.VarChar(50), userName)
        .input('Password', sql.VarChar(200), password)
        .input('Realm', sql.VarChar(100), realm)
        .execute('SaveIdathaAuth')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        console.log(err);
        return Promise.reject(err);
    });
}
exports.SaveIdathaAuth = SaveIdathaAuth;
function SaveUserAccessToken(vcc, userName, accessToken, realm, createdDate) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserName', sql.VarChar(50), userName)
        .input('AccessToken', sql.VarChar(2000), accessToken)
        .input('Realm', sql.VarChar(100), realm)
        .input('CreatedDate', sql.DateTime, createdDate)
        .execute('SaveUserAccessToken')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveUserAccessToken = SaveUserAccessToken;
