"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveAllegroGroup = exports.SaveAllegroUser = exports.SaveIntegratedUser = exports.GetAllegroRole = exports.GetAllegroAgent = exports.GetAllegroSupervisor = exports.GetAPIUsersAllegro = exports.GetAPIUserAllegro = exports.GetAPIUsersOCC = exports.GetAPIUserOCC = exports.GetIntegrationUsers = exports.GetIntegrationVCCs = exports.IntegrationMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function IntegrationMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.IntegrationMSSql = IntegrationMSSql;
function GetIntegrationVCCs(ip, type, ambiente) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('Type', sql.Int, type)
        .input('Ambiente', sql.VarChar(50), ambiente)
        .execute('GetIntegrationVCCs')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetIntegrationVCCs = GetIntegrationVCCs;
function GetIntegrationUsers(ip, type) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('Type', sql.Int, type)
        .execute('GetIntegrationUsers')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetIntegrationUsers = GetIntegrationUsers;
function GetAPIUserOCC(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetAPIUserOCC')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let ApiUserOCC = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(ApiUserOCC);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAPIUserOCC = GetAPIUserOCC;
function GetAPIUsersOCC() {
    return new sql.Request(sqlConn)
        .execute('GetAPIUsersOCC')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAPIUsersOCC = GetAPIUsersOCC;
function GetAPIUserAllegro(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetAPIUserAllegro')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let APIUserAllegro = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(APIUserAllegro);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAPIUserAllegro = GetAPIUserAllegro;
function GetAPIUsersAllegro() {
    return new sql.Request(sqlConn)
        .execute('GetAPIUsersAllegro')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAPIUsersAllegro = GetAPIUsersAllegro;
function GetAllegroSupervisor(ip, vcc, userId, type) {
    return new sql.Request(sqlConn)
        .input('IP', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Type', sql.Int, type)
        .execute('GetAllegroSupervisor')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let agent = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(agent);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[IntegrationMSSql::GetAllegroAgent] Getting error:', errorMsg, 'vcc:', vcc, 'userId:', userId);
        return Promise.resolve(false);
    });
}
exports.GetAllegroSupervisor = GetAllegroSupervisor;
function GetAllegroAgent(ip, vcc, userId, type) {
    return new sql.Request(sqlConn)
        .input('IP', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Type', sql.Int, type)
        .execute('GetAllegroAgent')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let agent = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(agent);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[IntegrationMSSql::GetAllegroAgent] Getting error:', errorMsg, 'vcc:', vcc, 'userId:', userId);
        return Promise.resolve(false);
    });
}
exports.GetAllegroAgent = GetAllegroAgent;
function GetAllegroRole(ip, vcc, roleId, type) {
    return new sql.Request(sqlConn)
        .input('IP', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('RoleId', sql.VarChar(50), roleId)
        .input('Type', sql.Int, type)
        .execute('GetAllegroRole')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let agent = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(agent);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[IntegrationMSSql::GetAllegroRole] Getting error:', errorMsg, 'vcc:', vcc, 'roleId:', roleId);
        return Promise.resolve(false);
    });
}
exports.GetAllegroRole = GetAllegroRole;
function SaveIntegratedUser(vcc, id, email, firstname, lastname, password, role, country, language, timeZone, preferences, isSystemUser, limitClients, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('Email', sql.VarChar(50), email)
        .input('Firstname', sql.VarChar(50), firstname)
        .input('Lastname', sql.VarChar(50), lastname)
        .input('Password', sql.VarChar(50), password)
        .input('Role', sql.VarChar(50), role)
        .input('Country', sql.VarChar(50), country)
        .input('Language', sql.VarChar(50), language)
        .input('TimeZone', sql.VarChar(50), timeZone)
        .input('Preferences', sql.VarChar(200), preferences)
        .input('IsSystemUser', sql.Bit, isSystemUser)
        .input('LimitClients', sql.Bit, limitClients)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveIntegratedUser')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveIntegratedUser = SaveIntegratedUser;
function SaveAllegroUser(userGroup, validationOrigin, country, id, state, isSystemUser, name, languageId, timeZoneId, password, vcc, vccGroup, ip, type) {
    return new sql.Request(sqlConn)
        .input('UserGroup', sql.VarChar(50), userGroup)
        .input('ValidationOrigin', sql.VarChar(50), validationOrigin)
        .input('Country', sql.VarChar(100), country)
        .input('Id', sql.VarChar(50), id)
        .input('State', sql.VarChar(20), state)
        .input('IsSystemUser', sql.VarChar(50), isSystemUser)
        .input('Name', sql.VarChar(100), name)
        .input('LanguageId', sql.VarChar(100), languageId)
        .input('TimeZoneId', sql.VarChar(50), timeZoneId)
        .input('Password', sql.VarChar(100), password)
        .input('VCC', sql.VarChar(50), vcc)
        .input('VccGroup', sql.VarChar(50), vccGroup)
        .input('Ip', sql.VarChar(50), ip)
        .input('Type', sql.Int, type)
        .execute('SaveAllegroUser')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        let messageValidate = err.message.indexOf('FOREIGN KEY constraint "FK_UserGroup') > -1 ? 'ALLEGRO_ROLE_NOT_FOUND' : 'GENERIC_ALLEGRO_ERROR';
        logger.error('[IntegrationMSSql::SaveAllegroUser] Getting error:', errorMsg, 'messageValidate:', messageValidate);
        return Promise.resolve({ status: false, messageValidate: messageValidate });
    });
}
exports.SaveAllegroUser = SaveAllegroUser;
function SaveAllegroGroup(vcc, id, isSystemGroup, description, ip, type) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Id', sql.VarChar(50), id)
        .input('IsSystemGroup', sql.VarChar(50), isSystemGroup)
        .input('Description', sql.VarChar(100), description)
        .input('Ip', sql.VarChar(50), ip)
        .input('Type', sql.Int, type)
        .execute('SaveAllegroGroup')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAllegroGroup = SaveAllegroGroup;
