"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSentimentAnalysisResult = exports.SaveSentimentAnalysisResult = exports.SentimentMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function SentimentMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.SentimentMSSql = SentimentMSSql;
function SaveSentimentAnalysisResult(vcc, interactonId, interactionSection, interactionPart, interactionType, interactionInterval, analysisType, sentimentId, appId, score, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, endDate, status) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactonId)
        .input('InteractionSection', sql.Decimal(5, 0), interactionSection)
        .input('InteractionPart', sql.Decimal(5, 0), interactionPart)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('InteractionInterval', sql.Int, interactionInterval)
        .input('AnalysisType', sql.VarChar(50), analysisType)
        .input('SentimentId', sql.VarChar(50), sentimentId)
        .input('AppId', sql.VarChar(50), appId)
        .input('Score', sql.Decimal(10, 5), score)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('EndDate', sql.VarChar(50), endDate)
        .input('Status', sql.VarChar(50), status)
        .execute('SaveSentimentAnalysisResult')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveSentimentAnalysisResult = SaveSentimentAnalysisResult;
function GetSentimentAnalysisResult(vcc, interactonId, interactionSection, interactionPart, endDate) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactonId)
        .input('InteractionSection', sql.Decimal(5, 0), interactionSection)
        .input('InteractionPart', sql.Decimal(5, 0), interactionPart)
        .input('EndDate', sql.VarChar(50), endDate)
        .execute('GetSentimentAnalysisResult')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetSentimentAnalysisResult = GetSentimentAnalysisResult;
