"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSupervisors = exports.SupervisorMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function SupervisorMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.SupervisorMSSql = SupervisorMSSql;
function GetSupervisors(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetSupervisors')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let supervisors = [];
        recordset.map(r => {
            let supervisor = {};
            supervisor.userId = r.userId;
            supervisor.userName = r.userName;
            supervisor.campaigns = [];
            supervisors.push(supervisor);
        });
        return Promise.resolve(supervisors);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetSupervisors = GetSupervisors;
