"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetTopBestAgents = exports.TopBestAgentsMssql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function TopBestAgentsMssql(app) {
    sqlConn = app.get('sqlConn');
}
exports.TopBestAgentsMssql = TopBestAgentsMssql;
function GetTopBestAgents(instance, initialDate, endDate, topQuantity, campaigns, evaluationFormats, evaluationPlans, agents, idGroup, idSubGroup, idAbility, auditors) {
    let request = new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('InitialDate', sql.DateTime, initialDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('TopQuantity', sql.Int, topQuantity)
        .input('TopBest', sql.Bit, 1);
    if (campaigns) {
        request.input('IdCampaign', sql.VarChar(sql.MAX), campaigns);
    }
    if (evaluationFormats) {
        request.input('IdEvaluationFormat', sql.VarChar(sql.MAX), evaluationFormats);
    }
    if (evaluationPlans) {
        request.input('IdEvaluationPlan', sql.VarChar(sql.MAX), evaluationPlans);
    }
    if (agents) {
        request.input('IdAgent', sql.VarChar(sql.MAX), agents);
    }
    if (idGroup) {
        request.input('IdGroup', sql.VarChar(sql.MAX), idGroup);
    }
    if (idSubGroup) {
        request.input('IdSubGroup', sql.VarChar(sql.MAX), idSubGroup);
    }
    if (idAbility) {
        request.input('IdAbility', sql.VarChar(sql.MAX), idAbility);
    }
    if (auditors) {
        request.input('IdAuditor', sql.VarChar(sql.MAX), auditors);
    }
    return request.execute('GetTopAgents')
        .then((sqlResult) => {
        logger.info(JSON.stringify(sqlResult.recordsets));
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTopBestAgents = GetTopBestAgents;
