"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetWordBlacklist = exports.WordBlacklistMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function WordBlacklistMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.WordBlacklistMSSql = WordBlacklistMSSql;
function GetWordBlacklist(vcc, processId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ProcessId', sql.VarChar(50), processId)
        .execute('GetWordBlacklist')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWordBlacklist = GetWordBlacklist;
