"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetI6Integration = exports.SaveI6Integration = exports.I6IntegrationRedis = void 0;
const log4js = require("log4js");
const redis_config_1 = require("../../config/redis.config");
let logger = log4js.getLogger('Redis');
let redisClient;
function I6IntegrationRedis(app) {
    redisClient = app.get('redisClient');
}
exports.I6IntegrationRedis = I6IntegrationRedis;
function SaveI6Integration(vcc, data) {
    let redisKey = `${vcc}:I6Integration`;
    return redisClient.hsetAsync(redisKey, vcc, JSON.stringify(data))
        .then((result) => {
        return redisClient.expireAsync(redisKey, redis_config_1.REDIS_DATA_PERSISTENCE);
    })
        .then((result) => {
        return Promise.resolve(true);
    })
        .catch((err) => {
        return Promise.reject(err);
    });
}
exports.SaveI6Integration = SaveI6Integration;
function GetI6Integration(vcc) {
    let redisKey = `${vcc}:I6Integration`;
    return redisClient.hgetAsync(redisKey, vcc)
        .then((result) => {
        let integrationData = null;
        try {
            integrationData = (typeof result === 'string') ? JSON.parse(result) : result;
        }
        catch (err) {
            return Promise.resolve(null);
        }
        return Promise.resolve(integrationData);
    })
        .catch((err) => {
        logger.error('[I6IntegrationRedis::GetI6Integration] getting err value:', err, 'hash:', redisKey, 'key:', vcc);
        return Promise.resolve(null);
    });
}
exports.GetI6Integration = GetI6Integration;
