"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.responseSaveOrDelete = exports.responseObjectGet = exports.responseArrayGet = exports.responseError = void 0;
const log4js = require("log4js");
let logger = log4js.getLogger('Sql');
const responseError = (err) => {
    let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
    logger.error(errorMsg);
    return Promise.reject(err);
};
exports.responseError = responseError;
const responseArrayGet = (sqlResult) => {
    let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
    return Promise.resolve(recordset);
};
exports.responseArrayGet = responseArrayGet;
const responseObjectGet = (sqlResult) => {
    let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
    let data = (recordset && recordset.length > 0 ? recordset[0] : null);
    return Promise.resolve(data);
};
exports.responseObjectGet = responseObjectGet;
const responseSaveOrDelete = (sqlResult) => {
    let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
    let output = (recordset && recordset.length > 0 ? recordset[0] : null);
    return Promise.resolve(output && output.result === 1);
};
exports.responseSaveOrDelete = responseSaveOrDelete;
