"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetServiceInstance = void 0;
const log4js = require("log4js");
const cognitive_analysis_implementation_1 = require("../cognitive-analysis.implementation");
const promises_shared_1 = require("../../shared/promises.shared");
const logger = log4js.getLogger('Task');
function GetServiceInstance(engine) {
    return promises_shared_1.DummyPromise().then(_ => {
        logger.info('[CognitiveEngineMigrateImplementation::GetServiceInstance] Getting Cognitive Service Instance For:', engine);
        return cognitive_analysis_implementation_1.GetCognitiveService(null, engine);
    })
        .then((service) => {
        if (service) {
            logger.info('[CognitiveEngineMigrateImplementation::GetServiceInstance]  CognitiveEngine OK');
            return service;
        }
        logger.error('[CognitiveEngineMigrateImplementation::GetServiceInstance] ERROR_COGNITIVE_ENGINE_NOT_INSTANTIATED:', service);
        return null;
    });
}
exports.GetServiceInstance = GetServiceInstance;
