"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BroadcastEvent = exports.SendEventToUser = exports.SendEventToAllUsersVcc = exports.SocketShared = void 0;
const log4js = require("log4js");
let logger = log4js.getLogger('IO');
let SpeechIO;
function SocketShared(app) {
    SpeechIO = app.get('SpeechIO');
}
exports.SocketShared = SocketShared;
function SendEventToAllUsersVcc(event, data, vcc) {
    if (!SpeechIO) {
        logger.error("[io.shared::SendEventToAllUsersVcc] SpeechIO is undefined", SpeechIO);
        return Promise.resolve(false);
    }
    SpeechIO.to(`${vcc}`).emit(event, data);
    return Promise.resolve(true);
}
exports.SendEventToAllUsersVcc = SendEventToAllUsersVcc;
function SendEventToUser(event, data, vcc, userId) {
    if (!SpeechIO) {
        logger.error("[io.shared::SendEventToUser] SpeechIO is undefined", SpeechIO);
        return Promise.resolve(false);
    }
    SpeechIO.to(`${vcc}-${userId}`).emit(event, data);
    return Promise.resolve(true);
}
exports.SendEventToUser = SendEventToUser;
function BroadcastEvent(event, data) {
    if (!SpeechIO) {
        logger.error("[io.shared::BroadcastEvent] SpeechIO is undefined", SpeechIO);
        return Promise.resolve(false);
    }
    SpeechIO.emit(event, data);
    return Promise.resolve(true);
}
exports.BroadcastEvent = BroadcastEvent;
