"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MailInit = void 0;
const log4js = require("log4js");
const mail_config_1 = require("../config/mail.config");
const smtp_mail_1 = require("./smtp.mail");
let logger = log4js.getLogger('ServerScripts');
function MailInit(app) {
    return new Promise((resolve, reject) => {
        logger.info('Iniciando conexión a webmail \'' + mail_config_1.MAILSERVER_CONFIG.server + '\'');
        console.log('Iniciando conexión a webmail \'' + mail_config_1.MAILSERVER_CONFIG.server + '\'');
        let nodemailer = require('nodemailer');
        let smtpTransport = nodemailer.createTransport({
            host: mail_config_1.MAILSERVER_CONFIG.server,
            port: mail_config_1.MAILSERVER_CONFIG.port,
            secure: mail_config_1.MAILSERVER_CONFIG.secure,
            tls: {
                rejectUnauthorized: false
            },
            auth: {
                user: mail_config_1.MAILSERVER_CONFIG.user,
                pass: mail_config_1.MAILSERVER_CONFIG.password
            }
        });
        smtpTransport.verify((err) => {
            if (err) {
                let errMsg = (typeof err.response === 'string' ? err.response : err);
                logger.error('No se pudo establecer conexion al webmail: ' + errMsg);
                console.error('No se pudo establecer conexion al webmail');
                reject(errMsg);
            }
            else {
                logger.info('Conexión al webmail establecida');
                console.log('Conexión al webmail establecida');
                resolve(true);
            }
        });
        app.set('mailserver', smtpTransport);
        smtp_mail_1.SmtpService(app);
    });
}
exports.MailInit = MailInit;
