"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BillingMovement = exports.BillingVCCRates = void 0;
class BillingVCCRates {
    constructor() {
        this.cognitiveAnalysisAverageRequestPerMinute = 0;
        this.cognitiveAnalysisAverageSecondsPerRequest = 0;
        this.cognitiveAnalysisCallBillingSecureRate = 0;
        this.semanticAnalysisRatePerTransaction = 0;
        this.cognitiveAnalysisTextBillingSecureRate = 0;
        this.isProcessPostChannel = false;
        this.processCallPhrases = 0;
        this.processRoundedValidDurationTime = 0;
        this.processTextPhrases = 0;
        this.processTotalValidDurationTime = 0;
        this.cognitiveAnalysisRatePerTransaction = 0;
        this.transcriptionRatePerHour = 0;
        this.transcriptionRatePerSecond = 0;
        this.totalCost = 0.00001;
    }
    SetBillingVCCRates(object) {
        this.cognitiveAnalysisAverageRequestPerMinute = object.cognitiveAnalysisAverageRequestPerMinute;
        this.cognitiveAnalysisAverageSecondsPerRequest = object.cognitiveAnalysisAverageSecondsPerRequest;
        this.cognitiveAnalysisCallBillingSecureRate = object.cognitiveAnalysisBillingSecureRate;
        this.semanticAnalysisRatePerTransaction = object.semanticAnalysisRatePerTransaction;
        this.cognitiveAnalysisTextBillingSecureRate = object.cognitiveAnalysisTextBillingSecureRate;
        this.isProcessPostChannel = object.isProcessPostChannel;
        this.processCallPhrases = object.processCallPhrases;
        this.processRoundedValidDurationTime = object.processRoundedValidDurationTime;
        this.processTextPhrases = object.processTextPhrases;
        this.processTotalValidDurationTime = object.processTotalValidDurationTime;
        this.cognitiveAnalysisRatePerTransaction = object.cognitiveAnalysisRatePerTransaction;
        this.transcriptionRatePerHour = object.transcriptionRatePerHour;
        this.transcriptionRatePerSecond = object.transcriptionRatePerSecond;
    }
    GetCognitiveAnalysisTotalAveragePhrasesFromProcess() {
        let cognitiveAnalysisTotalAveragePhrases = 0;
        if (this.isProcessPostChannel) {
            cognitiveAnalysisTotalAveragePhrases = (this.processCallPhrases * (1 + this.cognitiveAnalysisCallBillingSecureRate))
                + (this.processTextPhrases * (1 + this.cognitiveAnalysisTextBillingSecureRate));
        }
        return cognitiveAnalysisTotalAveragePhrases;
    }
    GetCognitiveAnalysisTotalCostFromProcess(totalModels) {
        let cognitiveTotalCost = 0;
        if (this.isProcessPostChannel) {
            cognitiveTotalCost = totalModels
                * Math.ceil(this.cognitiveAnalysisRatePerTransaction
                    * this.GetCognitiveAnalysisTotalAveragePhrasesFromProcess());
        }
        return cognitiveTotalCost;
    }
    GetCognitiveAnalysisTotalAveragePhrasesFromNone(estimatedRequests) {
        let cognitiveAnalysisTotalAveragePhrases = 0;
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromCallTime || 0) * (1 + this.cognitiveAnalysisCallBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestFromCallAlreadyPhrases || 0) * (1 + this.cognitiveAnalysisCallBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextRawChar || 0) * (1 + this.cognitiveAnalysisTextBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextAlreadyPhrases || 0) * (1 + this.cognitiveAnalysisTextBillingSecureRate);
        return cognitiveAnalysisTotalAveragePhrases;
    }
}
exports.BillingVCCRates = BillingVCCRates;
class BillingMovement {
    constructor(startDate, endDate, accountId = null, subAccountId = null, vcc = null, type = null) {
        this.startDate = startDate;
        this.endDate = endDate;
        this.accountId = accountId;
        this.subAccountId = subAccountId;
        this.vcc = vcc;
        this.type = type;
    }
}
exports.BillingMovement = BillingMovement;
