"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EvaluationPlanGenericQuery = exports.EvaluationPlanFilters = exports.EvaluationPlanStatus = exports.AuditorEvaluationPlan = exports.EvaluationPlanInteractionsSummary = exports.EvaluationPlan = void 0;
class EvaluationPlan {
    constructor(id, modality, dateFin, idEvaluationFormat, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, description, completedCount, interactionTimeSum, enabled, completed, status, evaluation_mode, totalEvaluations, completedEvaluations, completedPercentage, pendingInteractionCount) {
        this.id = id;
        this.modality = modality;
        this.dateFin = dateFin;
        this.idEvaluationFormat = idEvaluationFormat;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.description = description;
        this.completedCount = completedCount;
        this.interactionTimeSum = interactionTimeSum;
        this.enabled = enabled;
        this.completed = completed;
        this.status = status;
        this.evaluation_mode = evaluation_mode;
        this.totalEvaluations = totalEvaluations;
        this.completedEvaluations = completedEvaluations;
        this.completedPercentage = completedPercentage;
        this.pendingInteractionCount = pendingInteractionCount;
        this.vcc = null;
        this.selected = false;
        this.channelInteractions = [];
        this.uniqueInteractions = [];
        this.interactions = [];
        this.auditors = [];
        this.batchScheduleId = null;
        this.scheduleData = null;
        this.isExistingTranscription = false;
    }
}
exports.EvaluationPlan = EvaluationPlan;
class EvaluationPlanInteractionsSummary {
    constructor() {
        this.channelInteractions = [];
        this.audios = [];
        this.totalSyncInteraction = 0;
        this.totalAudio = 0;
        this.totalSyncDetailPhrases = 0;
        this.totalSyncDetailRawPhrases = 0;
        this.asyncInteractions = [];
        this.totalAsyncInteraction = 0;
        this.totalAsyncDetail = 0;
        this.totalAsyncDetailRawChar = 0;
        this.totalAsyncDetailRawPhrases = 0;
        this.totalAsyncDetailPhrases = 0;
        this.agentIds = [];
    }
    GetTotalInteractions() {
        return this.totalSyncInteraction + this.totalAsyncInteraction;
    }
}
exports.EvaluationPlanInteractionsSummary = EvaluationPlanInteractionsSummary;
class AuditorEvaluationPlan {
    constructor(idEvaluationPlan, idAuditor, descriptionAuditor, pendingInteractionCount, numberInteractions, uncompleteInteractions, interactionTimeSum, pendingInteractionTimeSum) {
        this.idEvaluationPlan = idEvaluationPlan;
        this.idAuditor = idAuditor;
        this.descriptionAuditor = descriptionAuditor;
        this.pendingInteractionCount = pendingInteractionCount;
        this.numberInteractions = numberInteractions;
        this.uncompleteInteractions = uncompleteInteractions;
        this.interactionTimeSum = interactionTimeSum;
        this.pendingInteractionTimeSum = pendingInteractionTimeSum;
        this.selected = false;
        this.interactions = [];
        this.percentage = 0;
    }
}
exports.AuditorEvaluationPlan = AuditorEvaluationPlan;
var EvaluationPlanStatus;
(function (EvaluationPlanStatus) {
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_CREATED"] = 1] = "STATUS_CREATED";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_TRANSCRIBING"] = 2] = "STATUS_TRANSCRIBING";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_TRANSCRIPT"] = 3] = "STATUS_TRANSCRIPT";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_ANALYZING"] = 4] = "STATUS_ANALYZING";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_ANALYZED"] = 5] = "STATUS_ANALYZED";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_EVALUATING"] = 6] = "STATUS_EVALUATING";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_COMPLETED"] = 7] = "STATUS_COMPLETED";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_MIXED_EVALUATING"] = 8] = "STATUS_MIXED_EVALUATING";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_FAILED"] = 9] = "STATUS_FAILED";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_CANCELLED_BY_FAILED_PROCESS"] = 10] = "STATUS_CANCELLED_BY_FAILED_PROCESS";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_ABILITY_EVALUATED"] = 11] = "STATUS_ABILITY_EVALUATED";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_TIPIFICATION_ANALYZING"] = 12] = "STATUS_TIPIFICATION_ANALYZING";
    EvaluationPlanStatus[EvaluationPlanStatus["STATUS_TIPIFICATION_ANALYZED"] = 13] = "STATUS_TIPIFICATION_ANALYZED";
})(EvaluationPlanStatus = exports.EvaluationPlanStatus || (exports.EvaluationPlanStatus = {}));
class EvaluationPlanFilters {
    constructor() {
        this.evaluationPlans = [];
        this.completed = false;
        this.view = null;
        this.efectivityMode = false;
        this.efectivityPlans = [];
    }
}
exports.EvaluationPlanFilters = EvaluationPlanFilters;
class EvaluationPlanGenericQuery {
}
exports.EvaluationPlanGenericQuery = EvaluationPlanGenericQuery;
