"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiUser = exports.UserAPI = exports.UserSocketMessage = exports.UserIndicator = exports.UserNotification = exports.UserClient = exports.User = void 0;
class User {
    constructor(id, email, firstname, lastname, password, role, country, language, timeZone, preferences, isSystemUser, limitClients, api, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.id = id;
        this.email = email;
        this.firstname = firstname;
        this.lastname = lastname;
        this.password = password;
        this.role = role;
        this.country = country;
        this.language = language;
        this.timeZone = timeZone;
        this.preferences = preferences;
        this.isSystemUser = isSystemUser;
        this.limitClients = limitClients;
        this.api = api;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.isLocalSupervisor = false;
        this.isExternalSupervisor = false;
        this.isExternalAgent = false;
    }
}
exports.User = User;
class UserClient {
    constructor(userId, clientId) {
        this.userId = userId;
        this.clientId = clientId;
    }
}
exports.UserClient = UserClient;
class UserNotification {
    constructor(userIndicatorId, vcc, indicatorId, userId, title, description, type, sendDate, opened, createdDate) {
        this.userIndicatorId = userIndicatorId;
        this.vcc = vcc;
        this.indicatorId = indicatorId;
        this.userId = userId;
        this.title = title;
        this.description = description;
        this.type = type;
        this.sendDate = sendDate;
        this.opened = opened;
        this.createdDate = createdDate;
    }
}
exports.UserNotification = UserNotification;
class UserIndicator {
    constructor(id, indicatorId, userId, customQuery, customParams, expectedOperator, expectedValue, lastKnownValue, lastModification, receiveByMail, receiveByBrowser, reference, timeSchedule, silentCriteria, silent) {
        this.id = id;
        this.indicatorId = indicatorId;
        this.userId = userId;
        this.customQuery = customQuery;
        this.customParams = customParams;
        this.expectedOperator = expectedOperator;
        this.expectedValue = expectedValue;
        this.lastKnownValue = lastKnownValue;
        this.lastModification = lastModification;
        this.receiveByMail = receiveByMail;
        this.receiveByBrowser = receiveByBrowser;
        this.reference = reference;
        this.timeSchedule = timeSchedule;
        this.silentCriteria = silentCriteria;
        this.silent = silent;
    }
}
exports.UserIndicator = UserIndicator;
class UserSocketMessage {
    constructor(id, message) {
        this.id = id;
        this.message = message;
    }
}
exports.UserSocketMessage = UserSocketMessage;
class UserAPI {
    constructor(vcc, id, params) {
        this.vcc = vcc;
        this.id = id;
        this.params = params;
    }
}
exports.UserAPI = UserAPI;
class ApiUser {
    constructor(vcc, user, pin, isLocked, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.user = user;
        this.pin = pin;
        this.isLocked = isLocked;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
    }
}
exports.ApiUser = ApiUser;
