"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IOService = void 0;
const log4js = require("log4js");
const io_shared_1 = require("../io/io.shared");
const promises_shared_1 = require("../shared/promises.shared");
let logger = log4js.getLogger('IO');
function IOService(app) {
    app.post('/io/send-events', (req, res) => {
        let events = req.body || [];
        promises_shared_1.DummyPromise().then(_ => {
            let promises = [];
            for (let e of events) {
                switch (e.type) {
                    case 1:
                        promises.push(io_shared_1.SendEventToUser(e.event, e.data, e.vcc, e.userId));
                        break;
                    case 2:
                        promises.push(io_shared_1.SendEventToAllUsersVcc(e.event, e.data, e.vcc));
                        break;
                    default:
                        promises.push(io_shared_1.BroadcastEvent(e.event, e.data));
                        break;
                }
            }
            return Promise.all(promises);
        }).then((results) => {
            res.send({
                status: !results.includes(false),
            });
        }).catch((err) => {
            let errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Unknow error');
            logger.error('[IOService::send-events]:', errorMsg);
            res.json({ status: false, error: errorMsg });
        });
    });
}
exports.IOService = IOService;
