"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProfileImageService = void 0;
const log4js = require("log4js");
const mssql_service_1 = require("../db/mssql.service");
const promises_shared_1 = require("../shared/promises.shared");
let logger = log4js.getLogger('ServerScripts');
function ProfileImageService(app) {
    app.get('/api/profile_image/:type/get_profile_image/:id', (req, res, next) => {
        let instance = res.locals.instance;
        let type = req.params.type;
        let id = req.params.id;
        promises_shared_1.DummyPromise()
            .then(result => {
            if (!type || !id)
                throw 'SERVER_ERROR_MISSING_PARAMETERS';
            return mssql_service_1.MSSql.GetProfileImage(instance, type, id);
        }).then(profileImage => {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'SERVER_SUCCESS_MESSAGE', data: profileImage });
        }).catch(err => {
            let errMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
            logger.error('Error al procesar \'' + req.path + '\': ' + errMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: 'CANNOT_PROCESS_REQUEST', error: errMsg });
        });
    });
}
exports.ProfileImageService = ProfileImageService;
