"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrantAccess = void 0;
const log4js = require("log4js");
const promises_shared_1 = require("../shared/promises.shared");
let logger = log4js.getLogger('ServerScripts');
function GrantAccess(req, res, next) {
    if (!req.url.match('^\/(api|builder)\/'))
        return next();
    let vcc = res.locals.vcc;
    let userId = res.locals.userId;
    let role = res.locals.userRole;
    let urlPath = req.path;
    if (urlPath.startsWith('/'))
        urlPath = urlPath.slice(1);
    if (urlPath.indexOf('api/public') > -1)
        return next();
    promises_shared_1.DummyPromise()
        .then(result => {
        if (HasPermissionForURL(role, urlPath)) {
            return next();
        }
        else {
            logger.warn('Intento de acceso sin permisos a la api: (instancia) ' + vcc + ' (user) ' + userId + ' (url) ' + urlPath);
            res.sendStatus(403);
        }
    }).catch((err) => {
        logger.error('Error al procesar validar permisos de acceso: ' + err);
    });
}
exports.GrantAccess = GrantAccess;
function HasPermissionForURL(role, url) {
    let hasPermission = !!(role.routePermissions && role.routePermissions.find(routePermission => {
        return (routePermission.level === 'api' && routePermission.route &&
            (routePermission.route === url || (routePermission.route.endsWith('/') && url.startsWith(routePermission.route))));
    }));
    return hasPermission;
}
