////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Versión reescrita de esta librería, ya que la original usa sessvars.js que no funciona dentro de iframes que usen CORS //
// En la epoca que se hizo originalmente esta librería no estaba aun implementado el uso de localStorage en los browsers  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Inicializo el objeto inconcert
var inconcert = inconcert || {};

// Prefijo para las claves de localStorage a usar
const KEY_PREFIX = "__INCONCERT_STORAGE_";

// Inicializo interfaz para storage
inconcert.storage = {

	Setup: function() {
		// Nada para hacer...
	},
	
	Reset: function() {
        // Obtengo la lista de claves existentes
        var keys = Object.keys(localStorage);
        // Obtengo la cantidad de elementos
        var i = keys.length;
        // Recorro el array obtenido
        while (i-- ) {
            // Si la clave comienza con el prefijo la elimino
            if (keys[i] && keys[i].startsWith(KEY_PREFIX)) localStorage.removeItem(KEY_PREFIX + keys[i]);
        }
	},
	
	Put: function(key, value) {
        // Guardo el elemento en local storage
		localStorage.setItem(KEY_PREFIX + key, value);
	},
	
	Get: function(key) {
        // Devuelvo el elemento de local storage
		return localStorage.getItem(KEY_PREFIX + key);
	},
	
	Erase: function(key) {
        // Elimino el elemento de local storage
		localStorage.removeItem(KEY_PREFIX + key);
	}
};
