"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const logger_config_1 = require("../config/logger.config");
const log4js = require("log4js");
log4js.configure(logger_config_1.LOGGER_CONFIG);
let logger = log4js.getLogger('Task');
const findProcess = require("../shared/manager-process");
const schedule_task_1 = require("./schedule.task");
let listFilter;
findProcess.FindProcess('node')
    .then((list) => {
    let arrayPromise = [];
    let onProgress = false;
    let ubuntuNodeParentProcess = { name: 'sh', cmd: '/bin/sh -c node ' };
    let ubuntuNodeProcess = { name: 'node', cmd: 'node ' };
    let windowsNodeProcess = { name: 'node.exe', cmd: 'node  ' };
    let currentFileName = __filename.includes('\\') ? __filename.split('\\').pop() : __filename.split('/').pop();
    list = list.filter(e => e.cmd.includes(currentFileName));
    listFilter = list.filter((element) => {
        onProgress = ((element.name === windowsNodeProcess.name
            ||
                element.name === ubuntuNodeProcess.name)) ? true : false;
        if (onProgress && element && element.time > 7200) {
            logger.info('[FindProcess] DELETED', element.pid, element);
            arrayPromise.push(findProcess.KillTask(element.pid));
        }
        return onProgress;
    });
    logger.info('[FindProcess] total Task on progress', (listFilter && listFilter.length ? listFilter.length : 0));
    return Promise.all(arrayPromise);
}).then((result) => {
    if (listFilter && (listFilter.length === 0 || listFilter.length === 1)) {
        logger.info('[FindProcess] RUN');
        return schedule_task_1.InitTask();
    }
    else {
        logger.info('[FindProcess] CANCEL EXEC');
    }
    return Promise.resolve(true);
}).catch(err => {
    logger.error('[FindProcess] getting error:', err);
    return Promise.resolve(false);
});
