import { r as require$$0, a as require$$0$1, b as require$$4, c as require$$26, d as require$$19, e as require$$3, m as moment$3, f as require$$18, g as require$$25, l as lib, h as require$$45, i as md5, j as require$$1, v as validator$1, k as require$$14, n as require$$54, o as require$$24, p as require$$22, q as require$$52, s as require$$48, t as require$$47, u as require$$23, w as index_ngfactory, x as require$$50, y as require$$17 } from './app-form.modules.js?1714777503828';
import { e as en, a as es, f as fr, p as pt } from './app-form.languages.js?1714777503828';

var modal_service = {};

Object.defineProperty(modal_service, "__esModule", {
  value: true
});
modal_service.ModalService = void 0;
const tslib_1$s = require$$0;
const core_1$s = require$$0$1;
const rxjs_1$5 = require$$4;

let ModalService = /*@__PURE__*/(() => {
  let ModalService = class ModalService {
    constructor() {
      this.onOpen = new rxjs_1$5.Subject();
      this.onClose = new rxjs_1$5.Subject();
      this.onSubmit = new rxjs_1$5.Subject();
      this.modal = null;
    }

    Initialize(modal) {
      this.modal = modal;
    }

    GetModal() {
      return this.modal;
    }

    Open() {
      this.onOpen.next(null);
    }

    Close() {
      this.onClose.next(null);
    }

    Submit(returnValue) {
      this.onSubmit.next(returnValue);
    }

  };
  ModalService = tslib_1$s.__decorate([core_1$s.Injectable()], ModalService);
  return ModalService;
})();

modal_service.ModalService = ModalService;

var layout_service = {};

Object.defineProperty(layout_service, "__esModule", {
  value: true
});
layout_service.LayoutService = void 0;
const tslib_1$r = require$$0;
const core_1$r = require$$0$1;
const rxjs_1$4 = require$$4;

let LayoutService = /*@__PURE__*/(() => {
  let LayoutService = class LayoutService {
    constructor() {
      this.onScreenResize = new rxjs_1$4.Subject();
      this.onNavStaticToggle = new rxjs_1$4.Subject();
      this.onNavCollapsedToggle = new rxjs_1$4.Subject();
      this.onPinVisibleChange = new rxjs_1$4.Subject();
      this.screens = {
        'xs-max': 543,
        'sm-min': 544,
        'sm-max': 767,
        'md-min': 768,
        'md-max': 991,
        'lg-min': 992,
        'lg-max': 1199,
        'xl-min': 1200
      };
      this.screenSizeCallbacks = {
        xs: {
          enter: [],
          exit: []
        },
        sm: {
          enter: [],
          exit: []
        },
        md: {
          enter: [],
          exit: []
        },
        lg: {
          enter: [],
          exit: []
        },
        xl: {
          enter: [],
          exit: []
        }
      };
      this.navCollapseTimeout = 500;
      this.appForm = false;
      this.InitResizeEvent();
      this.InitOnScreenSizeCallbacks();
    }

    get pinVisible() {
      return this._pinVisible;
    }

    set pinVisible(value) {
      if (value !== this._pinVisible) {
        this._pinVisible = value;
        this.onPinVisibleChange.next(value);
      }
    }

    get navStatic() {
      return this._navStatic;
    }

    set navStatic(value) {
      if (value !== this._navStatic) {
        this._navStatic = value;
        this.onNavStaticToggle.next(value);
      }
    }

    get navCollapsed() {
      return this._navCollapsed;
    }

    set navCollapsed(value) {
      if (value !== this._navCollapsed) {
        this._navCollapsed = value;
        this.onNavCollapsedToggle.next(value);
      }

      if ((this.GetScreenSize() === 'xs' || this.GetScreenSize() === 'sm') && !this.navCollapsed) {
        jQuery('#sidebar').css('z-index', 2);
      } else {
        jQuery('#sidebar').css('z-index', '');
      }
    }

    SetFullPage(enabled) {
      let $body = jQuery('body');

      if (enabled) {
        $body.addClass('full-page');
      } else {
        $body.removeClass('full-page');
      }
    }

    InitResizeEvent() {
      jQuery(window).on('resize', () => {
        let screenSize = this.GetScreenSize();
        this.onScreenResize.next(screenSize);
      });
    }

    InitOnScreenSizeCallbacks() {
      let resizeTimeout;
      let prevSize = this.GetScreenSize();
      jQuery(window).resize(() => {
        clearTimeout(resizeTimeout);
        resizeTimeout = setTimeout(() => {
          let size = this.GetScreenSize();

          if (size !== prevSize) {
            this.screenSizeCallbacks[prevSize].exit.forEach(fn => {
              fn(size, prevSize);
            });
            this.screenSizeCallbacks[size].enter.forEach(fn => {
              fn(size, prevSize);
            });

            if ((size === 'xs' || size === 'sm') && !this.navCollapsed) {
              jQuery('#sidebar').css('z-index', 2);
            } else {
              jQuery('#sidebar').css('z-index', '');
            }
          }

          prevSize = size;
        }, 100);
      });
    }

    IsScreen(size) {
      let screenPx = window.innerWidth;
      return (screenPx >= this.screens[size + '-min'] || size === 'xs') && (screenPx <= this.screens[size + '-max'] || size === 'xl');
    }

    GetScreenSize() {
      let screenPx = window.innerWidth;

      if (screenPx <= this.screens['xs-max']) {
        return 'xs';
      }

      if (screenPx >= this.screens['sm-min'] && screenPx <= this.screens['sm-max']) {
        return 'sm';
      }

      if (screenPx >= this.screens['md-min'] && screenPx <= this.screens['md-max']) {
        return 'md';
      }

      if (screenPx >= this.screens['lg-min'] && screenPx <= this.screens['lg-max']) {
        return 'lg';
      }

      if (screenPx >= this.screens['xl-min']) {
        return 'xl';
      }

      return 'xl';
    }

    GetNavCollapseTimeout() {
      return this.navCollapseTimeout;
    }

  };
  LayoutService = tslib_1$r.__decorate([core_1$r.Injectable(), tslib_1$r.__metadata("design:paramtypes", [])], LayoutService);
  return LayoutService;
})();

layout_service.LayoutService = LayoutService;

var loading_service = {};

Object.defineProperty(loading_service, "__esModule", {
  value: true
});
loading_service.LoadingService = void 0;
const tslib_1$q = require$$0;
const core_1$q = require$$0$1;

let LoadingService = /*@__PURE__*/(() => {
  let LoadingService = class LoadingService {
    constructor() {
      this.loading = null;
    }

    Initialize(loading) {
      this.loading = loading;
    }

    Open() {
      this.loading.open();
    }

    Close() {
      this.loading.close();
    }

    IsOpened() {
      return this.loading && this.loading.isOpened() || false;
    }

  };
  LoadingService = tslib_1$q.__decorate([core_1$q.Injectable()], LoadingService);
  return LoadingService;
})();

loading_service.LoadingService = LoadingService;

var authGuard_service = {};

var authentication_service = {};

var env_config = {};

Object.defineProperty(env_config, "__esModule", {
  value: true
});
env_config.INCONCERT_APPS_BASE_URL = env_config.translateCategoryGeneral = env_config.CHECK_CLIENT_PERMISSIONS = env_config.Config = void 0;
env_config.Config = JSON.parse('{"API":"","CENTRALIZED_API":"","ENV":"PROD"}');
env_config.CHECK_CLIENT_PERMISSIONS = true;
env_config.translateCategoryGeneral = 'general';
env_config.INCONCERT_APPS_BASE_URL = 'http://38.127.113.216:8082/inconcert/apps';

var language_service = {};

Object.defineProperty(language_service, "__esModule", {
  value: true
});
language_service.LanguageService = void 0;
const tslib_1$p = require$$0;
const core_1$p = require$$0$1;
const rxjs_1$3 = require$$4;
const en_1 = en;
const es_1 = es;
const fr_1 = fr;
const pt_1 = pt;

let LanguageService = /*@__PURE__*/(() => {
  let LanguageService = class LanguageService {
    constructor() {
      this.suportedLanguages = ['es', 'en', 'pt', 'fr'];
      this.currentLanguage = this.GetBrowserLanguage();
      this.onLanguageChanged = new rxjs_1$3.Subject();
    }

    GetCurrentLanguage() {
      return this.currentLanguage;
    }

    SetCurrentLanguage(languageCode, get_from_browser = false) {
      if (get_from_browser) {
        this.currentLanguage = this.GetBrowserLanguage();
      } else {
        this.currentLanguage = languageCode || this.currentLanguage;
      }

      this.onLanguageChanged.next(this.currentLanguage);
    }

    GetMessage(category, message, language) {
      let categoryKey = category || '';
      let messageKey = message || '';
      if (typeof messageKey !== 'string') console.error(messageKey);
      messageKey = messageKey.toUpperCase();
      let resultLanguage = (language || this.currentLanguage).toLowerCase();

      switch (resultLanguage) {
        case 'es':
          if (es_1.es[categoryKey] && es_1.es[categoryKey][messageKey] !== undefined && es_1.es[categoryKey][messageKey] !== null) {
            return es_1.es[categoryKey][messageKey];
          } else if (es_1.es.general && es_1.es.general.hasOwnProperty(messageKey)) {
            return es_1.es.general[messageKey];
          }

          break;

        case 'pt':
          if (pt_1.pt[categoryKey] && pt_1.pt[categoryKey][messageKey] !== undefined && pt_1.pt[categoryKey][messageKey] !== null) return pt_1.pt[categoryKey][messageKey];
          break;

        case 'fr':
          if (fr_1.fr[categoryKey] && fr_1.fr[categoryKey][messageKey] !== undefined && fr_1.fr[categoryKey][messageKey] !== null) return fr_1.fr[categoryKey][messageKey];
          break;

        case 'en':
        default:
          if (en_1.en[categoryKey] && en_1.en[categoryKey][messageKey] !== undefined && en_1.en[categoryKey][messageKey] !== null) {
            return en_1.en[categoryKey][messageKey];
          } else if (en_1.en.general && en_1.en.general.hasOwnProperty(messageKey)) {
            return en_1.en.general[messageKey];
          }

          break;
      }

      return message;
    }

    GetCountryName(countryCode, language) {
      let category = 'isoCountries';
      return this.GetMessage(category, countryCode, language);
    }

    GetLanguageName(languageCode, language) {
      let category = 'isoLanguages';
      return this.GetMessage(category, languageCode.toUpperCase(), language);
    }

    GetMonths(language, firstLetterCapital) {
      let category = 'months';
      return [firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month1', language), firstLetterCapital) : this.GetMessage(category, 'month1', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month2', language), firstLetterCapital) : this.GetMessage(category, 'month2', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month3', language), firstLetterCapital) : this.GetMessage(category, 'month3', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month4', language), firstLetterCapital) : this.GetMessage(category, 'month4', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month5', language), firstLetterCapital) : this.GetMessage(category, 'month5', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month6', language), firstLetterCapital) : this.GetMessage(category, 'month6', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month7', language), firstLetterCapital) : this.GetMessage(category, 'month7', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month8', language), firstLetterCapital) : this.GetMessage(category, 'month8', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month9', language), firstLetterCapital) : this.GetMessage(category, 'month9', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month10', language), firstLetterCapital) : this.GetMessage(category, 'month10', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month11', language), firstLetterCapital) : this.GetMessage(category, 'month11', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'month12', language), firstLetterCapital) : this.GetMessage(category, 'month12', language)];
    }

    GetShortMonths(language, firstLetterCapital) {
      let category = 'shortMonths';
      return [firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth1', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth1', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth2', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth2', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth3', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth3', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth4', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth4', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth5', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth5', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth6', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth6', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth7', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth7', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth8', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth8', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth9', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth9', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth10', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth10', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth11', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth11', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'shortMonth12', language), firstLetterCapital) : this.GetMessage(category, 'shortMonth12', language)];
    }

    GetWeekDays(language, firstLetterCapital) {
      let category = 'weekDays';
      return [firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay1', language), firstLetterCapital) : this.GetMessage(category, 'weekDay1', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay2', language), firstLetterCapital) : this.GetMessage(category, 'weekDay2', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay3', language), firstLetterCapital) : this.GetMessage(category, 'weekDay3', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay4', language), firstLetterCapital) : this.GetMessage(category, 'weekDay4', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay5', language), firstLetterCapital) : this.GetMessage(category, 'weekDay5', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay6', language), firstLetterCapital) : this.GetMessage(category, 'weekDay6', language), firstLetterCapital !== undefined ? ConvertCase(this.GetMessage(category, 'weekDay7', language), firstLetterCapital) : this.GetMessage(category, 'weekDay7', language)];
    }

    GetHighchartsLogDateFormat(language) {
      let resultLanguage = (language || this.currentLanguage).toLowerCase();
      let format;

      switch (resultLanguage) {
        case 'es':
          format = '%A, %e de %B de %Y';
          break;

        case 'pt':
          format = '%A, %e de %B de %Y';
          break;

        case 'fr':
          format = '%A %e %B %Y';
          break;

        case 'en':
        default:
          format = '%A, %B %e, %Y';
          break;
      }

      return format;
    }

    GetBrowserLanguage() {
      let lang = navigator.language || navigator.userLanguage || navigator.browserLanguage || 'es';
      if (lang) lang = lang.slice(0, 2);
      if (!this.suportedLanguages.includes(lang)) lang = 'en';
      return lang;
    }

    GetGraphLanguage() {
      let resultLanguage = (this.GetBrowserLanguage() || this.currentLanguage).toLowerCase();

      switch (resultLanguage) {
        case 'es':
          if (es_1.es['languageGraph']) return es_1.es['languageGraph'];
          break;

        case 'pt':
          if (pt_1.pt['languageGraph']) return pt_1.pt['languageGraph'];
          break;

        case 'fr':
          if (fr_1.fr['languageGraph']) return fr_1.fr['languageGraph'];
          break;

        case 'en':
          if (en_1.en['languageGraph']) return en_1.en['languageGraph'];
          break;

        default:
          if (en_1.en['languageGraph']) return en_1.en['languageGraph'];
          break;
      }
    }

  };
  LanguageService = tslib_1$p.__decorate([core_1$p.Injectable()], LanguageService);
  return LanguageService;
})();

language_service.LanguageService = LanguageService;

function ConvertCase(input, firstLetterCapital) {
  if (firstLetterCapital) {
    return input.charAt(0).toUpperCase() + input.slice(1);
  } else {
    return input.toLowerCase();
  }
}

Object.defineProperty(authentication_service, "__esModule", {
  value: true
});
authentication_service.AuthenticationService = void 0;
const tslib_1$o = require$$0;
const core_1$o = require$$0$1;
const router_1$1 = require$$26;
const rxjs_1$2 = require$$4;
const operators_1$f = require$$3;
const moment$2 = moment$3.exports;
const http_1$e = require$$19;
const env_config_1$f = env_config;
const language_service_1$2 = language_service;
let jsEncrypt;

if (!jsEncrypt && window.CLIENT_DATA_PUBLIC_KEY) {
  jsEncrypt = new window.JSEncrypt();
  jsEncrypt.setKey(window.CLIENT_DATA_PUBLIC_KEY);
}

let AuthenticationService = /*@__PURE__*/(() => {
  let AuthenticationService = class AuthenticationService {
    constructor(activatedRoute, httpClient, languageService, router) {
      this.activatedRoute = activatedRoute;
      this.httpClient = httpClient;
      this.languageService = languageService;
      this.router = router;
      this.onSessionChanged = new rxjs_1$2.Subject();
      this.onUserUpdated = new rxjs_1$2.Subject();
      this.clientOffset = 0;

      try {
        this.session = localStorage.getItem('Session');
        this.loggedUser = JSON.parse(localStorage.getItem('LoggedUser'));
        this.loggedUserRole = JSON.parse(localStorage.getItem('LoggedUserRole'));
      } catch (err) {}

      this.InitializeTimezone();

      if (this.loggedUser && this.session) {
        this.languageService.SetCurrentLanguage(this.loggedUser.language, this.hasDefaultBrowserLanguage(this.loggedUser));
      } else {
        this.loggedUser = null;
        this.session = null;
        this.onSessionChanged.next(this.session);
        let localStorageKeys = ['Session', 'LoggedUser', 'LoggedUserRole', 'dataStorage', 'dataStudyStorage', 'CategoryDashboardComponent_filters', 'CampaignDashboardComponent_filters', 'AuditorInboxComponent_Interactions_filters', 'AuditorInboxComponent_Evaluations_filters', 'EvaluationComponent_Evaluations_filters', 'EvaluationComponent_Interactions_filters', 'AgentEvaluationComponent_Evaluations_filters', 'AgentEvaluationComponent_Interactions_filters', 'AdminEvaluationComponent_Evaluations_filters', 'AdminEvaluationComponent_Interactions_filters', 'AudioComponent_filters', 'Platform', 'VCC', 'transcriptions', 'nav-static'];
        this.removeLocalStorageKeys(localStorageKeys);
        this.router.navigate(['/login']);
      }
    }

    hasDefaultBrowserLanguage(loggedUser) {
      return ["admin"].includes(loggedUser.id) && loggedUser.isSystemUser;
    }

    Login(userId, password) {
      let loginData = {
        userId: userId,
        password: password
      };
      let url = env_config_1$f.Config.API + '/auth/login';
      let headers = new http_1$e.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(loginData);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.httpClient.post(url, body, options).pipe(operators_1$f.map(json => {
        if (json.data && json.data.session && json.data.loggedUser) {
          this.session = json.data.session;
          this.loggedUserRole = json.data.loggedUserRole;
          this.loggedUser = json.data.loggedUser;
          this.InitializeTimezone();
          this.onSessionChanged.next(this.session);
          this.languageService.SetCurrentLanguage(json.data.loggedUser.language, this.hasDefaultBrowserLanguage(json.data.loggedUser));
          localStorage.setItem('Session', json.data.session);
          localStorage.setItem('LoggedUser', JSON.stringify(json.data.loggedUser));
          localStorage.setItem('LoggedUserRole', JSON.stringify(json.data.loggedUserRole));
          return true;
        } else {
          return false;
        }
      }));
    }

    RequestPasswordReset(userId) {
      let bodyContent = {
        userId: userId
      };
      let url = env_config_1$f.Config.API + '/auth/request_password_reset';
      let headers = new http_1$e.HttpHeaders({
        'Content-Type': 'application/json',
        ...(sessionStorage.getItem('IsSystemRoute') === 'true' ? {
          'User-Instance': 'true'
        } : null)
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true,
        responseType: 'json'
      };
      return this.httpClient.post(url, body, options).pipe(operators_1$f.map(response => {
        return response.data;
      }));
    }

    TokenValid(token) {
      let bodyContent = {
        token: token
      };
      let url = env_config_1$f.Config.API + '/auth/token_valid';
      let headers = new http_1$e.HttpHeaders({
        'Content-Type': 'application/json',
        ...(sessionStorage.getItem('IsSystemRoute') === 'true' ? {
          'User-Instance': 'true'
        } : null)
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true,
        responseType: 'json'
      };
      return this.httpClient.post(url, body, options).pipe(operators_1$f.map(response => {
        return response.data;
      }));
    }

    ResetPassword(token, password) {
      let encryptedPassword = password ? this.EncryptClientString(password) : '';
      let bodyContent = {
        token: token,
        encryptedPassword: encryptedPassword
      };
      let url = env_config_1$f.Config.API + '/auth/reset_password';
      let headers = new http_1$e.HttpHeaders({
        'Content-Type': 'application/json',
        ...(sessionStorage.getItem('IsSystemRoute') === 'true' ? {
          'User-Instance': 'true'
        } : null)
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true,
        responseType: 'json'
      };
      return this.httpClient.post(url, body, options).pipe(operators_1$f.map(response => {
        return response.data;
      }));
    }

    Logout() {
      let session = localStorage.getItem('Session');
      if (!session) throw 'No stored session!';
      let logoutData = {
        session: session
      };
      let url = env_config_1$f.Config.API + '/auth/logout';
      let headers = {
        'Content-Type': 'application/json'
      };
      let body = JSON.stringify(logoutData);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.httpClient.post(url, body, options).pipe(operators_1$f.map(_ => {
        this.loggedUser = null;
        this.session = null;
        this.timeZone = null;
        this.clientOffset = 0;
        this.onSessionChanged.next(this.session);
        let localStorageKeys = ['Session', 'LoggedUser', 'LoggedUserRole', 'dataStorage', 'dataStudyStorage', 'CategoryDashboardComponent_filters', 'CampaignDashboardComponent_filters', 'AuditorInboxComponent_Interactions_filters', 'AuditorInboxComponent_Evaluations_filters', 'EvaluationComponent_Evaluations_filters', 'EvaluationComponent_Interactions_filters', 'AgentEvaluationComponent_Evaluations_filters', 'AgentEvaluationComponent_Interactions_filters', 'AdminEvaluationComponent_Evaluations_filters', 'AdminEvaluationComponent_Interactions_filters', 'AudioComponent_filters', 'Platform', 'VCC', 'transcriptions', 'nav-static'];
        this.removeLocalStorageKeys(localStorageKeys);
        return true;
      }));
    }

    GetUserSessionData() {
      let url = env_config_1$f.Config.API + '/auth/get_user_session_data';
      let headers = new http_1$e.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers,
        withCredentials: true
      };
      return this.httpClient.get(url, options).pipe(operators_1$f.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }));
    }

    UpdateLoggedUserData(session, loggedUser, loggedUserRole) {
      this.session = session;
      this.loggedUser = loggedUser;
      this.loggedUserRole = loggedUserRole;
      this.InitializeTimezone();
      this.languageService.SetCurrentLanguage(loggedUser.language, this.hasDefaultBrowserLanguage(loggedUser));
      localStorage.setItem('Session', session);
      localStorage.setItem('LoggedUser', JSON.stringify(loggedUser));
      localStorage.setItem('LoggedUserRole', JSON.stringify(loggedUserRole));
      this.onUserUpdated.next(this.loggedUser);
    }

    GetSession() {
      return this.session;
    }

    GetLoggedUser() {
      return this.loggedUser;
    }

    SetPlatform(platform) {
      localStorage.setItem('Platform', JSON.stringify(platform));
    }

    GetPlatform() {
      try {
        this.platform = JSON.parse(localStorage.getItem('Platform'));
      } catch (err) {}

      return this.platform;
    }

    SetVCC(VCC) {
      localStorage.setItem('VCC', JSON.stringify(VCC));
    }

    GetVCC() {
      try {
        this.vcc = JSON.parse(localStorage.getItem('VCC'));
      } catch (err) {}

      return this.vcc;
    }

    GetLoggedUserId() {
      return this.loggedUser ? this.loggedUser.id : null;
    }

    GetLoggedUserRole() {
      return this.loggedUserRole;
    }

    GetLoggedUserLanguage() {
      return this.loggedUser ? this.loggedUser.language : null;
    }

    GetTimeZone() {
      return this.timeZone;
    }

    GetClientOffset() {
      return this.clientOffset;
    }

    UserHasPermission(permission) {
      if (!env_config_1$f.CHECK_CLIENT_PERMISSIONS) return true;
      if (!permission || !this.loggedUserRole) return false;
      let rolePermissions = this.loggedUserRole.permissions || [];
      let hasPermission = !!(rolePermissions && rolePermissions.find(rolePermission => rolePermission.groupId === permission));
      return hasPermission;
    }

    UserHasRoutePermission(route) {
      if (!env_config_1$f.CHECK_CLIENT_PERMISSIONS) return true;
      if (!route || !this.loggedUserRole) return false;
      let routePath = route.join('/');
      let routePermissions = this.loggedUserRole.routePermissions || [];
      let hasPermission = !!(routePermissions && routePermissions.find(routePermission => {
        return routePermission.level === 'client' && routePermission.route && (routePermission.route === routePath || routePermission.route.endsWith('/') && routePath.startsWith(routePermission.route));
      }));
      return hasPermission;
    }

    UserHasPermissionGroup(group, action) {
      let group_view = `PERM_GROUP_${group}_VIEW`;
      let group_action = `PERM_GROUP_${group}_${action}`;
      let permissions_user = this.loggedUserRole.permissions || [];

      if (permissions_user.filter(x => x.groupId === group_view).length > 0) {
        if (group_view === group_action) return true;

        if (permissions_user.filter(x => x.groupId === group_action).length > 0) {
          return true;
        } else {
          return false;
        }
      } else {
        return false;
      }
    }

    InitializeTimezone() {
      this.timeZone = this.loggedUser && this.loggedUser.timeZone ? this.loggedUser.timeZone : moment$2.tz.guess();
      let zone = moment$2.tz.zone(this.timeZone);
      if (zone) this.clientOffset = -1 * zone.offset(moment$2());
    }

    ParseQuery(queryString) {
      let query = {};
      let pairs = (queryString[0] === '?' ? queryString.substr(1) : queryString).split('&');

      for (let i = 0; i < pairs.length; i++) {
        let pair = pairs[i].split('=');
        if (decodeURIComponent(pair[0])) query[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1] || '');
      }

      return query;
    }

    EncryptClientString(str) {
      let encryptedStr = '';

      if (!jsEncrypt && window.CLIENT_DATA_PUBLIC_KEY) {
        jsEncrypt = new window.JSEncrypt();
        jsEncrypt.setKey(window.CLIENT_DATA_PUBLIC_KEY);
      }

      if (!jsEncrypt) {
        console.error('Encryption library not initialized. Cannot encrypt data...');
        return encryptedStr;
      }

      if (!str) return encryptedStr;

      try {
        encryptedStr = jsEncrypt.encrypt(str) || '';
      } catch (err) {
        console.error('Error while trying to encrypt data...');
        console.error(err);
        encryptedStr = '';
      }

      return encryptedStr;
    }

    removeLocalStorageKeys(keys) {
      keys.forEach(key => {
        let lsKeysToRemove = Object.keys(localStorage).filter(k => k.startsWith(key));

        if (lsKeysToRemove?.length) {
          lsKeysToRemove.forEach(lsktr => {
            localStorage.removeItem(lsktr);
          });
        }
      });
    }

  };
  AuthenticationService = tslib_1$o.__decorate([core_1$o.Injectable(), tslib_1$o.__metadata("design:paramtypes", [router_1$1.ActivatedRoute, http_1$e.HttpClient, language_service_1$2.LanguageService, router_1$1.Router])], AuthenticationService);
  return AuthenticationService;
})();

authentication_service.AuthenticationService = AuthenticationService;

var localStorageHelper = {};

var search_component = {exports: {}};

var router_animation = {};

Object.defineProperty(router_animation, "__esModule", {
  value: true
});
router_animation.blurAnimation100 = router_animation.routerTransitionSupported = router_animation.SlideToTopAnimation = router_animation.SlideToBottomAnimation = router_animation.SlideToLeftAnimation = router_animation.SlideToRightAnimation = router_animation.BlurAnimation = void 0;
const animations_1$2 = require$$18;

function BlurAnimation(triggerName, delay) {
  delay = delay || 100;
  let timeMs = delay.toString() + 'ms';
  let blurPx = '5px';
  let opacityValue = '0.7';
  let auxWidth = 'calc(100% - 225px - 15px)';
  return animations_1$2.trigger(triggerName, [animations_1$2.state('void', animations_1$2.style({
    'position': 'fixed',
    'width': '100%'
  })), animations_1$2.state('*', animations_1$2.style({
    'position': 'inherit',
    'width': 'inherit'
  })), animations_1$2.transition(':enter', [animations_1$2.style({
    'position': 'fixed',
    'width': auxWidth,
    'filter': 'blur(' + blurPx + ')',
    'opacity': opacityValue
  }), animations_1$2.animate(timeMs + ' ' + timeMs + ' ease-in', animations_1$2.style({
    'position': 'fixed',
    'width': auxWidth,
    'filter': 'blur(0)',
    'opacity': '1'
  }))]), animations_1$2.transition(':leave', [animations_1$2.style({
    'position': 'fixed',
    'width': auxWidth,
    'filter': 'blur(0)',
    'opacity': '1'
  }), animations_1$2.animate(timeMs + ' ease-out', animations_1$2.style({
    'position': 'fixed',
    'width': auxWidth,
    'filter': 'blur(' + blurPx + ')',
    'opacity': opacityValue
  }))])]);
}

router_animation.BlurAnimation = BlurAnimation;

function SlideToRightAnimation(triggerName, delay) {
  delay = delay || 500;
  return animations_1$2.trigger(triggerName, [animations_1$2.state('void', animations_1$2.style({
    'position': 'fixed',
    'width': '100%'
  })), animations_1$2.state('*', animations_1$2.style({
    'position': 'fixed',
    'width': '100%'
  })), animations_1$2.transition(':enter', [animations_1$2.style({
    'transform': 'translateX(-100%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateX(0%)'
  }))]), animations_1$2.transition(':leave', [animations_1$2.style({
    'transform': 'translateX(0%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateX(100%)'
  }))])]);
}

router_animation.SlideToRightAnimation = SlideToRightAnimation;

function SlideToLeftAnimation(triggerName, delay) {
  delay = delay || 500;
  return animations_1$2.trigger(triggerName, [animations_1$2.state('void', animations_1$2.style({
    'position': 'fixed',
    'width': '100%'
  })), animations_1$2.state('*', animations_1$2.style({
    'position': 'fixed',
    'width': '100%'
  })), animations_1$2.transition(':enter', [animations_1$2.style({
    'transform': 'translateX(100%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateX(0%)'
  }))]), animations_1$2.transition(':leave', [animations_1$2.style({
    'transform': 'translateX(0%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateX(-100%)'
  }))])]);
}

router_animation.SlideToLeftAnimation = SlideToLeftAnimation;

function SlideToBottomAnimation(triggerName, delay) {
  delay = delay || 500;
  return animations_1$2.trigger(triggerName, [animations_1$2.state('void', animations_1$2.style({
    'position': 'fixed',
    'width': '100%',
    'height': '100%'
  })), animations_1$2.state('*', animations_1$2.style({
    'position': 'fixed',
    'width': '100%',
    'height': '100%'
  })), animations_1$2.transition(':enter', [animations_1$2.style({
    'transform': 'translateY(-100%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateY(0%)'
  }))]), animations_1$2.transition(':leave', [animations_1$2.style({
    'transform': 'translateY(0%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateY(100%)'
  }))])]);
}

router_animation.SlideToBottomAnimation = SlideToBottomAnimation;

function SlideToTopAnimation(triggerName, delay) {
  delay = delay || 500;
  return animations_1$2.trigger(triggerName, [animations_1$2.state('void', animations_1$2.style({
    'position': 'fixed',
    'width': '100%',
    'height': '100%'
  })), animations_1$2.state('*', animations_1$2.style({
    'position': 'fixed',
    'width': '100%',
    'height': '100%'
  })), animations_1$2.transition(':enter', [animations_1$2.style({
    'transform': 'translateY(100%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateY(0%)'
  }))]), animations_1$2.transition(':leave', [animations_1$2.style({
    'transform': 'translateY(0%)'
  }), animations_1$2.animate(delay.toString() + 'ms ease-in-out', animations_1$2.style({
    'transform': 'translateY(-100%)'
  }))])]);
}

router_animation.SlideToTopAnimation = SlideToTopAnimation;
router_animation.routerTransitionSupported = false ;
router_animation.blurAnimation100 = animations_1$2.trigger('routerTransition', [animations_1$2.state('void', animations_1$2.style({
  'position': 'fixed',
  'display': 'contents'
})), animations_1$2.state('*', animations_1$2.style({
  'position': 'inherit',
  'display': 'inherit'
})), animations_1$2.transition('void => true', [animations_1$2.style({
  'position': 'fixed',
  'display': 'contents',
  'opacity': '0.7'
}), animations_1$2.animate('100ms 100ms ease-in', animations_1$2.style({
  'position': 'fixed',
  'display': 'contents',
  'opacity': '1'
}))]), animations_1$2.transition('true => void', [animations_1$2.style({
  'position': 'fixed',
  'display': 'contents',
  'opacity': '1'
}), animations_1$2.animate('100ms ease-out', animations_1$2.style({
  'position': 'fixed',
  'display': 'contents',
  'opacity': '0.7'
}))])]);

var collapse_animation = {};

Object.defineProperty(collapse_animation, "__esModule", {
  value: true
});
collapse_animation.tableExpandAnimation200 = collapse_animation.tableExpandAnimation500 = collapse_animation.sectionExpandAnimation200 = collapse_animation.sectionExpandAnimation500 = collapse_animation.CollapseExpandAnimation = void 0;
const animations_1$1 = require$$18;

function CollapseExpandAnimation(triggerName, delay) {
  delay = delay || 500;
  return animations_1$1.trigger(triggerName, [animations_1$1.transition(':enter', [animations_1$1.style({
    'height': '0',
    'paddingBottom': '0',
    'paddingTop': '0',
    'opacity': '0',
    'overflow': 'hidden'
  }), animations_1$1.animate(delay.toString() + 'ms ease-in', animations_1$1.style({
    'height': '*',
    'paddingBottom': '*',
    'paddingTop': '*',
    'opacity': '1',
    'overflow': 'hidden'
  }))]), animations_1$1.transition(':leave', [animations_1$1.style({
    'height': '*',
    'paddingBottom': '*',
    'paddingTop': '*',
    'opacity': '1',
    'overflow': 'hidden'
  }), animations_1$1.animate(delay.toString() + 'ms ease-out', animations_1$1.style({
    'height': '0',
    'paddingBottom': '0',
    'paddingTop': '0',
    'opacity': '0',
    'overflow': 'hidden'
  }))])]);
}

collapse_animation.CollapseExpandAnimation = CollapseExpandAnimation;
collapse_animation.sectionExpandAnimation500 = animations_1$1.trigger('sectionExpand', [animations_1$1.transition(':enter', [animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}), animations_1$1.animate('500ms ease-in', animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}))]), animations_1$1.transition(':leave', [animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}), animations_1$1.animate('500ms ease-out', animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}))])]);
collapse_animation.sectionExpandAnimation200 = animations_1$1.trigger('sectionExpand', [animations_1$1.transition(':enter', [animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}), animations_1$1.animate('200ms ease-in', animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}))]), animations_1$1.transition(':leave', [animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}), animations_1$1.animate('200ms ease-out', animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}))])]);
collapse_animation.tableExpandAnimation500 = animations_1$1.trigger('tableExpand', [animations_1$1.transition(':enter', [animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}), animations_1$1.animate('500ms ease-in', animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}))]), animations_1$1.transition(':leave', [animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}), animations_1$1.animate('500ms ease-out', animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}))])]);
collapse_animation.tableExpandAnimation200 = animations_1$1.trigger('tableExpand', [animations_1$1.transition(':enter', [animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}), animations_1$1.animate('200ms ease-in', animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}))]), animations_1$1.transition(':leave', [animations_1$1.style({
  'height': '*',
  'paddingBottom': '*',
  'paddingTop': '*',
  'opacity': '1',
  'overflow': 'hidden'
}), animations_1$1.animate('200ms ease-out', animations_1$1.style({
  'height': '0',
  'paddingBottom': '0',
  'paddingTop': '0',
  'opacity': '0',
  'overflow': 'hidden'
}))])]);

var comboData_model = {};

Object.defineProperty(comboData_model, "__esModule", {
  value: true
});
comboData_model.ClearRepeatedElements = comboData_model.GetComboOptionById = comboData_model.ComboData = void 0;

class ComboData {
  constructor(value, description, icon = null, status = true, title) {
    this.value = value;
    this.description = description;
    this.icon = icon;
    this.status = status;
    this.title = title;
  }

  GetValueId(field) {
    return field && this.value && typeof this.value[field] === 'string' ? this.value[field] : this.value && typeof this.value === 'string' ? this.value : this.value && typeof this.value === 'number' ? this.value : (this.value || this.value === false) && typeof this.value === 'boolean' ? this.value : this.value && typeof this.value.id === 'string' ? this.value.id : null;
  }

  GetValueData(field) {
    return field && this.value && this.value[field] ? this.value[field] : null;
  }

}

comboData_model.ComboData = ComboData;

function GetComboOptionById(optionsList, optionId, optionIdFieldName) {
  return optionsList.find(item => {
    return (item.value || item.value === false || item.value === null && optionId === null) && (typeof item.value === typeof optionId && item.value === optionId || typeof item.value === typeof optionId && typeof item.value === 'object' && JSON.stringify(item.value) === JSON.stringify(optionId) || typeof item.GetValueId() === typeof optionId && item.GetValueId() === optionId && item.GetValueId() || optionIdFieldName && typeof item.value[optionIdFieldName] === typeof optionId && item.value[optionIdFieldName] === optionId);
  }) || null;
}

comboData_model.GetComboOptionById = GetComboOptionById;

function ClearRepeatedElements(optionsList) {
  var hashes = {};
  return optionsList.filter(function (el) {
    var key = JSON.stringify(el);
    var match = Boolean(hashes[key]);
    return match ? false : hashes[key] = true;
  });
}

comboData_model.ClearRepeatedElements = ClearRepeatedElements;

var stringsHelper = {};

Object.defineProperty(stringsHelper, "__esModule", {
  value: true
});
stringsHelper.splitUrlPage = stringsHelper.addPointsValue = stringsHelper.ValidateNumericString = void 0;

function ValidateNumericString(event) {
  const charCode = event.which ? event.which : event.keyCode;

  if (charCode > 31 && (charCode < 48 || charCode > 57)) {
    return false;
  }

  return true;
}

stringsHelper.ValidateNumericString = ValidateNumericString;

const addPointsValue = (value, length = 30) => value.length > 30 ? `${value.substring(0, length)}...` : value;

stringsHelper.addPointsValue = addPointsValue;

const splitUrlPage = (url, step = null) => {
  const arraySpeechanalytic = url.split('speechanalytic/');
  let arraySections = arraySpeechanalytic[1].split('/');
  if (step) arraySections.unshift(`step-${step}`);
  let urlStorage = arraySections.join('/');

  if (arraySections.length === 6 && arraySections[3] === 'utterance') {
    arraySections = arraySections.slice(0, 4);
    urlStorage = arraySections.join('/');
  } else if (arraySections.length === 4 && arraySections[2] === 'intent') {
    arraySections = arraySections.slice(0, 3);
    urlStorage = arraySections.join('/');
  } else if (arraySections.length === 5 && arraySections[2] === 'interactions') {
    arraySections = arraySections.slice(0, 3);
    urlStorage = arraySections.join('/');
  } else if (arraySections.length === 4 && arraySections[2] === 'entity') {
    arraySections = arraySections.slice(0, 3);
    urlStorage = arraySections.join('/');
  } else if (arraySections.length === 5 && arraySections[1] === 'process') {
    arraySections = arraySections.slice(0, 3);
    urlStorage = arraySections.join('/');
  }

  return urlStorage;
};

stringsHelper.splitUrlPage = splitUrlPage;

var datetime_service = {};

Object.defineProperty(datetime_service, "__esModule", {
  value: true
});
datetime_service.DatetimeService = void 0;
const tslib_1$n = require$$0;
const core_1$n = require$$0$1;
const moment$1 = moment$3.exports;
const authentication_service_1$2 = authentication_service;

let DatetimeService = /*@__PURE__*/(() => {
  let DatetimeService = class DatetimeService {
    constructor(authenticationService) {
      this.authenticationService = authenticationService;
      moment$1.tz.setDefault(this.authenticationService.GetTimeZone());
      moment$1.locale(this.authenticationService.GetLoggedUserLanguage());
    }

    NgbDateStructToDate(ngbDate, asLocalDate, endOfDay) {
      if (!ngbDate) return null;
      let objDate = {
        year: ngbDate.year,
        month: ngbDate.month - 1,
        day: ngbDate.day,
        hour: 0,
        minute: 0,
        second: 0
      };
      let momentDate = asLocalDate ? moment$1(objDate) : moment$1.utc(objDate);
      if (endOfDay) momentDate = momentDate.endOf('day');
      return momentDate.isValid() ? momentDate.toDate() : null;
    }

    NgbDateTimeStructToDate(ngbDate, ngbTime, asLocalDate) {
      if (!ngbDate || !ngbTime) return null;
      let objDate = {
        year: ngbDate.year,
        month: ngbDate.month - 1,
        day: ngbDate.day,
        hour: ngbTime.hour,
        minute: ngbTime.minute,
        second: ngbTime.second
      };
      let momentDate = asLocalDate ? moment$1(objDate) : moment$1.utc(objDate);
      return momentDate.isValid() ? momentDate.toDate() : null;
    }

    DateToNgbDateStruct(date, asLocalDate) {
      if (!date || !(date instanceof Date)) return null;
      let momentDate = asLocalDate ? moment$1(date) : moment$1.utc(date);
      return {
        year: momentDate.year(),
        month: momentDate.month() + 1,
        day: momentDate.date()
      };
    }

    DateToNgbTimeStruct(date, asLocalDate) {
      if (!date || !(date instanceof Date)) return null;
      let momentDate = asLocalDate ? moment$1(date) : moment$1.utc(date);
      return {
        hour: momentDate.hour(),
        minute: momentDate.minute(),
        second: momentDate.second()
      };
    }

  };
  DatetimeService = tslib_1$n.__decorate([core_1$n.Injectable(), tslib_1$n.__metadata("design:paramtypes", [authentication_service_1$2.AuthenticationService])], DatetimeService);
  return DatetimeService;
})();

datetime_service.DatetimeService = DatetimeService;

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SearchComponent = exports.kEY_SEARCH_STORAGE = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const router_animation_1 = router_animation;
  const collapse_animation_1 = collapse_animation;
  const combo_data_model_1 = comboData_model;
  const router_1 = require$$26;
  const strings_helper_1 = stringsHelper;
  const localStorage_helper_1 = localStorageHelper;
  const moment = moment$3.exports;
  const datetime_service_1 = datetime_service;
  exports.kEY_SEARCH_STORAGE = 'Search';

  let SearchComponent = /*@__PURE__*/(() => {
    let SearchComponent = class SearchComponent {
      constructor(router, datetimeService) {
        this.router = router;
        this.datetimeService = datetimeService;
        this.refreshSearchParent = new core_1.EventEmitter();
        this.clearSearchParent = new core_1.EventEmitter();
        this.disabled = undefined;
        this.disabledChangeParent = new core_1.EventEmitter();
        this.searchExpression = '';
        this.searchExpressionChange = new core_1.EventEmitter();
        this.searchCriteria = undefined;
        this.searchCriteriaOptions = [];
        this.SetCustomFieldSearchCriteriaParent = new core_1.EventEmitter();
        this.selectedFilterStartDate = undefined;
        this.selectedFilterEndDate = undefined;
        this.translateCategory = '';
        this.SetFilterStartDateParent = new core_1.EventEmitter();
        this.SetFilterEndDateParent = new core_1.EventEmitter();
        this.step = null;
        this.visibilityPopOverFilter = true;
        this.selectedFilterStartDateBadge = undefined;
        this.selectedFilterEndDateBadge = undefined;
      }

      ngOnInit() {}

      ngAfterViewInit() {
        const url = strings_helper_1.splitUrlPage(this.router.url, this.step);
        let searchStorage = localStorage_helper_1.getLocalStorage(exports.kEY_SEARCH_STORAGE);

        if (searchStorage && JSON.parse(searchStorage)[url]) {
          const {
            search,
            disabled,
            selectedFilterEndDate,
            selectedFilterStartDate,
            dropDownSearchCriteria
          } = JSON.parse(searchStorage)[url];
          const optionSearch = this.searchCriteriaOptions.find(item => item.value === dropDownSearchCriteria);
          this.searchExpression = search;
          this.searchCriteria = optionSearch || this.searchCriteriaOptions[0] || null;
          this.selectedFilterStartDate = selectedFilterStartDate;
          this.selectedFilterEndDate = selectedFilterEndDate;

          if (this.selectedFilterEndDate || this.selectedFilterStartDate) {
            this.selectedFilterStartDateBadge = selectedFilterStartDate;
            this.selectedFilterEndDateBadge = selectedFilterEndDate;
          }

          this.disabled = disabled;
          this.SetFilterEndDate(this.selectedFilterEndDate || null);
          this.SetFilterStartDate(this.selectedFilterStartDate || null);
          this.SetCustomFieldSearchCriteria(this.searchCriteria);
          this.DisabledChange(this.disabled);
        }

        this.RefreshSearch(true);
      }

      ClearSerachPopUp() {
        this.selectedFilterStartDateBadge = null;
        this.selectedFilterEndDateBadge = null;
        this.selectedFilterStartDate = null;
        this.selectedFilterEndDate = null;
        this.SetFilterEndDateParent.emit(null);
        this.SetFilterStartDateParent.emit(null);
        this.addStorage();
        this.clearSearchParent.emit();
      }

      SetFilterEndDate(date) {
        this.SetFilterEndDateParent.emit(date);
      }

      SetFilterStartDate(date) {
        this.SetFilterStartDateParent.emit(date);
      }

      ToggleDatePicker(toShow, toHide) {
        if (toHide.isOpen()) {
          toHide.close();
        }

        toShow.toggle();
      }

      SetCustomFieldSearchCriteria(option) {
        this.SetCustomFieldSearchCriteriaParent.emit(option);
      }

      DisabledChange(disabled) {
        this.disabledChangeParent.emit(disabled);
      }

      ClearSearch() {
        this.searchExpression = '';
        if (this.disabled != undefined) this.disabled = false;
        this.selectedFilterStartDateBadge = null;
        this.selectedFilterEndDateBadge = null;
        this.selectedFilterStartDate = null;
        this.selectedFilterEndDate = null;
        this.searchExpressionChange.emit(this.searchExpression);
        this.SetFilterEndDateParent.emit(null);
        this.SetFilterStartDateParent.emit(null);
        this.addStorage();
        this.clearSearchParent.emit();
      }

      addStorage() {
        const url = strings_helper_1.splitUrlPage(this.router.url, this.step);
        let searchStorage = localStorage_helper_1.getLocalStorage(exports.kEY_SEARCH_STORAGE);
        let filters = {
          search: this.searchExpression,
          dropDownSearchCriteria: this.searchCriteria?.value || null,
          disabled: this.disabled,
          selectedFilterStartDate: this.selectedFilterStartDate,
          selectedFilterEndDate: this.selectedFilterEndDate
        };
        localStorage_helper_1.saveStorageGeneric({
          searchStorage,
          url,
          filters
        });
      }

      RefreshSearchPopup() {
        this.selectedFilterStartDateBadge = JSON.parse(JSON.stringify(this.selectedFilterStartDate));
        this.selectedFilterEndDateBadge = JSON.parse(JSON.stringify(this.selectedFilterEndDate));
        this.RefreshSearch();
      }

      RefreshSearch(eventActiveByStorage = null) {
        this.searchExpression = this.searchExpression ? this.searchExpression.trim() : '';
        this.addStorage();
        this.searchExpressionChange.emit(this.searchExpression);
        this.refreshSearchParent.emit(eventActiveByStorage);
      }

      SetDate(date) {
        return moment(this.datetimeService.NgbDateStructToDate(date, true, false)).format('YYYY-MM-DD');
      }

      ClearStartDate() {
        this.selectedFilterStartDate = null;
        this.selectedFilterStartDateBadge = null;
        this.SetFilterStartDate(null);
        this.RefreshSearch();
      }

      ClearEndDate() {
        this.selectedFilterEndDate = null;
        this.selectedFilterEndDateBadge = null;
        this.SetFilterEndDate(null);
        this.RefreshSearch();
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", core_1.TemplateRef)], SearchComponent.prototype, "templateAdditional", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "refreshSearchParent", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "clearSearchParent", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComponent.prototype, "disabled", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "disabledChangeParent", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComponent.prototype, "searchExpression", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "searchExpressionChange", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", combo_data_model_1.ComboData)], SearchComponent.prototype, "searchCriteria", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], SearchComponent.prototype, "searchCriteriaOptions", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "SetCustomFieldSearchCriteriaParent", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "selectedFilterStartDate", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "selectedFilterEndDate", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComponent.prototype, "translateCategory", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "SetFilterStartDateParent", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], SearchComponent.prototype, "SetFilterEndDateParent", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComponent.prototype, "step", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComponent.prototype, "popOverFilter", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComponent.prototype, "visibilityPopOverFilter", void 0);

    SearchComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'search',
      templateUrl: 'search.component.html',
      styleUrls: [],
      animations: [collapse_animation_1.sectionExpandAnimation500, collapse_animation_1.sectionExpandAnimation200, router_animation_1.blurAnimation100]
    }), tslib_1.__metadata("design:paramtypes", [router_1.Router, datetime_service_1.DatetimeService])], SearchComponent);
    return SearchComponent;
  })();

  exports.SearchComponent = SearchComponent;
})(search_component, search_component.exports);

(function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.setOrderStorageGeneric = exports.saveOrderStorageGeneric = exports.SaveStorageDataFilter = exports.GetStorageDataFilters = exports.getLocalStorage = exports.saveLocalStorage = exports.saveStorageGeneric = exports.removeLocalStorageKeys = exports.NAMES_STORAGE_FILTERS = void 0;
  const search_component_1 = search_component.exports;
  exports.NAMES_STORAGE_FILTERS = {
    CREATEPLAN_FILTERS: 'CreatePlan_filters',
    AUDITORINBOXCOMPONENT_INTERACTIONS_FILTERS: 'AuditorInboxComponent_Interactions_filters',
    AUDITORINBOXCOMPONENT_EVALUATIONS_FILTERS: 'AuditorInboxComponent_Evaluations_filters',
    TEAMPERFORMANCEAGENTCOMPONENT_FILTERS: 'TeamPerformanceAgentComponent_filters',
    EVALUATIONCOMPONENT_EVALUATIONS_FILTERS: 'EvaluationComponent_Evaluations_filters',
    EVALUATIONCOMPONENT_INTERACTIONS_FILTERS: 'EvaluationComponent_Interactions_filters',
    AGENTEVALUATIONCOMPONENT_INTERACTIONS_FILTERS: 'AgentEvaluationComponent_Interactions_filters',
    AGENTEVALUATIONCOMPONENT_EVALUATIONS_FILTERS: 'AgentEvaluationComponent_Evaluations_filters',
    ADMINEVALUATIONCOMPONENT_EVALUATIONS_FILTERS: 'AdminEvaluationComponent_Evaluations_filters',
    ADMINEVALUATIONCOMPONENT_INTERACTIONS_FILTERS: 'AdminEvaluationComponent_Interactions_filters',
    PROCESSADDCOMPONENT_FILTERS: 'ProcessAddComponent_filters',
    REPORT_BY_SUMMARY_AGENT_FILTERS: 'ReportBySummaryAgent_filters',
    REPORT_BY_DETAIL_AGENT_FILTERS: 'ReportByDetailAgent_filters',
    GLOBAL_SEARCH: 'GlobalSearch_filters',
    BILLIN_GRAPHI_FILTERS: 'BillinGraphicComponent_filters',
    CATEGORY_DASHBOARD_FILTERS: 'CategoryDashboardComponent_filters',
    CAMPAING_DASHBOARD_FILTERS: 'CampaignDashboardComponent_filters'
  };

  function removeLocalStorageKeys(keys) {
    keys.forEach(key => {
      let lsKeysToRemove = Object.keys(localStorage).filter(k => k.startsWith(key));

      if (lsKeysToRemove?.length) {
        lsKeysToRemove.forEach(lsktr => {
          localStorage.removeItem(lsktr);
        });
      }
    });
  }

  exports.removeLocalStorageKeys = removeLocalStorageKeys;

  const saveStorageGeneric = ({
    searchStorage,
    url,
    filters
  }) => {
    if (!searchStorage) {
      exports.saveLocalStorage(search_component_1.kEY_SEARCH_STORAGE, JSON.stringify({
        [url]: filters
      }));
    } else {
      searchStorage = JSON.parse(searchStorage);
      if (searchStorage[url]) searchStorage[url] = { ...searchStorage[url],
        ...filters
      };else searchStorage[url] = filters;
      exports.saveLocalStorage(search_component_1.kEY_SEARCH_STORAGE, JSON.stringify(searchStorage));
    }
  };

  exports.saveStorageGeneric = saveStorageGeneric;

  const saveLocalStorage = (key, value) => {
    localStorage.setItem(key, value);
  };

  exports.saveLocalStorage = saveLocalStorage;

  const getLocalStorage = key => localStorage.getItem(key) || undefined;

  exports.getLocalStorage = getLocalStorage;

  const GetStorageDataFilters = (constructorName, tabName = '') => {
    let resultStorageData = null;
    const tabNameStorage = tabName ? '_' + tabName : '';
    let storageData = localStorage.getItem(constructorName + tabNameStorage + '_filters');

    if (storageData) {
      resultStorageData = JSON.parse(storageData);
    }

    return resultStorageData;
  };

  exports.GetStorageDataFilters = GetStorageDataFilters;

  const SaveStorageDataFilter = (storageData, constructorName, tabName = '') => {
    const tabNameStorage = tabName ? '_' + tabName : '';
    exports.saveLocalStorage(constructorName + tabNameStorage + '_filters', JSON.stringify(storageData));
  };

  exports.SaveStorageDataFilter = SaveStorageDataFilter;

  const saveOrderStorageGeneric = (url, order) => {
    let searchStorage = exports.getLocalStorage(search_component_1.kEY_SEARCH_STORAGE);
    searchStorage = JSON.parse(searchStorage);

    if (searchStorage[url]) {
      const dataFilter = searchStorage[url];
      searchStorage[url] = { ...dataFilter,
        order
      };
      exports.saveLocalStorage(search_component_1.kEY_SEARCH_STORAGE, JSON.stringify(searchStorage));
    }
  };

  exports.saveOrderStorageGeneric = saveOrderStorageGeneric;

  const setOrderStorageGeneric = url => {
    let searchStorage = exports.getLocalStorage(search_component_1.kEY_SEARCH_STORAGE);
    if (!searchStorage) return null;
    searchStorage = JSON.parse(searchStorage);

    if (searchStorage[url]) {
      return searchStorage[url].order || null;
    }

    return null;
  };

  exports.setOrderStorageGeneric = setOrderStorageGeneric;
})(localStorageHelper);

Object.defineProperty(authGuard_service, "__esModule", {
  value: true
});
authGuard_service.AuthPasswordResetGuardService = authGuard_service.AuthGuardService = void 0;
const tslib_1$m = require$$0;
const core_1$m = require$$0$1;
const router_1 = require$$26;
const angular2_notifications_1 = require$$25;
const rxjs_1$1 = require$$4;
const operators_1$e = require$$3;
const jwtDecode = lib.exports;
const authentication_service_1$1 = authentication_service;
const language_service_1$1 = language_service;
const localStorage_helper_1 = localStorageHelper;
const layout_service_1$1 = layout_service;

let AuthGuardService = /*@__PURE__*/(() => {
  let AuthGuardService = class AuthGuardService {
    constructor(activatedRoute, authenticationService, languageService, notificationsService, layoutService, router) {
      this.activatedRoute = activatedRoute;
      this.authenticationService = authenticationService;
      this.languageService = languageService;
      this.notificationsService = notificationsService;
      this.layoutService = layoutService;
      this.router = router;
      this.translateCategory = 'auth';
      this.isSystemRoute = false;
      this.isSettingsRoute = false;
    }

    canActivate(route, state) {
      let urlSessionRegexp = /[?&#]?(?:session|token)=([^?&#]+)&*/.exec(window.location.search || '');
      let fromUrlSessionToken = urlSessionRegexp && urlSessionRegexp.length > 1 ? decodeURIComponent(urlSessionRegexp[1]) : null;
      let cookieSession = localStorage.getItem('Session');
      let session = cookieSession || fromUrlSessionToken;
      let sessionDecoded = null;
      let sessionValid = this.validateSessionExpired(localStorage.getItem('Session'));

      try {
        if (session) sessionDecoded = jwtDecode(session);

        if (sessionDecoded && !sessionDecoded.exp) {
          sessionValid = true;
        } else if (sessionDecoded && sessionDecoded.exp) {
          let currentDate = new Date();
          let expirationDate = new Date(0);
          expirationDate.setUTCSeconds(sessionDecoded.exp);
          if (expirationDate.valueOf() > currentDate.valueOf()) sessionValid = true;
        }
      } catch (e) {}

      if (!sessionValid && session && fromUrlSessionToken && session !== fromUrlSessionToken) {
        session = fromUrlSessionToken;
        localStorage.setItem('Session', fromUrlSessionToken);

        try {
          sessionDecoded = jwtDecode(session);

          if (sessionDecoded && !sessionDecoded.exp) {
            sessionValid = true;
          } else if (sessionDecoded && sessionDecoded.exp) {
            let currentDate = new Date();
            let expirationDate = new Date(0);
            expirationDate.setUTCSeconds(sessionDecoded.exp);
            if (expirationDate.valueOf() > currentDate.valueOf()) sessionValid = true;
          }
        } catch (e) {}
      }

      if (!sessionValid) {
        let isLogin = /^\/?(form-login|login)$/.test(window.location.pathname);
        if (!isLogin) this.router.navigate(['/login'], {
          relativeTo: this.activatedRoute,
          queryParams: {
            redirect: state.url || window.location.pathname
          }
        });
        return false;
      }

      let urlRoute = state.url.split('?')[0].split('/');
      if (urlRoute.length > 0 && urlRoute[0] === '') urlRoute.splice(0, 1);
      this.isSystemRoute = !!(route.data && route.data.isSystemRoute) || urlRoute[0] === 'system';
      if (this.isSystemRoute) sessionStorage.setItem('IsSystemRoute', this.isSystemRoute.toString());else sessionStorage.removeItem('IsSystemRoute');
      this.isSettingsRoute = !!(route.data && route.data.isSettingsRoute) || urlRoute[0] === 'settings';
      if (this.isSettingsRoute) sessionStorage.setItem('IsSettingsRoute', this.isSettingsRoute.toString());else sessionStorage.removeItem('IsSettingsRoute');

      if (urlRoute.length > 0 && urlRoute[urlRoute.length - 1] === 'forbidden') {
        return true;
      }

      if (fromUrlSessionToken && fromUrlSessionToken === session && !cookieSession) {
        localStorage.setItem('Session', fromUrlSessionToken);
      }

      if (!this.authenticationService.UserHasRoutePermission(urlRoute) && !fromUrlSessionToken) {
        if (this.layoutService.appForm) {
          this.router.navigate(['/form/forbidden']);
        } else {
          this.router.navigate(['/speechanalytic/forbidden']);
        }

        return false;
      }

      return true;
    }

    validateSessionExpired(session) {
      let sessionDecoded = null;
      let sessionValid = false;
      if (session) sessionDecoded = jwtDecode(session);

      if (sessionDecoded && !sessionDecoded.exp) {
        sessionValid = true;
      } else if (sessionDecoded && sessionDecoded.exp) {
        let currentDate = new Date();
        let expirationDate = new Date(0);
        expirationDate.setUTCSeconds(sessionDecoded.exp);
        if (expirationDate.valueOf() > currentDate.valueOf()) sessionValid = true;
      }

      return sessionValid;
    }

    HandleError(err) {
      let errMsg = typeof err === 'string' ? err : err.message || err.description || this.languageService.GetMessage(this.translateCategory, 'CONNECTION_ERROR');

      if (err.status === 401) {
        let localStorageKeys = ['Session', 'LoggedUser', 'LoggedUserRole', 'dataStorage', 'dataStudyStorage', 'CategoryDashboardComponent_filters', 'CampaignDashboardComponent_filters', 'AuditorInboxComponent_Interactions_filters', 'AuditorInboxComponent_Evaluations_filters', 'EvaluationComponent_Evaluations_filters', 'EvaluationComponent_Interactions_filters', 'AgentEvaluationComponent_Evaluations_filters', 'AgentEvaluationComponent_Interactions_filters', 'AdminEvaluationComponent_Evaluations_filters', 'AdminEvaluationComponent_Interactions_filters', 'AudioComponent_filters', 'Platform', 'VCC', 'transcriptions', 'nav-static'];
        localStorage_helper_1.removeLocalStorageKeys(localStorageKeys);
        this.router.navigate(['/login']);
        errMsg = this.languageService.GetMessage(this.translateCategory, 'SESSION_LOST');
        setTimeout(function (context) {
          context.notificationsService.remove();
          context.notificationsService.alert(context.languageService.GetMessage(context.translateCategory, 'WARNING'), errMsg);
        }, 100, this);
      }

      if (err.status === 403) {
        errMsg = this.languageService.GetMessage(this.translateCategory, 'USER_HAS_NOT_PERSMISSIONS');
        console.error(`Error on ${err.url}`);
        this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'WARNING'), errMsg);
      }

      return rxjs_1$1.throwError(errMsg);
    }

  };
  AuthGuardService = tslib_1$m.__decorate([core_1$m.Injectable(), tslib_1$m.__metadata("design:paramtypes", [router_1.ActivatedRoute, authentication_service_1$1.AuthenticationService, language_service_1$1.LanguageService, angular2_notifications_1.NotificationsService, layout_service_1$1.LayoutService, router_1.Router])], AuthGuardService);
  return AuthGuardService;
})();

authGuard_service.AuthGuardService = AuthGuardService;

let AuthPasswordResetGuardService = /*@__PURE__*/(() => {
  let AuthPasswordResetGuardService = class AuthPasswordResetGuardService {
    constructor(authService, router) {
      this.authService = authService;
      this.router = router;
    }

    canActivate(route, state) {
      this.token = route.params['token'];
      return this.authService.TokenValid(this.token).pipe(operators_1$e.map(e => {
        if (e) return true;
        return false;
      }), operators_1$e.catchError(err => {
        this.router.navigate(['/login']);
        return rxjs_1$1.of(false);
      }));
    }

  };
  AuthPasswordResetGuardService = tslib_1$m.__decorate([core_1$m.Injectable(), tslib_1$m.__metadata("design:paramtypes", [authentication_service_1$1.AuthenticationService, router_1.Router])], AuthPasswordResetGuardService);
  return AuthPasswordResetGuardService;
})();

authGuard_service.AuthPasswordResetGuardService = AuthPasswordResetGuardService;

var navigateGuard_service = {};

var skin_service = {};

(function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SkinService = exports.DAHOOX_ENABLED = exports.FRONTEND_SKIN = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const router_1 = require$$26;
  const rxjs_1 = require$$4;
  const modal_service_1 = modal_service;
  exports.FRONTEND_SKIN = 'occ';
  exports.DAHOOX_ENABLED = false;

  let SkinService = /*@__PURE__*/(() => {
    let SkinService = class SkinService {
      constructor(router, modalService) {
        this.router = router;
        this.modalService = modalService;
        this.skin = exports.FRONTEND_SKIN || 'occ';
        this.dahoox = !!exports.DAHOOX_ENABLED;
        this.isMobile = this.GetIsMobile();
        this.isResizeMobile = new rxjs_1.Subject();
        this.isApp = true;
        this.keyboardHeight = 0;
        this.onSkinDataUpdated = new rxjs_1.Subject();
        this.onAndroidBackButtonPressed = new rxjs_1.Subject();
        this.isKeyboardUp = new rxjs_1.BehaviorSubject(false);
        this.InitIsDeviceEvent();
      }

      GetSkin() {
        return this.skin;
      }

      DaHooxEnabled() {
        return this.dahoox;
      }

      IsKeyboardUp() {
        return this.isKeyboardUp.value;
      }

      GetKeyboardHeight() {
        return this.keyboardHeight;
      }

      InitIsDeviceEvent() {
        jQuery(window).on('resize', () => {
          let isMobile = this.GetScreenIsDevice();
          this.isResizeMobile.next(isMobile);
        });
      }

      GetScreenIsDevice() {
        const ua = navigator.userAgent;

        if (/(tablet|ipad|playbook|silk)|(android(?!.*mobi))/i.test(ua) || /Mobile|Android|iP(hone|od)|IEMobile|BlackBerry|Kindle|Silk-Accelerated|(hpw|web)OS|Opera M(obi|ini)/.test(ua)) {
          return true;
        }

        return false;
      }

      GetInitialSkin() {
        return exports.FRONTEND_SKIN;
      }

      GetInitialDaHoox() {
        return exports.DAHOOX_ENABLED;
      }

      SetFrontendSkin(skin) {
        this.skin = skin;
      }

      SetDahooxEnabled(dahoox) {
        this.dahoox = dahoox;
      }

      UpdateSkinData(skin, dahoox) {
        if (this.skin === skin && this.dahoox === !!dahoox) return;
        this.skin = skin || 'occ';
        this.dahoox = !!dahoox;
        let links = document.head.getElementsByTagName('link');
        let skinLink;
        let faviconLink;

        for (let i = 0, linksLength = links.length; i < linksLength; i++) {
          let href = links[i] && links[i].href || '';

          if (href.match(/\/skin-main-(.*)\.css/)) {
            skinLink = links[i];
            break;
          }
        }

        for (let j = 0, linksLength = links.length; j < linksLength; j++) {
          let rel = links[j] && links[j].rel || '';
          let type = links[j] && links[j].type || '';

          if (rel === 'icon' && type === 'image/x-icon') {
            faviconLink = links[j];
            break;
          }
        }

        document.title = this.GetSkinTitle();
        if (skinLink) skinLink.href = this.GetSkinCssUrl();
        if (faviconLink) faviconLink.href = this.GetSkinFaviconUrl();
        let bodyClass = document.body.getAttribute('class') || '';
        document.body.setAttribute('class', (bodyClass.replace(/skin-\w+/g, '').replace(/\s+/g, ' ') + ' ' + this.GetSkinClass()).trim());
        let currentUrl = (this.router.url || '/').split('?')[0];
        this.router.navigate(['/']);
        setTimeout(function () {
          this.router.navigate([currentUrl]);
        }.bind(this), 500);
        this.onSkinDataUpdated.next({
          skin: this.skin,
          dahoox: this.dahoox
        });
      }

      GetSkinTitle() {
        return this.dahoox ? 'daHoox' : 'Speech Analytics';
      }

      GetSkinFaviconUrl() {
        let iconPath = '/client/assets/' + (this.skin === 'dahoox' ? this.skin : 'img') + '/';
        let iconFile = 'favicon.ico';
        return iconPath + iconFile;
      }

      GetSkinCssUrl() {
        let cssPath = '/client/css/';
        let cssFile = 'skin-main-' + (this.skin === 'dahoox' ? this.skin : 'occ') + '.css';
        return cssPath + cssFile;
      }

      GetSkinClass() {
        return 'skin-' + (this.skin === 'dahoox' || this.skin === 'occ' ? this.skin : 'occ skin-' + this.skin);
      }

      IsMobile() {
        return this.isMobile;
      }

      GetIsMobile(opts) {
        let mobileRE = /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series[46]0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i;
        let tabletRE = /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series[46]0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino|android|ipad|playbook|silk/i;
        if (!opts) opts = {};
        let ua = opts.ua;
        if (!ua && typeof navigator !== 'undefined') ua = navigator.userAgent;
        if (ua && ua.headers && typeof ua.headers['user-agent'] === 'string') ua = ua.headers['user-agent'];
        if (typeof ua !== 'string') return false;
        let result = opts.tablet ? tabletRE.test(ua) : mobileRE.test(ua);
        if (!result && opts.tablet && opts.featureDetect && navigator && navigator.maxTouchPoints > 1 && ua.indexOf('Macintosh') !== -1 && ua.indexOf('Safari') !== -1) result = true;
        return result;
      }

      IsApp() {
        return this.isApp;
      }

    };
    SkinService = tslib_1.__decorate([core_1.Injectable(), tslib_1.__metadata("design:paramtypes", [router_1.Router, modal_service_1.ModalService])], SkinService);
    return SkinService;
  })();

  exports.SkinService = SkinService;
})(skin_service);

Object.defineProperty(navigateGuard_service, "__esModule", {
  value: true
});
navigateGuard_service.NavigateGuardService = void 0;
const tslib_1$l = require$$0;
const core_1$l = require$$0$1;
const layout_service_1 = layout_service;
const skin_service_1 = skin_service;

let NavigateGuardService = /*@__PURE__*/(() => {
  let NavigateGuardService = class NavigateGuardService {
    constructor(layoutService, skinService) {
      this.layoutService = layoutService;
      this.skinService = skinService;
      this.isDaHoox = this.skinService.DaHooxEnabled();
      this.isMobile = this.skinService.IsMobile();
      this.isApp = this.skinService.IsApp();
      this.preventNavigate = false;
    }

    canDeactivate(component, currentRoute, currentState, nextState) {
      if (this.preventNavigate) {
        this.preventNavigate = false;
        history.pushState(null, null, location.href);
        return false;
      }

      return true;
    }

  };
  NavigateGuardService = tslib_1$l.__decorate([core_1$l.Injectable(), tslib_1$l.__metadata("design:paramtypes", [layout_service_1.LayoutService, skin_service_1.SkinService])], NavigateGuardService);
  return NavigateGuardService;
})();

navigateGuard_service.NavigateGuardService = NavigateGuardService;

var layoutForm_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.LayoutFormComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const rxjs_1 = require$$4;
  const operators_1 = require$$3;
  const router_1 = require$$26;
  const angular2_notifications_1 = require$$25;
  const authentication_service_1 = authentication_service;
  const language_service_1 = language_service;
  const layout_service_1 = layout_service;
  const loading_service_1 = loading_service;
  const skin_service_1 = skin_service;

  let LayoutFormComponent = /*@__PURE__*/(() => {
    let LayoutFormComponent = class LayoutFormComponent {
      constructor(activatedRoute, authenticationService, languageService, layoutService, loadingService, notificationsService, router, skinService) {
        this.activatedRoute = activatedRoute;
        this.authenticationService = authenticationService;
        this.languageService = languageService;
        this.layoutService = layoutService;
        this.loadingService = loadingService;
        this.notificationsService = notificationsService;
        this.router = router;
        this.skinService = skinService;
        this.document = document;
        this.window = window;
        this.loggedUser = this.authenticationService.GetLoggedUser();
        this.userLanguage = this.languageService.GetCurrentLanguage();
        this.translateCategory = 'layout';
        this.isDaHoox = this.skinService.DaHooxEnabled();
        this.scrollPercentage = null;
      }

      ngOnInit() {
        rxjs_1.forkJoin([this.InitNavigation(), this.InitSocket()]).pipe(operators_1.mergeMap(result => {
          if (result) {
            let initNavigationResult = result[0];
            let initSocketResult = result[1];
            if (!initNavigationResult) throw this.languageService.GetMessage(this.translateCategory, 'ERROR_LAYOUT_INIT_NAVIGATION');
            if (!initSocketResult) throw this.languageService.GetMessage(this.translateCategory, 'ERROR_LAYOUT_INIT_SOCKET');
            this.InitializeLayout();
            return rxjs_1.of(true);
          } else {
            throw this.languageService.GetMessage(this.translateCategory, 'ERROR_RESULT_GET');
          }
        })).subscribe(result => {
          this.loadingService.Close();
        }, err => {
          let msg = this.languageService.GetMessage(this.translateCategory, 'ERROR_ON_LOAD');
          console.error(msg);
          console.dir(err);
          this.notificationsService.error(this.languageService.GetMessage(this.translateCategory, 'ERROR'), msg);
          this.loadingService.Close();
        });
      }

      ngOnDestroy() {
        if (this.routerNavigateSubscription) this.routerNavigateSubscription.unsubscribe();
      }

      OnScroll(event) {
        if (!this.document.scrollingElement || !(this.document.scrollingElement.scrollHeight - this.window.innerHeight)) this.scrollPercentage = null;else this.scrollPercentage = 100 * this.window.scrollY / (this.document.scrollingElement.scrollHeight - this.window.innerHeight);
      }

      InitializeLayout() {}

      InitNavigation() {
        this.routerNavigateSubscription = this.router.events.subscribe(event => {
          if (!(event instanceof router_1.NavigationEnd)) return;
          window.scrollTo(0, 0);
          setTimeout(function (context) {
            context.OnScroll();
          }, 500, this);
        });
        return rxjs_1.of(true);
      }

      InitSocket() {
        return rxjs_1.of(true);
      }

    };

    tslib_1.__decorate([core_1.HostListener('window:scroll', ['$event']), tslib_1.__metadata("design:type", Function), tslib_1.__metadata("design:paramtypes", [Object]), tslib_1.__metadata("design:returntype", void 0)], LayoutFormComponent.prototype, "OnScroll", null);

    LayoutFormComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'layout-form-cmp',
      templateUrl: 'layout-form.component.html',
      styleUrls: ['layout-form.component.css'],
      encapsulation: core_1.ViewEncapsulation.None
    }), tslib_1.__metadata("design:paramtypes", [router_1.ActivatedRoute, authentication_service_1.AuthenticationService, language_service_1.LanguageService, layout_service_1.LayoutService, loading_service_1.LoadingService, angular2_notifications_1.NotificationsService, router_1.Router, skin_service_1.SkinService])], LayoutFormComponent);
    return LayoutFormComponent;
  })();

  exports.LayoutFormComponent = LayoutFormComponent;
})(layoutForm_component, layoutForm_component.exports);

var login_component = {exports: {}};

var platform_service = {};

Object.defineProperty(platform_service, "__esModule", {
  value: true
});
platform_service.PlatformService = void 0;
const tslib_1$k = require$$0;
const core_1$k = require$$0$1;
const http_1$d = require$$19;
const operators_1$d = require$$3;
const env_config_1$e = env_config;
const auth_guard_service_1$d = authGuard_service;

let PlatformService = /*@__PURE__*/(() => {
  let PlatformService = class PlatformService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetPlatformStatus() {
      let url = env_config_1$e.Config.API + '/api/activation/get_platform_status';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({});
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(json => {
        return json;
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetPlatformAvailableLicenses() {
      let url = env_config_1$e.Config.API + '/api/activation/get_platform_available_licenses';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({});
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(json => {
        return json;
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

    GenerateLicenseFile(guid) {
      let bodyContent = {
        guidContainer: guid
      };
      let url = env_config_1$e.Config.API + '/api/generate_license_file';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'text/csv;charset=utf-8;'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true,
        observe: 'response',
        responseType: 'blob'
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(response => {
        if (!/{"status":false/.test(response._body)) {
          let blob = null;
          if (typeof response.body === 'string') blob = new Blob(['\ufeff' + response._body], {
            type: 'text/csv;charset=utf-8;'
          });else blob = response.body;
          let downLink = document.createElement('a');
          let url = URL.createObjectURL(blob);
          downLink.setAttribute('href', url);
          downLink.setAttribute('download', 'licenseFile.lic');
          downLink.style.visibility = 'hidden';
          document.body.appendChild(downLink);
          downLink.click();
          document.body.removeChild(downLink);
          window.URL.revokeObjectURL(url);
        } else {
          throw response.json().description || response.json().error || '';
        }

        return true;
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

    PlatformActivate(serverParams) {
      let url = env_config_1$e.Config.API + '/api/activation/activate_platform';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(serverParams);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(json => {
        return json;
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetPlatformAccounts() {
      let url = env_config_1$e.Config.API + '/api/activation/get_platform_accounts';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({});
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetInstallationData(installationId) {
      let url = env_config_1$e.Config.API + '/api/platform/data_installation';
      let headers = new http_1$d.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = {
        installationId: installationId
      };
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$d.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$d.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  PlatformService = tslib_1$k.__decorate([core_1$k.Injectable(), tslib_1$k.__metadata("design:paramtypes", [http_1$d.HttpClient, auth_guard_service_1$d.AuthGuardService])], PlatformService);
  return PlatformService;
})();

platform_service.PlatformService = PlatformService;

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.LoginComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const router_1 = require$$26;
  const forms_1 = require$$45;
  const angular2_notifications_1 = require$$25;
  const md5_1 = md5;
  const authentication_service_1 = authentication_service;
  const language_service_1 = language_service;
  const platform_service_1 = platform_service;

  let LoginComponent = /*@__PURE__*/(() => {
    let LoginComponent = class LoginComponent {
      constructor(authenticationService, platformService, languageService, notificationsService, formBuilder, router) {
        this.authenticationService = authenticationService;
        this.platformService = platformService;
        this.languageService = languageService;
        this.notificationsService = notificationsService;
        this.formBuilder = formBuilder;
        this.router = router;
        this.userLanguage = this.languageService.GetCurrentLanguage();
        this.translateCategory = 'auth';
        this.submitted = false;
        this.processing = false;
        this.errorMessage = '';
      }

      ngOnInit() {
        this.loginForm = this.formBuilder.group({
          userId: ['', forms_1.Validators.required],
          password: ['', forms_1.Validators.required]
        });
      }

      Login() {
        this.submitted = true;
        if (!this.loginForm.valid) return false;
        this.processing = true;
        let credentials = this.loginForm.controls['userId'].value.split('@');
        let userId = credentials.length > 0 ? credentials[0] : '';
        let password = this.loginForm.controls['password'].value;
        this.authenticationService.Login(this.loginForm.controls['userId'].value, md5_1.Md5.hashStr(userId + password)).subscribe(result => {
          if (result) {
            if (this.loginForm.controls['userId'].value === 'admin') {
              this.GetPlatformStatus().subscribe(result => {
                let targetRoute = '';

                if (result.status === false) {
                  targetRoute = 'speechanalytic/provisioning/platform-activation';
                } else {
                  targetRoute = 'speechanalytic/provisioning/vcc';
                }

                this.router.navigate([targetRoute]);
              });
            } else {
              this.router.navigate(['/']);
            }
          } else {
            this.errorMessage = this.languageService.GetMessage(this.translateCategory, 'LOGIN_FAILED');
            this.processing = false;
          }
        }, error => {
          if (error.status === 0) this.notificationsService.error('Error', this.languageService.GetMessage(this.translateCategory, 'CONNECTION_ERROR'));else if (error.status > 0) this.notificationsService.error('Error', this.languageService.GetMessage(this.translateCategory, error.error.error));
          this.processing = false;
        });
        return false;
      }

      GetPlatformStatus() {
        let result = this.platformService.GetPlatformStatus();
        result.subscribe(result => {
          return result;
        }, err => {
          console.dir(err);
          this.notificationsService.error(this.languageService.GetMessage(this.translateCategory, 'ERROR'), this.languageService.GetMessage(this.translateCategory, err));
        });
        return result;
      }

    };
    LoginComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'login-cmp',
      templateUrl: 'login.html'
    }), tslib_1.__metadata("design:paramtypes", [authentication_service_1.AuthenticationService, platform_service_1.PlatformService, language_service_1.LanguageService, angular2_notifications_1.NotificationsService, forms_1.FormBuilder, router_1.Router])], LoginComponent);
    return LoginComponent;
  })();

  exports.LoginComponent = LoginComponent;
})(login_component, login_component.exports);

var evaluationFormat_service = {};

Object.defineProperty(evaluationFormat_service, "__esModule", {
  value: true
});
evaluationFormat_service.EvaluationFormatService = void 0;
const tslib_1$j = require$$0;
const core_1$j = require$$0$1;
const http_1$c = require$$19;
const operators_1$c = require$$3;
const env_config_1$d = env_config;
const auth_guard_service_1$c = authGuard_service;
const combo_data_model_1$2 = comboData_model;

let EvaluationFormatService = /*@__PURE__*/(() => {
  let EvaluationFormatService = class EvaluationFormatService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetEvaluationFormats(searchCriteria, searchExpression, disabled = false, historic = false) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/get_evaluationformats/' + searchCriteria + '/' + searchExpression + '?disabled=' + disabled + '&historic=' + historic;
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateEvaluationFormat(evaluationFormat) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/create_evaluationformat';
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationFormat);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationFormat(evaluationFormatId, find_queries = false, find_entities = false, evaluation_plan_id = null) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/get_evaluationformat/' + evaluationFormatId + '?evaluation_plan_id=' + evaluation_plan_id;

      if (find_queries) {
        url += '&find_queries=true';

        if (find_entities) {
          url += '&find_entities=true';
        }
      }

      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveEvaluationFormat(evaluationformat) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/save_evaluationformat';
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationformat);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteEvaluationFormat(evaluationFormat) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/delete_evaluationformat';
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationFormat);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteEvaluationFormats(evaluationFormats) {
      let bodyContent = {};
      bodyContent.evaluationFormats = [];
      evaluationFormats.forEach(function (evaluationFormat) {
        bodyContent.evaluationFormats.push(evaluationFormat);
      });
      let url = env_config_1$d.Config.API + '/api/evaluationformat/delete_evaluationformats';
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationFormatQualificationAverage(evaluationFormatId) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/get_evaluationformat_qualification_average/' + evaluationFormatId;
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetPenalizationOptions(languageService) {
      return [new combo_data_model_1$2.ComboData('NO', languageService.GetMessage('evaluationformat', 'PENALIZATION_NO')), new combo_data_model_1$2.ComboData('GRP', languageService.GetMessage('evaluationformat', 'PENALIZATION_GROUP')), new combo_data_model_1$2.ComboData('SGR', languageService.GetMessage('evaluationformat', 'PENALIZATION_SUBGROUP')), new combo_data_model_1$2.ComboData('INT', languageService.GetMessage('evaluationformat', 'PENALIZATION_INTERACTION'))];
    }

    GetEfectivityOptions(languageService) {
      return [new combo_data_model_1$2.ComboData('1', languageService.GetMessage('efectivity', 'CORRECT_VALUE')), new combo_data_model_1$2.ComboData('0', languageService.GetMessage('efectivity', 'INCORRECT_VALUE'))];
    }

    isQueryBeingUsedByQuality(queryName) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/isQueryBeingUsedByQuality/' + queryName;
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    isTemplateBeingUsedByQuality(TemplateId) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/isTemplateBeingUsedByQuality/' + TemplateId;
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationFormatAttachedSignatures(evaluationFormatId) {
      let url = env_config_1$d.Config.API + '/api/evaluationformat/get_evaluationformat_attachedsignatures/' + evaluationFormatId;
      let headers = new http_1$c.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$c.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$c.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  EvaluationFormatService = tslib_1$j.__decorate([core_1$j.Injectable(), tslib_1$j.__metadata("design:paramtypes", [http_1$c.HttpClient, auth_guard_service_1$c.AuthGuardService])], EvaluationFormatService);
  return EvaluationFormatService;
})();

evaluationFormat_service.EvaluationFormatService = EvaluationFormatService;

var checklistCombo_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ChecklistComboComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const combo_data_model_1 = comboData_model;
  const searchComboConfig = {
    disabled: false,
    optionsList: [],
    maxElements: undefined,
    showValueInLabel: false,
    labelValuePrefix: '',
    labelValueSufix: '',
    placeholder: 'Select...',
    searchEnabled: false,
    selectAllEnabled: true,
    selectAllLabel: 'Select all'
  };

  const noop = () => {};

  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => ChecklistComboComponent),
    multi: true
  };

  let ChecklistComboComponent = /*@__PURE__*/(() => {
    let ChecklistComboComponent = class ChecklistComboComponent {
      constructor(myElement) {
        this.isDropdownOpen = false;
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.focusIn = new core_1.EventEmitter();
        this.focusOut = new core_1.EventEmitter();
        this.optionsChanged = new core_1.EventEmitter();
        this.optionFilter = '';
        this.textValue = '';
        this.fullFilteredList = [];
        this.filteredList = [];
        this.optionsDropdownOpened = false;
        this.initialized = false;
        this.isClicked = false;
        this.elementsSelectedCount = 0;
        this.translateCategory = 'general';
        this.OnTouchedCallback = noop;
        this.OnChangeCallback = noop;
        this.elementRef = myElement;
      }

      get value() {
        return this.innerValue;
      }

      set value(v) {
        if (v !== this.innerValue) {
          this.innerValue = v;
          this.onChangeCallback(v);
        }
      }

      set optionsList(list) {
        if (list !== this._optionsList) {
          this._optionsList = list;
          let oldOptionFilter = this.optionFilter;
          this.optionFilter = '';
          this.RefreshList(false);

          if (oldOptionFilter && this.innerValue) {
            this.innerValue = this.optionsList.find(option => {
              return option.description.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c').indexOf(oldOptionFilter.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c')) > -1;
            });
            if (this.innerValue) this.optionFilter = oldOptionFilter;
          }
        }
      }

      get optionsList() {
        return this._optionsList;
      }

      OpenDropDown() {
        this.optionsDropdownOpened = true;
      }

      ngOnInit() {
        if (!this.globalChipSelected) {
          this.disabled = typeof this.disabled !== 'undefined' ? this.disabled : searchComboConfig.disabled;
          this.optionsList = typeof this.optionsList !== 'undefined' ? this.optionsList : searchComboConfig.optionsList;
          this.maxElements = typeof this.maxElements !== 'undefined' ? this.maxElements : searchComboConfig.maxElements;
          this.showValueInLabel = typeof this.showValueInLabel !== 'undefined' ? this.showValueInLabel : searchComboConfig.showValueInLabel;
          this.labelValuePrefix = typeof this.labelValuePrefix !== 'undefined' ? this.labelValuePrefix : searchComboConfig.labelValuePrefix;
          this.labelValueSufix = typeof this.labelValueSufix !== 'undefined' ? this.labelValueSufix : searchComboConfig.labelValueSufix;
          this.placeholder = typeof this.placeholder !== 'undefined' ? this.placeholder : searchComboConfig.placeholder;
          this.searchEnabled = typeof this.searchEnabled !== 'undefined' ? this.searchEnabled : searchComboConfig.searchEnabled;
          this.selectAllEnabled = typeof this.selectAllEnabled !== 'undefined' ? this.selectAllEnabled : searchComboConfig.selectAllEnabled;
          this.selectAllLabel = typeof this.selectAllLabel !== 'undefined' ? this.selectAllLabel : searchComboConfig.selectAllLabel;
          this.RefreshList(false);

          if (this.selectAllOptionsByDefault) {
            this.optionsList.forEach(i => {
              i.status = true;
            });
          }

          this.updatePlaceholder();
          this.initialized = true;
        } else {
          this.RefreshList(true);
        }
      }

      ngAfterViewInit() {}

      onBlur() {
        this.onTouchedCallback();
      }

      writeValue(value) {
        if (value !== this.innerValue) {
          this.innerValue = value;
        }
      }

      registerOnChange(fn) {
        this.onChangeCallback = fn;
      }

      registerOnTouched(fn) {
        this.onTouchedCallback = fn;
      }

      RefreshList(openDropdown) {
        if (openDropdown && !this.disabled) this.optionsDropdownOpened = true;
        this.fullFilteredList = this.optionsList.filter(option => {
          return option && option.description && option.description.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c').indexOf(this.optionFilter.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c')) > -1;
        });
        this.filteredList = this.fullFilteredList.slice(0, this.maxElements);
        this.updatePlaceholder();
      }

      ShowOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) ; else {
            list.classList.add('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === false) {
          this.optionsDropdownOpened = true;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      ToogleDropDownList(source, elementRef) {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (this.optionsDropdownOpened === true) {
            this.HideOptions();
          } else {
            this.ShowOptions();
          }
        }
      }

      HideOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) {
            list.classList.remove('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === true) {
          this.optionsDropdownOpened = false;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      OnFocusIn() {
        setTimeout(() => {
          if (this.isClicked === false) this.ShowOptions();
        }, 250);
        this.focusIn.emit();
      }

      OnFocusOut(event) {
        setTimeout(() => {
          if (this.isClicked === false) {
            this.optionsDropdownOpened = false;
            this.HideOptions();
          }
        }, 250);
        this.focusOut.emit();
      }

      SwitchOption(event, option) {
        event.stopPropagation();

        if (event.target.type === 'checkbox') {
          option.status = !option.status;
          this.updatePlaceholder();
          this.optionsChanged.emit(this.optionsList);
          return true;
        }

        option.status = !option.status;
        this.updatePlaceholder();
        this.optionsChanged.emit(this.optionsList);
        return false;
      }

      SwitchAll(event) {
        if (event) event.stopPropagation();
        let allSelected = !this.fullFilteredList.find(option => !option.status);

        if (allSelected) {
          this.optionsList.forEach(option => {
            option.status = false;
          });
          this.updatePlaceholder();
        } else {
          this.fullFilteredList.forEach(option => {
            option.status = true;
          });
          this.updatePlaceholder();
        }

        this.optionsChanged.emit(this.optionsList);
        return false;
      }

      GetOptionLabel(option) {
        option = option || new combo_data_model_1.ComboData(null, null);

        if (this.showValueInLabel && option.value && typeof option.value === 'string') {
          return option.description + ' (' + (this.labelValuePrefix + option.value + this.labelValueSufix).trim() + ')';
        } else {
          return option.description;
        }
      }

      OnKeyUp() {
        if (this.textValue === '') {
          this.value = new combo_data_model_1.ComboData('', '');
          this.textValue = this.GetOptionLabel(this.value);
        }

        this.optionFilter = this.textValue;
        this.RefreshList(true);
      }

      updatePlaceholder() {
        this.elementsSelectedCount = 0;

        if (this.enablePlaceholderCount && this.textPlaceholderCount) {
          this.optionsList.forEach(i => {
            if (i.status) this.elementsSelectedCount += 1;
          });
          if (this.elementsSelectedCount === 0) this.placeholder = this.textNoneSelected ? this.textNoneSelected : 'None selected';else if (this.elementsSelectedCount === this.optionsList.length) this.placeholder = this.textAllSelected ? this.textAllSelected : 'All selected';else if (this.elementsSelectedCount === 1) this.placeholder = this.elementsSelectedCount + ' ' + (this.textOneSelected ? this.textOneSelected : this.textPlaceholderCount) + ' ' + this.optionsList.length;else this.placeholder = this.elementsSelectedCount + ' ' + this.textPlaceholderCount + ' ' + this.optionsList.length;
        }
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array), tslib_1.__metadata("design:paramtypes", [Array])], ChecklistComboComponent.prototype, "optionsList", null);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], ChecklistComboComponent.prototype, "focusIn", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], ChecklistComboComponent.prototype, "focusOut", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "disabled", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number)], ChecklistComboComponent.prototype, "maxElements", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "showValueInLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "labelValuePrefix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "labelValueSufix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "showEmptyItem", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "placeholder", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "searchEnabled", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "selectAllEnabled", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "selectAllLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "enablePlaceholderCount", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "textPlaceholderCount", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "textAllSelected", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "textOneSelected", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "textNoneSelected", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "selectAllOptionsByDefault", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ChecklistComboComponent.prototype, "globalChipSelected", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "labelOne", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ChecklistComboComponent.prototype, "labelTwo", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], ChecklistComboComponent.prototype, "optionsChanged", void 0);

    ChecklistComboComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'checklist-combo-cmp',
      templateUrl: 'checklist-combo.html',
      styleUrls: ['checklist-combo.css'],
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [core_1.ElementRef])], ChecklistComboComponent);
    return ChecklistComboComponent;
  })();

  exports.ChecklistComboComponent = ChecklistComboComponent;
})(checklistCombo_component, checklistCombo_component.exports);

var contenteditable_directive = {};

Object.defineProperty(contenteditable_directive, "__esModule", {
  value: true
});
contenteditable_directive.ContenteditableDirective = void 0;
const tslib_1$i = require$$0;
const core_1$i = require$$0$1;

let ContenteditableDirective = /*@__PURE__*/(() => {
  let ContenteditableDirective = class ContenteditableDirective {
    constructor(elementRef) {
      this.elementRef = elementRef;
      this.contenteditableModelChange = new core_1$i.EventEmitter();
    }

    onInput(event) {
      let newValue = this.elementRef.nativeElement.innerText;
      this.contenteditableModelChange.emit(newValue);
    }

    ngOnChanges(changes) {
      if (changes.contenteditableModel && (changes.contenteditableModel.isFirstChange() || changes.contenteditableModel.currentValue !== changes.contenteditableModel.previousValue)) {
        let newValue = changes.contenteditableModel.currentValue;
        if (this.elementRef.nativeElement.innerText !== newValue) this.elementRef.nativeElement.innerText = newValue;
      }
    }

  };

  tslib_1$i.__decorate([core_1$i.Input(), tslib_1$i.__metadata("design:type", String)], ContenteditableDirective.prototype, "contenteditableModel", void 0);

  tslib_1$i.__decorate([core_1$i.Output(), tslib_1$i.__metadata("design:type", Object)], ContenteditableDirective.prototype, "contenteditableModelChange", void 0);

  tslib_1$i.__decorate([core_1$i.HostListener('input', ['$event']), tslib_1$i.__metadata("design:type", Function), tslib_1$i.__metadata("design:paramtypes", [Object]), tslib_1$i.__metadata("design:returntype", void 0)], ContenteditableDirective.prototype, "onInput", null);

  ContenteditableDirective = tslib_1$i.__decorate([core_1$i.Directive({
    selector: '[contenteditableModel]'
  }), tslib_1$i.__metadata("design:paramtypes", [core_1$i.ElementRef])], ContenteditableDirective);
  return ContenteditableDirective;
})();

contenteditable_directive.ContenteditableDirective = ContenteditableDirective;

var dropdownCombo_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.DropdownComboComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const combo_data_model_1 = comboData_model;
  const searchComboConfig = {
    disabled: false,
    optionsList: [],
    maxElements: undefined,
    showValueInLabel: false,
    labelValuePrefix: '',
    labelValueSufix: '',
    showEmptyItem: false,
    emptyOptionValue: null,
    emptyOptionDescription: '',
    placeholder: 'Select...'
  };

  const noop = () => {};

  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => DropdownComboComponent),
    multi: true
  };

  let DropdownComboComponent = /*@__PURE__*/(() => {
    let DropdownComboComponent = class DropdownComboComponent {
      constructor(myElement) {
        this.isDropdownOpen = false;
        this.className = 'input-group input-group-sm';
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.optionChanged = new core_1.EventEmitter();
        this.focusOut = new core_1.EventEmitter();
        this.focusIn = new core_1.EventEmitter();
        this.filteredList = [];
        this.optionsDropdownOpened = false;
        this.initialized = false;
        this.OnTouchedCallback = noop;
        this.OnChangeCallback = noop;
        this.elementRef = myElement;
      }

      get value() {
        return this.innerValue;
      }

      set value(v) {
        if (v !== this.innerValue) {
          this.innerValue = v;
          this.onChangeCallback(v);
        }
      }

      get optionsList() {
        return this._optionsList;
      }

      set optionsList(list) {
        if (list !== this._optionsList) {
          this._optionsList = list;
          this.RefreshList(false);
        }
      }

      ngOnInit() {
        this.disabled = typeof this.disabled !== 'undefined' ? this.disabled : searchComboConfig.disabled;
        this.optionsList = typeof this.optionsList !== 'undefined' ? this.optionsList : searchComboConfig.optionsList;
        this.maxElements = typeof this.maxElements !== 'undefined' ? this.maxElements : searchComboConfig.maxElements;
        this.showValueInLabel = typeof this.showValueInLabel !== 'undefined' ? this.showValueInLabel : searchComboConfig.showValueInLabel;
        this.labelValuePrefix = typeof this.labelValuePrefix !== 'undefined' ? this.labelValuePrefix : searchComboConfig.labelValuePrefix;
        this.labelValueSufix = typeof this.labelValueSufix !== 'undefined' ? this.labelValueSufix : searchComboConfig.labelValueSufix;
        this.showEmptyItem = typeof this.showEmptyItem !== 'undefined' ? this.showEmptyItem : searchComboConfig.showEmptyItem;
        this.emptyOptionValue = typeof this.emptyOptionValue !== 'undefined' ? this.emptyOptionValue : searchComboConfig.emptyOptionValue;
        this.emptyOptionDescription = typeof this.emptyOptionDescription !== 'undefined' ? this.emptyOptionDescription : searchComboConfig.emptyOptionDescription;
        this.placeholder = typeof this.placeholder !== 'undefined' ? this.placeholder : searchComboConfig.placeholder;
        this.emptyOption = new combo_data_model_1.ComboData(this.emptyOptionValue, this.emptyOptionDescription || '');
        this.RefreshList(false);
        this.initialized = true;
      }

      onBlur() {
        this.onTouchedCallback();
      }

      writeValue(value) {
        if (value !== this.innerValue) {
          this.innerValue = value ? value : this.emptyOption;
        }
      }

      registerOnChange(fn) {
        this.onChangeCallback = fn;
      }

      registerOnTouched(fn) {
        this.onTouchedCallback = fn;
      }

      RefreshList(openDropdown) {
        if (openDropdown && !this.disabled) this.optionsDropdownOpened = true;
        this.filteredList = this.optionsList.slice(0, this.maxElements);
      }

      SelectOption(option) {
        this.value = option;
        this.optionChanged.emit(option);
        return false;
      }

      ShowOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) ; else {
            list.classList.add('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === false) {
          this.optionsDropdownOpened = true;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      HideOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) {
            list.classList.remove('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === true) {
          this.optionsDropdownOpened = false;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      OnFocusIn() {
        setTimeout(() => {
          this.optionsDropdownOpened = true;
          this.ShowOptions();
        }, 250);
        this.focusIn.emit();
      }

      OnFocusOut(event) {
        setTimeout(() => {
          this.optionsDropdownOpened = false;
          this.HideOptions();
        }, 250);
        this.focusOut.emit();
      }

      GetOptionLabel(option) {
        option = option || new combo_data_model_1.ComboData(null, null);

        if (this.showValueInLabel && option.value && typeof option.value === 'string') {
          return option.description + ' (' + (this.labelValuePrefix + option.value + this.labelValueSufix).trim() + ')';
        } else {
          return option.description;
        }
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "className", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array), tslib_1.__metadata("design:paramtypes", [Array])], DropdownComboComponent.prototype, "optionsList", null);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], DropdownComboComponent.prototype, "disabled", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number)], DropdownComboComponent.prototype, "maxElements", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], DropdownComboComponent.prototype, "showValueInLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "labelValuePrefix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "labelValueSufix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], DropdownComboComponent.prototype, "showEmptyItem", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "emptyOptionValue", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "emptyOptionDescription", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], DropdownComboComponent.prototype, "placeholder", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], DropdownComboComponent.prototype, "optionChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], DropdownComboComponent.prototype, "focusOut", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], DropdownComboComponent.prototype, "focusIn", void 0);

    DropdownComboComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'dropdown-combo-cmp',
      templateUrl: 'dropdown-combo.html',
      styleUrls: ['dropdown-combo.css'],
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [core_1.ElementRef])], DropdownComboComponent);
    return DropdownComboComponent;
  })();

  exports.DropdownComboComponent = DropdownComboComponent;
})(dropdownCombo_component, dropdownCombo_component.exports);

var fileBrowser_component = {exports: {}};

var template_service = {};

Object.defineProperty(template_service, "__esModule", {
  value: true
});
template_service.TemplateService = void 0;
const tslib_1$h = require$$0;
const core_1$h = require$$0$1;
const http_1$b = require$$19;
const operators_1$b = require$$3;
const env_config_1$c = env_config;
const auth_guard_service_1$b = authGuard_service;

let TemplateService = /*@__PURE__*/(() => {
  let TemplateService = class TemplateService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetTemplates(type, searchCriteria, searchExpression, language = 'en') {
      let url = env_config_1$c.Config.API + '/api/template/get_templates/' + type + '/' + searchCriteria + '/' + searchExpression + '?language=' + language;
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetTemplate(type, templateId) {
      let url = env_config_1$c.Config.API + '/api/template/get_template/' + type + '/' + templateId;
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetTemplateThemeItems(type, templateId) {
      let url = env_config_1$c.Config.API + '/api/template/get_template_theme_items/' + type + '/' + templateId;
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetTemplateThemeModels(type, templateId) {
      let url = env_config_1$c.Config.API + '/api/template/get_template_theme_models/' + type + '/' + templateId;
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateTemplate(template) {
      let url = env_config_1$c.Config.API + '/api/template/create_template';
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(template);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveTemplate(template) {
      let url = env_config_1$c.Config.API + '/api/template/save_template';
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(template);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateTemplateByAPI(template) {
      let url = env_config_1$c.Config.API + '/api/template/create_template_by_api';
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(template);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteTemplate(template) {
      let bodyContent = {};
      bodyContent.template = template;
      let url = env_config_1$c.Config.API + '/api/template/delete_template';
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteTemplates(templates) {
      let bodyContent = {};
      bodyContent.templates = [];
      templates.forEach(function (template) {
        bodyContent.templates.push(template);
      });
      let url = env_config_1$c.Config.API + '/api/template/delete_templates';
      let headers = new http_1$b.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$b.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$b.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  TemplateService = tslib_1$h.__decorate([core_1$h.Injectable(), tslib_1$h.__metadata("design:paramtypes", [http_1$b.HttpClient, auth_guard_service_1$b.AuthGuardService])], TemplateService);
  return TemplateService;
})();

template_service.TemplateService = TemplateService;

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.FileBrowserComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const angular2_notifications_1 = require$$25;
  const language_service_1 = language_service;
  const template_service_1 = template_service;

  let FileBrowserComponent = /*@__PURE__*/(() => {
    let FileBrowserComponent = class FileBrowserComponent {
      constructor(languageService, templateService, notificationsService) {
        this.languageService = languageService;
        this.templateService = templateService;
        this.notificationsService = notificationsService;
        this.translateCategory = 'modal';
        this.allowedExtensions = [];
        this.itemSelected = new core_1.EventEmitter();
        this.itemSubmit = new core_1.EventEmitter();
      }

      ngAfterViewInit() {}

      OnItemSelected(selectedFilePath) {
        this.RefreshSelected(selectedFilePath);
        this.itemSelected.emit(selectedFilePath);
      }

      OnItemSubmit(selectedFilePath) {
        this.RefreshSelected(selectedFilePath);
        this.itemSubmit.emit(selectedFilePath);
      }

      RefreshSelected(selectedFilePath) {
        let walkTree = function (arr) {
          if (arr instanceof Array) {
            for (let i = 0; i < arr.length; i++) {
              if (arr[i]) arr[i].selected = arr[i].relativePath === selectedFilePath;
              if (arr[i] && !arr[i].show) arr[i].show = selectedFilePath.startsWith(arr[i].relativePath);
              if (arr[i] && arr[i].children && arr[i].children instanceof Array) walkTree(arr[i].children);
            }
          }
        };

        walkTree(this.folderTree);
        this.selectedFilePath = selectedFilePath;
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], FileBrowserComponent.prototype, "folderName", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], FileBrowserComponent.prototype, "isTemporal", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], FileBrowserComponent.prototype, "selectedValue", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], FileBrowserComponent.prototype, "allowedExtensions", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], FileBrowserComponent.prototype, "itemSelected", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], FileBrowserComponent.prototype, "itemSubmit", void 0);

    FileBrowserComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'file-browser-cmp',
      encapsulation: core_1.ViewEncapsulation.None,
      templateUrl: 'file-browser.component.html',
      styleUrls: ['file-browser.component.css']
    }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService, template_service_1.TemplateService, angular2_notifications_1.NotificationsService])], FileBrowserComponent);
    return FileBrowserComponent;
  })();

  exports.FileBrowserComponent = FileBrowserComponent;
})(fileBrowser_component, fileBrowser_component.exports);

var fileTree_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.FileTreeComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const collapse_animation_1 = collapse_animation;

  let FileTreeComponent = /*@__PURE__*/(() => {
    let FileTreeComponent = class FileTreeComponent {
      constructor() {
        this.itemSelected = new core_1.EventEmitter();
        this.itemSubmit = new core_1.EventEmitter();
        this.treeData = [];
        this.allowedExtensions = [];
      }

      OnItemSelected(selectedFilePath) {
        this.itemSelected.emit(selectedFilePath);
      }

      OnItemSubmit(selectedFilePath) {
        this.itemSubmit.emit(selectedFilePath);
      }

      IsExtensionAllowed(extension) {
        return !this.allowedExtensions || this.allowedExtensions.length === 0 || this.allowedExtensions.indexOf(extension) > -1;
      }

    };

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], FileTreeComponent.prototype, "itemSelected", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], FileTreeComponent.prototype, "itemSubmit", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], FileTreeComponent.prototype, "treeData", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], FileTreeComponent.prototype, "allowedExtensions", void 0);

    FileTreeComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'file-tree-cmp',
      encapsulation: core_1.ViewEncapsulation.None,
      templateUrl: 'file-tree.component.html',
      animations: [collapse_animation_1.sectionExpandAnimation200]
    })], FileTreeComponent);
    return FileTreeComponent;
  })();

  exports.FileTreeComponent = FileTreeComponent;
})(fileTree_component, fileTree_component.exports);

var jwt_interceptor = {};

Object.defineProperty(jwt_interceptor, "__esModule", {
  value: true
});
jwt_interceptor.JwtInterceptor = void 0;
const tslib_1$g = require$$0;
const core_1$g = require$$0$1;
const env_config_1$b = env_config;

let JwtInterceptor = /*@__PURE__*/(() => {
  let JwtInterceptor = class JwtInterceptor {
    constructor() {
      this.backendHost = env_config_1$b.Config.ENV.toLowerCase() === 'dev' ? env_config_1$b.Config.API : window.location.origin;
      this.backendDomain = this.backendHost.replace('http://', '').replace('https://', '');
      this.urlRegex = new RegExp('^((http|https):\/\/' + this.backendDomain + ')?\/(.+)$');
    }

    intercept(request, next) {
      let session = localStorage.getItem('Session');

      if (session && request && request.url && this.urlRegex.test(request.url)) {
        request = request.clone({
          setHeaders: {
            'Authorization': `bearer ${session}`,
            'Cache-Control': 'no-cache',
            'Pragma': 'no-cache',
            'Expires': 'Sat, 01 Jan 2000 00:00:00 GMT'
          }
        });
      }

      return next.handle(request);
    }

  };
  JwtInterceptor = tslib_1$g.__decorate([core_1$g.Injectable(), tslib_1$g.__metadata("design:paramtypes", [])], JwtInterceptor);
  return JwtInterceptor;
})();

jwt_interceptor.JwtInterceptor = JwtInterceptor;

var loading_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.LoadingComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const loading_service_1 = loading_service;

  let LoadingComponent = /*@__PURE__*/(() => {
    let LoadingComponent = class LoadingComponent {
      constructor(loadingService) {
        this.loadingService = loadingService;
        this.onLoaded = new core_1.EventEmitter();
        this.opened = false;
        this.backdropElement = document.createElement('div');
        this.backdropElement.classList.add('modal-backdrop');
        this.backdropElement.classList.add('fade');
        this.backdropElement.classList.add('show');
      }

      ngOnInit() {
        this.onLoaded.emit(this);
      }

      open() {
        document.body.appendChild(this.backdropElement);
        document.body.className = document.body.className.replace(/ modal-open\b/, '');
        document.body.className += ' modal-open';
        this.opened = true;
        return false;
      }

      close() {
        if (!this.opened) return false;
        document.body.removeChild(this.backdropElement);
        document.body.className = document.body.className.replace(/ modal-open\b/, '');
        this.opened = false;
        return false;
      }

      isOpened() {
        return this.opened === true;
      }

    };

    tslib_1.__decorate([core_1.Output('onLoaded'), tslib_1.__metadata("design:type", core_1.EventEmitter)], LoadingComponent.prototype, "onLoaded", void 0);

    LoadingComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'loading-cmp',
      templateUrl: 'loading.html'
    }), tslib_1.__metadata("design:paramtypes", [loading_service_1.LoadingService])], LoadingComponent);
    return LoadingComponent;
  })();

  exports.LoadingComponent = LoadingComponent;
})(loading_component, loading_component.exports);

var modal_component = {exports: {}};

var modal_animation = {};

Object.defineProperty(modal_animation, "__esModule", {
  value: true
});
modal_animation.upToDownAnimation300 = modal_animation.UpToDownAnimation = modal_animation.rightToLeftAnimation300 = modal_animation.RigthToLeftAnimation = void 0;
const animations_1 = require$$18;

function RigthToLeftAnimation(triggerName, delay) {
  delay = delay || 300;
  return animations_1.trigger(triggerName, [animations_1.transition('hide => show', [animations_1.style({
    'right': '-100%',
    'opacity': '0',
    'display': 'none'
  }), animations_1.animate(delay.toString() + 'ms ease-in', animations_1.style({
    'right': '0',
    'opacity': '1',
    'display': 'block'
  }))]), animations_1.transition('show => hide', [animations_1.style({
    'right': '0',
    'opacity': '1',
    'display': 'block'
  }), animations_1.animate(delay.toString() + 'ms ease-out', animations_1.style({
    'right': '-100%',
    'opacity': '0',
    'display': 'none'
  }))])]);
}

modal_animation.RigthToLeftAnimation = RigthToLeftAnimation;
modal_animation.rightToLeftAnimation300 = animations_1.trigger('modalAnimationRTL', [animations_1.transition('hide => show', [animations_1.style({
  'right': '-100%',
  'opacity': '0'
}), animations_1.animate('300ms ease-in', animations_1.style({
  'right': '0',
  'opacity': '1'
}))]), animations_1.transition('show => hide', [animations_1.style({
  'right': '0',
  'opacity': '1'
}), animations_1.animate('300ms ease-out', animations_1.style({
  'right': '-100%',
  'opacity': '0'
}))])]);

function UpToDownAnimation(triggerName, delay) {
  delay = delay || 300;
  return animations_1.trigger(triggerName, [animations_1.transition('hide => show', [animations_1.style({
    'top': '-100%',
    'opacity': '0',
    'display': 'none'
  }), animations_1.animate(delay.toString() + 'ms ease-in', animations_1.style({
    'top': '0',
    'opacity': '1',
    'display': 'block'
  }))]), animations_1.transition('show => hide', [animations_1.style({
    'top': '0',
    'opacity': '1',
    'display': 'block'
  }), animations_1.animate(delay.toString() + 'ms ease-out', animations_1.style({
    'top': '100%',
    'opacity': '0',
    'display': 'none'
  }))])]);
}

modal_animation.UpToDownAnimation = UpToDownAnimation;
modal_animation.upToDownAnimation300 = animations_1.trigger('modalAnimation', [animations_1.transition('hide => show', [animations_1.style({
  'top': '-100%',
  'opacity': '0'
}), animations_1.animate('300ms ease-in', animations_1.style({
  'top': '0',
  'opacity': '1'
}))]), animations_1.transition('show => hide', [animations_1.style({
  'top': '0',
  'opacity': '1'
}), animations_1.animate('300ms ease-out', animations_1.style({
  'top': '100%',
  'opacity': '0'
}))])]);

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ModalComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const modal_animation_1 = modal_animation;
  const modal_service_1 = modal_service;
  const platform_browser_1 = require$$1;
  const angular2_notifications_1 = require$$25;

  let ModalComponent = /*@__PURE__*/(() => {
    let ModalComponent = class ModalComponent {
      constructor(modalService, domSanitizer, notificationsService) {
        this.modalService = modalService;
        this.domSanitizer = domSanitizer;
        this.notificationsService = notificationsService;
        this.formTitle = null;
        this.formBody = null;
        this.htmlBody = null;
        this.isHtml = false;
        this.cancelButtonLabel = 'Cancel';
        this.submitButtonLabel = 'OK';
        this.submitButtonClass = 'btn-primary btn-medium';
        this.modalClass = '';
        this.closeOnEscape = true;
        this.closeOnSpace = false;
        this.closeOnOutsideClick = true;
        this.showCloseButton = false;
        this.selectedValue = null;
        this.showInput = false;
        this.inputRequired = false;
        this.inputMissingTitle = 'Warning';
        this.inputMissingMessage = 'Input required';
        this.showFileBrowser = false;
        this.allowedExtensions = [];
        this.showFooter = true;
        this.onLoaded = new core_1.EventEmitter();
        this.isOpened = false;
        this.isOpenedAnimation = 'hide';
        this.backdropElement = document.createElement('div');
        this.backdropElement.classList.add('modal-backdrop');
        this.backdropElement.classList.add('fade');
        this.backdropElement.classList.add('show');
      }

      ngOnInit() {
        this.onLoaded.emit(this);
      }

      OnItemSelected(value) {
        if (value) this.selectedValue = value;
      }

      OnItemSubmit(value) {
        if (value) this.selectedValue = value;
        this.submit();
      }

      open() {
        if (this.isHtml) {
          this.htmlBody = this.GetCleanHtml();
        }

        document.body.appendChild(this.backdropElement);
        document.body.className = document.body.className.replace(/ modal-open\b/, '');
        document.body.className += ' modal-open';
        window.setTimeout(() => {
          this.modalContentElement.nativeElement.focus();
        }, 0);
        this.isOpened = true;
        this.isOpenedAnimation = 'show';
        this.modalService.Open();
        return false;
      }

      cancel() {
        if (!this.isOpened) return false;
        this.isOpenedAnimation = 'hide';
        window.setTimeout(() => {
          document.body.removeChild(this.backdropElement);
          document.body.className = document.body.className.replace(/ modal-open\b/, '');
          this.isOpened = false;
        }, 250);
        this.modalService.Close();
        return false;
      }

      submit() {
        if (this.inputRequired && !this.inputValue) {
          this.notificationsService.warn(this.inputMissingTitle, this.inputMissingMessage);
          return false;
        }

        if (!this.isOpened) return false;
        this.isOpenedAnimation = 'hide';
        window.setTimeout(() => {
          document.body.removeChild(this.backdropElement);
          document.body.className = document.body.className.replace(/ modal-open\b/, '');
          this.isOpened = false;
        }, 250);
        this.modalService.Submit(this.selectedValue);
        return false;
      }

      clear() {
        if (this.modalBodyViewContainer) this.modalBodyViewContainer.clear();
        this.showFooter = true;
        this.showCloseButton = false;
        return false;
      }

      GetCleanHtml() {
        return this.domSanitizer.bypassSecurityTrustHtml(this.formBody);
      }

    };

    tslib_1.__decorate([core_1.Output('onLoaded'), tslib_1.__metadata("design:type", core_1.EventEmitter)], ModalComponent.prototype, "onLoaded", void 0);

    tslib_1.__decorate([core_1.ViewChild('modalContent'), tslib_1.__metadata("design:type", core_1.ElementRef)], ModalComponent.prototype, "modalContentElement", void 0);

    tslib_1.__decorate([core_1.ViewChild('modalBodyContainer', {
      read: core_1.ViewContainerRef,
      static: true
    }), tslib_1.__metadata("design:type", core_1.ViewContainerRef)], ModalComponent.prototype, "modalBodyViewContainer", void 0);

    ModalComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'modal-cmp',
      templateUrl: 'modal.component.html',
      animations: [modal_animation_1.upToDownAnimation300]
    }), tslib_1.__metadata("design:paramtypes", [modal_service_1.ModalService, platform_browser_1.DomSanitizer, angular2_notifications_1.NotificationsService])], ModalComponent);
    return ModalComponent;
  })();

  exports.ModalComponent = ModalComponent;
})(modal_component, modal_component.exports);

var pagination_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.PaginationComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const language_service_1 = language_service;
  const strings_helper_1 = stringsHelper;
  const localStorage_helper_1 = localStorageHelper;
  const search_component_1 = search_component.exports;
  const router_1 = require$$26;
  const paginationConfig = {
    maxSize: 5,
    itemsPerPage: 5,
    boundaryLinks: true,
    directionLinks: true,
    firstText: 'far fa-chevron-double-left',
    previousText: 'far fa-chevron-double-left',
    nextText: 'far fa-chevron-right',
    lastText: 'far fa-chevron-double-right',
    itemsText: 'ITEMS',
    rotate: true
  };
  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => PaginationComponent),
    multi: true
  };

  let PaginationComponent = /*@__PURE__*/(() => {
    let PaginationComponent = class PaginationComponent {
      constructor(languageService, elementRef, router) {
        this.languageService = languageService;
        this.elementRef = elementRef;
        this.router = router;
        this.isSaveStorage = true;
        this.inited = false;
        this.translateCategory = 'pagination';
        this.currentPageChanged = new core_1.EventEmitter();
        this.currentPageMinItemChanged = new core_1.EventEmitter();
        this.currentPageMaxItemChanged = new core_1.EventEmitter();
        this.currentPageItemsChanged = new core_1.EventEmitter();
        this.SetItemsPerPage = new core_1.EventEmitter();
        this.step = null;
        this.eventActiveByStorage = null;
        this.config = this.config || paginationConfig;
      }

      get itemsPerPage() {
        return this._itemsPerPage;
      }

      set itemsPerPage(value) {
        this._itemsPerPage = value;
        this.totalPages = this.calculateTotalPages();
        this.currentPageMinItem = this.calculateCurrentPageMinItem();
        this.currentPageMaxItem = this.calculateCurrentPageMaxItem();
        this.currentPageItems = this.calculateCurrentPageItems();
      }

      get totalItems() {
        return this._totalItems;
      }

      set totalItems(value) {
        this._totalItems = value;
        this.totalPages = this.calculateTotalPages();
        this.currentPageMinItem = this.calculateCurrentPageMinItem();
        this.currentPageMaxItem = this.calculateCurrentPageMaxItem();
        this.currentPageItems = this.calculateCurrentPageItems();
      }

      get allItems() {
        return this._allItems;
      }

      set allItems(value) {
        this._allItems = value;
        this.allItemsText = this.generateAllItemsText();
      }

      get totalPages() {
        return this._totalPages;
      }

      set totalPages(value) {
        this._totalPages = value;

        if (this.inited) {
          this.selectPage(this.currentPage);
        }
      }

      get currentPageMinItem() {
        return this._currentPageMinItem;
      }

      set currentPageMinItem(v) {
        this._currentPageMinItem = v;
        this.currentPageMinItemChanged.emit(v);
      }

      get currentPageMaxItem() {
        return this._currentPageMaxItem;
      }

      set currentPageMaxItem(v) {
        this._currentPageMaxItem = v;
        this.currentPageMaxItemChanged.emit(v);
      }

      get currentPageItems() {
        return this._currentPageItems;
      }

      set currentPageItems(v) {
        this._currentPageItems = v;
        this.currentPageItemsChanged.emit(v);
      }

      get currentPage() {
        return this._currentPage;
      }

      set currentPage(value) {
        const _previous = this._currentPage;
        this._currentPage = value > this.totalPages ? this.totalPages : value || 1;
        this.currentPageMinItem = this.calculateCurrentPageMinItem();
        this.currentPageMaxItem = this.calculateCurrentPageMaxItem();
        this.currentPageItems = this.calculateCurrentPageItems();

        if (_previous === this._currentPage || typeof _previous === 'undefined') {
          return;
        }

        this.currentPageChanged.emit({
          page: this._currentPage,
          itemsPerPage: this.itemsPerPage
        });
      }

      get allItemsText() {
        return this._allItemsText;
      }

      set allItemsText(value) {
        this._allItemsText = value;
      }

      ngOnInit() {
        this.classMap = this.elementRef.nativeElement.getAttribute('class') || '';
        this.maxSize = typeof this.maxSize !== 'undefined' ? this.maxSize : paginationConfig.maxSize;
        this.rotate = typeof this.rotate !== 'undefined' ? this.rotate : paginationConfig.rotate;
        this.boundaryLinks = typeof this.boundaryLinks !== 'undefined' ? this.boundaryLinks : paginationConfig.boundaryLinks;
        this.directionLinks = typeof this.directionLinks !== 'undefined' ? this.directionLinks : paginationConfig.directionLinks;
        this.itemsPerPage = typeof this.itemsPerPage !== 'undefined' ? this.itemsPerPage : paginationConfig.itemsPerPage;
        this.itemsText = typeof this.itemsText !== 'undefined' ? this.itemsText : paginationConfig.itemsText;
        this.currentPageMinItem = this.calculateCurrentPageMinItem();
        this.currentPageMaxItem = this.calculateCurrentPageMaxItem();
        this.currentPageItems = this.calculateCurrentPageItems();
        this.pages = this.getPages(this.currentPage, this.totalPages);
        this.inited = true;
      }

      ngAfterViewInit() {
        const url = strings_helper_1.splitUrlPage(this.router.url, this.step);
        let searchStorage = localStorage_helper_1.getLocalStorage(search_component_1.kEY_SEARCH_STORAGE);

        if (searchStorage && JSON.parse(searchStorage)[url] && JSON.parse(searchStorage)[url].pager) {
          const {
            currentPage,
            itemsPerPage,
            totalItems
          } = JSON.parse(searchStorage)[url].pager;
          this.itemsPerPage = itemsPerPage;

          if (this.eventActiveByStorage) {
            this.totalItems = totalItems;
            setTimeout(() => {
              this.selectPage(currentPage);
            }, 300);
          }
        }
      }

      writeValue(value) {
        this.currentPage = value;
        this.pages = this.getPages(this.currentPage, this.totalPages);
        if (value) this.addStorage();
      }

      registerOnChange(fn) {}

      registerOnTouched(fn) {}

      selectPage(page, event) {
        if (event) {
          event.preventDefault();
        }

        if (!this.disabled) {
          if (event && event.target) {
            let target = event.target;
            target.blur();
          }

          this.writeValue(page);
        }
      }

      getText(key) {
        return this[key + 'Text'] || paginationConfig[key + 'Text'];
      }

      noPrevious() {
        return this.currentPage === 1;
      }

      noNext() {
        return this.currentPage === this.totalPages;
      }

      makePage(number, text, isActive) {
        return {
          number: number,
          text: text,
          active: isActive
        };
      }

      getPages(currentPage, totalPages) {
        let pages = [];
        let startPage = 1;
        let endPage = totalPages;
        let isMaxSized = typeof this.maxSize !== 'undefined' && this.maxSize < totalPages;

        if (isMaxSized) {
          if (this.rotate) {
            startPage = Math.max(currentPage - Math.floor(this.maxSize / 2), 1);
            endPage = startPage + this.maxSize - 1;

            if (endPage > totalPages) {
              endPage = totalPages;
              startPage = endPage - this.maxSize + 1;
            }
          } else {
            startPage = (Math.ceil(currentPage / this.maxSize) - 1) * this.maxSize + 1;
            endPage = Math.min(startPage + this.maxSize - 1, totalPages);
          }
        }

        for (var number = startPage; number <= endPage; number++) {
          let page = this.makePage(number, number.toString(), number === currentPage);
          pages.push(page);
        }

        if (isMaxSized && !this.rotate) {
          if (startPage > 1) {
            let previousPageSet = this.makePage(startPage - 1, '...', false);
            pages.unshift(previousPageSet);
          }

          if (endPage < totalPages) {
            let nextPageSet = this.makePage(endPage + 1, '...', false);
            pages.push(nextPageSet);
          }
        }

        return pages;
      }

      calculateTotalPages() {
        let totalPages = this.itemsPerPage < 1 ? 1 : Math.ceil(this.totalItems / this.itemsPerPage);
        return Math.max(totalPages || 0, 1);
      }

      calculateCurrentPageMinItem() {
        return (this.currentPage - 1) * this.itemsPerPage;
      }

      calculateCurrentPageItems() {
        return Math.min(this.currentPageMaxItem, this.totalItems - 1);
      }

      calculateCurrentPageMaxItem() {
        return this.currentPage * this.itemsPerPage - 1;
      }

      generateAllItemsText() {
        let text = this.languageService.GetMessage(this.translateCategory, 'PREVIEWING_ITEMS');

        if (this.allItems < this.itemsPerPage) {
          text = text.replace('{downloadedItems}', this.allItems.toString());
        } else {
          text = text.replace('{downloadedItems}', this.itemsPerPage.toString());
        }

        text = text.replace('{itemsTotal}', this.allItems.toString());
        return text;
      }

      setItemsPerPageInt(totalItems) {
        this.itemsPerPage = totalItems;
        this.selectPage(1);
        this.SetItemsPerPage.emit(totalItems);
        this.addStorage();
      }

      addStorage() {
        if (this.isSaveStorage) {
          const url = strings_helper_1.splitUrlPage(this.router.url, this.step);
          let searchStorage = localStorage_helper_1.getLocalStorage(search_component_1.kEY_SEARCH_STORAGE);
          let pager = {
            pager: {
              currentPage: this.currentPage,
              totalItems: this.totalItems,
              itemsPerPage: this.itemsPerPage
            }
          };

          if (searchStorage) {
            searchStorage = JSON.parse(searchStorage);
            searchStorage[url] = { ...searchStorage[url],
              ...pager
            };
            localStorage_helper_1.saveLocalStorage(search_component_1.kEY_SEARCH_STORAGE, JSON.stringify(searchStorage));
          }
        }
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number)], PaginationComponent.prototype, "maxSize", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], PaginationComponent.prototype, "boundaryLinks", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], PaginationComponent.prototype, "directionLinks", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "firstText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "previousText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "nextText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "lastText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "itemsText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], PaginationComponent.prototype, "rotate", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], PaginationComponent.prototype, "isSaveStorage", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number), tslib_1.__metadata("design:paramtypes", [Number])], PaginationComponent.prototype, "itemsPerPage", null);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number), tslib_1.__metadata("design:paramtypes", [Number])], PaginationComponent.prototype, "totalItems", null);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number), tslib_1.__metadata("design:paramtypes", [Number])], PaginationComponent.prototype, "allItems", null);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], PaginationComponent.prototype, "currentPageChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], PaginationComponent.prototype, "currentPageMinItemChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], PaginationComponent.prototype, "currentPageMaxItemChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], PaginationComponent.prototype, "currentPageItemsChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], PaginationComponent.prototype, "SetItemsPerPage", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], PaginationComponent.prototype, "step", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], PaginationComponent.prototype, "eventActiveByStorage", void 0);

    PaginationComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'pagination-cmp',
      templateUrl: 'pagination.html',
      styleUrls: ['pagination.css'],
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService, core_1.ElementRef, router_1.Router])], PaginationComponent);
    return PaginationComponent;
  })();

  exports.PaginationComponent = PaginationComponent;
})(pagination_component, pagination_component.exports);

var searchCombo_component = {exports: {}};

var guid_module = {};

Object.defineProperty(guid_module, "__esModule", {
  value: true
});
guid_module.GenerateGuid = guid_module.GenerateRandomString = void 0;

function GenerateRandomString(length, chars) {
  if (!chars) chars = '012345678901234567890123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  let result = '';

  for (let i = length; i > 0; --i) result += chars[Math.floor(Math.random() * chars.length)];

  return result;
}

guid_module.GenerateRandomString = GenerateRandomString;

function GenerateGuid() {
  return GenerateRandomString(8) + '-' + GenerateRandomString(4) + '-' + GenerateRandomString(4) + '-' + GenerateRandomString(4) + '-' + GenerateRandomString(12);
}

guid_module.GenerateGuid = GenerateGuid;

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SearchComboComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const guid_module_1 = guid_module;
  const combo_data_model_1 = comboData_model;
  const searchComboConfig = {
    disabled: false,
    optionsList: [],
    favOptionsList: [],
    maxElements: undefined,
    showValueInLabel: false,
    labelValuePrefix: '',
    labelValueSufix: '',
    showEmptyItem: false,
    emptyOptionValue: null,
    emptyOptionDescription: '',
    placeholder: 'Select...',
    showInputOption: false,
    inputOptionPrefix: '',
    inputOptionSuffix: ''
  };

  const noop = () => {};

  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => SearchComboComponent),
    multi: true
  };

  let SearchComboComponent = /*@__PURE__*/(() => {
    let SearchComboComponent = class SearchComboComponent {
      constructor(myElement) {
        this.isDropdownOpen = false;
        this.textBoxId = guid_module_1.GenerateGuid();
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.allowInsertIncluded = false;
        this.optionChanged = new core_1.EventEmitter();
        this.optionAdded = new core_1.EventEmitter();
        this.focusIn = new core_1.EventEmitter();
        this.focusOut = new core_1.EventEmitter();
        this.click = new core_1.EventEmitter();
        this.optionFilter = '';
        this.textValue = '';
        this.filteredList = [];
        this.optionsDropdownOpened = false;
        this.initialized = false;
        this.addOptionFormVisible = false;
        this.isClicked = false;
        this.textValuePru = '';
        this.isButtonEnabled = true;
        this.elementRef = myElement;
      }

      get value() {
        return this.innerValue;
      }

      set value(v) {
        if (v !== this.innerValue) {
          this.innerValue = v;
          this.onChangeCallback(v);
        }
      }

      get optionsList() {
        return this._optionsList;
      }

      set optionsList(list) {
        if (list !== this._optionsList) {
          this._optionsList = list;
          let oldOptionFilter = this.optionFilter;
          this.optionFilter = '';
          this.RefreshList(false);

          if (oldOptionFilter && this.innerValue) {
            this.innerValue = this.optionsList.find(option => {
              return option.description.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c').indexOf(oldOptionFilter.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c')) > -1;
            });
            if (this.innerValue) this.optionFilter = oldOptionFilter;
          }
        }
      }

      get favOptionsList() {
        return this._favOptionsList;
      }

      set favOptionsList(list) {
        if (list !== this._favOptionsList) {
          this._favOptionsList = list;
          this.RefreshList(false);
        }
      }

      ngOnInit() {
        this.disabled = typeof this.disabled !== 'undefined' ? this.disabled : searchComboConfig.disabled;
        this.optionsList = typeof this.optionsList !== 'undefined' ? this.optionsList : searchComboConfig.optionsList;
        this.favOptionsList = typeof this.favOptionsList !== 'undefined' ? this.favOptionsList : searchComboConfig.favOptionsList;
        this.maxElements = typeof this.maxElements !== 'undefined' ? this.maxElements : searchComboConfig.maxElements;
        this.showValueInLabel = typeof this.showValueInLabel !== 'undefined' ? this.showValueInLabel : searchComboConfig.showValueInLabel;
        this.labelValuePrefix = typeof this.labelValuePrefix !== 'undefined' ? this.labelValuePrefix : searchComboConfig.labelValuePrefix;
        this.labelValueSufix = typeof this.labelValueSufix !== 'undefined' ? this.labelValueSufix : searchComboConfig.labelValueSufix;
        this.showEmptyItem = typeof this.showEmptyItem !== 'undefined' ? this.showEmptyItem : searchComboConfig.showEmptyItem;
        this.emptyOptionValue = typeof this.emptyOptionValue !== 'undefined' ? this.emptyOptionValue : searchComboConfig.emptyOptionValue;
        this.emptyOptionDescription = typeof this.emptyOptionDescription !== 'undefined' ? this.emptyOptionDescription : searchComboConfig.emptyOptionDescription;
        this.placeholder = typeof this.placeholder !== 'undefined' ? this.placeholder : searchComboConfig.placeholder;
        this.showInputOption = typeof this.showInputOption !== 'undefined' ? this.showInputOption : searchComboConfig.showInputOption;
        this.inputOptionPrefix = typeof this.inputOptionPrefix !== 'undefined' ? this.inputOptionPrefix : searchComboConfig.inputOptionPrefix;
        this.inputOptionSuffix = typeof this.inputOptionSuffix !== 'undefined' ? this.inputOptionSuffix : searchComboConfig.inputOptionSuffix;
        this.showButtonIcon = typeof this.showButtonIcon !== 'undefined' ? this.showButtonIcon : searchComboConfig.showButtonIcon;
        this.emptyOption = new combo_data_model_1.ComboData(this.emptyOptionValue, this.emptyOptionDescription || '');
        this.inputOption = new combo_data_model_1.ComboData('', '');
        this.RefreshList(false);
        this.initialized = true;
      }

      onBlur() {
        this.onTouchedCallback();
      }

      writeValue(value) {
        if (value !== this.innerValue) {
          this.innerValue = value ? value : this.emptyOption;
        }

        this.textValue = value ? this.GetOptionLabel(value) : this.GetOptionLabel(this.emptyOption);
        this.isButtonEnabled = true;
      }

      registerOnChange(fn) {
        this.onChangeCallback = fn;
      }

      registerOnTouched(fn) {
        this.onTouchedCallback = fn;
      }

      RefreshList(openDropdown) {
        if (openDropdown && !this.disabled) this.optionsDropdownOpened = true;
        this.filteredList = this.optionsList.filter(option => {
          return option && option.description && option.description.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c').indexOf(this.optionFilter.toLowerCase().replace('á', 'a').replace('é', 'e').replace('í', 'i').replace('ó', 'o').replace('ú', 'u').replace('à', 'a').replace('è', 'e').replace('ì', 'i').replace('ò', 'o').replace('ù', 'u').replace('ñ', 'n').replace('ç', 'c')) > -1;
        }).slice(0, this.maxElements);
        if (this.allowInsertIncluded || this.allowInsert && this.filteredList.length === 0) this.addOptionFormVisible = true;else this.addOptionFormVisible = false;
      }

      SelectOption(option) {
        if (option.status === undefined || option.status && option.status === true) {
          this.isClicked = true;
          setTimeout(() => {
            this.isClicked = false;
          }, 500);
          this.textValue = this.GetOptionLabel(option);
          this.value = option;
          this.optionsDropdownOpened = true;
          this.HideOptions();
          this.optionChanged.emit(option);
        }

        return false;
      }

      ToogleDropDownList(source, elementRef) {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (this.optionsDropdownOpened === true) {
            this.HideOptions();
          } else {
            this.ShowOptions();
          }
        }
      }

      GetOptionLabel(option) {
        option = option || new combo_data_model_1.ComboData(null, null);

        if (this.showValueInLabel && option.value && typeof option.value === 'string') {
          return option.description + ' (' + (this.labelValuePrefix + option.value + this.labelValueSufix).trim() + ')';
        } else {
          return option.description;
        }
      }

      OnKeyUp() {
        if (this.textValue === '') {
          this.value = new combo_data_model_1.ComboData('', '');
          this.textValue = this.GetOptionLabel(this.value);
          this.optionChanged.emit(this.value);
        }

        this.optionFilter = this.textValue;
        let valueFilterOption = this.GetOptionLabel(this.value);
        this.isButtonEnabled = this.textValue.toLowerCase() == valueFilterOption.toLowerCase() ? true : false;

        if (this.showInputOption) {
          this.inputOption.value = this.textValue || '';
          this.inputOption.description = this.textValue ? this.inputOptionPrefix + this.textValue + this.inputOptionSuffix : '';
        }

        this.RefreshList(true);
      }

      OnClick() {
        if (this.isClicked === false) {
          setTimeout(() => {
            this.isClicked = false;
          }, 500);
          this.click.emit();
        } else {
          this.isClicked = false;
        }

        document.getElementById(this.textBoxId).focus();
      }

      OnFocusIn() {
        setTimeout(() => {
          if (this.isClicked === false) this.ShowOptions();
        }, 250);
        this.focusIn.emit();
      }

      OnFocusOut(event) {
        setTimeout(() => {
          if (this.isClicked === false) {
            this.optionsDropdownOpened = false;
            this.HideOptions();
          }
        }, 250);
        this.focusOut.emit();
      }

      ShowOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) ; else {
            list.classList.add('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === false) {
          this.optionsDropdownOpened = true;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      HideOptions() {
        let list = this.elementRef.nativeElement.firstChild;

        if (list) {
          if (list.classList.contains('show') || list.classList.contains('open')) {
            list.classList.remove('show', 'open');
          }
        }

        if (this.optionsDropdownOpened === true) {
          this.optionsDropdownOpened = false;

          if (list.children && list.children.length) {
            list.children[0].setAttribute('aria-expanded', this.optionsDropdownOpened);
          }
        }
      }

      AddOption() {
        this.optionAdded.emit(this.textValue);
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array), tslib_1.__metadata("design:paramtypes", [Array])], SearchComboComponent.prototype, "optionsList", null);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array), tslib_1.__metadata("design:paramtypes", [Array])], SearchComboComponent.prototype, "favOptionsList", null);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "disabled", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Number)], SearchComboComponent.prototype, "maxElements", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "showValueInLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "labelValuePrefix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "labelValueSufix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "showEmptyItem", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "emptyOptionValue", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "emptyOptionDescription", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "placeholder", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "showInputOption", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "inputOptionPrefix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "inputOptionSuffix", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "allowInsert", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "addOptionButtonText", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "showButtonIcon", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], SearchComboComponent.prototype, "allowInsertIncluded", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], SearchComboComponent.prototype, "addOptionButtonIcon", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], SearchComboComponent.prototype, "optionChanged", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], SearchComboComponent.prototype, "optionAdded", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], SearchComboComponent.prototype, "focusIn", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], SearchComboComponent.prototype, "focusOut", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], SearchComboComponent.prototype, "click", void 0);

    SearchComboComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'search-combo-cmp',
      templateUrl: 'search-combo.html',
      styleUrls: ['search-combo.css'],
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [core_1.ElementRef])], SearchComboComponent);
    return SearchComboComponent;
  })();

  exports.SearchComboComponent = SearchComboComponent;
})(searchCombo_component, searchCombo_component.exports);

var toggleSwitch_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ToggleSwitchComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const toggleSwitchConfig = {
    beforeLabel: '',
    afterLabel: '',
    disabled: true
  };

  const noop = () => {};

  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => ToggleSwitchComponent),
    multi: true
  };

  let ToggleSwitchComponent = /*@__PURE__*/(() => {
    let ToggleSwitchComponent = class ToggleSwitchComponent {
      constructor(myElement) {
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.change = new core_1.EventEmitter();
        this.initialized = false;
        this.elementRef = myElement;
      }

      get value() {
        return this.innerValue;
      }

      set value(v) {
        if (v !== this.innerValue) {
          this.innerValue = v;
          this.onChangeCallback(v);
          this.change.emit(this.innerValue);
        }
      }

      ngOnInit() {
        this.beforeLabel = typeof this.beforeLabel !== 'undefined' ? this.beforeLabel : toggleSwitchConfig.beforeLabel;
        this.afterLabel = typeof this.afterLabel !== 'undefined' ? this.afterLabel : toggleSwitchConfig.afterLabel;
        this.disabled = typeof this.disabled !== 'undefined' ? this.disabled : toggleSwitchConfig.disabled;
        this.initialized = true;
      }

      onBlur() {
        this.onTouchedCallback();
      }

      writeValue(value) {
        if (value !== this.innerValue) {
          this.innerValue = value;
        }
      }

      registerOnChange(fn) {
        this.onChangeCallback = fn;
      }

      registerOnTouched(fn) {
        this.onTouchedCallback = fn;
      }

      SwitchValue(event) {
        if (!this.disabled) this.value = !this.value;
        return false;
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ToggleSwitchComponent.prototype, "beforeLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], ToggleSwitchComponent.prototype, "afterLabel", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], ToggleSwitchComponent.prototype, "disabled", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], ToggleSwitchComponent.prototype, "change", void 0);

    ToggleSwitchComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'toggle-switch-cmp',
      templateUrl: 'toggle-switch.html',
      styleUrls: ['toggle-switch.css'],
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [core_1.ElementRef])], ToggleSwitchComponent);
    return ToggleSwitchComponent;
  })();

  exports.ToggleSwitchComponent = ToggleSwitchComponent;
})(toggleSwitch_component, toggleSwitch_component.exports);

var ability_model = {};

var score_model = {};

var arraysHelper = {};

(function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TrimFieldsObject = exports.SortObjectArrayByValue = exports.SortArrayByValue = exports.GetUniqueFromObjectArray = exports.GetUniqueFromArray = exports.arrayRemove = exports.GetCompareItemsFromObjectArray = void 0;

  function GetCompareItemsFromObjectArray(oldArr, newArr, keyPropertyOA, keyPropertyNA) {
    if (!oldArr) oldArr = [];
    if (!newArr) newArr = [];
    let newItems = [];
    let oldItems = [];
    let removedItems = [];
    oldArr.map(oa => {
      if (!newArr.find(na => na[keyPropertyNA] === oa[keyPropertyOA])) removedItems.push(oa);else oldItems.push(oa);
    });
    newArr.map(na => {
      if (!oldArr.find(oa => oa[keyPropertyOA] === na[keyPropertyNA])) newItems.push(na);
    });
    return {
      new: newItems,
      old: oldItems,
      removed: removedItems
    };
  }

  exports.GetCompareItemsFromObjectArray = GetCompareItemsFromObjectArray;

  function arrayRemove(arr, value) {
    return arr.filter(function (ele) {
      return ele !== value;
    });
  }

  exports.arrayRemove = arrayRemove;

  function GetUniqueFromArray(arr) {
    let reducedArray = arr.reduce((unique, item) => {
      return unique.includes(item) ? unique : [...unique, item];
    }, []);
    return reducedArray;
  }

  exports.GetUniqueFromArray = GetUniqueFromArray;

  function GetUniqueFromObjectArray(arr, value) {
    const unique = arr.map(e => e[value]).map((e, i, final) => final.indexOf(e) === i && i).filter(e => arr[e]).map(e => arr[e]);
    return unique;
  }

  exports.GetUniqueFromObjectArray = GetUniqueFromObjectArray;

  function SortArrayByValue(arr, sortType) {
    let sortedObjectArray = [];

    switch (sortType) {
      case 'A':
        sortedObjectArray = arr.sort((a, b) => a - b);
        break;

      case 'D':
        sortedObjectArray = arr.sort((a, b) => b - a);
        break;
    }

    return sortedObjectArray;
  }

  exports.SortArrayByValue = SortArrayByValue;

  function SortObjectArrayByValue(arr, key, sortType) {
    return arr.sort((a, b) => {
      if (!a[key]) a[key] = '';
      if (!b[key]) b[key] = '';

      if (isNaN(a[key])) {
        let aText = a[key]?.normalize('NFD').replace(/[\u0300-\u036f]/g, '');
        let bText = b[key]?.normalize('NFD').replace(/[\u0300-\u036f]/g, '');
        if (aText?.toLowerCase() > bText?.toLowerCase()) return sortType === 'A' ? 1 : -1;
        if (aText?.toLowerCase() < bText?.toLowerCase()) return sortType === 'A' ? -1 : 1;
      } else {
        if (a[key] > b[key]) return sortType === 'A' ? 1 : -1;
        if (a[key] < b[key]) return sortType === 'A' ? -1 : 1;
      }

      return 0;
    });
  }

  exports.SortObjectArrayByValue = SortObjectArrayByValue;

  const TrimFieldsObject = object => {
    for (const property in object) {
      if (typeof object[property] === "string") object[property] = object[property].trim();else if (typeof object[property] === "object") object[property] = exports.TrimFieldsObject(object[property]);
    }

    return object;
  };

  exports.TrimFieldsObject = TrimFieldsObject;
})(arraysHelper);

var tipification_model = {};

Object.defineProperty(tipification_model, "__esModule", {
  value: true
});
tipification_model.TipificationFormItem = tipification_model.TipificationForm = tipification_model.TipificationItem = tipification_model.TipificationQuery = tipification_model.Tipification = void 0;
const arrays_helper_1$3 = arraysHelper;

class Tipification {
  constructor() {
    this.id = null;
    this.description = null;
    this.detail = null;
    this.tipificationQuery = new TipificationQuery();
    this.items = [];
    this.selected = false;
    this.createdByUserId = null;
    this.createdDate = null;
    this.lastModifiedByUserId = null;
    this.lastModifiedDate = null;
  }

}

tipification_model.Tipification = Tipification;

class TipificationQuery {
  constructor() {
    this.queryId = null;
    this.queryContent = null;
    this.acceptancePercentage = 0;
    this.acceptanceInteger = 0;
  }

}

tipification_model.TipificationQuery = TipificationQuery;

class TipificationItem {
  constructor() {
    this.tipificationId = null;
    this.id = null;
    this.secondLevelItemId = null;
    this.description = null;
    this.order = null;
    this.isChecked = false;
  }

}

tipification_model.TipificationItem = TipificationItem;

class TipificationForm {
  constructor() {
    this.id = null;
    this.items = [];
    this._content = [];
  }

  get content() {
    return this._content;
  }

  UpdateItemsOrder() {
    this.items.forEach((item, index) => item.order = index);
  }

  RenderContent() {
    this.UpdateItemsOrder();
    let formContent = [];
    formContent = this.items.filter(i => !i.secondLevelItemId).map(i => {
      let clonedItem = { ...i
      };
      clonedItem.item = i;
      return clonedItem;
    });
    formContent = arrays_helper_1$3.SortObjectArrayByValue(formContent, 'order', 'A');
    formContent.forEach(sl => {
      let thirdLevelItems = this.items.filter(i => i.secondLevelItemId === sl.id).map(i => {
        let clonedItem = { ...i
        };
        clonedItem.item = i;
        return clonedItem;
      });
      thirdLevelItems = arrays_helper_1$3.SortObjectArrayByValue(thirdLevelItems, 'order', 'A');
      sl.items = thirdLevelItems;
    });
    this._content = formContent;
  }

  RemoveEmptyItems() {
    this.items = this.items.filter(i => i.label);
    this.UpdateItemsOrder();
  }

  GetFormItemsFromData(data) {
    this.items = [];
    data.forEach(d => {
      let item = new TipificationFormItem(this.id, d.id);
      item.tipificationId = d.tipificationId;
      item.secondLevelItemId = d.secondLevelItemId;
      item.label = d.description;
      item.order = d.order;
      item.isChecked = d.isChecked;
      item.isEditing = false;
      this.items.push(item);
    });
    this.RenderContent();
  }

  GetTipificationItem() {
    let items = [];
    this.items.forEach(i => {
      if (i.label) {
        let item = new TipificationItem();
        item.id = i.id;
        item.tipificationId = i.tipificationId;
        item.secondLevelItemId = i.secondLevelItemId;
        item.description = i.label;
        item.order = i.order;
        item.isChecked = i.isChecked;
        items.push(item);
      }
    });
    return items;
  }

}

tipification_model.TipificationForm = TipificationForm;

class TipificationFormItem {
  constructor(formId = null, id = null) {
    this.formId = formId;
    this.id = id;
    this.tipificationId = null;
    this.secondLevelItemId = null;
    this.label = null;
    this.isEditing = true;
    this.isChecked = false;
    this.item = null;
    this.order = null;
  }

}

tipification_model.TipificationFormItem = TipificationFormItem;

Object.defineProperty(score_model, "__esModule", {
  value: true
});
score_model.ScoreTipificationItem = score_model.ScoreTipificationForm = score_model.ScoreTipification = score_model.Score = void 0;
const arrays_helper_1$2 = arraysHelper;
const combo_data_model_1$1 = comboData_model;
const tipification_model_1 = tipification_model;

class Score {
  constructor(id, description, value) {
    this.id = id;
    this.description = description;
    this.value = value;
    this.tipifications = [];
    this.calificationOption = null;
  }

}

score_model.Score = Score;

class ScoreTipification {
  constructor() {
    this.id = null;
    this.description = null;
    this.descriptionDetail = null;
    this.order = null;
    this.tipificationQuery = new tipification_model_1.TipificationQuery();
    this.items = [];
  }

}

score_model.ScoreTipification = ScoreTipification;

class ScoreTipificationForm {
  constructor() {
    this.id = null;
    this.items = [];
    this._content = [];
    this.tipificationsOptions = null;
  }

  get content() {
    return this._content;
  }

  UpdateItemsOrder() {
    this.items.forEach((item, index) => item.order = index);
  }

  RenderContent() {
    this.UpdateItemsOrder();
    let formContent = [];
    formContent = this.items.map(i => {
      let clonedItem = { ...i
      };
      clonedItem.item = i;
      return clonedItem;
    });
    formContent = arrays_helper_1$2.SortObjectArrayByValue(formContent, 'order', 'A');
    this._content = formContent;
  }

  AddItem(item, renderContent = true) {
    this.items.splice(item.order, 0, item);
    if (renderContent) this.RenderContent();
  }

  GetItemsFromScoreTipifications(scoreTipifications, tipificationOptions, queryOptions) {
    this.items = [];
    scoreTipifications.forEach(st => {
      let newItem = new ScoreTipificationItem();
      newItem.selectedOption = tipificationOptions.find(to => to.GetValueId() === st.id);
      newItem.selectedQueryOption = queryOptions.find(qo => qo.GetValueData('id') === st.tipificationQuery.queryId);
      newItem.id = st.id;
      newItem.label = st.description;
      newItem.item = st;
      newItem.isEditing = false;
      newItem.order = st.order ? st.order : this.items.length;
      this.AddItem(newItem, false);
    });
    this.RenderContent();
  }

  GetTipificationsOptions(allTipifications) {
    let validTipificationsOptions = [];
    allTipifications.forEach(at => {
      if (!this.items.find(i => i.item?.id === at.id)) validTipificationsOptions.push(new combo_data_model_1$1.ComboData(at, at.description));
    });
    if (JSON.stringify(this.tipificationsOptions) !== JSON.stringify(validTipificationsOptions)) this.tipificationsOptions = validTipificationsOptions;
    return this.tipificationsOptions;
  }

}

score_model.ScoreTipificationForm = ScoreTipificationForm;

class ScoreTipificationItem {
  constructor() {
    this.id = null;
    this.item = null;
    this.tipificationQuery = new tipification_model_1.TipificationQuery();
    this.comment = null;
    this.items = [];
    this.label = null;
    this.order = null;
    this.isEditing = true;
    this.isLoadingLevels = false;
    this.selectedOption = null;
    this.selectedQueryOption = null;
  }

}

score_model.ScoreTipificationItem = ScoreTipificationItem;

Object.defineProperty(ability_model, "__esModule", {
  value: true
});
ability_model.AbilityQueryEntity = ability_model.AbilityQuery = ability_model.SelectAbilityQuery = ability_model.Ability = ability_model.AbilityCalificationTypes = ability_model.AbilityTypes = void 0;
const score_model_1 = score_model;

class AbilityTypes {
  constructor(manual = 'MANUAL', automatic = 'MANUAL_AUTOMATIC') {
    this.manual = manual;
    this.automatic = automatic;
  }

}

ability_model.AbilityTypes = AbilityTypes;

class AbilityCalificationTypes {
  constructor(qualitative = 'QUALITATIVE', quantitative = 'QUANTITATIVE') {
    this.qualitative = qualitative;
    this.quantitative = quantitative;
  }

}

ability_model.AbilityCalificationTypes = AbilityCalificationTypes;

class Ability {
  constructor(id, title, detail, binary, notApply, acceptComments, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled) {
    this.id = id;
    this.title = title;
    this.detail = detail;
    this.binary = binary;
    this.notApply = notApply;
    this.acceptComments = acceptComments;
    this.createdDate = createdDate;
    this.createdByUserId = createdByUserId;
    this.lastModifiedDate = lastModifiedDate;
    this.lastModifiedByUserId = lastModifiedByUserId;
    this.enabled = enabled;
    this.selected = false;
    this.type = null;
    this.distribute = false;
    this.analysisType = null;
    this.calificationType = null;
    this.executionType = null;
    this.isCritical = false;
    this.queries = [];
    this.isNegative = false;
    this.degradeScoreCard = false;
  }

  static createDefault(name, yesName, noName) {
    let a = new Ability(null, name, name, true, false, false, null, null, null, null, null);
    a.calificationType = 'QUALITATIVE';
    a.type = 'MANUAL';
    a.distribute = false;
    a.scores = [];
    a.scores.push(new score_model_1.Score(null, yesName, 100));
    a.scores.push(new score_model_1.Score(null, noName, 0));
    return a;
  }

}

ability_model.Ability = Ability;

class SelectAbilityQuery {
  constructor() {
    this.id = null;
    this.modelIntentOptions = [];
    this.selectedModelIntentOption = null;
    this.lastSelectedModelIntentOption = null;
    this.modelEntityOptions = [];
    this.abilityQuery = null;
    this.order = null;
  }

}

ability_model.SelectAbilityQuery = SelectAbilityQuery;

class AbilityQuery {
  constructor() {
    this.id = null;
    this.abilityId = null;
    this.queryId = null;
    this.queryContent = null;
    this.acceptancePercentage = 0;
    this.acceptanceInteger = 0;
    this.order = null;
    this.entities = [];
    this.createdDate = null;
    this.createdByUserId = null;
    this.lastModifiedDate = null;
    this.lastModifiedByUserId = null;
    this.showDescription = false;
  }

}

ability_model.AbilityQuery = AbilityQuery;

class AbilityQueryEntity {
  constructor() {
    this.abilityQueryId = null;
    this.entityId = null;
    this.entityName = null;
    this.acceptancePercentage = 0;
    this.acceptanceInteger = 0;
    this.order = null;
    this.createdDate = null;
    this.createdByUserId = null;
    this.lastModifiedDate = null;
    this.lastModifiedByUserId = null;
  }

}

ability_model.AbilityQueryEntity = AbilityQueryEntity;

var intent_service = {};

Object.defineProperty(intent_service, "__esModule", {
  value: true
});
intent_service.IntentService = void 0;
const tslib_1$f = require$$0;
const core_1$f = require$$0$1;
const http_1$a = require$$19;
const operators_1$a = require$$3;
const env_config_1$a = env_config;
const auth_guard_service_1$a = authGuard_service;

let IntentService = /*@__PURE__*/(() => {
  let IntentService = class IntentService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetNLUsIntents(searchCriteria, searchExpression) {
      let url = env_config_1$a.Config.API + '/api/nlu/get_nlus_intents/' + searchCriteria + '/' + searchExpression;
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetIntents(searchCriteria, searchExpression, appId) {
      let url = env_config_1$a.Config.API + '/api/intent/get_intents/' + appId + '/' + searchCriteria + '/' + searchExpression;
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetIntent(intentId) {
      let url = env_config_1$a.Config.API + '/api/intent/get_intent/' + intentId;
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateIntent(intent) {
      let url = env_config_1$a.Config.API + '/api/intent/create_intent';
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(intent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveIntent(intent) {
      let url = env_config_1$a.Config.API + '/api/intent/save_intent';
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(intent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteIntent(intent) {
      let bodyContent = {};
      bodyContent.intent = intent;
      let url = env_config_1$a.Config.API + '/api/intent/delete_intent';
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteIntents(intents) {
      let bodyContent = {};
      bodyContent.intents = [];
      intents.forEach(function (intent) {
        bodyContent.intents.push(intent);
      });
      let url = env_config_1$a.Config.API + '/api/intent/delete_intents';
      let headers = new http_1$a.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$a.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$a.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  IntentService = tslib_1$f.__decorate([core_1$f.Injectable(), tslib_1$f.__metadata("design:paramtypes", [http_1$a.HttpClient, auth_guard_service_1$a.AuthGuardService])], IntentService);
  return IntentService;
})();

intent_service.IntentService = IntentService;

var tipification_service = {};

Object.defineProperty(tipification_service, "__esModule", {
  value: true
});
tipification_service.TipificationService = void 0;
const tslib_1$e = require$$0;
const core_1$e = require$$0$1;
const http_1$9 = require$$19;
const operators_1$9 = require$$3;
const auth_guard_service_1$9 = authGuard_service;
const env_config_1$9 = env_config;

let TipificationService = /*@__PURE__*/(() => {
  let TipificationService = class TipificationService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    CreateTipification(tipification) {
      let url = env_config_1$9.Config.API + '/api/tipification/create_tipification';
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(tipification);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveTipification(tipification) {
      let url = env_config_1$9.Config.API + '/api/tipification/save_tipification';
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(tipification);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetTipifications(searchCriteria, searchExpression) {
      let url = `${env_config_1$9.Config.API}/api/tipification/get_tipifications/${searchCriteria}/${searchExpression}`;
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetTipification(tipificationId) {
      let url = `${env_config_1$9.Config.API}/api/tipification/get_tipification/${tipificationId}`;
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteTipification(tipification) {
      let url = env_config_1$9.Config.API + '/api/tipification/delete_tipification';
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(tipification);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteTipifications(tipifications) {
      let bodyContent = {};
      bodyContent.tipifications = [];
      tipifications.forEach(t => bodyContent.tipifications.push(t));
      let url = env_config_1$9.Config.API + '/api/tipification/delete_tipifications';
      let headers = new http_1$9.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$9.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$9.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  TipificationService = tslib_1$e.__decorate([core_1$e.Injectable(), tslib_1$e.__metadata("design:paramtypes", [http_1$9.HttpClient, auth_guard_service_1$9.AuthGuardService])], TipificationService);
  return TipificationService;
})();

tipification_service.TipificationService = TipificationService;

var shared_validator = {};

Object.defineProperty(shared_validator, "__esModule", {
  value: true
});
shared_validator.isPinAvailable = shared_validator.isDecimalWithLimit = shared_validator.isCurrency = shared_validator.isAlpha = shared_validator.isValidDate = shared_validator.areStringAndEqual = shared_validator.isStringAndPhoneNumber = shared_validator.isDecimal = shared_validator.isNumber = shared_validator.isNumberAndInt = shared_validator.isStringAndInt = shared_validator.isStringAndEmail = shared_validator.isStringAndValiadURL = shared_validator.isStringAndValiadDomain = shared_validator.isStringAndValidUserId = shared_validator.isStringAndValiadId = shared_validator.isStringAndAllowedValue = shared_validator.isValidHost = shared_validator.isValidIP = shared_validator.isFTPDirectory = shared_validator.HasSpecialCharacters2 = shared_validator.HasSpecialCharacters1 = shared_validator.HasSpaces = shared_validator.isStringAndEmpty = shared_validator.isNull = void 0;
const validator = validator$1.exports;

function isNull(value) {
  return value === null || value === undefined;
}

shared_validator.isNull = isNull;

function isStringAndEmpty(str) {
  if (typeof str !== 'string') {
    return true;
  } else {
    return validator.isEmpty(str);
  }
}

shared_validator.isStringAndEmpty = isStringAndEmpty;

function HasSpaces(str) {
  if (str.trim().match(/\s+/g)) return true;
  return false;
}

shared_validator.HasSpaces = HasSpaces;

function HasSpecialCharacters1(str) {
  let text = str.replace(/[A-Za-zÁÉÍÓÚÜÑáéíóúüñ]/g, '');
  if (text.length > 0) return true;
  return false;
}

shared_validator.HasSpecialCharacters1 = HasSpecialCharacters1;

function HasSpecialCharacters2(str) {
  let text = str.replace(/[A-Za-zÁáÀàÂâÃãÉéÊêÍíÓóÔôÕõÚú]/g, '');
  if (text.length > 0) return true;
  return false;
}

shared_validator.HasSpecialCharacters2 = HasSpecialCharacters2;

function isFTPDirectory(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return !validator.matches(str, /^(\/[\w-_]+)*$/);
  }
}

shared_validator.isFTPDirectory = isFTPDirectory;

function isValidIP(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    const ip = str.split('.');
    if (ip.length != 4) return false;

    for (var i in ip) {
      if (!/^\d+$/g.test(ip[i]) || +ip[i] > 255 || +ip[i] < 0 || /^[0][0-9]{1,2}/.test(ip[i])) return false;
    }

    return true;
  }
}

shared_validator.isValidIP = isValidIP;

function isValidHost(str) {
  const ip = str.split('.');
  if (ip.length != 4) return false;

  for (var i in ip) {
    if (!/^\d+$/g.test(ip[i]) || +ip[i] > 255 || +ip[i] < 0 || /^[0][0-9]{1,2}/.test(ip[i])) return false;
  }

  return true;
}

shared_validator.isValidHost = isValidHost;

function isStringAndAllowedValue(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return !validator.isIn(str, ['new']);
  }
}

shared_validator.isStringAndAllowedValue = isStringAndAllowedValue;

function isStringAndValiadId(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.matches(str, /^[0-9a-zA-Z\-\_]+$/);
  }
}

shared_validator.isStringAndValiadId = isStringAndValiadId;

function isStringAndValidUserId(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.matches(str, /^[0-9a-zA-Z\-\_\.]+$/);
  }
}

shared_validator.isStringAndValidUserId = isStringAndValidUserId;

function isStringAndValiadDomain(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.matches(str, /[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_\+.~#?&//=]*)/) && !str.startsWith('www.') && !str.startsWith('http://') && !str.startsWith('https://') && !str.startsWith('http://');
  }
}

shared_validator.isStringAndValiadDomain = isStringAndValiadDomain;

function isStringAndValiadURL(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.isURL(str);
  }
}

shared_validator.isStringAndValiadURL = isStringAndValiadURL;

function isStringAndEmail(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.isEmail(str);
  }
}

shared_validator.isStringAndEmail = isStringAndEmail;

function isStringAndInt(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.isInt(str);
  }
}

shared_validator.isStringAndInt = isStringAndInt;

function isNumberAndInt(num) {
  if (typeof num !== 'number') {
    return false;
  } else {
    return validator.isInt(num || num === 0 ? num.toString() : '');
  }
}

shared_validator.isNumberAndInt = isNumberAndInt;

function isNumber(num) {
  num = Number(num);

  if (typeof num !== 'number') {
    return false;
  } else {
    return validator.isNumeric(num || num === 0 ? num.toString() : '');
  }
}

shared_validator.isNumber = isNumber;

function isDecimal(num) {
  if (typeof num !== 'number') {
    return false;
  } else {
    return validator.isDecimal(num || num === 0 ? num.toString() : '');
  }
}

shared_validator.isDecimal = isDecimal;

function isStringAndPhoneNumber(str) {
  if (typeof str !== 'string') {
    return false;
  } else {
    return validator.matches(str, /^[0-9\-\(\)\+\s]+$/);
  }
}

shared_validator.isStringAndPhoneNumber = isStringAndPhoneNumber;

function areStringAndEqual(str1, str2) {
  if (typeof str1 !== 'string' || typeof str2 !== 'string') {
    return false;
  } else {
    return str1 === str2;
  }
}

shared_validator.areStringAndEqual = areStringAndEqual;

function isValidDate(date) {
  return date && Object.prototype.toString.call(date) === '[object Date]' && !isNaN(date.getTime());
}

shared_validator.isValidDate = isValidDate;

function isAlpha(str) {
  return validator.isAlpha(str);
}

shared_validator.isAlpha = isAlpha;

function isCurrency(str) {
  return validator.isCurrency(str, {
    allow_negatives: false,
    decimal_separator: '.',
    allow_space_after_digits: false
  });
}

shared_validator.isCurrency = isCurrency;

function isDecimalWithLimit(str, decimalsAmount) {
  let result = false;
  let regex = /^[0-9]+([.][0-9]{1,5})?$/gm;

  if (typeof str === 'string') {
    result = regex.test(str);
  }

  return result;
}

shared_validator.isDecimalWithLimit = isDecimalWithLimit;

function isPinAvailable(pin) {
  if (pin.toString().length == 6 && !pin.toString().includes('e') && !pin.toString().includes('.')) {
    return true;
  } else {
    return false;
  }
}

shared_validator.isPinAvailable = isPinAvailable;

var modalGeneric_service = {};

Object.defineProperty(modalGeneric_service, "__esModule", {
  value: true
});
modalGeneric_service.ModalGenericService = void 0;
const tslib_1$d = require$$0;
const core_1$d = require$$0$1;
const rxjs_1 = require$$4;

let ModalGenericService = /*@__PURE__*/(() => {
  let ModalGenericService = class ModalGenericService {
    constructor() {
      this.onOpen = new rxjs_1.Subject();
      this.onClose = new rxjs_1.Subject();
      this.onSubmit = new rxjs_1.Subject();
      this.modal = null;
    }

    Initialize(modal) {
      this.modal = modal;
    }

    GetModal() {
      return this.modal;
    }

    Open() {
      this.onOpen.next(null);
    }

    Close() {
      this.onClose.next(null);
    }

    Submit(returnValue) {
      this.onSubmit.next(returnValue);
    }

  };
  ModalGenericService = tslib_1$d.__decorate([core_1$d.Injectable()], ModalGenericService);
  return ModalGenericService;
})();

modalGeneric_service.ModalGenericService = ModalGenericService;

var keysHelper = {};

(function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KEY_CODE = void 0;

  exports.KEY_CODE = /*@__PURE__*/function (KEY_CODE) {
    KEY_CODE[KEY_CODE["RIGHT_ARROW"] = 39] = "RIGHT_ARROW";
    KEY_CODE[KEY_CODE["LEFT_ARROW"] = 37] = "LEFT_ARROW";
    KEY_CODE[KEY_CODE["UP_ARROW"] = 38] = "UP_ARROW";
    KEY_CODE[KEY_CODE["DOWN_ARROW"] = 40] = "DOWN_ARROW";
    KEY_CODE[KEY_CODE["BACKSPACE"] = 8] = "BACKSPACE";
    KEY_CODE[KEY_CODE["ENTER"] = 13] = "ENTER";
    KEY_CODE[KEY_CODE["ESCAPE"] = 27] = "ESCAPE";
    KEY_CODE[KEY_CODE["ADD"] = 107] = "ADD";
    KEY_CODE[KEY_CODE["TAB"] = 9] = "TAB";
    KEY_CODE[KEY_CODE["DELETE"] = 46] = "DELETE";
    KEY_CODE[KEY_CODE["SPACE"] = 32] = "SPACE";
    return KEY_CODE;
  }(exports.KEY_CODE || {});
})(keysHelper);

var ability_validator = {};

Object.defineProperty(ability_validator, "__esModule", {
  value: true
});
ability_validator.AbilityValidator = void 0;
const shared$1 = shared_validator;
const ability_model_1 = ability_model;

class AbilityValidator {
  static Validate(ability, isCreate) {
    let errors = [];
    let abilityTypes = new ability_model_1.AbilityTypes();

    try {
      if (shared$1.isStringAndEmpty(ability.title)) {
        errors.push('ERROR_ABILITY_TITLE_MISSING');
      } else {
        if (!shared$1.isStringAndAllowedValue(ability.title)) errors.push('ERROR_ABILITY_TITLE_INVALID');else if (!shared$1.isStringAndValidUserId(ability.title)) errors.push('ERROR_ABILITY_TITLE_INVALID');
      }

      if (shared$1.isStringAndEmpty(ability.detail)) errors.push('ERROR_ABILITY_DETAIL_MISSING');

      if (ability.scores) {
        if (ability.scores.length === 0) errors.push('ERROR_ABILITY_SCORES_EMPTY');
        ability.scores.forEach(score => {
          if (shared$1.isStringAndEmpty(score.description)) errors.push('ERROR_ABILITY_SCORE_MISSING_DESCRIPTION');
          if (!shared$1.isNumber(score.value)) errors.push('ERROR_ABILITY_SCORE_MISSING_VALUE');
          if (score.value > 100 || score.value < 0) errors.push('ERROR_ABILITY_SCORE_VALUE_0_TO_100');
        });
        let control = false;
        ability.scores.forEach(score => {
          if (score.value == 0) control = true;
        });
        if (!control) errors.push('ERROR_ABILITY_SCORE_VALUE_ZERO');
        let nbrCantidad = 0;
        let blnExiste100 = false;
        let blnExiste0 = false;
        let blnScoreOutRange = false;
        let arrNotas = [];
        let blnScoreRepetido = false;
        ability.scores.forEach(score => {
          if (!shared$1.isStringAndEmpty(score.description)) {
            nbrCantidad = nbrCantidad + 1;

            if (shared$1.isNumber(score.value)) {
              if (score.value === 100) {
                blnExiste100 = true;
              }

              if (score.value <= 0) {
                blnExiste0 = true;
              }

              if (score.value > 100 || score.value < 0) {
                blnScoreOutRange = true;
              }

              if (arrNotas.indexOf(score.value) === -1) {
                arrNotas.push(score.value);
              } else {
                if (ability.title === 'MANUAL_AUTOMATIC') blnScoreRepetido = true;
              }
            }
          }
        });

        if (blnScoreRepetido) {
          errors.push('ERROR_ABILITY_REPEATED_SCORE');
        }

        if (ability.binary) {
          if (!(nbrCantidad === 2)) {
            errors.push('ERROR_ABILITY_BINARY_MORE_2_SCORES');
          }

          if (blnExiste100 === false) {
            errors.push('ERROR_ABILITY_NO_100_SCORE');
          }
        } else {
          if (nbrCantidad < 2) {
            errors.push('ERROR_ABILITY_MULTIPLE_LESS_2_SCORES');
          }

          if (blnExiste100 === false) {
            errors.push('ERROR_ABILITY_NO_100_SCORE');
          }

          if (blnScoreOutRange) {
            errors.push('ERROR_ABILITY_MULTIPLE_SCORE_OUTRANGE');
          }
        }
      }

      if (ability.type === abilityTypes.automatic) {
        if (!ability.queries.filter(q => q.queryId.length).length) errors.push('ERROR_AUTOMATIC_ABILITY_NEED_AT_LEAST_A_QUERY_INTENT');
      }
    } catch (e) {
      errors.push('ERROR_ON_VALIDATE');
    }

    return errors;
  }

  static ValidateManualToAutomatic(ability) {
    let errors = [];

    try {
      if (ability.scores) {
        if (ability.scores.length === 0) errors.push('ERROR_ABILITY_SCORES_EMPTY');
        ability.scores.forEach(score => {
          if (shared$1.isStringAndEmpty(score.description)) errors.push('ERROR_ABILITY_SCORE_MISSING_DESCRIPTION');
          if (!shared$1.isNumber(score.value)) errors.push('ERROR_ABILITY_SCORE_MISSING_VALUE');
          if (score.value > 100 || score.value < 0) errors.push('ERROR_ABILITY_SCORE_VALUE_0_TO_100');
        });
        let control = false;
        ability.scores.forEach(score => {
          if (score.value == 0) control = true;
        });
        if (!control) errors.push('ERROR_ABILITY_SCORE_VALUE_ZERO');
        let nbrCantidad = 0;
        let blnExiste100 = false;
        let blnExiste0 = false;
        let blnScoreOutRange = false;
        let arrNotas = [];
        let blnScoreRepetido = false;
        ability.scores.forEach(score => {
          if (!shared$1.isStringAndEmpty(score.description)) {
            nbrCantidad = nbrCantidad + 1;

            if (shared$1.isNumber(score.value)) {
              if (score.value === 100) {
                blnExiste100 = true;
              }

              if (score.value <= 0) {
                blnExiste0 = true;
              }

              if (score.value > 100 || score.value < 0) {
                blnScoreOutRange = true;
              }

              if (arrNotas.indexOf(score.value) === -1) {
                arrNotas.push(score.value);
              } else {
                blnScoreRepetido = true;
              }
            }
          }
        });

        if (blnScoreRepetido) {
          errors.push('ERROR_ABILITY_REPEATED_SCORE');
        }

        if (!(nbrCantidad === 2)) {
          errors.push('ERROR_ABILITY_BINARY_MORE_2_SCORES');
        }

        if (blnExiste100 === false) {
          errors.push('ERROR_ABILITY_NO_100_SCORE');
        }
      }
    } catch (e) {
      errors.push('ERROR_ON_VALIDATE');
    }

    return errors;
  }

}

ability_validator.AbilityValidator = AbilityValidator;

var ability_service = {};

Object.defineProperty(ability_service, "__esModule", {
  value: true
});
ability_service.AbilityService = void 0;
const tslib_1$c = require$$0;
const core_1$c = require$$0$1;
const http_1$8 = require$$19;
const operators_1$8 = require$$3;
const env_config_1$8 = env_config;
const auth_guard_service_1$8 = authGuard_service;

let AbilityService = /*@__PURE__*/(() => {
  let AbilityService = class AbilityService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetAbilityDetail(abilityId) {
      let url = env_config_1$8.Config.API + `/api/ability/get_ability_detail/${abilityId}`;
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetAbilities(searchCriteria, searchExpression, executionType, disabled = false) {
      executionType ?? (executionType = 'BATCH');
      searchCriteria ?? (searchCriteria = null);
      searchExpression ?? (searchExpression = null);
      let url = `${env_config_1$8.Config.API}/api/ability/get_abilitys/${searchCriteria}/${searchExpression}?executionType=${executionType}&disabled=${disabled}`;
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateAbility(ability) {
      let url = env_config_1$8.Config.API + '/api/ability/create_ability';
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(ability);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetAbility(abilityId) {
      let url = env_config_1$8.Config.API + '/api/ability/get_ability/' + abilityId;
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveAbility(ability) {
      let url = env_config_1$8.Config.API + '/api/ability/save_ability';
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(ability);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteAbility(ability) {
      let url = env_config_1$8.Config.API + '/api/ability/delete_ability';
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(ability);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteAbilitys(abilitys) {
      let bodyContent = {};
      bodyContent.abilitys = [...abilitys];
      let url = env_config_1$8.Config.API + '/api/ability/delete_abilitys';
      let headers = new http_1$8.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$8.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$8.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  AbilityService = tslib_1$c.__decorate([core_1$c.Injectable(), tslib_1$c.__metadata("design:paramtypes", [http_1$8.HttpClient, auth_guard_service_1$8.AuthGuardService])], AbilityService);
  return AbilityService;
})();

ability_service.AbilityService = AbilityService;

var genericQuery_validator = {};

Object.defineProperty(genericQuery_validator, "__esModule", {
  value: true
});
genericQuery_validator.GenericQueryValidator = void 0;
const shared = shared_validator;

class GenericQueryValidator {
  static Validate(genericQuery, isCreate) {
    let errors = [];

    try {
      if (shared.isStringAndEmpty(genericQuery.name)) errors.push('ERROR_NAME_MISSING');
      if (!shared.isStringAndValiadId(genericQuery.name)) errors.push('ERROR_NAME_INVALID');
      if (shared.isStringAndEmpty(genericQuery.description)) errors.push('ERROR_DESCRIPTION_MISSING');
      if (shared.isStringAndEmpty(genericQuery.query)) errors.push('ERROR_QUERY_MISSING');
    } catch (e) {
      errors.push('ERROR_ON_VALIDATE');
    }

    return errors;
  }

}

genericQuery_validator.GenericQueryValidator = GenericQueryValidator;

var genericQuery_model = {};

Object.defineProperty(genericQuery_model, "__esModule", {
  value: true
});
genericQuery_model.GenericQuery = void 0;

class GenericQuery {
  constructor(vcc, name, description, query, semanticQuery, rawData, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, version = 1) {
    this.vcc = vcc;
    this.name = name;
    this.description = description;
    this.query = query;
    this.semanticQuery = semanticQuery;
    this.rawData = rawData;
    this.createdDate = createdDate;
    this.createdByUserId = createdByUserId;
    this.lastModifiedDate = lastModifiedDate;
    this.lastModifiedByUserId = lastModifiedByUserId;
    this.version = version;
    this.type = null;
    this.selected = false;
    this.validationShow = false;
  }

}

genericQuery_model.GenericQuery = GenericQuery;

var genericQuery_service = {};

Object.defineProperty(genericQuery_service, "__esModule", {
  value: true
});
genericQuery_service.GenericQueryService = void 0;
const tslib_1$b = require$$0;
const core_1$b = require$$0$1;
const http_1$7 = require$$19;
const operators_1$7 = require$$3;
const env_config_1$7 = env_config;
const auth_guard_service_1$7 = authGuard_service;

let GenericQueryService = /*@__PURE__*/(() => {
  let GenericQueryService = class GenericQueryService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetGenericQueries(searchCriteria, searchExpression) {
      let url = env_config_1$7.Config.API + '/api/generic_query/get_generic_queries/' + searchCriteria + '/' + searchExpression;
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetGenericQuery(name) {
      let url = env_config_1$7.Config.API + '/api/generic_query/get_generic_query/' + name;
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetGenericQueryUsage(name) {
      let url = env_config_1$7.Config.API + '/api/generic_query/get_generic_query_usage/' + name;
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateGenericQuery(genericQuery) {
      let url = env_config_1$7.Config.API + '/api/generic_query/create_generic_query';
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(genericQuery);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveGenericQuery(genericQuery) {
      let url = env_config_1$7.Config.API + '/api/generic_query/save_generic_query';
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(genericQuery);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteGenericQuery(genericQuery) {
      let bodyContent = {};
      bodyContent.genericQuery = genericQuery;
      let url = env_config_1$7.Config.API + '/api/generic_query/delete_generic_query';
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$7.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

    TestGenericQuery(query) {
      let url = env_config_1$7.Config.API + '/api/generic_query/test_generic_query';
      let headers = new http_1$7.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        query
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$7.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  GenericQueryService = tslib_1$b.__decorate([core_1$b.Injectable(), tslib_1$b.__metadata("design:paramtypes", [http_1$7.HttpClient, auth_guard_service_1$7.AuthGuardService])], GenericQueryService);
  return GenericQueryService;
})();

genericQuery_service.GenericQueryService = GenericQueryService;

var nlu_service = {};

Object.defineProperty(nlu_service, "__esModule", {
  value: true
});
nlu_service.NLUService = void 0;
const tslib_1$a = require$$0;
const core_1$a = require$$0$1;
const http_1$6 = require$$19;
const operators_1$6 = require$$3;
const env_config_1$6 = env_config;
const auth_guard_service_1$6 = authGuard_service;

let NLUService = /*@__PURE__*/(() => {
  let NLUService = class NLUService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetUploadNLUUrl() {
      return env_config_1$6.Config.API + '/api/nlu/upload_file/';
    }

    DeleteFileTemporal() {
      let bodyContent = {};
      let url = env_config_1$6.Config.API + '/api/nlu/delete_file_temporal';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetNLUs(searchCriteria, searchExpression, isSystemApp = false) {
      let bodyContent = {
        searchCriteria: searchCriteria,
        searchExpression: searchExpression,
        isSystemApp: isSystemApp
      };
      let url = env_config_1$6.Config.API + '/api/nlu/get_nlus/';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetNLUsIntents(searchCriteria, searchExpression) {
      let url = env_config_1$6.Config.API + '/api/nlu/get_nlus_intents/' + searchCriteria + '/' + searchExpression;
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetCultures() {
      let url = env_config_1$6.Config.API + '/api/nlu/get_cultures';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetNLU(nluId) {
      let url = env_config_1$6.Config.API + `/api/nlu/get_nlu/${nluId}`;
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetNluByName(name) {
      let url = env_config_1$6.Config.API + `/api/nlu/get_nlu_by_name/${name}`;
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetUniqueNLUByIntents(params) {
      let url = env_config_1$6.Config.API + '/api/nlu/get_unique_nlu_by_intents';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(params);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateNLU(nlu) {
      let url = env_config_1$6.Config.API + '/api/nlu/create_nlu';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json',
        'TimeOut': '300000'
      });
      let body = JSON.stringify(nlu);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveNLU(nlu) {
      let url = env_config_1$6.Config.API + '/api/nlu/save_nlu';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(nlu);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteNLU(nlu) {
      let bodyContent = {};
      bodyContent.nlu = nlu;
      let url = env_config_1$6.Config.API + '/api/nlu/delete_nlu';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteNLUs(nlus) {
      let bodyContent = {};
      bodyContent.nlus = [];
      nlus.forEach(function (nlu) {
        bodyContent.nlus.push(nlu);
      });
      let url = env_config_1$6.Config.API + '/api/nlu/delete_nlus';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetSubscriptionKey(azureSubscriptionKey) {
      let url = env_config_1$6.Config.API + '/api/nlu/get_subscriptionkey';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(azureSubscriptionKey);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetSubscriptionKeys() {
      let url = env_config_1$6.Config.API + '/api/nlu/get_subscriptionkeys';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({});
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    ValidateAzureCredentials(azureSubscriptionKey, azureSubscription) {
      let url = env_config_1$6.Config.API + '/api/nlu/validate_azure_credentials';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        'azureSubscriptionKey': azureSubscriptionKey,
        'azureSubscription': azureSubscription
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    ExportNLU(nlu, fileName) {
      let bodyContent = {};
      bodyContent.nlu = nlu;
      let url = env_config_1$6.Config.API + '/api/nlu/export_nlu';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(response => {
        if (!/{"status":false/.test(response._body)) {
          let blob = new Blob([JSON.stringify(response)], {
            type: 'text/plain;charset=utf-8;'
          });
          let downLink = document.createElement('a');
          let url = URL.createObjectURL(blob);
          downLink.setAttribute('href', url);
          downLink.setAttribute('download', fileName);
          downLink.style.visibility = 'hidden';
          document.body.appendChild(downLink);
          downLink.click();
          document.body.removeChild(downLink);
          window.URL.revokeObjectURL(url);
        } else {
          throw response.json().description || response.json().error || '';
        }

        return true;
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetInteractionAgents() {
      let url = env_config_1$6.Config.API + '/api/agent/interaction/';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetInteractionCampaigns() {
      let url = env_config_1$6.Config.API + '/api/campaign/interaction/';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetNluToExport(vcc) {
      let url = env_config_1$6.Config.API + '/api/nlu/nlu-to-export/?vcc=' + vcc;
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$6.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    RetryNLU(appId) {
      let url = env_config_1$6.Config.API + '/api/nlu/retry_nlu';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        appId
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    TestNluPhrase(nlu) {
      let url = env_config_1$6.Config.API + '/api/nlu/test_nlu_phrase/';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        nlu
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

    StopTestNluPhrase(nlu) {
      let url = env_config_1$6.Config.API + '/api/nlu/stop_test_nlu_phrase/';
      let headers = new http_1$6.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        nlu
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$6.map(json => {
        if (json.status) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$6.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  NLUService = tslib_1$a.__decorate([core_1$a.Injectable(), tslib_1$a.__metadata("design:paramtypes", [http_1$6.HttpClient, auth_guard_service_1$6.AuthGuardService])], NLUService);
  return NLUService;
})();

nlu_service.NLUService = NLUService;

var entity_service = {};

Object.defineProperty(entity_service, "__esModule", {
  value: true
});
entity_service.EntityService = void 0;
const tslib_1$9 = require$$0;
const core_1$9 = require$$0$1;
const http_1$5 = require$$19;
const operators_1$5 = require$$3;
const env_config_1$5 = env_config;
const auth_guard_service_1$5 = authGuard_service;

let EntityService = /*@__PURE__*/(() => {
  let EntityService = class EntityService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetNLUsEntities(appIds) {
      let url = env_config_1$5.Config.API + '/api/entity/get_nlus_entities';
      let headers = new http_1$5.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        appIds: appIds
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$5.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$5.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEntities(searchCriteria, searchExpression, appId) {
      let url = env_config_1$5.Config.API + '/api/entity/get_entities/' + appId + '/' + searchCriteria + '/' + searchExpression;
      let headers = new http_1$5.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$5.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$5.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateEntity(entity) {
      let url = env_config_1$5.Config.API + '/api/entity/create_entity';
      let headers = new http_1$5.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(entity);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$5.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$5.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteEntity(entity) {
      let bodyContent = {};
      bodyContent.entity = entity;
      let url = env_config_1$5.Config.API + '/api/entity/delete_entity';
      let headers = new http_1$5.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$5.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$5.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  EntityService = tslib_1$9.__decorate([core_1$9.Injectable(), tslib_1$9.__metadata("design:paramtypes", [http_1$5.HttpClient, auth_guard_service_1$5.AuthGuardService])], EntityService);
  return EntityService;
})();

entity_service.EntityService = EntityService;

var cancelForm_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CancelFormComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const router_1 = require$$26;
  const modal_generic_service_1 = modalGeneric_service;
  const language_service_1 = language_service;
  const modal_service_1 = modal_service;

  let CancelFormComponent = /*@__PURE__*/(() => {
    let CancelFormComponent = class CancelFormComponent {
      constructor(activatedRoute, router, modalService, languageService, modalGenericService) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.modalService = modalService;
        this.languageService = languageService;
        this.modalGenericService = modalGenericService;
        this.callbackCancel = new core_1.EventEmitter();
      }

      ngOnInit() {}

      CancelEvent() {
        if (this.callbackCancel) {
          this.callbackCancel.emit();
        }

        if (!this.validateShowModal()) {
          if (!this.routeBack.length) {
            let modal = this.modalGenericService.GetModal();
            modal.cancel();
          } else {
            this.router.navigate(this.routeBack, {
              relativeTo: this.activatedRoute
            });
          }
        } else {
          let modal = this.modalService.GetModal();
          modal.formTitle = this.languageService.GetMessage('', 'CONFIRM');
          modal.formBody = this.languageService.GetMessage('', 'DISCARD_STORED_CHANGES');
          modal.cancelButtonLabel = this.languageService.GetMessage('', 'CANCEL');
          modal.submitButtonLabel = this.languageService.GetMessage('', 'CONFIRM');
          modal.showCloseButton = false;
          modal.modalClass = 'modal-xs';
          let subscription = this.modalService.onSubmit.subscribe(value => {
            if (!this.routeBack.length) {
              let modal = this.modalGenericService.GetModal();
              modal.cancel();
            } else {
              this.router.navigate(this.routeBack, {
                relativeTo: this.activatedRoute
              });
            }

            subscription.unsubscribe();
          });
          this.modalService.onClose.subscribe(value => subscription.unsubscribe());
          modal.open();
        }
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], CancelFormComponent.prototype, "title", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], CancelFormComponent.prototype, "translateCategory", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Function)], CancelFormComponent.prototype, "validateShowModal", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], CancelFormComponent.prototype, "routeBack", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", Object)], CancelFormComponent.prototype, "callbackCancel", void 0);

    CancelFormComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'cancel-form',
      templateUrl: 'cancel-form.html'
    }), tslib_1.__metadata("design:paramtypes", [router_1.ActivatedRoute, router_1.Router, modal_service_1.ModalService, language_service_1.LanguageService, modal_generic_service_1.ModalGenericService])], CancelFormComponent);
    return CancelFormComponent;
  })();

  exports.CancelFormComponent = CancelFormComponent;
})(cancelForm_component, cancelForm_component.exports);

var genericQuery_component = {exports: {}};

var comboTemplateData_model = {};

Object.defineProperty(comboTemplateData_model, "__esModule", {
  value: true
});
comboTemplateData_model.ClearRepeatedElementsComboTemplate = comboTemplateData_model.GetComboTemplateOptionById = comboTemplateData_model.ComboDataTemplate = void 0;

class ComboDataTemplate {
  constructor(value, description, title, icon, status) {
    this.value = value;
    this.description = description;
    this.title = title;
    this.icon = icon;
    this.status = status;
  }

  GetValueId(field) {
    return field && this.value && typeof this.value[field] === 'string' ? this.value[field] : this.value && typeof this.value === 'string' ? this.value : this.value && typeof this.value === 'number' ? this.value : (this.value || this.value === false) && typeof this.value === 'boolean' ? this.value : this.value && typeof this.value.id === 'string' ? this.value.id : null;
  }

  GetValueData(field) {
    return field && this.value && this.value[field] ? this.value[field] : null;
  }

}

comboTemplateData_model.ComboDataTemplate = ComboDataTemplate;

function GetComboTemplateOptionById(optionsList, optionId, optionIdFieldName) {
  return optionsList.find(item => {
    return (item.value || item.value === false || item.value === null && optionId === null) && (typeof item.value === typeof optionId && item.value === optionId || typeof item.value === typeof optionId && typeof item.value === 'object' && JSON.stringify(item.value) === JSON.stringify(optionId) || typeof item.GetValueId() === typeof optionId && item.GetValueId() === optionId && item.GetValueId() || optionIdFieldName && typeof item.value[optionIdFieldName] === typeof optionId && item.value[optionIdFieldName] === optionId);
  }) || null;
}

comboTemplateData_model.GetComboTemplateOptionById = GetComboTemplateOptionById;

function ClearRepeatedElementsComboTemplate(optionsList) {
  var hashes = {};
  return optionsList.filter(function (el) {
    var key = JSON.stringify(el);
    var match = Boolean(hashes[key]);
    return match ? false : hashes[key] = true;
  });
}

comboTemplateData_model.ClearRepeatedElementsComboTemplate = ClearRepeatedElementsComboTemplate;

var genericQuery_data = {};

(function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.WORDS_FIELDS = exports.DURATION_FILTERS = exports.NEAREST_FILTERS = exports.WORDS_FILTERS = exports.SENTENCE_FILTERS = exports.SCOPES = exports.CONFIDENCE_FILTERS_WITHOUT_TIME = exports.CONFIDENCE_FILTERS = exports.CLIENT = exports.AGENT = exports.scopeFilters = exports.FILLERS = exports.SILENCES = exports.IN_CONFIDENCE = exports.OUT_CONFIDENCE = exports.WORDS_CONFIDENCE = exports.INTERACTION = exports.TEXT_ALL = exports.OUT_SENTENCES = exports.IN_SENTENCES = void 0;
  exports.IN_SENTENCES = 'in_sentences.';
  exports.OUT_SENTENCES = 'out_sentences.';
  exports.TEXT_ALL = 'TEXT_ALL';
  exports.INTERACTION = 'INTERACTION';
  exports.WORDS_CONFIDENCE = 'words.confidence:';
  exports.OUT_CONFIDENCE = 'out_sentences.confidence:';
  exports.IN_CONFIDENCE = 'in_sentences.confidence:';
  exports.SILENCES = 'silences:';
  exports.FILLERS = 'fillers:';
  exports.scopeFilters = [{
    scope: exports.TEXT_ALL,
    filter: ['TEXT', 'NEAR', 'WORDS', 'NOT', exports.WORDS_CONFIDENCE, exports.SILENCES, exports.FILLERS]
  }, {
    scope: exports.IN_SENTENCES,
    filter: ['TEXT', 'NEAR', 'WORDS', 'NOT', exports.OUT_CONFIDENCE, exports.SILENCES, exports.FILLERS]
  }, {
    scope: exports.OUT_SENTENCES,
    filter: ['TEXT', 'NEAR', 'WORDS', 'NOT', exports.IN_CONFIDENCE, exports.SILENCES, exports.FILLERS]
  }, {
    scope: exports.INTERACTION,
    filter: ['duration:', 'words.silence:', 'topics:']
  }];
  exports.AGENT = 'in';
  exports.CLIENT = 'out';
  exports.CONFIDENCE_FILTERS = ["duration:", "words.duration:", "words.silence:", "words.time:"];
  exports.CONFIDENCE_FILTERS_WITHOUT_TIME = exports.CONFIDENCE_FILTERS.splice(exports.CONFIDENCE_FILTERS.length - 1, 1);
  exports.SCOPES = exports.scopeFilters.map(s => s.scope);
  exports.SENTENCE_FILTERS = ["in_sentences.", "out_sentences."];
  exports.WORDS_FILTERS = ["WORDS", exports.WORDS_CONFIDENCE, exports.OUT_CONFIDENCE, exports.IN_CONFIDENCE];
  exports.NEAREST_FILTERS = ['NEAR'];
  exports.DURATION_FILTERS = ["words.silence:", "words.duration:"];
  exports.WORDS_FIELDS = {
    [exports.WORDS_CONFIDENCE]: "confidence",
    "WORDS": "time",
    [exports.OUT_CONFIDENCE]: "confidence",
    [exports.IN_CONFIDENCE]: "confidence"
  };
})(genericQuery_data);

var genericQuery_helper = {};

Object.defineProperty(genericQuery_helper, "__esModule", {
  value: true
});
genericQuery_helper.ExistErrorOnTest = genericQuery_helper.FormToGenericQuery = genericQuery_helper.CheckBrackets = genericQuery_helper.IsDuplicated = void 0;

function IsDuplicated(query, queryData) {
  query = query.replace('AND', '').replace('OR', '').trim();

  if (queryData.length > 0) {
    let queries = queryData.filter(q => {
      return q.query.indexOf(query) > -1 && q.query.replace('AND', '').replace('OR', '').trim().length == query.length;
    });

    if (queries && queries.length > 0) {
      return true;
    }
  }

  return false;
}

genericQuery_helper.IsDuplicated = IsDuplicated;

function CheckBrackets(str) {
  let s;
  str = str.replace(/[^{}[\]()]/g, '');

  while (s !== str) {
    s = str;
    str = str.replace(/{}|\[]|\(\)/g, '');
  }

  return !str;
}

genericQuery_helper.CheckBrackets = CheckBrackets;

function FormToGenericQuery(form) {
  let gq = {};

  for (let key in form.value) {
    gq[key] = form.get(key).value;
  }

  return Object.assign(gq, {
    version: 2
  });
}

genericQuery_helper.FormToGenericQuery = FormToGenericQuery;

function ExistErrorOnTest(errorCode) {
  if (typeof errorCode === 'string' && ["QUERY_INTERNAL_SERVER_ERROR", "QUERY_SYNTAX_ERROR"].includes(errorCode)) {
    return errorCode;
  }

  return '';
}

genericQuery_helper.ExistErrorOnTest = ExistErrorOnTest;

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.GenericQueryComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const generic_query_model_1 = genericQuery_model;
  const forms_1 = require$$45;
  const combo_template_data_model_1 = comboTemplateData_model;
  const language_service_1 = language_service;
  const angular2_notifications_1 = require$$25;
  const generic_query_data_1 = genericQuery_data;
  const generic_query_service_1 = genericQuery_service;
  const generic_query_helper_1 = genericQuery_helper;
  const loading_service_1 = loading_service;

  let GenericQueryComponent = /*@__PURE__*/(() => {
    let GenericQueryComponent = class GenericQueryComponent {
      constructor(languageService, notificationsService, loadingService, service) {
        this.languageService = languageService;
        this.notificationsService = notificationsService;
        this.loadingService = loadingService;
        this.service = service;
        this.lineSpace = true;
        this.showCardSection = false;
        this.showQuerySection = false;
        this.translateCategory = "genericQuery";
        this.queryData = [];
        this.index = -1;
        this.hasEditingQuery = false;
        this.rangeFrom = '';
        this.rangeTo = '';
        this.textQueryNear = '';
        this.textBetween = '';
        this.textAnd = '';
        this.validationStatus = false;
        this.validationShow = false;
        this.validationMessage = '';
        this.queryErrorCode = '';
        this.scope = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.filter = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.value = '';
        this.secondValue = '';
        this.nearDistance = '5';
        this.silencesRangeFromType = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.silencesRangeToType = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.silencesMinOcurrencies = 1;
        this.fillersMinOcurrencies = 1;
        this.operatorOptions = [new combo_template_data_model_1.ComboDataTemplate('AND', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_AND'), ''), new combo_template_data_model_1.ComboDataTemplate('OR', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_OR'), '')];
        this.openParenthesisOptions = [new combo_template_data_model_1.ComboDataTemplate('(', '(', '')];
        this.closeParenthesisOptions = [new combo_template_data_model_1.ComboDataTemplate(')', ')', '')];
        this.scopeOptions = [];
        this.computedFilterOptions = [];
        this.filterOptions = [];
        this.silencesFromOptions = [new combo_template_data_model_1.ComboDataTemplate({
          id: 'GT',
          description: 'GREATER_THAN'
        }, this.languageService.GetMessage(this.translateCategory, 'GREATER_THAN'), this.languageService.GetMessage(this.translateCategory, 'GREATER_THAN_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate({
          id: 'GTE',
          description: 'GREATER_THAN_OR_EQUAL'
        }, this.languageService.GetMessage(this.translateCategory, 'GREATER_THAN_OR_EQUAL'), this.languageService.GetMessage(this.translateCategory, 'GREATER_THAN_OR_EQUAL_TOOLTIP'))];
        this.silencesToOptions = [new combo_template_data_model_1.ComboDataTemplate({
          id: 'LT',
          description: 'LESS_THAN'
        }, this.languageService.GetMessage(this.translateCategory, 'LESS_THAN'), this.languageService.GetMessage(this.translateCategory, 'LESS_THAN_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate({
          id: 'LTE',
          description: 'LESS_THAN_OR_EQUAL'
        }, this.languageService.GetMessage(this.translateCategory, 'LESS_THAN_OR_EQUAL'), this.languageService.GetMessage(this.translateCategory, 'LESS_THAN_OR_EQUALTOOLTIP'))];
        this.isEditing = false;
        this.executionType = null;
        this.genericQuery = {
          vcc: '',
          name: '',
          description: '',
          type: this.executionType ? this.executionType : 'BATCH',
          query: '',
          status: '',
          rawData: ''
        };
        this.changed = new core_1.EventEmitter();
        this.textQueryNear = this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NEAR_2');
        this.textBetween = this.languageService.GetMessage(this.translateCategory, 'BETWEEN');
        this.textAnd = this.languageService.GetMessage(this.translateCategory, 'AND');
      }

      ngOnInit() {
        this.UpdateFilters();
        this.InitForm(this.genericQuery);
        this.checkButtonTest();
      }

      ngOnChanges(changes) {
        if (Object.keys(this.genericQuery || {}).length > 0 && this.genericQuery.name.length > 0) {
          this.InitForm(this.genericQuery, false);
          this.isEditing = true;

          try {
            this.queryData = JSON.parse(this.genericQuery.rawData);
          } catch (err) {}
        }

        if (changes.executionType) {
          this.genericQuery.type = changes.executionType.currentValue;
          this.UpdateFilters();
        }
      }

      IsWordsFilter(query) {
        return query.includes('words:') || query.includes('words.silence:') || query.includes('duration:');
      }

      InitForm(gq, subscribe = true) {
        this.form = new forms_1.FormGroup({
          name: new forms_1.FormControl({
            value: gq.name,
            disabled: this.isEditing
          }),
          description: new forms_1.FormControl(gq.description),
          type: new forms_1.FormControl(gq.type)
        });

        if (subscribe) {
          this.form.get("name").valueChanges.subscribe(() => {
            this.WhatchFormChanges();
          });
          this.form.get("description").valueChanges.subscribe(() => {
            this.WhatchFormChanges();
          });
          this.form.get("type").valueChanges.subscribe(() => {
            this.WhatchFormChanges();
          });
        }
      }

      UpdateFilters() {
        if (this.genericQuery.type === 'REALTIME') {
          this.scopeOptions = [new combo_template_data_model_1.ComboDataTemplate('in_sentences.', this.languageService.GetMessage(this.translateCategory, 'TEXT_AGENT'), '')];
          this.filterOptions = [new combo_template_data_model_1.ComboDataTemplate('TEXT', this.languageService.GetMessage(this.translateCategory, 'TEXT_TEXT'), this.languageService.GetMessage(this.translateCategory, 'TEXT_TEXT_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('NEAR', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NEAR'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NEAR_TOOLTIP'))];
        } else {
          this.scopeOptions = [new combo_template_data_model_1.ComboDataTemplate('TEXT_ALL', this.languageService.GetMessage(this.translateCategory, 'TEXT_ALL'), ''), new combo_template_data_model_1.ComboDataTemplate('in_sentences.', this.languageService.GetMessage(this.translateCategory, 'TEXT_AGENT'), ''), new combo_template_data_model_1.ComboDataTemplate('out_sentences.', this.languageService.GetMessage(this.translateCategory, 'TEXT_CLIENT'), ''), new combo_template_data_model_1.ComboDataTemplate('INTERACTION', this.languageService.GetMessage(this.translateCategory, 'INTERACTION'), '')];
          this.filterOptions = [new combo_template_data_model_1.ComboDataTemplate('TEXT', this.languageService.GetMessage(this.translateCategory, 'TEXT_TEXT'), this.languageService.GetMessage(this.translateCategory, 'TEXT_TEXT_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('NOT', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NOT'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NOT_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('WORDS', this.languageService.GetMessage(this.translateCategory, 'WORD_QUERY_TOOLTIP'), this.languageService.GetMessage(this.translateCategory, 'WORD_QUERY_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('NEAR', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NEAR'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_NEAR_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('words.confidence:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_WORDS_CONFIDENCE'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_WORDS_CONFIDENCE_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('out_sentences.confidence:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_OUT_SENTENCES_CONFIDENCE'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_OUT_SENTENCES_CONFIDENCE_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('in_sentences.confidence:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_IN_SENTENCES_CONFIDENCE'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_IN_SENTENCES_CONFIDENCE_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('duration:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_DURATION'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_DURATION_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('words.silence:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_WORDS_SILENCE'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_WORDS_SILENCE_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('topics:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_TOPICS'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_TOPICS')), new combo_template_data_model_1.ComboDataTemplate('silences:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_SILENCES'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_SILENCES_TOOLTIP')), new combo_template_data_model_1.ComboDataTemplate('fillers:', this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_FILLERS'), this.languageService.GetMessage(this.translateCategory, 'TEXT_QUERY_FILLERS_TOOLTIP'))];
        }
      }

      OnChangeGenericQueryType(event) {
        this.UpdateFilters();
        if (this.genericQuery.type === 'REALTIME') this.ClearQuery();
      }

      WhatchFormChanges() {
        this.changed.emit(Object.assign(this.genericQuery, generic_query_helper_1.FormToGenericQuery(this.form)));
      }

      AddOrUpdate() {
        if (this.hasEditing) {
          this.UpdateQuery();
        } else {
          this.AddQuery();
        }

        this.showCardSection = true;
      }

      ShowDuplicatedAlert(query) {
        let msj = this.languageService.GetMessage(this.translateCategory, 'TXT_DUPLICATED_QUERY');
        this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING'), msj.replace('{text}', query ? ` "${query}" ` : ' '));
      }

      GetDuplicatedMessage(queryObject) {
        let message = [];
        message.push(queryObject.open);
        message.push(queryObject.scopeDescription);

        if (['NOT'].includes(queryObject.filter)) {
          message.push(queryObject.fieldDescription);
          message.push(queryObject.queryDescription);
          message.push(queryObject.queryDescription2);
        } else {
          message.push(queryObject.queryDescription);
          message.push(queryObject.fieldDescription);
          message.push(queryObject.queryDescription2);
        }

        message.push(queryObject.close);
        return message.join(' ').trim();
      }

      AddQuery() {
        if (this.isRequiredOperator) {
          this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING'), this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING_REQUIRED_OPERATOR'));
          return;
        }

        let queryObject = this.CollectQuery();

        if (queryObject) {
          if (generic_query_helper_1.IsDuplicated(queryObject.query, this.queryData)) {
            this.ShowDuplicatedAlert(this.GetDuplicatedMessage(queryObject));
            return;
          }

          this.queryData.push(queryObject);
          this.ClearControls();
        }
      }

      UpdateQuery() {
        let queryObject = this.CollectQuery();

        if (queryObject) {
          if (!this.hasEditingQuery && generic_query_helper_1.IsDuplicated(queryObject.query, this.queryData)) {
            this.ShowDuplicatedAlert(this.GetDuplicatedMessage(queryObject));
          } else {
            this.queryData[this.index] = queryObject;
            this.hasEditingQuery = false;
            this.ClearControls();
          }
        }
      }

      CollectQuery() {
        let queryDescription2 = '';
        let data = {};
        let staticData = this.CollectStaticData();

        if (this.isNear) {
          data = this.GetNearQuery(staticData);
        } else if (this.isWords) {
          data = this.GetWordsQuery(staticData);
        } else if (this.isConfidence) {
          data = this.GetConfidenceQuery(staticData);
        } else if (this.isSilences) {
          data = this.GetSilencesQuery(staticData);
        } else if (this.isFillers) {
          data = this.GetFillersQuery(staticData);
        } else if (!this.isNear) {
          data = this.GetTextQuery(staticData);
        }

        if (data === null) {
          return null;
        }

        return Object.assign({
          queryDescription2,
          ...staticData,
          ...data
        }, {
          query: data.query.replace(/TEXT_ALL/g, '').replace(/TEXT_ALLNOT/g, '').replace(/TEXT/g, '').replace(/INTERACTION/g, '').trim()
        });
      }

      CollectStaticData() {
        const scopeLanguages = {
          'TEXT_ALL': 'TEXT_ALL',
          'in_sentences.': 'TEXT_AGENT',
          'out_sentences.': 'TEXT_CLIENT',
          'INTERACTION': 'INTERACTION'
        };
        return {
          queryDescription: this.value,
          filter: this.filter.value,
          open: this.openParenthesis ? this.openParenthesis.description : '',
          close: this.closeParenthesis ? this.closeParenthesis.description : '',
          fieldDescription: ["Texto"].includes(this.filter.description) ? '' : `${this.filter.description} `,
          operatorDescription: this.operator ? this.operator.description : '',
          operator: this.operator ? `${this.operator.value}` : '',
          scope: this.scope.value,
          scopeDescription: scopeLanguages[this.scope.value] || undefined,
          rangeFrom: this.rangeFrom,
          rangeTo: this.rangeTo
        };
      }

      GetWordsQuery({
        open,
        close,
        operator,
        filter
      }) {
        let query = [];
        let value = (this.value || '').trim();
        let words = value.split(" ");
        let from = parseInt(this.rangeFrom || 0);
        let to = parseInt(this.rangeTo || 5);
        let word_list = [];
        let speaker = '';
        let isAgentOrClient = false;
        let fieldLanguage;

        if ([generic_query_data_1.IN_SENTENCES].includes(this.scope.value)) {
          speaker = `,speaker:\\"${generic_query_data_1.AGENT}\\"`;
          isAgentOrClient = true;
          fieldLanguage = filter === 'WORDS' ? 'WORD_QUERY_TOOLTIP' : 'TEXT_QUERY_OUT_SENTENCES_CONFIDENCE';
        } else if ([generic_query_data_1.OUT_SENTENCES].includes(this.scope.value)) {
          speaker = `,speaker:\\"${generic_query_data_1.CLIENT}\\"`;
          isAgentOrClient = true;
          fieldLanguage = filter === 'WORDS' ? 'WORD_QUERY_TOOLTIP' : 'TEXT_QUERY_IN_SENTENCES_CONFIDENCE';
        }

        for (let word of words) {
          word_list.push(`words:(name:\\"${word.trim()}\\",${generic_query_data_1.WORDS_FIELDS[this.filter.value]}:[${from} TO ${to}]${speaker})`);
        }

        if (words.length > 1) {
          query.push(this.isOpenedAndClosedParenthesis ? '' : '(');

          if (isAgentOrClient) {
            query.push(`${this.scope.value}text:`);
          }

          query.push(`\\"${words.join(" ")}\\" AND (${word_list.join(" AND ")})`);
          query.push(this.isOpenedAndClosedParenthesis ? '' : ')');
        } else {
          query.push(word_list.join(""));
        }

        return {
          query: (operator === "OR" ? ` ${operator} ${open}${query.join('')}${close}` : `${operator} ${open}${query.join('')}${close}`).trim(),
          queryDescription2: `${this.textBetween} ${from} ${this.textAnd} ${to}`,
          fieldDescription: fieldLanguage
        };
      }

      GetConfidenceQuery({
        filter,
        operator,
        open,
        close
      }) {
        let query = `${filter}[${this.rangeFrom} TO ${this.rangeTo}]`;
        return {
          query: `${operator}${open}(${query})${close}`,
          queryDescription2: `${this.textBetween} ${this.rangeFrom} ${this.textAnd} ${this.rangeTo} `,
          fieldDescription: filter === 'duration:' ? 'TEXT_QUERY_DURATION' : 'TEXT_QUERY_WORDS_SILENCE'
        };
      }

      GetNearQuery({
        fieldDescription,
        filter,
        operator,
        open,
        close
      }) {
        let query = [];
        let distance = this.nearDistance || '5';
        let value = (this.value || '').trim();
        let second_value = (this.secondValue || '').trim();
        let words = value.split(" ");
        let words_str = words.map(w => w.trim()).join(' ');
        let second_words = second_value.split(" ");
        let second_words_str = second_words.map(w => w.trim()).join(' ');
        let isOutOrInOrTextAll = ["TEXT_ALL"].concat(generic_query_data_1.SENTENCE_FILTERS).includes(this.scope.value);

        if (isOutOrInOrTextAll) {
          query.push(this.isOpenedAndClosedParenthesis ? '' : `(${this.scope.value}`);

          if (this.isOutOrInSentences) {
            query.push('confidence:');
          } else if (this.scope.value !== 'TEXT_ALL') {
            query.push('text:');
          }
        }

        query.push(`\\"${words_str}\\" ${filter}_${distance} ${this.scope.value}`);

        if (this.isOutOrInSentences) {
          query.push('confidence:');
        } else if (this.scope.value !== 'TEXT_ALL') {
          query.push('text:');
        }

        query.push(`\\"${second_words_str}\\"`);

        if (isOutOrInOrTextAll && !this.isOpenedAndClosedParenthesis) {
          query.push(')');
        }

        return {
          query: (operator === "OR" ? ` ${operator} ${open}${query.join('')}${close}` : `${operator} ${open}${query.join('')}${close}`).trim(),
          queryDescription: `${this.value} `,
          queryDescription2: this.secondValue,
          fieldDescription: 'NEAR_VALUES',
          fieldValue: distance
        };
      }

      GetTextQuery({
        operator,
        open,
        close,
        filter
      }) {
        let query = [];
        let isSentences = generic_query_data_1.SENTENCE_FILTERS.includes(this.scope.value);
        let isInteraction = [generic_query_data_1.INTERACTION].includes(this.scope.value);
        let value = (this.value || '').trim();
        let words = value.split(" ");
        let words_str = words.map(w => w.trim()).join(` `);
        let isFilterNot = ["NOT"].includes(this.filter.value);
        let fieldLanguage = isFilterNot ? 'TEXT_QUERY_NOT' : '';

        if (isInteraction || isSentences) {
          let prefix = isSentences && isFilterNot ? `${this.filter.value} ` : '';
          query.push(`${prefix}${this.scope.value}`);

          if (["topics:"].includes(this.filter.value)) {
            query.push(`${this.filter.value}`);
          } else {
            query.push('text:');
          }
        }

        if (isSentences && isFilterNot) {
          query.push(`\\"${words_str}\\"`);
        } else if (isFilterNot || this.isTextFilter && words.length > 1) {
          query.push(`${this.filter.value}${isFilterNot ? ' ' : ''}\\"${words_str}\\"`);
        } else {
          fieldLanguage = filter !== 'TEXT' ? 'TEXT_QUERY_TOPICS' : '';
          query.push(`\\"${words_str}\\"`);
        }

        return {
          query: operator === "OR" ? ` ${operator} ${open}${query.join('')}${close}` : `${operator} ${open}${query.join('')}${close}`,
          fieldDescription: fieldLanguage
        };
      }

      GetSilencesQuery({
        rangeFrom,
        rangeTo
      }) {
        let error = null;
        let query = {
          scope: this.scope.value,
          filter: this.filter.value,
          minType: this.silencesRangeFromType.value ? this.silencesRangeFromType.value.id : null,
          minValue: rangeFrom,
          maxType: this.silencesRangeToType.value ? this.silencesRangeToType.value.id : null,
          maxValue: rangeTo,
          minOcurrencies: this.silencesMinOcurrencies
        };
        let greater = null;

        if (this.isSilenceRangeFromSelected && this.silencesRangeFromType.value.description.length && !isNaN(rangeFrom)) {
          if (rangeFrom !== '' && !isNaN(rangeFrom)) {
            greater = this.languageService.GetMessage(this.translateCategory, this.silencesRangeFromType.value.description + '_QUERY');
            greater = greater.replace('%s', rangeFrom);

            if (this.isSilenceRangeToSelected && rangeTo !== '' && !isNaN(rangeTo)) {
              if (rangeTo < rangeFrom) {
                error = 'WARNING_RANGE_FROM_IS_HIGHER_THAN_RANGE_TO';
              } else if (rangeTo === rangeFrom) {
                error = 'WARNING_RANGE_TO_CAN_NOT_BE_EQUAL_TO_RANGE_FROM';
              }
            }
          }
        }

        let less = null;

        if (this.isSilenceRangeToSelected && this.silencesRangeToType.description.length && !isNaN(rangeTo)) {
          if (rangeTo !== '' && !isNaN(rangeTo)) {
            less = this.languageService.GetMessage(this.translateCategory, this.silencesRangeToType.value.description + '_QUERY');
            less = less.replace('%s', rangeTo);

            if (this.isSilenceRangeFromSelected && rangeFrom !== '' && !isNaN(rangeFrom)) {
              if (rangeTo < rangeFrom) {
                error = 'WARNING_RANGE_TO_IS_LOWER_THAN_RANGE_FROM';
              } else if (rangeTo === rangeFrom) {
                error = 'WARNING_RANGE_FROM_CAN_NOT_BE_EQUAL_TO_RANGE_TO';
              }
            }
          }
        }

        if (greater === null && less === null) error = 'WARNING_RANGE_FROM_RANGE_TO_MISSING';

        if (error) {
          this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING'), this.languageService.GetMessage(this.translateCategory, error));
          return null;
        }

        let ocurrencies = '';
        ocurrencies = this.languageService.GetMessage(this.translateCategory, 'OCURRENCIES_QUERY');
        ocurrencies = ocurrencies.replace('%s', this.silencesMinOcurrencies.toString());
        if (greater === null) greater = '';
        if (less === null) less = '';
        return {
          query: JSON.stringify(query),
          queryDescription2: `${greater} ${less} ${ocurrencies}`.trim(),
          greaterLanguage: this.silencesRangeFromType.value.description + '_QUERY',
          lessLanguage: this.silencesRangeToType.value.description + '_QUERY',
          ocurrenciesLanguage: 'OCURRENCIES_QUERY',
          ocurrencie: this.silencesMinOcurrencies,
          fieldDescription: 'TEXT_QUERY_SILENCES'
        };
      }

      GetFillersQuery(_) {
        let query = {
          scope: this.scope.value,
          filter: this.filter.value,
          value: (this.value || '').trim(),
          minOcurrencies: this.fillersMinOcurrencies
        };

        let ocurrencies = '';
        ocurrencies = this.languageService.GetMessage(this.translateCategory, 'OCURRENCIES_QUERY');
        ocurrencies = ocurrencies.replace('{{MIN_TIMES}}', this.fillersMinOcurrencies.toString());
        return {
          query: JSON.stringify(query),
          ocurrencie: this.fillersMinOcurrencies,
          fieldDescription: 'TEXT_QUERY_FILLERS',
          queryDescription2: 'OCURRENCIES_QUERY'
        };
      }

      BuildQuery() {
        if (this.queryData.length > 0) {
          let query = '';

          for (let row of this.queryData) {
            query += `${row.query.trim()} `;
          }

          this.genericQuery.query = query.trim();
          this.genericQuery.rawData = JSON.stringify(this.queryData);
          this.changed.emit(Object.assign(this.genericQuery, generic_query_helper_1.FormToGenericQuery(this.form)));
        }

        this.showQuerySection = true;
      }

      ClearQuery() {
        this.genericQuery.query = '';
        this.queryData.splice(0, this.queryData.length);
        this.ClearControls();
        this.hasEditingQuery = false;
        this.index = -1;
        this.validationShow = false;
      }

      ClearControls() {
        this.scope = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.operator = null;
        this.filter = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.openParenthesis = null;
        this.closeParenthesis = null;
        this.value = '';
        this.secondValue = '';
        this.nearDistance = '5';
        this.rangeFrom = '';
        this.rangeTo = '';
      }

      EditQuery(index, query) {
        this.index = index;
        this.hasEditingQuery = true;
        this.openParenthesis = query.open ? this.openParenthesisOptions[0] : null;
        this.closeParenthesis = query.close ? this.closeParenthesisOptions[0] : null;

        if (query.scope) {
          this.scope = this.scopeOptions.find(so => so.value == query.scope);
          this.ShowFiltersByScope();

          if (generic_query_data_1.SCOPES.includes(this.scope.value) && generic_query_data_1.CONFIDENCE_FILTERS_WITHOUT_TIME.includes(query.filter)) {
            let event = {
              value: query.filter
            };
            this.OnFilterChanged(event, parseInt(query.rangeFrom), parseInt(query.rangeTo));
          }
        }

        let operator = (query.operator || '').trim();
        this.operator = operator ? this.operatorOptions.find(o => o.value === operator) : null;
        this.filter = query.filter ? this.computedFilterOptions.find(fo => fo.value === query.filter) : null;
        this.value = query.queryDescription;

        if (this.isNear) {
          this.secondValue = query.queryDescription2;
        }

        if (this.isWords || this.isSilences) {
          this.rangeTo = query.rangeTo;
          this.rangeFrom = query.rangeFrom;
        }
      }

      EditRowQuery(index, query) {
        query.operatorCombo = query.operator ? this.operatorOptions.find(o => o.value === (query.operator || '').trim()) : null;
        query.openParenthesisCombo = query.open ? this.openParenthesisOptions[0] : null;
        query.closeParenthesisCombo = query.close ? this.closeParenthesisOptions[0] : null;
        query.scopeCombo = query.scope ? this.scopeOptions.find(so => so.value == query.scope) : null;
        query.filterCombo = query.filter ? this.filterOptions.find(fo => fo.value === query.filter) : null;
        query.silencesRangeFromType = query.minType ? this.silencesFromOptions.find(fo => fo.value === query.minType) : null;
        query.silencesRangeToType = query.maxType ? this.silencesToOptions.find(fo => fo.value === query.maxType) : null;
        query.distance = query.distance ? query.distance : 5;
        query.fillersMinOcurrencies = this.fillersMinOcurrencies;
        query.silencesMinOcurrencies = this.silencesMinOcurrencies;
        query.isEditing = true;
        query.isWords = generic_query_data_1.WORDS_FILTERS.includes(query.filter) ? true : false;
        query.isNear = generic_query_data_1.NEAREST_FILTERS.includes(query.filter) ? true : false;
        query.isSilences = query.filter && query.filter == generic_query_data_1.SILENCES ? true : false;
        query.isConfidence = generic_query_data_1.CONFIDENCE_FILTERS.includes(query.filter) ? true : false;
        query.inUse = this.genericQuery.inUse || (this.existsQuerySilencesFilter || this.existsQueryFillersFilter) && !this.hasEditing ? true : false;
        query.isFillers = query.filter && query.filter == generic_query_data_1.FILLERS ? true : false;
        this.ShowFiltersByRowScope(query.scopeCombo, query);
        this.OnRowFilterChanged(query.filterCombo, query, index);
      }

      ShowFiltersByRowScope(combo, query) {
        if (!combo.value) return;
        let filters;
        let scope = generic_query_data_1.scopeFilters.find(f => f.scope === combo.value);

        if (scope) {
          filters = scope.filter.map(f => {
            return this.filterOptions.find(fo => f == fo.value);
          });
          filters = filters.filter(f => f);
        }

        query.computedFilterOptions = filters && filters.length ? filters.filter(cfo => cfo.value !== generic_query_data_1.SILENCES || cfo.value != generic_query_data_1.FILLERS) : [];
      }

      OnRowFilterChanged(combo, query, index) {
        query.isWords = generic_query_data_1.WORDS_FILTERS.includes(combo && combo.value ? combo.value : query.filter) ? true : false;
        query.isNear = generic_query_data_1.NEAREST_FILTERS.includes(combo && combo.value ? combo.value : query.filter) ? true : false;
        query.isSilences = (combo && combo.value ? combo.value : query.filter) == generic_query_data_1.SILENCES ? true : false;
        query.isConfidence = generic_query_data_1.CONFIDENCE_FILTERS.includes(combo && combo.value ? combo.value : query.filter) ? true : false;
        query.inUse = this.genericQuery.inUse || (this.existsQuerySilencesFilter || this.existsQueryFillersFilter) && !this.hasEditing ? true : false;
        query.isFillers = (combo && combo.value ? combo.value : query.filter) == generic_query_data_1.FILLERS ? true : false;

        if (query.isConfidence) {
          this.OnFilterChanged(event, parseInt(query.rangeFrom), parseInt(query.rangeTo));
          let max = 0;
          let max_postfix = 'Seg';

          let _to = query.rangeTo ? parseInt(query.rangeTo) : Math.round(max / 2);

          if (generic_query_data_1.DURATION_FILTERS.includes(combo.value)) {
            max = 900;
          } else {
            max = 1800;
          }

          setTimeout(() => {
            let range = $('#range' + index);
            range.ionRangeSlider({
              type: 'double',
              min: query.rangeFrom ? parseInt(query.rangeFrom) : 0,
              max: max,
              from: 0,
              to: _to,
              step: 1,
              max_postfix: max_postfix,
              onStart: data => {
                query.rangeFrom = data.from;
                query.rangeTo = data.to;
              },
              onFinish: data => {
                query.rangeFrom = data.from;
                query.rangeTo = data.to;
              },
              onUpdate: data => {
                query.rangeFrom = data.from;
                query.rangeTo = data.to;
              }
            });
            range.data('ionRangeSlider').update({
              min: query.rangeFrom ? parseInt(query.rangeFrom) : 0,
              max: max,
              from: 0,
              to: _to,
              max_postfix: max_postfix
            });
          }, 250);
        }
      }

      UpdateRowQuery(index, query) {
        this.value = query.queryDescription;
        this.secondValue = query.queryDescription2;
        this.filter = query.filterCombo;
        this.openParenthesis = query.openParenthesisCombo;
        this.closeParenthesis = query.closeParenthesisCombo;
        this.operator = query.operatorCombo;
        this.scope = query.scopeCombo;
        this.rangeFrom = query.rangeFrom;
        this.rangeTo = query.rangeTo;
        this.nearDistance = query.distance;
        this.silencesMinOcurrencies = query.silencesMinOcurrencies;
        this.fillersMinOcurrencies = query.fillersMinOcurrencies;
        let queryObject = this.CollectQuery();

        if (queryObject) {
          if (query.hasEditing && generic_query_helper_1.IsDuplicated(queryObject, this.queryData)) {
            this.ShowDuplicatedAlert(this.GetDuplicatedMessage(query));
          } else {
            if (query.scopeCombo.value === 'INTERACTION' && query.filterCombo.value !== 'topics:') queryObject.queryDescription = '';

            for (const property in query) {
              query[property] = queryObject[property] ? queryObject[property] : null;
            }

            query.isEditing = false;
            this.ClearControls();
          }
        }
      }

      ProcessHtml() {
        return this.genericQuery.query.replace(/OR/g, '<b> OR </b>').replace(/AND/g, '<b> AND </b>');
      }

      CheckCanRemoveQuery(index) {
        if (this.queryData.length > 1) {
          let currentQuery = this.queryData[index];
          return /AND|OR/.test(currentQuery.operator);
        }

        return true;
      }

      RemoveQuery(index) {
        if (this.queryData.length > index) {
          if (this.CheckCanRemoveQuery(index)) {
            this.queryData.splice(index, 1);
          } else {
            this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'TXT_QUERY_WITH_OPERATOR'), this.languageService.GetMessage(this.translateCategory, 'TXT_QUERY_WITH_OPERATOR_DESCRIPTION'));
          }
        }

        if (this.queryData.length == 0) {
          this.operator = null;
          this.ClearQuery();
        }

        if (this.hasEditing) {
          this.hasEditingQuery = false;
          this.ClearControls();
        }
      }

      ValidateQuery() {
        if (!generic_query_helper_1.CheckBrackets(this.genericQuery.query)) {
          this.genericQuery.status = 'ERROR_MISSING_IN_QUERY';
          this.notificationsService.error(this.languageService.GetMessage(this.translateCategory, 'TXT_ERROR_MISSING_IN_QUERY'), this.languageService.GetMessage(this.translateCategory, 'TXT_ERROR_MISSING_IN_QUERY_MSG'));
          return false;
        }

        if (this.queryErrorCode) {
          this.notificationsService.error(this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING'), this.languageService.GetMessage(this.translateCategory, this.queryErrorCode));
          return false;
        }

        this.genericQuery.status = '';
        return true;
      }

      ShowFiltersByScope() {
        if (!this.scope.value) return;
        let filters;
        let scope = generic_query_data_1.scopeFilters.find(f => f.scope === this.scope.value);

        if (scope) {
          filters = scope.filter.map(f => this.filterOptions.filter(fo => f == fo.value)[0]);
          this.value = '';
          this.secondValue = '';
          this.rangeTo = '';
          this.rangeFrom = '';
        }

        this.filter = new combo_template_data_model_1.ComboDataTemplate('', '', '');
        this.computedFilterOptions = filters;

        if (this.queryData && this.queryData.length > 0 && !(this.queryData.length === 1 && this.hasEditing)) {
          this.computedFilterOptions = this.computedFilterOptions.filter(cfo => cfo.value !== generic_query_data_1.SILENCES || cfo.value !== generic_query_data_1.FILLERS);
        }
      }

      ReplacePoint(e) {
        let value = e.target.value;
        value = value.replace(/\./g, '');
        e.target.value = value;
      }

      PositiveNumbersOnly(e) {
        if (!/^\d*(\.\d+)?$/.test(e.target.value)) {
          e.target.value = 0;
          return;
        }

        if (parseFloat(this.rangeFrom) >= parseFloat(this.rangeTo)) {
          this.notificationsService.alert(this.languageService.GetMessage(this.translateCategory, 'TXT_WARNING'), this.languageService.GetMessage(this.translateCategory, 'FROM_GREATER_THAN_TO'));
        }
      }

      Test() {
        this.validationShow = false;
        this.queryErrorCode = '';

        if (this.ValidateQuery()) {
          this.loadingService.Open();
          this.service.TestGenericQuery(this.genericQuery.query).subscribe(result => {
            this.loadingService.Close();
            this.validationStatus = result.status && result.data && result.data.total_results >= 0;
            this.validationMessage = this.languageService.GetMessage(this.translateCategory, result.description);
            this.validationShow = true;
            this.queryErrorCode = generic_query_helper_1.ExistErrorOnTest(result.description);
            this.genericQuery.validationShow = this.validationShow;
            this.changed.emit(Object.assign(this.genericQuery, generic_query_helper_1.FormToGenericQuery(this.form)));
          }, error => {
            this.loadingService.Close();
          });
        }
      }

      checkButtonTest() {
        if (this.queryData.length > 0 && this.genericQuery.query != '') {
          return false;
        } else {
          return true;
        }
      }

      OnFilterChanged(e, min = 0, to = 0) {
        if (!this.isConfidence) return;
        let max = 0;
        let max_postfix = 'Seg';

        let _to = this.hasEditing ? to : Math.round(max / 2);

        if (generic_query_data_1.DURATION_FILTERS.includes(this.filter.value)) {
          max = 900;
        } else {
          max = 1800;
        }

        setTimeout(() => {
          let range = $('#range');
          range.ionRangeSlider({
            type: 'double',
            min: this.hasEditing ? min : 0,
            max: max,
            from: 0,
            to: _to,
            step: 1,
            max_postfix: max_postfix,
            onStart: data => {
              this.rangeFrom = data.from;
              this.rangeTo = data.to;
            },
            onFinish: data => {
              this.rangeFrom = data.from;
              this.rangeTo = data.to;
            },
            onUpdate: data => {
              this.rangeFrom = data.from;
              this.rangeTo = data.to;
            }
          });
          range.data('ionRangeSlider').update({
            min: this.hasEditing ? min : 0,
            max: max,
            from: 0,
            to: _to,
            max_postfix: max_postfix
          });
        }, 250);
      }

      get disabledOperator() {
        return this.queryData && this.queryData.length === 0 || this.index == 0 && this.hasEditingQuery || this.genericQuery.inUse;
      }

      get disabledFilter() {
        return !this.scope.value || this.inUse;
      }

      get disabledValue() {
        return !this.scope.value || !this.filter.value || this.inUse;
      }

      get disabledButton() {
        let disabled = !this.scope.value || !this.filter.value || this.inUse;

        if (this.isConfidence) {
          return disabled;
        }

        if (this.isWords) {
          return !this.value || this.rangeFrom === '' || this.rangeTo === '' || parseFloat(this.rangeFrom) >= parseFloat(this.rangeTo) || disabled;
        }

        if (this.isSilences) {
          return !this.silencesMinOcurrencies || disabled;
        }

        if (this.isFillers) {
          return !this.fillersMinOcurrencies || disabled;
        }

        return !this.value || disabled;
      }

      get disableItemOptions() {
        return this.genericQuery.inUse;
      }

      get inUse() {
        return this.genericQuery.inUse || (this.existsQuerySilencesFilter || this.existsQueryFillersFilter) && !this.hasEditing;
      }

      get hasEditing() {
        return this.hasEditingQuery && this.queryData && this.queryData.length > 0;
      }

      get isRequiredOperator() {
        return this.queryData.length > 0 && (!this.operator || this.operator.value == '');
      }

      get isTextFilter() {
        return this.filter && this.filter.value == 'TEXT' && this.scope && this.scope.value == 'TEXT_ALL';
      }

      get isNear() {
        return generic_query_data_1.NEAREST_FILTERS.includes(this.filter.value);
      }

      get isConfidence() {
        return generic_query_data_1.CONFIDENCE_FILTERS.includes(this.filter.value);
      }

      get isWords() {
        return generic_query_data_1.WORDS_FILTERS.includes(this.filter.value);
      }

      get isOutOrInSentences() {
        return generic_query_data_1.SENTENCE_FILTERS.includes(this.filter.value);
      }

      get isSilences() {
        return this.filter && this.filter.value == generic_query_data_1.SILENCES;
      }

      get isFillers() {
        return this.filter && this.filter.value == generic_query_data_1.FILLERS;
      }

      get isSilenceRangeFromSelected() {
        return this.silencesRangeFromType.value && typeof this.silencesRangeFromType.value === 'object';
      }

      get isSilenceRangeToSelected() {
        return this.silencesRangeToType.value && typeof this.silencesRangeToType.value === 'object';
      }

      get isOpenedAndClosedParenthesis() {
        return this.openParenthesis && this.closeParenthesis && this.openParenthesis.value === '(' && this.closeParenthesis.value === ')';
      }

      get existsQuerySilencesFilter() {
        return this.queryData.find(qd => qd.filter === generic_query_data_1.SILENCES) ? true : false;
      }

      get existsQueryFillersFilter() {
        return this.queryData.find(qd => qd.filter === generic_query_data_1.FILLERS) ? true : false;
      }

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], GenericQueryComponent.prototype, "isEditing", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], GenericQueryComponent.prototype, "executionType", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", generic_query_model_1.GenericQuery)], GenericQueryComponent.prototype, "genericQuery", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], GenericQueryComponent.prototype, "changed", void 0);

    GenericQueryComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'generic-query-v2-cmp',
      encapsulation: core_1.ViewEncapsulation.Emulated,
      templateUrl: 'generic-query.component.html'
    }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService, angular2_notifications_1.NotificationsService, loading_service_1.LoadingService, generic_query_service_1.GenericQueryService])], GenericQueryComponent);
    return GenericQueryComponent;
  })();

  exports.GenericQueryComponent = GenericQueryComponent;
})(genericQuery_component, genericQuery_component.exports);

var genericQuerySelect_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.GenericQuerySelectComponent = exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const forms_1 = require$$45;
  const language_service_1 = language_service;
  const generic_query_model_1 = genericQuery_model;
  exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => GenericQuerySelectComponent),
    multi: true
  };

  let GenericQuerySelectComponent = /*@__PURE__*/(() => {
    let GenericQuerySelectComponent = class GenericQuerySelectComponent {
      constructor(languageService) {
        this.languageService = languageService;
        this.addNewOption = true;
        this.executionType = null;
        this.showQueryForm = false;
        this.showHorizontalLine = true;
        this.openGenericQueryCreate = false;
        this.genericQuery = {};
        this.translateCategory = 'genericQuery';
        this.getSelectedGenericQuery = new core_1.EventEmitter();
        this.getGenericQueryData = new core_1.EventEmitter();
      }

      ngOnChanges() {
        if (this.inputGenericQueries) {
          if (this.inputGenericQueries.length > 0) {
            this.inputGenericQueries.map(x => {
              if (x.name !== 'new') {
                return x.description = [x.name, x.query].join(' | ');
              } else {
                return x.description;
              }
            });
          }
        }

        if (this.inputGenericQueries && this.inputGenericQueries.length > 0) {
          let index = -1;
          index = this.inputGenericQueries.findIndex(function (x) {
            return x.name === 'new';
          });

          if (index === -1 && this.addNewOption) {
            this.inputGenericQueries.unshift(new generic_query_model_1.GenericQuery('', 'new', this.languageService.GetMessage(this.translateCategory, 'PLUS_NEW_GENERIC_QUERY'), '', '', null, null, null, null, null));
          }
        }
      }

      ngOnInit() {
        this.genericQuery = {};
        if (this.executionType) this.genericQuery.type = this.executionType;
        this.selectedGenericQuery = null;
        this.hideCreateGenericQueryComponent();
      }

      ngOnDestroy() {}

      hideCreateGenericQueryComponent() {
        this.openGenericQueryCreate = false;
      }

      setData(genericQuery, data) {
        this.inputGenericQueries = data;
        this.ngOnChanges();
        this.hideCreateGenericQueryComponent();

        if (genericQuery) {
          let objGenericQuery = this.inputGenericQueries.find(x => {
            return x.name === genericQuery.name;
          });

          if (objGenericQuery) {
            this.selectedGenericQuery = objGenericQuery;
          } else {
            this.selectedGenericQuery = new generic_query_model_1.GenericQuery('', '', '', '', '', '', null, null, null, null);
          }
        } else {
          this.selectedGenericQuery = new generic_query_model_1.GenericQuery('', '', '', '', '', '', null, null, null, null);
        }
      }

      onGetGenericQuery($event) {
        this.genericQuery = $event;
        this.getGenericQueryData.emit($event);
        this.getSelectedGenericQuery.emit($event);
      }

      SelectGenericQuery(data) {
        this.getSelectedGenericQuery.emit(data);

        if (data.name && data.name === 'new') {
          this.openGenericQueryCreate = true;
        } else {
          this.openGenericQueryCreate = false;
        }
      }

      writeValue(obj) {
        this.selectedGenericQuery = obj;

        if (obj && obj.vcc) {
          this.selectedGenericQuery.description = this.selectedGenericQuery.name + ' | ' + this.selectedGenericQuery.query;
        }

        if (obj === undefined) {
          this.genericQuery = {};
          this.openGenericQueryCreate = false;
        }
      }

      registerOnChange(fn) {}

      registerOnTouched(fn) {}

      setDisabledState(isDisabled) {}

    };

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Array)], GenericQuerySelectComponent.prototype, "inputGenericQueries", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], GenericQuerySelectComponent.prototype, "addNewOption", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", String)], GenericQuerySelectComponent.prototype, "executionType", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], GenericQuerySelectComponent.prototype, "showQueryForm", void 0);

    tslib_1.__decorate([core_1.Input(), tslib_1.__metadata("design:type", Boolean)], GenericQuerySelectComponent.prototype, "showHorizontalLine", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], GenericQuerySelectComponent.prototype, "getSelectedGenericQuery", void 0);

    tslib_1.__decorate([core_1.Output(), tslib_1.__metadata("design:type", core_1.EventEmitter)], GenericQuerySelectComponent.prototype, "getGenericQueryData", void 0);

    GenericQuerySelectComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'generic-query-select-cmp',
      templateUrl: 'generic-query-select.component.html',
      styleUrls: ['generic-query-select.component.css'],
      encapsulation: core_1.ViewEncapsulation.None,
      providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
    }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], GenericQuerySelectComponent);
    return GenericQuerySelectComponent;
  })();

  exports.GenericQuerySelectComponent = GenericQuerySelectComponent;
})(genericQuerySelect_component, genericQuerySelect_component.exports);

var ad_directive = {};

Object.defineProperty(ad_directive, "__esModule", {
  value: true
});
ad_directive.AdDirective = void 0;
const tslib_1$8 = require$$0;
const core_1$8 = require$$0$1;

let AdDirective = /*@__PURE__*/(() => {
  let AdDirective = class AdDirective {
    constructor(viewContainerRef) {
      this.viewContainerRef = viewContainerRef;
    }

  };
  AdDirective = tslib_1$8.__decorate([core_1$8.Directive({
    selector: '[adHost]'
  }), tslib_1$8.__metadata("design:paramtypes", [core_1$8.ViewContainerRef])], AdDirective);
  return AdDirective;
})();

ad_directive.AdDirective = AdDirective;

var modalGeneric_component = {exports: {}};

(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ModalGenericComponent = void 0;
  const tslib_1 = require$$0;
  const core_1 = require$$0$1;
  const modal_animation_1 = modal_animation;
  const ad_directive_1 = ad_directive;
  const modal_generic_service_1 = modalGeneric_service;

  let ModalGenericComponent = /*@__PURE__*/(() => {
    let ModalGenericComponent = class ModalGenericComponent {
      constructor(modalService, componentFactoryResolver) {
        this.modalService = modalService;
        this.componentFactoryResolver = componentFactoryResolver;
        this.inputCustomclass = 'modal';
        this.modalClass = '';
        this.closeOnOutsideClick = false;
        this.hideCloseButton = true;
        this.headerTitle = '';
        this.hideFooter = false;
        this.inputRequired = false;
        this.inputMissingTitle = 'Warning';
        this.inputMissingMessage = 'Input required';
        this.onLoaded = new core_1.EventEmitter();
        this.isOpened = false;
        this.isOpenedAnimation = 'hide';
        this.isOpenedAnimationRTL = 'hide';
        this.alternateAnimation = '';
        this.modalClassCustom = 'modal';
        this.backdropElement = document.createElement('div');
        this.backdropElement.classList.add('modal-backdrop');
        this.backdropElement.classList.add('fade');
        this.backdropElement.classList.add('show');
      }

      ngOnInit() {
        this.onLoaded.emit(this);
      }

      open() {
        this.loadComponent();
        document.body.appendChild(this.backdropElement);
        document.body.className = document.body.className.replace(/ modal-open\b/, '');
        document.body.className += ' modal-open';
        window.setTimeout(() => {
          this.modalContentElement.nativeElement.focus();
        }, 0);
        this.isOpened = true;

        if (this.alternateAnimation === 'RigthToLeftAnimation') {
          this.isOpenedAnimationRTL = 'show';
          this.modalClassCustom = 'modal right fade';
        } else this.isOpenedAnimation = 'show';

        this.modalService.Open();
        return false;
      }

      cancel() {
        if (!this.isOpened) return false;
        if (this.alternateAnimation === 'RigthToLeftAnimation') this.isOpenedAnimationRTL = 'hide';else this.isOpenedAnimation = 'hide';
        window.setTimeout(() => {
          document.body.removeChild(this.backdropElement);
          document.body.className = document.body.className.replace(/ modal-open\b/, '');
          this.isOpened = false;
        }, 250);
        this.alternateAnimation = '';
        this.modalService.Close();
        return false;
      }

      submit(returnValue) {
        if (!this.isOpened) return false;
        this.modalService.Submit(returnValue);
        return false;
      }

      loadComponent() {
        this.headerTitle = this.headerTitle ? this.headerTitle : '';
        let componentFactory = this.componentFactoryResolver.resolveComponentFactory(this.adItem.component);
        let viewContainerRef = this.adHost.viewContainerRef;
        viewContainerRef.clear();
        let componentRef = viewContainerRef.createComponent(componentFactory);
        componentRef.instance.data = this.adItem.data;
      }

    };

    tslib_1.__decorate([core_1.ViewChild(ad_directive_1.AdDirective), tslib_1.__metadata("design:type", ad_directive_1.AdDirective)], ModalGenericComponent.prototype, "adHost", void 0);

    tslib_1.__decorate([core_1.Output('onLoaded'), tslib_1.__metadata("design:type", core_1.EventEmitter)], ModalGenericComponent.prototype, "onLoaded", void 0);

    tslib_1.__decorate([core_1.ViewChild('modalContent'), tslib_1.__metadata("design:type", core_1.ElementRef)], ModalGenericComponent.prototype, "modalContentElement", void 0);

    ModalGenericComponent = tslib_1.__decorate([core_1.Component({
      moduleId: module.id,
      selector: 'modal-generic-cmp',
      templateUrl: 'modal-generic.component.html',
      styleUrls: ['modal-generic.component.css'],
      animations: [modal_animation_1.upToDownAnimation300, modal_animation_1.rightToLeftAnimation300]
    }), tslib_1.__metadata("design:paramtypes", [modal_generic_service_1.ModalGenericService, core_1.ComponentFactoryResolver])], ModalGenericComponent);
    return ModalGenericComponent;
  })();

  exports.ModalGenericComponent = ModalGenericComponent;
})(modalGeneric_component, modalGeneric_component.exports);

var group_service = {};

Object.defineProperty(group_service, "__esModule", {
  value: true
});
group_service.GroupService = void 0;
const tslib_1$7 = require$$0;
const core_1$7 = require$$0$1;
const http_1$4 = require$$19;
const operators_1$4 = require$$3;
const env_config_1$4 = env_config;
const auth_guard_service_1$4 = authGuard_service;

let GroupService = /*@__PURE__*/(() => {
  let GroupService = class GroupService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetGroups(searchCriteria, searchExpression, disabled = false) {
      let url = env_config_1$4.Config.API + '/api/group/get_groups/' + searchCriteria + '/' + searchExpression + '?disabled=' + disabled;
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateGroup(group) {
      let url = env_config_1$4.Config.API + '/api/group/create_group';
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(group);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetGroup(groupId) {
      let url = env_config_1$4.Config.API + '/api/group/get_group/' + groupId;
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveGroup(group) {
      let url = env_config_1$4.Config.API + '/api/group/save_group';
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(group);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteGroup(group) {
      let url = env_config_1$4.Config.API + '/api/group/delete_group';
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(group);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteGroups(groups) {
      let bodyContent = {};
      bodyContent.groups = [...groups];
      let url = env_config_1$4.Config.API + '/api/group/delete_groups';
      let headers = new http_1$4.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$4.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$4.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  GroupService = tslib_1$7.__decorate([core_1$7.Injectable(), tslib_1$7.__metadata("design:paramtypes", [http_1$4.HttpClient, auth_guard_service_1$4.AuthGuardService])], GroupService);
  return GroupService;
})();

group_service.GroupService = GroupService;

var subgroup_service = {};

Object.defineProperty(subgroup_service, "__esModule", {
  value: true
});
subgroup_service.SubgroupService = void 0;
const tslib_1$6 = require$$0;
const core_1$6 = require$$0$1;
const http_1$3 = require$$19;
const operators_1$3 = require$$3;
const env_config_1$3 = env_config;
const auth_guard_service_1$3 = authGuard_service;

let SubgroupService = /*@__PURE__*/(() => {
  let SubgroupService = class SubgroupService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetSubgroups(searchCriteria, searchExpression, disabled = false) {
      let url = env_config_1$3.Config.API + '/api/subgroup/get_subgroups/' + searchCriteria + '/' + searchExpression + '?disabled=' + disabled;
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateSubgroup(subgroup) {
      let url = env_config_1$3.Config.API + '/api/subgroup/create_subgroup';
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(subgroup);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetSubgroup(subgroupId) {
      let url = env_config_1$3.Config.API + '/api/subgroup/get_subgroup/' + subgroupId;
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveSubgroup(subgroup) {
      let url = env_config_1$3.Config.API + '/api/subgroup/save_subgroup';
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(subgroup);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteSubgroup(subgroup) {
      let url = env_config_1$3.Config.API + '/api/subgroup/delete_subgroup';
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(subgroup);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteSubgroups(subgroups) {
      let bodyContent = {};
      bodyContent.subgroups = [...subgroups];
      let url = env_config_1$3.Config.API + '/api/subgroup/delete_subgroups';
      let headers = new http_1$3.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$3.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$3.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  SubgroupService = tslib_1$6.__decorate([core_1$6.Injectable(), tslib_1$6.__metadata("design:paramtypes", [http_1$3.HttpClient, auth_guard_service_1$3.AuthGuardService])], SubgroupService);
  return SubgroupService;
})();

subgroup_service.SubgroupService = SubgroupService;

var customField_service = {};

Object.defineProperty(customField_service, "__esModule", {
  value: true
});
customField_service.CustomFieldService = void 0;
const tslib_1$5 = require$$0;
const core_1$5 = require$$0$1;
const http_1$2 = require$$19;
const env_config_1$2 = env_config;
const auth_guard_service_1$2 = authGuard_service;
const operators_1$2 = require$$3;

let CustomFieldService = /*@__PURE__*/(() => {
  let CustomFieldService = class CustomFieldService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetCustomFields(searchCriteria, searchExpression, disabled = false) {
      let url = env_config_1$2.Config.API + '/api/customfield/get_customfields/' + searchCriteria + '/' + searchExpression + '?disabled=' + disabled;
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetCustomField(customFieldId) {
      let url = env_config_1$2.Config.API + '/api/customfield/get_customfield/' + customFieldId;
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateCustomField(customField) {
      let url = env_config_1$2.Config.API + '/api/customfield/create_customfield/';
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(customField);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveCustomField(customField) {
      let url = env_config_1$2.Config.API + '/api/customfield/save_customfield/';
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(customField);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteCustomField(customField) {
      let url = env_config_1$2.Config.API + '/api/customfield/delete_customfield';
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(customField);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteCustomFields(customField) {
      let url = env_config_1$2.Config.API + '/api/customfield/delete_customfields';
      let headers = new http_1$2.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(customField);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$2.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$2.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  CustomFieldService = tslib_1$5.__decorate([core_1$5.Injectable(), tslib_1$5.__metadata("design:paramtypes", [http_1$2.HttpClient, auth_guard_service_1$2.AuthGuardService])], CustomFieldService);
  return CustomFieldService;
})();

customField_service.CustomFieldService = CustomFieldService;

var evaluationPlan_service = {};

Object.defineProperty(evaluationPlan_service, "__esModule", {
  value: true
});
evaluationPlan_service.EvaluationPlanService = void 0;
const tslib_1$4 = require$$0;
const core_1$4 = require$$0$1;
const http_1$1 = require$$19;
const operators_1$1 = require$$3;
const auth_guard_service_1$1 = authGuard_service;
const env_config_1$1 = env_config;

let EvaluationPlanService = /*@__PURE__*/(() => {
  let EvaluationPlanService = class EvaluationPlanService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    CreateEvaluationPlan(evaluationPlan, process) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/create_evaluationplan';
      let headers = new Headers({
        'Content-Type': 'application/json'
      });
      let body = {
        evaluationPlan,
        process
      };
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveEvaluationPlan(evaluationPlan) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/save_evaluationplan';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationPlan);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlans(searchCriteria, searchExpression, disabled = false) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplans/' + searchCriteria + '/' + searchExpression + '?disabled=' + disabled;
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlanByName(evaluationPlanName) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplan_by_name/' + evaluationPlanName;
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlansAdmin(evaluationPlanFilters) {
      evaluationPlanFilters.target = 'AD';
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplans_summary/';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationPlanFilters);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlansAuditor(evaluationPlanFilters) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplans_auditor/0?';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationPlanFilters);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlansAgent(evaluationPlanFilters) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplans_agent/0?';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationPlanFilters);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlan(evaluationPlanId) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluationplan/' + evaluationPlanId;
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteEvaluationPlan(evaluationPlan) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/delete_evaluationplan';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(evaluationPlan);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteEvaluationPlans(evaluationPlans) {
      let bodyContent = {};
      bodyContent.evaluationPlans = [];
      evaluationPlans.forEach(function (evaluationPlan) {
        bodyContent.evaluationPlans.push(evaluationPlan);
      });
      let url = env_config_1$1.Config.API + '/api/evaluationplan/delete_evaluationplans';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetEvaluationPlanEvaluationItems(evaluationPlanId) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_evaluation_items/' + evaluationPlanId;
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetFiltersFromEvaluation(campaigns, efectivityMode) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_filters_from_evaluation';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        campaigns: campaigns ? campaigns : [],
        efectivityMode: efectivityMode
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetFiltersPerformanceAgent(batchType, evaluationFormatId, templateId) {
      let url = env_config_1$1.Config.API + '/api/evaluationplan/get_filters_performance_agent';
      let headers = new http_1$1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        batchType: batchType,
        evaluationFormatId: evaluationFormatId,
        templateId: templateId ? templateId : []
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1$1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1$1.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  EvaluationPlanService = tslib_1$4.__decorate([core_1$4.Injectable(), tslib_1$4.__metadata("design:paramtypes", [http_1$1.HttpClient, auth_guard_service_1$1.AuthGuardService])], EvaluationPlanService);
  return EvaluationPlanService;
})();

evaluationPlan_service.EvaluationPlanService = EvaluationPlanService;

var adItem_model = {};

Object.defineProperty(adItem_model, "__esModule", {
  value: true
});
adItem_model.AdItem = void 0;

class AdItem {
  constructor(component, data) {
    this.component = component;
    this.data = data;
  }

}

adItem_model.AdItem = AdItem;

var evaluationFormat_model = {};

Object.defineProperty(evaluationFormat_model, "__esModule", {
  value: true
});
evaluationFormat_model.EvaluationFormatFormQualificationSummary = evaluationFormat_model.EvaluationFormatFormItemResult = evaluationFormat_model.EvaluationFormatFormItemConditional = evaluationFormat_model.EvaluationFormatFormItem = evaluationFormat_model.EvaluationFormatForm = evaluationFormat_model.EvaluationFormat = evaluationFormat_model.EvaluationFormatExecutionTypes = evaluationFormat_model.EvaluationFormatTypes = void 0;
const arrays_helper_1$1 = arraysHelper;
const combo_data_model_1 = comboData_model;
const guid_module_1 = guid_module;

class EvaluationFormatTypes {
  constructor(manual = 'MANUAL', manual_automatic = 'MANUAL_AUTOMATIC', mixed = 'MIXED') {
    this.manual = manual;
    this.manual_automatic = manual_automatic;
    this.mixed = mixed;
  }

}

evaluationFormat_model.EvaluationFormatTypes = EvaluationFormatTypes;

class EvaluationFormatExecutionTypes {
  constructor(batch = 'BATCH', realtime = 'REALTIME') {
    this.batch = batch;
    this.realtime = realtime;
  }

}

evaluationFormat_model.EvaluationFormatExecutionTypes = EvaluationFormatExecutionTypes;

class EvaluationFormat {
  constructor(id, description, type, minQualificationAcceptable, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, managementFormURL, enabled, templateId) {
    this.id = id;
    this.description = description;
    this.type = type;
    this.minQualificationAcceptable = minQualificationAcceptable;
    this.createdDate = createdDate;
    this.createdByUserId = createdByUserId;
    this.lastModifiedDate = lastModifiedDate;
    this.lastModifiedByUserId = lastModifiedByUserId;
    this.managementFormURL = managementFormURL;
    this.enabled = enabled;
    this.templateId = templateId;
    this.selected = false;
    this.executionType = null;
    this.evaluationFormatMaximunCustomFieldsAmount = 8;
    this.minAutomaticQualification = 0;
    this.modelLanguages = null;
  }

  get isRealTime() {
    let types = new EvaluationFormatExecutionTypes();
    console.log(this.executionType === types.realtime);
    return this.executionType === types.realtime;
  }

}

evaluationFormat_model.EvaluationFormat = EvaluationFormat;

class EvaluationFormatForm {
  constructor(id = null, title = null, calificationType = null, evaluationFormtType = null) {
    this.id = id;
    this.title = title;
    this.calificationType = calificationType;
    this.evaluationFormtType = evaluationFormtType;
    this.evaluationFormatTypes = new EvaluationFormatTypes();
    this.dependsWith = [];
    this.items = [];
    this.conditionalGroupsOptions = [];
    this.selectedConditionalGroupOption = null;
    this.isPenalized = false;
    this.qualificationSummary = new EvaluationFormatFormQualificationSummary();
    this.showGroups = true;
    this.showSubGroups = true;
    this.showPenalizedAbilities = false;
    this.groupsOptions = null;
    this.subGroupsOptions = null;
    this.abilitiesOptions = null;
    this._content = [];
  }

  get content() {
    return this._content;
  }

  UpdateItemsOrder() {
    this.items.forEach((item, index) => item.order = index);
  }

  RenderContent() {
    this.UpdateItemsOrder();
    let formContent = [];
    formContent = this.items.filter(i => !i.groupItemId && !i.subGroupItemId).map(i => {
      let clonedItem = { ...i
      };
      clonedItem.item = i;
      return clonedItem;
    });
    formContent = arrays_helper_1$1.SortObjectArrayByValue(formContent, 'order', 'A');
    formContent.filter(fc => fc.type === 'GROUP').forEach(fc => {
      let formGroupItemContent = this.items.filter(i => i.groupItemId === fc.id && !i.subGroupItemId).map(i => {
        let clonedItem = { ...i
        };
        clonedItem.item = i;
        return clonedItem;
      });
      formGroupItemContent.filter(fgic => fgic.type === 'SUBGROUP').forEach(fgic => {
        let formGroupItemSubGroupItemContent = this.items.filter(i => i.groupItemId === fc.id && i.subGroupItemId === fgic.id).map(i => {
          let clonedItem = { ...i
          };
          clonedItem.item = i;
          return clonedItem;
        });
        fgic.items = formGroupItemSubGroupItemContent;
      });
      fc.items = formGroupItemContent;
    });
    this._content = formContent;
  }

  UpdateContent() {
    this.isPenalized = false;

    this._content.forEach(gi => {
      gi.isPenalized = false;
      gi.item.isPenalized = false;
      gi.weight = gi.item?.weight ? gi.item.weight : 0;
      gi.item.itemResult.qualification = gi.item.itemResult?.qualification ? gi.item.itemResult.qualification : 0;
      gi.items.forEach(sgi => {
        sgi.isPenalized = false;
        sgi.item.isPenalized = false;
        sgi.weight = sgi.item?.weight ? sgi.item.weight : 0;
        sgi.item.itemResult.qualification = sgi.item.itemResult?.qualification ? sgi.item.itemResult.qualification : 0;
        sgi.items.forEach(ai => {
          ai.isPenalized = false;
          ai.item.isPenalized = false;

          if (ai.itemResult?.selectedScore && ai.itemResult.selectedScore.value === 0 && ai.penalizeOption.value !== 'NO') {
            let penalizedItem = null;

            switch (ai.penalizeOption.value) {
              case 'GRP':
                gi.isPenalized = true;
                gi.item.isPenalized = true;
                penalizedItem = this.items.find(i => i.type === 'GROUP' && i.id === ai.groupItemId);
                this.items.filter(i => i.groupItemId === ai.groupItemId).forEach(i => i.isPenalized = true);
                break;

              case 'SGR':
                sgi.isPenalized = true;
                sgi.item.isPenalized = true;
                penalizedItem = this.items.find(i => i.type === 'SUBGROUP' && i.id === ai.subGroupItemId);
                this.items.filter(i => i.subGroupItemId === ai.subGroupItemId).forEach(i => i.isPenalized = true);
                break;

              case 'INT':
                this.isPenalized = true;
                ai.isPenalized = true;
                ai.item.isPenalized = true;
                break;
            }

            ai.itemResult.penalizes = true;
            if (penalizedItem) penalizedItem.isPenalized = true;
          } else ai.itemResult.penalizes = false;
        });
      });
    });
  }

  GetGroupsOptions(allGroupsOptions) {
    let validGroupsOptions = [];
    allGroupsOptions.forEach(ago => {
      if (!this.items.find(i => i.type === 'GROUP' && i.item?.id === ago.GetValueId())) validGroupsOptions.push(ago);
    });
    if (JSON.stringify(this.groupsOptions) !== JSON.stringify(validGroupsOptions)) this.groupsOptions = validGroupsOptions;
    return this.groupsOptions;
  }

  GetSubGroupsOptions(allSubGroupsOptions, conditionalGroupItemParentId) {
    let validSubGroupsOptions = [];
    allSubGroupsOptions.forEach(asgo => {
      if (conditionalGroupItemParentId) {
        if (!this.items.find(i => i.type === 'SUBGROUP' && i.item?.id === asgo.GetValueId() && !i.conditional)) validSubGroupsOptions.push(asgo);
      } else {
        if (!this.items.find(i => i.type === 'SUBGROUP' && i.item?.id === asgo.GetValueId())) validSubGroupsOptions.push(asgo);
      }
    });
    if (JSON.stringify(this.subGroupsOptions) !== JSON.stringify(validSubGroupsOptions)) this.subGroupsOptions = validSubGroupsOptions;
    return this.subGroupsOptions;
  }

  GetAbilitiesOptions(allAbilitiesOptions, conditionalGroupItemParentId) {
    let validAbilitiesOptions = [];
    allAbilitiesOptions.forEach(aao => {
      if (conditionalGroupItemParentId) {
        if (!this.items.find(i => i.type === 'ABILITY' && i.item?.id === aao.GetValueId() && !i.conditional)) validAbilitiesOptions.push(aao);
      } else {
        if (!this.items.find(i => i.type === 'ABILITY' && i.item?.id === aao.GetValueId())) validAbilitiesOptions.push(aao);
      }
    });
    if (JSON.stringify(this.abilitiesOptions) !== JSON.stringify(validAbilitiesOptions)) this.abilitiesOptions = validAbilitiesOptions;
    return this.abilitiesOptions;
  }

  GetConditionalGroupsOptions() {
    if (!this.conditionalGroupsOptions.length) this.items.filter(i => i.type === 'GROUP' && i.conditional).forEach(i => this.conditionalGroupsOptions.push(new combo_data_model_1.ComboData(i.conditional.name, i.conditional.name)));
    return this.conditionalGroupsOptions;
  }

  SetDistributeScores() {
    this.RessetDistributeScores();
    this.items.filter(i => i.type === 'SUBGROUP').forEach(sgi => {
      let sgiAbilities = this.items.filter(i => i.type === 'ABILITY' && i.subGroupItemId === sgi.id);
      let unabledSiblings = sgiAbilities.filter(sgia => sgia.itemResult.notApplies);
      let enabledSiblings = sgiAbilities.filter(sgia => sgia.itemResult.notApplies !== true);

      if (enabledSiblings?.length) {
        let enableSiblingsTotalWeight = 0;
        enabledSiblings = arrays_helper_1$1.SortObjectArrayByValue(enabledSiblings, 'weight', 'D');
        enabledSiblings.forEach(es => enableSiblingsTotalWeight += es.weight);
        unabledSiblings.forEach(us => {
          if (us.item.distributes) {
            let itemWeight = us.weight;
            enabledSiblings.forEach(es => {
              if (es.weight === 0) console.warn('La habilidad habilitada tiene weight 0, no recibirá nada de la distribución...');
              let inheritedWeight = Math.round(es.weight * us.weight * 100 / enableSiblingsTotalWeight) / 100;
              if (itemWeight >= inheritedWeight) es.itemResult.inheritedScore += inheritedWeight;else es.itemResult.inheritedScore += itemWeight;
              itemWeight -= inheritedWeight;
            });
          }
        });
      }
    });
  }

  RessetDistributeScores() {
    this.items.filter(i => i.type === 'ABILITY').forEach(i => i.itemResult.inheritedScore = 0);
  }

  GetTotalWeight() {
    let totalWeight = 0;
    this.items.filter(i => i.type === 'SUBGROUP').forEach(sgi => {
      sgi.weight = 0;
      this.items.filter(ai => ai.type === 'ABILITY' && ai.subGroupItemId === sgi.id).forEach(ai => {
        if (!ai.conditional || !this.selectedConditionalGroupOption || ai.conditional.isPrimary && this.selectedConditionalGroupOption?.value === ai.conditional.name) sgi.weight += ai.weight;
      });
    });
    this.items.filter(i => i.type === 'GROUP').forEach(gi => {
      gi.weight = 0;
      this.items.filter(sgi => sgi.type === 'SUBGROUP' && sgi.groupItemId === gi.id).forEach(sgi => gi.weight += sgi.weight);
      totalWeight += gi.weight;
    });
    return totalWeight;
  }

  GetTotalQualification() {
    let totalQualification = 0;
    this.items.filter(i => i.type === 'SUBGROUP').forEach(sgi => {
      sgi.itemResult.qualification = 0;
      this.items.filter(ai => ai.type === 'ABILITY' && ai.subGroupItemId === sgi.id).forEach(ai => {
        if ((!ai.conditional || this.selectedConditionalGroupOption?.value === ai.conditional?.name) && ai.itemResult?.selectedScore?.value === 100) {
          ai.itemResult.qualification = ai.itemResult.ownScore + ai.itemResult.inheritedScore;
          if (!sgi.isPenalized) sgi.itemResult.qualification += ai.itemResult.qualification;
        } else {
          if (ai.itemResult.notApplies && !ai.item.distributes) {
            sgi.itemResult.qualification += ai.weight;
          }
        }
      });
    });
    this.items.filter(i => i.type === 'GROUP').forEach(gi => {
      gi.itemResult.qualification = 0;
      this.items.filter(sgi => sgi.type === 'SUBGROUP' && sgi.groupItemId === gi.id).forEach(sgi => {
        gi.itemResult.qualification += sgi.itemResult.qualification;
      });
      if (!gi.isPenalized) totalQualification += gi.itemResult.qualification + gi.itemResult.inheritedScore;
    });
    if (this.isPenalized) totalQualification = 0;
    this.qualificationSummary.isPenalized = this.isPenalized;
    return totalQualification;
  }

  IsConditionalGroupsWeightEqual() {
    let isConditionalGroupsWeightEqual = true;
    let itemConditionalPrimary = this.items.find(i => i.conditional?.isPrimary);
    let itemConditionalAlternative = this.items.find(i => i.conditional && !i.conditional.isPrimary);
    if (itemConditionalPrimary && itemConditionalAlternative) isConditionalGroupsWeightEqual = itemConditionalPrimary.weight === itemConditionalAlternative.weight;
    return isConditionalGroupsWeightEqual;
  }

  GetAbilityEvaluationFormatFromFormItems() {
    let abilityEvaluationFormats = [];
    let groupItems = this.items.filter(i => i.type === 'GROUP');
    let subGroupItems = this.items.filter(i => i.type === 'SUBGROUP');
    abilityEvaluationFormats = this.items.filter(i => i.type === 'ABILITY').map(i => {
      let abilityEvaluationFormat = {};
      let currentGroupItem = groupItems.find(gi => gi.id === i.groupItemId);
      let currentSubGroupItem = subGroupItems.find(sgi => sgi.id === i.subGroupItemId);
      abilityEvaluationFormat.id = null;
      abilityEvaluationFormat.idEvaluationFormat = null;
      abilityEvaluationFormat.idAbility = i.item.id;
      abilityEvaluationFormat.abilityType = i.item.type;
      abilityEvaluationFormat.titleAbility = i.item.title;
      abilityEvaluationFormat.descriptionAbility = i.item.title;
      abilityEvaluationFormat.abilityCalificationType = i.item.calificationType;
      abilityEvaluationFormat.abilityScores = i.item.scores;
      abilityEvaluationFormat.query = i.item.queryName;
      abilityEvaluationFormat.idGroup = currentGroupItem.item.id;
      abilityEvaluationFormat.descriptionGroup = currentGroupItem.item.description;
      abilityEvaluationFormat.idSubGroup = currentSubGroupItem.item.id;
      abilityEvaluationFormat.descriptionSubGroup = currentSubGroupItem.item.description;
      abilityEvaluationFormat.penalizes = i.penalizeOption.value;
      abilityEvaluationFormat.score = i.weight;
      abilityEvaluationFormat.order = i.order;
      abilityEvaluationFormat.conditional = i.conditional?.name ? i.conditional.name : null;
      abilityEvaluationFormat.acceptComments = i.item.acceptComments;
      abilityEvaluationFormat.acceptNotApplies = i.item.notApply;
      abilityEvaluationFormat.distribute = null;
      abilityEvaluationFormat.scores = null;
      abilityEvaluationFormat.notApplies = null;
      abilityEvaluationFormat.comments = null;
      abilityEvaluationFormat.abilityIsBinary = i.item.binary;
      abilityEvaluationFormat.helpComment = i.helpComment;
      return abilityEvaluationFormat;
    });
    return abilityEvaluationFormats;
  }

  GetEvaluationResultFromFormItem() {
    let abilityEvaluationResults = [];
    this.qualificationSummary = new EvaluationFormatFormQualificationSummary();
    this.items.filter(i => i.type === 'ABILITY').forEach(i => {
      if (!i.conditional || i.conditional.name === this.selectedConditionalGroupOption?.description) {
        let abilityEvaluationResult = {};
        abilityEvaluationResult.comments = i.itemResult.comment;
        abilityEvaluationResult.notApplies = i.itemResult.notApplies;
        abilityEvaluationResult.ownScore = i.itemResult.ownScore;
        abilityEvaluationResult.inheritedScore = i.itemResult.inheritedScore;
        abilityEvaluationResult.conditionalSelected = i.conditional ? i.conditional.name : null;
        abilityEvaluationResult.abilityOrder = i.order;
        abilityEvaluationResult.abilityId = i.item.id;
        abilityEvaluationResult.groupId = this.items.find(gi => gi.type === 'GROUP' && gi.id === i.groupItemId).item.id;
        abilityEvaluationResult.subGroupId = this.items.find(sgi => sgi.type === 'SUBGROUP' && sgi.id === i.subGroupItemId).item.id;

        if (i.itemResult.selectedScore) {
          abilityEvaluationResult.qualification = i.isPenalized ? 0 : i.itemResult.qualification;
          abilityEvaluationResult.scoreDescription = i.itemResult.selectedScore.description;
          abilityEvaluationResult.abilityInnerScore = i.itemResult.selectedScore.value;
          abilityEvaluationResult.maxAbilityScore = i.weight * i.itemResult.selectedScore.value / 100;
          abilityEvaluationResult.tipifications = i.itemResult.selectedScore.tipifications;
        } else {
          abilityEvaluationResult.qualification = i.itemResult.notApplies && !i.item.distributes ? i.itemResult.qualification : 0;
          abilityEvaluationResult.scoreDescription = i.itemResult.notApplies ? '' : null;
          abilityEvaluationResult.abilityInnerScore = 0;
          abilityEvaluationResult.maxAbilityScore = 0;
          abilityEvaluationResult.tipifications = [];
        }

        switch (i.item.type) {
          case 'MANUAL':
            this.qualificationSummary.manualScore += abilityEvaluationResult.qualification;
            break;

          case 'MANUAL_AUTOMATIC':
            this.qualificationSummary.automaticScore += abilityEvaluationResult.qualification;
            break;
        }

        this.qualificationSummary.ownScore += i.isPenalized ? 0 : abilityEvaluationResult.ownScore;
        this.qualificationSummary.inhereticScore += i.isPenalized ? 0 : abilityEvaluationResult.inheritedScore;
        abilityEvaluationResults.push(abilityEvaluationResult);
      }
    });
    return abilityEvaluationResults;
  }

  GetFormItemFromAbilityEvaluationFormats(abilityEvaluationFormats, allGroupsOptions, allSubGroupsOptions, allAbilitiesOptions, allPenalizesOptions) {
    let groupIds = arrays_helper_1$1.GetUniqueFromObjectArray(abilityEvaluationFormats, 'idGroup');
    let subGroupIds = arrays_helper_1$1.GetUniqueFromObjectArray(abilityEvaluationFormats, 'idSubGroup');
    groupIds.forEach(gi => {
      let groupsToAdd = [];
      let newGroupItem = new EvaluationFormatFormItem(this.id, guid_module_1.GenerateGuid(), 'GROUP');
      let alternativeNewGroupItem = null;
      newGroupItem.order = gi.order - 2;

      if (gi.conditional) {
        let primaryConditionalObject = new EvaluationFormatFormItemConditional();
        primaryConditionalObject.isPrimary = true;
        primaryConditionalObject.name = gi.conditional;
        newGroupItem.conditional = primaryConditionalObject;
        let alternativeGroupConditionals = abilityEvaluationFormats.filter(aef => aef.idGroup === gi.idGroup && aef.conditional && aef.conditional !== primaryConditionalObject.name);
        alternativeGroupConditionals = arrays_helper_1$1.GetUniqueFromObjectArray(alternativeGroupConditionals, 'conditional');

        if (alternativeGroupConditionals[0]) {
          let alternativeConditionalObject = new EvaluationFormatFormItemConditional();
          alternativeNewGroupItem = new EvaluationFormatFormItem(this.id, guid_module_1.GenerateGuid(), 'GROUP');
          alternativeNewGroupItem.order = alternativeGroupConditionals[0].order - 2;
          alternativeConditionalObject.isPrimary = false;
          alternativeConditionalObject.name = alternativeGroupConditionals[0].conditional;
          alternativeNewGroupItem.conditional = alternativeConditionalObject;
        }
      }

      groupsToAdd.push(newGroupItem);
      if (alternativeNewGroupItem) groupsToAdd.push(alternativeNewGroupItem);
      groupsToAdd.forEach(gta => {
        let currentGroupValue = allGroupsOptions.find(ago => ago.GetValueId() === gi.idGroup);
        gta.label = currentGroupValue.description;
        gta.item = currentGroupValue.value;
        gta.itemResult = new EvaluationFormatFormItemResult();
        gta.itemResult.qualification = 0;
        gta.selectedOption = currentGroupValue;
        gta.isEditing = false;
      });
      this.items = this.items.concat(groupsToAdd);
    });
    subGroupIds.forEach(sgi => {
      let subGroupsToAdd = [];
      let newSubGroupItem = new EvaluationFormatFormItem(this.id, guid_module_1.GenerateGuid(), 'SUBGROUP');
      let alternativeNewSubGroupItem = null;
      newSubGroupItem.order = sgi.order - 1;

      if (sgi.conditional) {
        let primaryConditionalObject = new EvaluationFormatFormItemConditional();
        primaryConditionalObject.isPrimary = true;
        primaryConditionalObject.name = sgi.conditional;
        newSubGroupItem.conditional = primaryConditionalObject;
        let alternativeSubGroupConditionals = abilityEvaluationFormats.filter(aef => aef.idSubGroup === sgi.idSubGroup && aef.conditional && aef.conditional !== primaryConditionalObject.name);
        alternativeSubGroupConditionals = arrays_helper_1$1.GetUniqueFromObjectArray(alternativeSubGroupConditionals, 'conditional');

        if (alternativeSubGroupConditionals[0]) {
          let alternativeConditionalObject = new EvaluationFormatFormItemConditional();
          alternativeNewSubGroupItem = new EvaluationFormatFormItem(this.id, guid_module_1.GenerateGuid(), 'SUBGROUP');
          alternativeNewSubGroupItem.order = alternativeSubGroupConditionals[0].order - 1;
          alternativeConditionalObject.isPrimary = false;
          alternativeConditionalObject.name = alternativeSubGroupConditionals[0].conditional;
          alternativeNewSubGroupItem.groupItemId = this.items.find(i => i.type === 'GROUP' && !i.conditional.isPrimary).id;
          alternativeNewSubGroupItem.conditional = alternativeConditionalObject;
        }
      }

      subGroupsToAdd.push(newSubGroupItem);
      if (alternativeNewSubGroupItem) subGroupsToAdd.push(alternativeNewSubGroupItem);
      subGroupsToAdd.forEach(sgta => {
        let currentSubGroupValue = allSubGroupsOptions.find(ago => ago.GetValueId() === sgi.idSubGroup);
        if (!sgta.groupItemId) sgta.groupItemId = this.items.find(i => i.item.id === sgi.idGroup).id;
        sgta.label = currentSubGroupValue.description;
        sgta.item = currentSubGroupValue.value;
        sgta.itemResult = new EvaluationFormatFormItemResult();
        sgta.itemResult.qualification = 0;
        sgta.selectedOption = currentSubGroupValue;
        sgta.isEditing = false;
      });
      this.items = this.items.concat(subGroupsToAdd);
    });
    abilityEvaluationFormats.forEach(aef => {
      let newItem = new EvaluationFormatFormItem(this.id, guid_module_1.GenerateGuid(), 'ABILITY');
      let currentGroupItem = null;
      let currentSubGroupItem = null;
      let currentAbilityValue = allAbilitiesOptions.find(aao => aao.GetValueId() === aef.idAbility);

      if (currentAbilityValue) {
        currentAbilityValue.value.scores = aef.scores;
        if (aef.conditional) currentGroupItem = this.items.find(i => i.type === 'GROUP' && i.item?.id === aef.idGroup && i.conditional?.name === aef.conditional);else currentGroupItem = this.items.find(i => i.type === 'GROUP' && i.item?.id === aef.idGroup);
        currentSubGroupItem = this.items.find(i => i.type === 'SUBGROUP' && i.groupItemId === currentGroupItem.id && i.item?.id === aef.idSubGroup);
        newItem.groupItemId = currentGroupItem.id;
        newItem.conditional = currentGroupItem.conditional;
        newItem.subGroupItemId = currentSubGroupItem.id;
        newItem.label = currentAbilityValue.description;
        newItem.labelDetail = currentAbilityValue.GetValueData('detail');
        newItem.item = currentAbilityValue.value;
        newItem.itemResult = new EvaluationFormatFormItemResult();
        newItem.itemResult.showItems = false;
        newItem.itemResult.showTipifications = false;
        newItem.itemResult.selectedScore = null;
        newItem.itemResult.qualification = 0;
        newItem.itemResult.ownScore = 0;
        newItem.itemResult.inheritedScore = 0;
        newItem.selectedOption = currentAbilityValue;
        newItem.penalizeOption = allPenalizesOptions.find(apo => apo.value === aef.penalizes);
        newItem.order = aef.order;
        newItem.weight = aef.score;
        newItem.isEditing = false;
        newItem.helpComment = aef.helpComment;
        this.items.push(newItem);
      }
    });
    this.items = arrays_helper_1$1.SortObjectArrayByValue(this.items, 'order', 'A');
    this.GetTotalWeight();
    this.RenderContent();
  }

  GetFormItemResultFromEvaluationResults(evaluationResults) {
    this.GetConditionalGroupsOptions();
    let selectedConditional = arrays_helper_1$1.GetUniqueFromObjectArray(evaluationResults, 'conditional').find(ufoa => ufoa.conditional);
    if (selectedConditional) this.selectedConditionalGroupOption = this.conditionalGroupsOptions.find(cgo => cgo.description === selectedConditional.conditional);
    this.items.filter(i => i.type === 'ABILITY').forEach(ai => {
      let evaluationResult = evaluationResults.find(er => er.idAbility === ai.item.id && (!er.conditional && !ai.conditional || er.conditional === ai.conditional.name));

      if (evaluationResult) {
        ai.itemResult.qualification = evaluationResult.qualification;
        ai.itemResult.comment = evaluationResult.comments;
        ai.itemResult.efectivity = evaluationResult.efectivity ? evaluationResult.efectivity : '';
        ai.itemResult.efectivitySatus = evaluationResult.efectivityStatus;
        ai.itemResult.abilityEvaluationFormatId = evaluationResult.abilityEvaluationFormatId;
        ai.itemResult.abilityType = evaluationResult.abilityType;
        ai.itemResult.efectivityPlanId = evaluationResult.efectivityPlanId;

        if (evaluationResult.scoreDescription === '') {
          ai.itemResult.notApplies = true;
          ai.itemResult.ownScore = evaluationResult.ownScore;
        } else {
          let selectedScore = ai.item.scores.find(s => s.description === evaluationResult.scoreDescription);

          if (selectedScore) {
            selectedScore.tipifications.forEach(t => {
              let savedTipification = evaluationResult.tipifications.find(ert => ert.id === t.id);

              if (savedTipification) {
                t.isChecked = savedTipification.isChecked;
                t.comment = savedTipification.comment;
                t.items.forEach(ti => {
                  let savedTipificationItem = savedTipification.items.find(sti => sti.id === ti.id);
                  ti.isChecked = savedTipificationItem?.isChecked ? true : false;
                });
              }
            });
            ai.itemResult.selectedScore = selectedScore;
            ai.itemResult.ownScore = ai.weight * selectedScore.value / 100;
          }
        }

        let currentGroupItem = this.items.find(gi => gi.type === 'GROUP' && gi.id === ai.groupItemId);
        let currentSubGroupItem = this.items.find(sgi => sgi.type === 'SUBGROUP' && sgi.id === ai.subGroupItemId);
        currentGroupItem.itemResult.summaryTotalAbilities += 1;
        currentGroupItem.itemResult.summaryTotalErrorAbilities += ai.itemResult.selectedScore?.value === 0 ? 1 : 0;
        currentGroupItem.itemResult.summaryTotalPenalizedAbilities += ai.penalizeOption.value !== 'NO' && ai.itemResult.selectedScore?.value === 0 ? 1 : 0;
        currentSubGroupItem.itemResult.summaryTotalAbilities += 1;
        currentSubGroupItem.itemResult.summaryTotalErrorAbilities += ai.itemResult.selectedScore?.value === 0 ? 1 : 0;
        currentSubGroupItem.itemResult.summaryTotalPenalizedAbilities += ai.penalizeOption.value !== 'NO' && ai.itemResult.selectedScore?.value === 0 ? 1 : 0;
      }
    });
    this.SetDistributeScores();
    this.UpdateContent();
    this.GetTotalQualification();
    this.GetEvaluationResultFromFormItem();
    this.RenderContent();
  }

  GetAbilitiesTypes() {
    let abilitiesTypes;
    abilitiesTypes = this.items.filter(i => i.type === 'ABILITY').map(i => i.item.type);
    abilitiesTypes = arrays_helper_1$1.GetUniqueFromArray(abilitiesTypes);
    return abilitiesTypes;
  }

  IsConditionalAvailable() {
    let hasConditional = false;
    let canHaveConditional = false;
    hasConditional = this.items.filter(i => i.conditional).length ? true : false;
    canHaveConditional = this.evaluationFormtType === this.evaluationFormatTypes.manual;
    return !hasConditional && canHaveConditional;
  }

}

evaluationFormat_model.EvaluationFormatForm = EvaluationFormatForm;

class EvaluationFormatFormItem {
  constructor(formId = null, id = null, type = null) {
    this.formId = formId;
    this.id = id;
    this.type = type;
    this.selectedOption = null;
    this.label = null;
    this.labelDetail = null;
    this.weight = 0;
    this.penalizeOption = null;
    this.isPenalized = false;
    this.conditional = null;
    this.groupItemId = null;
    this.subGroupItemId = null;
    this.item = null;
    this.itemResult = new EvaluationFormatFormItemResult();
    this.order = null;
    this.isEditing = true;
    this.helpComment = null;
  }

  GetTotalWeight() {
    return this.item?.weight ? this.item.weight : 0;
  }

}

evaluationFormat_model.EvaluationFormatFormItem = EvaluationFormatFormItem;

class EvaluationFormatFormItemConditional {
  constructor() {
    this.name = null;
    this.isPrimary = false;
  }

}

evaluationFormat_model.EvaluationFormatFormItemConditional = EvaluationFormatFormItemConditional;

class EvaluationFormatFormItemResult {
  constructor() {
    this.qualification = 0;
    this.selectedScore = null;
    this.penalizes = false;
    this.notApplies = false;
    this.comment = null;
    this.ownScore = 0;
    this.inheritedScore = 0;
    this.summaryTotalAbilities = 0;
    this.summaryTotalPenalizedAbilities = 0;
    this.summaryTotalErrorAbilities = 0;
    this.queryContent = '';
    this.queryId = '';
    this.analysisType = '';
    this.isEditing = false;
    this.isLoadingData = false;
    this.showItems = true;
    this.showItem = true;
    this.showTipifications = true;
    this.showHelpComment = false;
    this.isHelpCommentEditing = false;
    this.efectivity = '';
    this.efectivitySatus = '';
    this.abilityEvaluationFormatId = '';
    this.efectivityPlanId = '';
    this.abilityType = '';
  }

}

evaluationFormat_model.EvaluationFormatFormItemResult = EvaluationFormatFormItemResult;

class EvaluationFormatFormQualificationSummary {
  constructor() {
    this.isPenalized = false;
    this.automaticScore = 0;
    this.manualScore = 0;
    this.ownScore = 0;
    this.inhereticScore = 0;
  }

  get totalScore() {
    return (this.automaticScore + this.manualScore) * (this.isPenalized ? 0 : 1);
  }

}

evaluationFormat_model.EvaluationFormatFormQualificationSummary = EvaluationFormatFormQualificationSummary;

var group_model = {};

Object.defineProperty(group_model, "__esModule", {
  value: true
});
group_model.Group = void 0;

class Group {
  constructor(id, description, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled) {
    this.id = id;
    this.description = description;
    this.createdDate = createdDate;
    this.createdByUserId = createdByUserId;
    this.lastModifiedDate = lastModifiedDate;
    this.lastModifiedByUserId = lastModifiedByUserId;
    this.enabled = enabled;
    this.selected = false;
  }

}

group_model.Group = Group;

var subgroup_model = {};

Object.defineProperty(subgroup_model, "__esModule", {
  value: true
});
subgroup_model.Subgroup = void 0;

class Subgroup {
  constructor(id, description, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled) {
    this.id = id;
    this.description = description;
    this.createdDate = createdDate;
    this.createdByUserId = createdByUserId;
    this.lastModifiedDate = lastModifiedDate;
    this.lastModifiedByUserId = lastModifiedByUserId;
    this.enabled = enabled;
    this.selected = false;
  }

}

subgroup_model.Subgroup = Subgroup;

var genericQueryHelper = {};

Object.defineProperty(genericQueryHelper, "__esModule", {
  value: true
});
genericQueryHelper.GenericQueryHelper = void 0;
const arrays_helper_1 = arraysHelper;

class GenericQueryHelper {
  constructor() {
    this.query = null;
    this.contents = [];
    this.chat = [];
    this.words = [];
  }

  Reset() {
    this.query = null;
    this.contents = [];
  }

  IsAllowedQuery(query) {
    if (this.query === null) this.query = query;
    let isAllowedQuery = true;
    let notAllowedWords = ['AND', 'OR', 'NEAR', 'NOT', 'in_sentences', 'out_sentences'];
    notAllowedWords.map(naw => {
      if (query.includes(naw)) {
        isAllowedQuery = false;
      }
    });
    return isAllowedQuery;
  }

  CheckQueryOnChat() {
    let subQueries = this.GetQueryContents();
    let results = [];
    subQueries.forEach(sq => {
      let query = new RegExp(sq.subQuery.replace(/\s+/g, '\\s'), 'gmi');
      this.chat.filter(c => c.phrase?.length).forEach(c => {
        if (sq.subQuery.includes('NEAR_')) {
          let target = null;

          if (sq.subQuery.includes('in_sentences.text:') || sq.subQuery.includes('out_sentences.text:')) {
            if (sq.subQuery.includes('in_sentences.text:')) {
              target = 'Agent';
              sq.subQuery = sq.subQuery.replace(/in_sentences.text:/g, '');
            }

            if (sq.subQuery.includes('out_sentences.text:')) {
              target = 'Caller';
              sq.subQuery = sq.subQuery.replace(/out_sentences.text:/g, '');
            }
          }

          let nearRegex = new RegExp(`(?<=NEAR_)[0-9]*\\b`, 'g');
          let nearCloseness = sq.subQuery.match(nearRegex)[0] || 5;
          let nearWords = sq.subQuery.split(`NEAR_${nearCloseness}`);
          nearWords = nearWords.map(nw => nw = nw.trim());
          let subQuery = new RegExp(`\\b(${nearWords[0]})\\b\\s*(.*?)\\s*\\b(${nearWords[1]})\\b`, 'gmi');
          let subQueryMatches = c.phrase.match(subQuery) || [];
          let partialResultQuery = {
            concatenator: null,
            subQuery: null
          };
          subQueryMatches.forEach(sqm => {
            let sqmArray = sqm.split(' ');
            let nearWord01 = nearWords[0].split(' ');
            let nearWord02 = nearWords[1].split(' ');
            let matchWithNear = false;
            let word01LastOccurrenceIndex = sqmArray.lastIndexOf(nearWords[0]);
            sqmArray = sqmArray.slice(word01LastOccurrenceIndex);
            sqmArray = sqmArray.filter(sqma => !['.', ',', '?', '!'].includes(sqma));
            matchWithNear = nearCloseness >= sqmArray.length - (nearWord01.length + (nearWord02.length - 1)) - 1;

            if (matchWithNear) {
              partialResultQuery = sqmArray.join(' ');
              let partianResult = this.SearchQueryOnWords(partialResultQuery, c);
              partianResult.subQuery = sq.subQuery;

              if (target) {
                if (c.entity === target) results.push(partianResult);
              } else results.push(partianResult);
            }
          });
        } else {
          if (c.phrase?.match(query)) {
            let result = this.SearchQueryOnWords(query, c);
            result.subQuery = sq.subQuery;
            results.push(result);
          }
        }
      });
    });
    results = arrays_helper_1.SortObjectArrayByValue(results, 'startTime', 'A');
    return results;
  }

  GetQueryContents() {
    let queryContents = [];
    let generalSeparators = /.+?(?=AND|OR|$)/gm;
    let queryStringContents = this.query.match(generalSeparators);
    queryStringContents.map(qc => {
      if (qc.startsWith('AND')) qc = qc.replace('AND', 'AND ');
      if (qc.startsWith('OR')) qc = qc.replace('OR', 'OR ');
      if (qc.includes('(')) qc = qc.replace('(', '');
      if (qc.includes('))')) qc = qc.replace(')', '');
      qc = qc.trim();
      let arr = qc.split(' ');
      let concatenator = ['AND', 'OR'].includes(arr[0]) ? arr.shift() : null;
      qc = arr.join(' ');
      qc = qc.replace(/([(\\")])/gm, '');
      queryContents.push({
        concatenator: concatenator,
        subQuery: qc
      });
    });
    return queryContents;
  }

  SearchQueryOnChat() {
    let query = new RegExp(this.query.replace(/\s+/g, '\\s'), 'gmi');
    let result = null;
    this.chat.every(c => {
      if (c.phrase?.match(query)) {
        result = c;
        return false;
      }

      return true;
    });

    if (result) {
      return this.SearchQueryOnWords(query, result);
    } else {
      return result;
    }
  }

  SearchQueryOnWords(regexQuery, matchedPhrase) {
    let onRangeWords = this.words.filter(w => w.start_time >= matchedPhrase.startTime && w.end_time <= matchedPhrase.endTime && w.type === 'word');
    let filteredWords = [];
    onRangeWords.every(w => {
      let phrase = '';
      filteredWords.push(w);
      filteredWords.map(fw => phrase += fw.name + ' ');

      if (phrase.match(regexQuery)) {
        return false;
      }

      return true;
    });
    let totalFilteredWords = filteredWords.length;

    for (let index = 0; index <= totalFilteredWords - 1; index++) {
      let phrase = '';
      filteredWords.map((fw, i) => phrase += i >= 1 ? fw.name + ' ' : '');

      if (phrase.match(regexQuery)) {
        filteredWords.shift();
      } else {
        index = totalFilteredWords;
      }
    }

    let result = null;

    if (filteredWords && filteredWords.length > 0) {
      result = {
        startTime: filteredWords[0].start_time,
        endTime: filteredWords[filteredWords.length - 1].end_time,
        query: this.query,
        words: filteredWords
      };
    }

    return result;
  }

}

genericQueryHelper.GenericQueryHelper = GenericQueryHelper;

var user_service = {};

Object.defineProperty(user_service, "__esModule", {
  value: true
});
user_service.UserService = void 0;
const tslib_1$3 = require$$0;
const core_1$3 = require$$0$1;
const http_1 = require$$19;
const operators_1 = require$$3;
const env_config_1 = env_config;
const auth_guard_service_1 = authGuard_service;

let UserService = /*@__PURE__*/(() => {
  let UserService = class UserService {
    constructor(authHttp, authGuardService) {
      this.authHttp = authHttp;
      this.authGuardService = authGuardService;
    }

    GetUsers(searchCriteria, searchExpression, isExcludeUsers = false) {
      let url = env_config_1.Config.API + '/api/user/get_users/' + searchCriteria + '/' + searchExpression + '?isExcludeUsers=' + isExcludeUsers;
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetUser(userId) {
      let url = env_config_1.Config.API + '/api/user/get_user/' + userId;
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    GetCurrentUser() {
      let url = env_config_1.Config.API + '/api/current_user/get_user';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.get(url, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.data;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    CreateUser(user) {
      let url = env_config_1.Config.API + '/api/user/create_user';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(user);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveUser(user) {
      let url = env_config_1.Config.API + '/api/user/save_user';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(user);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    SaveCurrentUser(user) {
      let url = env_config_1.Config.API + '/api/current_user/save_user';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(user);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json.status === true;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    ValidateUserPin(pin) {
      let url = env_config_1.Config.API + '/api/user/validate_user_pin';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify({
        pin: pin
      });
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteUser(user) {
      let bodyContent = {};
      bodyContent.user = user;
      let url = env_config_1.Config.API + '/api/user/delete_user';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

    DeleteUsers(users) {
      let bodyContent = {};
      bodyContent.users = [];
      users.forEach(function (user) {
        bodyContent.users.push(user);
      });
      let url = env_config_1.Config.API + '/api/user/delete_users';
      let headers = new http_1.HttpHeaders({
        'Content-Type': 'application/json'
      });
      let body = JSON.stringify(bodyContent);
      let options = {
        headers: headers,
        withCredentials: true
      };
      return this.authHttp.post(url, body, options).pipe(operators_1.map(json => {
        if (json.status === true) {
          return json;
        } else {
          throw json.description || json.error || '';
        }
      }), operators_1.catchError(err => this.authGuardService.HandleError(err)));
    }

  };
  UserService = tslib_1$3.__decorate([core_1$3.Injectable(), tslib_1$3.__metadata("design:paramtypes", [http_1.HttpClient, auth_guard_service_1.AuthGuardService])], UserService);
  return UserService;
})();

user_service.UserService = UserService;

var object_pipes = {};

Object.defineProperty(object_pipes, "__esModule", {
  value: true
});
object_pipes.ObjectToKeysArrayPipe = void 0;
const tslib_1$2 = require$$0;
const core_1$2 = require$$0$1;

let ObjectToKeysArrayPipe = /*@__PURE__*/(() => {
  let ObjectToKeysArrayPipe = class ObjectToKeysArrayPipe {
    constructor() {}

    transform(value, args) {
      let keys = [];

      for (let key in value) {
        keys.push(key);
      }

      return keys;
    }

  };
  ObjectToKeysArrayPipe = tslib_1$2.__decorate([core_1$2.Pipe({
    name: 'objectToKeysArray'
  }), tslib_1$2.__metadata("design:paramtypes", [])], ObjectToKeysArrayPipe);
  return ObjectToKeysArrayPipe;
})();

object_pipes.ObjectToKeysArrayPipe = ObjectToKeysArrayPipe;

var datetime_pipes = {};

Object.defineProperty(datetime_pipes, "__esModule", {
  value: true
});
datetime_pipes.DateFormatPipe = datetime_pipes.FromNowPipe = datetime_pipes.TimeToHHmmssPipe = void 0;
const tslib_1$1 = require$$0;
const core_1$1 = require$$0$1;
const moment = moment$3.exports;
const authentication_service_1 = authentication_service;

let TimeToHHmmssPipe = /*@__PURE__*/(() => {
  let TimeToHHmmssPipe = class TimeToHHmmssPipe {
    constructor() {}

    transform(value) {
      if (!value || typeof value !== 'number') value = 0;
      return moment().startOf('day').seconds(value).format('HH:mm:ss');
    }

  };
  TimeToHHmmssPipe = tslib_1$1.__decorate([core_1$1.Pipe({
    name: 'timeToHHmmss'
  }), tslib_1$1.__metadata("design:paramtypes", [])], TimeToHHmmssPipe);
  return TimeToHHmmssPipe;
})();

datetime_pipes.TimeToHHmmssPipe = TimeToHHmmssPipe;

let FromNowPipe = /*@__PURE__*/(() => {
  let FromNowPipe = class FromNowPipe {
    constructor(authenticationService) {
      this.authenticationService = authenticationService;
      moment.tz.setDefault(this.authenticationService.GetTimeZone());
      moment.locale(this.authenticationService.GetLoggedUserLanguage());
    }

    transform(value) {
      if (!value) return '';
      let momentDate = moment(value);
      if (!momentDate.isValid()) return '';
      return capitalize(momentDate.fromNow());
    }

  };
  FromNowPipe = tslib_1$1.__decorate([core_1$1.Pipe({
    name: 'fromNow'
  }), tslib_1$1.__metadata("design:paramtypes", [authentication_service_1.AuthenticationService])], FromNowPipe);
  return FromNowPipe;
})();

datetime_pipes.FromNowPipe = FromNowPipe;

let DateFormatPipe = /*@__PURE__*/(() => {
  let DateFormatPipe = class DateFormatPipe {
    constructor(authenticationService) {
      this.authenticationService = authenticationService;
      moment.tz.setDefault(this.authenticationService.GetTimeZone());
      moment.locale(this.authenticationService.GetLoggedUserLanguage());
    }

    transform(value, format) {
      if (!value) return '';
      let momentDate = moment(value);
      if (!momentDate.isValid()) return '';
      let momentFormat = format || 'YYYY-MM-DD HH:mm';

      switch (format) {
        case 'medium':
          momentFormat = 'lll';
          break;

        case 'short':
          momentFormat = 'l LT';
          break;

        case 'fullDate':
          momentFormat = 'dddd LL';
          break;

        case 'longDate':
          momentFormat = 'LL';
          break;

        case 'mediumDate':
          momentFormat = 'll';
          break;

        case 'shortDate':
          momentFormat = 'l';
          break;

        case 'mediumTime':
          momentFormat = 'LTS';
          break;

        case 'shortTime':
          momentFormat = 'LT';
          break;
      }

      return capitalize(momentDate.format(momentFormat));
    }

  };
  DateFormatPipe = tslib_1$1.__decorate([core_1$1.Pipe({
    name: 'dateFormat'
  }), tslib_1$1.__metadata("design:paramtypes", [authentication_service_1.AuthenticationService])], DateFormatPipe);
  return DateFormatPipe;
})();

datetime_pipes.DateFormatPipe = DateFormatPipe;

function capitalize(text) {
  return text && text.length > 0 ? text.charAt(0).toUpperCase() + text.slice(1) : text;
}

var language_pipes = {};

Object.defineProperty(language_pipes, "__esModule", {
  value: true
});
language_pipes.TranslateHelpPipe = language_pipes.TranslateMessageReplacePipe = language_pipes.TranslateMessagePipe = language_pipes.IsoToCountryPipe = language_pipes.IsoToLanguagePipe = void 0;
const tslib_1 = require$$0;
const core_1 = require$$0$1;
const language_service_1 = language_service;

let IsoToLanguagePipe = /*@__PURE__*/(() => {
  let IsoToLanguagePipe = class IsoToLanguagePipe {
    constructor(languageService) {
      this.languageService = languageService;
    }

    transform(value, language) {
      return this.languageService.GetLanguageName(value, language);
    }

  };
  IsoToLanguagePipe = tslib_1.__decorate([core_1.Pipe({
    name: 'isoToLanguage'
  }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], IsoToLanguagePipe);
  return IsoToLanguagePipe;
})();

language_pipes.IsoToLanguagePipe = IsoToLanguagePipe;

let IsoToCountryPipe = /*@__PURE__*/(() => {
  let IsoToCountryPipe = class IsoToCountryPipe {
    constructor(languageService) {
      this.languageService = languageService;
    }

    transform(value, language) {
      return this.languageService.GetCountryName(value, language);
    }

  };
  IsoToCountryPipe = tslib_1.__decorate([core_1.Pipe({
    name: 'isoToCountry'
  }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], IsoToCountryPipe);
  return IsoToCountryPipe;
})();

language_pipes.IsoToCountryPipe = IsoToCountryPipe;

let TranslateMessagePipe = /*@__PURE__*/(() => {
  let TranslateMessagePipe = class TranslateMessagePipe {
    constructor(languageService) {
      this.languageService = languageService;
    }

    transform(value, category, language) {
      return this.languageService.GetMessage(category, value, language);
    }

  };
  TranslateMessagePipe = tslib_1.__decorate([core_1.Pipe({
    name: 'translateMessage'
  }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], TranslateMessagePipe);
  return TranslateMessagePipe;
})();

language_pipes.TranslateMessagePipe = TranslateMessagePipe;

let TranslateMessageReplacePipe = /*@__PURE__*/(() => {
  let TranslateMessageReplacePipe = class TranslateMessageReplacePipe {
    constructor(languageService) {
      this.languageService = languageService;
    }

    transform(value, category, replace, language) {
      return this.languageService.GetMessage(category, value, language).replace('%s', replace);
    }

  };
  TranslateMessageReplacePipe = tslib_1.__decorate([core_1.Pipe({
    name: 'translateMessageReplace'
  }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], TranslateMessageReplacePipe);
  return TranslateMessageReplacePipe;
})();

language_pipes.TranslateMessageReplacePipe = TranslateMessageReplacePipe;

let TranslateHelpPipe = /*@__PURE__*/(() => {
  let TranslateHelpPipe = class TranslateHelpPipe {
    constructor(languageService) {
      this.languageService = languageService;
    }

    transform(value, category, language) {
      return this.languageService.GetMessage(category + 'Help', value, language);
    }

  };
  TranslateHelpPipe = tslib_1.__decorate([core_1.Pipe({
    name: 'translateHelp'
  }), tslib_1.__metadata("design:paramtypes", [language_service_1.LanguageService])], TranslateHelpPipe);
  return TranslateHelpPipe;
})();

language_pipes.TranslateHelpPipe = TranslateHelpPipe;

var login_component_ngfactory = {};

Object.defineProperty(login_component_ngfactory, "__esModule", {
  value: true
});
login_component_ngfactory.LoginComponentNgFactory = login_component_ngfactory.View_LoginComponent_Host_0 = login_component_ngfactory.View_LoginComponent_0 = login_component_ngfactory.RenderType_LoginComponent = void 0;
const i0$8 = require$$0$1;
const i1$8 = language_pipes;
const i2$8 = language_service;
const i3$7 = require$$45;
const i4$6 = require$$14;
const i5$6 = login_component.exports;
const i6$5 = authentication_service;
const i7$5 = platform_service;
const i8$5 = require$$25;
const i9$5 = require$$26;
var styles_LoginComponent = [];
var RenderType_LoginComponent = i0$8.ɵcrt({
  encapsulation: 2,
  styles: styles_LoginComponent,
  data: {}
});
login_component_ngfactory.RenderType_LoginComponent = RenderType_LoginComponent;

function View_LoginComponent_1(_l) {
  return i0$8.ɵvid(0, [(_l()(), i0$8.ɵeld(0, 0, null, null, 2, "div", [["class", "help-block text-danger"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(1, null, ["\n\t\t\t\t\t\t\t\t", ""])), i0$8.ɵppd(2, 2)], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$8.ɵunv(_v, 1, 0, _ck(_v, 2, 0, i0$8.ɵnov(_v.parent, 0), "USER_MISSING", _co.translateCategory));

    _ck(_v, 1, 0, currVal_0);
  });
}

function View_LoginComponent_2(_l) {
  return i0$8.ɵvid(0, [(_l()(), i0$8.ɵeld(0, 0, null, null, 2, "div", [["class", "help-block text-danger"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(1, null, ["\n\t\t\t\t\t\t\t\t", ""])), i0$8.ɵppd(2, 2)], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$8.ɵunv(_v, 1, 0, _ck(_v, 2, 0, i0$8.ɵnov(_v.parent, 0), "PASSWORD_MISSING", _co.translateCategory));

    _ck(_v, 1, 0, currVal_0);
  });
}

function View_LoginComponent_3(_l) {
  return i0$8.ɵvid(0, [(_l()(), i0$8.ɵeld(0, 0, null, null, 0, "i", [["class", "fad fa-spinner fa-spin"]], null, null, null, null, null))], null, null);
}

function View_LoginComponent_0(_l) {
  return i0$8.ɵvid(0, [i0$8.ɵpid(0, i1$8.TranslateMessagePipe, [i2$8.LanguageService]), (_l()(), i0$8.ɵeld(1, 0, null, null, 82, "div", [["class", "container-fluid login-page"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t"])), (_l()(), i0$8.ɵeld(3, 0, null, null, 79, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t"])), (_l()(), i0$8.ɵeld(5, 0, null, null, 63, "div", [["class", "col-md-5 login-section-wrapper mb-0 pr-0"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i0$8.ɵeld(7, 0, null, null, 60, "div", [["class", "login-wrapper animated fadeInUp"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(9, 0, null, null, 0, "img", [["class", "brand-logo"], ["src", "/client/assets/img/logo.webp"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(11, 0, null, null, 2, "h1", [["class", "login-title"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(12, null, ["", ""])), i0$8.ɵppd(13, 2), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(15, 0, null, null, 2, "p", [["class", "login-subtitle"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(16, null, ["", ""])), i0$8.ɵppd(17, 2), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(19, 0, null, null, 43, "form", [["novalidate", ""]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "ng-submitted", null]], [[null, "submit"], [null, "reset"]], function (_v, en, $event) {
    var ad = true;

    if ("submit" === en) {
      var pd_0 = i0$8.ɵnov(_v, 21).onSubmit($event) !== false;
      ad = pd_0 && ad;
    }

    if ("reset" === en) {
      var pd_1 = i0$8.ɵnov(_v, 21).onReset() !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, null, null)), i0$8.ɵdid(20, 16384, null, 0, i3$7.ɵangular_packages_forms_forms_bc, [], null, null), i0$8.ɵdid(21, 671744, null, 0, i3$7.FormGroupDirective, [[8, null], [8, null]], {
    form: [0, "form"]
  }, null), i0$8.ɵprd(2048, null, i3$7.ControlContainer, null, [i3$7.FormGroupDirective]), i0$8.ɵdid(23, 16384, null, 0, i3$7.NgControlStatusGroup, [[6, i3$7.ControlContainer]], null, null), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(25, 0, null, null, 12, "div", [["class", "form-group"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(27, 0, null, null, 6, "input", [["autocomplete", "username"], ["class", "form-control form-control-sm"], ["formControlName", "userId"], ["id", "userId"], ["name", "userId"], ["type", "text"]], [[8, "placeholder", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;

    if ("input" === en) {
      var pd_0 = i0$8.ɵnov(_v, 28)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$8.ɵnov(_v, 28).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$8.ɵnov(_v, 28)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$8.ɵnov(_v, 28)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    return ad;
  }, null, null)), i0$8.ɵdid(28, 16384, null, 0, i3$7.DefaultValueAccessor, [i0$8.Renderer2, i0$8.ElementRef, [2, i3$7.COMPOSITION_BUFFER_MODE]], null, null), i0$8.ɵprd(1024, null, i3$7.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i3$7.DefaultValueAccessor]), i0$8.ɵdid(30, 671744, null, 0, i3$7.FormControlName, [[3, i3$7.ControlContainer], [8, null], [8, null], [6, i3$7.NG_VALUE_ACCESSOR], [2, i3$7.ɵangular_packages_forms_forms_t]], {
    name: [0, "name"]
  }, null), i0$8.ɵprd(2048, null, i3$7.NgControl, null, [i3$7.FormControlName]), i0$8.ɵdid(32, 16384, null, 0, i3$7.NgControlStatus, [[4, i3$7.NgControl]], null, null), i0$8.ɵppd(33, 2), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵand(16777216, null, null, 1, null, View_LoginComponent_1)), i0$8.ɵdid(36, 16384, null, 0, i4$6.NgIf, [i0$8.ViewContainerRef, i0$8.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(39, 0, null, null, 12, "div", [["class", "form-group"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(41, 0, null, null, 6, "input", [["class", "form-control form-control-sm"], ["formControlName", "password"], ["id", "password"], ["name", "password"], ["type", "password"]], [[8, "placeholder", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;

    if ("input" === en) {
      var pd_0 = i0$8.ɵnov(_v, 42)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$8.ɵnov(_v, 42).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$8.ɵnov(_v, 42)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$8.ɵnov(_v, 42)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    return ad;
  }, null, null)), i0$8.ɵdid(42, 16384, null, 0, i3$7.DefaultValueAccessor, [i0$8.Renderer2, i0$8.ElementRef, [2, i3$7.COMPOSITION_BUFFER_MODE]], null, null), i0$8.ɵprd(1024, null, i3$7.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i3$7.DefaultValueAccessor]), i0$8.ɵdid(44, 671744, null, 0, i3$7.FormControlName, [[3, i3$7.ControlContainer], [8, null], [8, null], [6, i3$7.NG_VALUE_ACCESSOR], [2, i3$7.ɵangular_packages_forms_forms_t]], {
    name: [0, "name"]
  }, null), i0$8.ɵprd(2048, null, i3$7.NgControl, null, [i3$7.FormControlName]), i0$8.ɵdid(46, 16384, null, 0, i3$7.NgControlStatus, [[4, i3$7.NgControl]], null, null), i0$8.ɵppd(47, 2), (_l()(), i0$8.ɵted(-1, null, ["\t\t\t\t\t\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵand(16777216, null, null, 1, null, View_LoginComponent_2)), i0$8.ɵdid(50, 16384, null, 0, i4$6.NgIf, [i0$8.ViewContainerRef, i0$8.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(53, 0, null, null, 8, "div", [["class", "d-flex align-items-center"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵeld(55, 0, null, null, 5, "button", [["class", "btn btn-primary ml-auto"], ["type", "submit"]], [[8, "disabled", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.Login() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$8.ɵted(56, null, ["\n\t\t\t\t\t\t\t\t", "\n\t\t\t\t\t\t\t\t"])), i0$8.ɵppd(57, 2), (_l()(), i0$8.ɵand(16777216, null, null, 1, null, View_LoginComponent_3)), i0$8.ɵdid(59, 16384, null, 0, i4$6.NgIf, [i0$8.ViewContainerRef, i0$8.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(64, 0, null, null, 2, "footer", [], null, null, null, null, null)), (_l()(), i0$8.ɵted(65, null, ["\n\t\t\t\t\t\u00A9 ", " \n\t\t\t\t"])), i0$8.ɵppd(66, 2), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t"])), (_l()(), i0$8.ɵeld(70, 0, null, null, 11, "div", [["class", "col-md-7 pr-0 pl-0 d-none d-md-block"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i0$8.ɵeld(72, 0, null, null, 0, "img", [["class", "background-login-img"], ["src", "/client/assets/img/background-login.webp"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i0$8.ɵeld(74, 0, null, null, 6, "div", [["class", "login-slogan animated animated-fast fadeInRight"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(76, 0, null, null, 1, "h2", [], [[8, "innerHTML", 1]], null, null, null, null)), i0$8.ɵppd(77, 2), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i0$8.ɵeld(79, 0, null, null, 0, "img", [["src", "/client/assets/img/dashboard-login.png"]], null, null, null, null, null)), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n\t"])), (_l()(), i0$8.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_10 = _co.loginForm;

    _ck(_v, 21, 0, currVal_10);

    var currVal_19 = "userId";

    _ck(_v, 30, 0, currVal_19);

    var currVal_20 = !_co.loginForm.controls.userId.valid && _co.submitted;

    _ck(_v, 36, 0, currVal_20);

    var currVal_29 = "password";

    _ck(_v, 44, 0, currVal_29);

    var currVal_30 = !_co.loginForm.controls.password.valid && _co.submitted;

    _ck(_v, 50, 0, currVal_30);

    var currVal_33 = _co.processing;

    _ck(_v, 59, 0, currVal_33);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$8.ɵunv(_v, 12, 0, _ck(_v, 13, 0, i0$8.ɵnov(_v, 0), "HELLO_LOGIN", _co.translateCategory));

    _ck(_v, 12, 0, currVal_0);

    var currVal_1 = i0$8.ɵunv(_v, 16, 0, _ck(_v, 17, 0, i0$8.ɵnov(_v, 0), "ENTER_ACCES_DATA", _co.translateCategory));

    _ck(_v, 16, 0, currVal_1);

    var currVal_2 = i0$8.ɵnov(_v, 23).is("untouched");
    var currVal_3 = i0$8.ɵnov(_v, 23).is("touched");
    var currVal_4 = i0$8.ɵnov(_v, 23).is("pristine");
    var currVal_5 = i0$8.ɵnov(_v, 23).is("dirty");
    var currVal_6 = i0$8.ɵnov(_v, 23).is("valid");
    var currVal_7 = i0$8.ɵnov(_v, 23).is("invalid");
    var currVal_8 = i0$8.ɵnov(_v, 23).is("pending");
    var currVal_9 = i0$8.ɵnov(_v, 23).is("submitted");

    _ck(_v, 19, 0, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9);

    var currVal_11 = i0$8.ɵinlineInterpolate(1, "", i0$8.ɵunv(_v, 27, 0, _ck(_v, 33, 0, i0$8.ɵnov(_v, 0), "PLACEHOLDER_USER", _co.translateCategory)), "");
    var currVal_12 = i0$8.ɵnov(_v, 32).is("untouched");
    var currVal_13 = i0$8.ɵnov(_v, 32).is("touched");
    var currVal_14 = i0$8.ɵnov(_v, 32).is("pristine");
    var currVal_15 = i0$8.ɵnov(_v, 32).is("dirty");
    var currVal_16 = i0$8.ɵnov(_v, 32).is("valid");
    var currVal_17 = i0$8.ɵnov(_v, 32).is("invalid");
    var currVal_18 = i0$8.ɵnov(_v, 32).is("pending");

    _ck(_v, 27, 0, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18);

    var currVal_21 = i0$8.ɵinlineInterpolate(1, "", i0$8.ɵunv(_v, 41, 0, _ck(_v, 47, 0, i0$8.ɵnov(_v, 0), "PLACEHOLDER_PASSWORD", _co.translateCategory)), "");
    var currVal_22 = i0$8.ɵnov(_v, 46).is("untouched");
    var currVal_23 = i0$8.ɵnov(_v, 46).is("touched");
    var currVal_24 = i0$8.ɵnov(_v, 46).is("pristine");
    var currVal_25 = i0$8.ɵnov(_v, 46).is("dirty");
    var currVal_26 = i0$8.ɵnov(_v, 46).is("valid");
    var currVal_27 = i0$8.ɵnov(_v, 46).is("invalid");
    var currVal_28 = i0$8.ɵnov(_v, 46).is("pending");

    _ck(_v, 41, 0, currVal_21, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28);

    var currVal_31 = _co.processing;

    _ck(_v, 55, 0, currVal_31);

    var currVal_32 = i0$8.ɵunv(_v, 56, 0, _ck(_v, 57, 0, i0$8.ɵnov(_v, 0), "LOGIN", _co.translateCategory));

    _ck(_v, 56, 0, currVal_32);

    var currVal_34 = i0$8.ɵunv(_v, 65, 0, _ck(_v, 66, 0, i0$8.ɵnov(_v, 0), "COPYRIGHTS_INCONCERT_1", _co.translateCategory));

    _ck(_v, 65, 0, currVal_34);

    var currVal_35 = i0$8.ɵunv(_v, 76, 0, _ck(_v, 77, 0, i0$8.ɵnov(_v, 0), "LABEL_SLOGAN", _co.translateCategory));

    _ck(_v, 76, 0, currVal_35);
  });
}

login_component_ngfactory.View_LoginComponent_0 = View_LoginComponent_0;

function View_LoginComponent_Host_0(_l) {
  return i0$8.ɵvid(0, [(_l()(), i0$8.ɵeld(0, 0, null, null, 1, "login-cmp", [], null, null, null, View_LoginComponent_0, RenderType_LoginComponent)), i0$8.ɵdid(1, 114688, null, 0, i5$6.LoginComponent, [i6$5.AuthenticationService, i7$5.PlatformService, i2$8.LanguageService, i8$5.NotificationsService, i3$7.FormBuilder, i9$5.Router], null, null)], function (_ck, _v) {
    _ck(_v, 1, 0);
  }, null);
}

login_component_ngfactory.View_LoginComponent_Host_0 = View_LoginComponent_Host_0;
var LoginComponentNgFactory = i0$8.ɵccf("login-cmp", i5$6.LoginComponent, View_LoginComponent_Host_0, {}, {}, []);
login_component_ngfactory.LoginComponentNgFactory = LoginComponentNgFactory;

var layoutForm_component_ngfactory = {};

var layoutForm_component_css_ngstyle = {};

Object.defineProperty(layoutForm_component_css_ngstyle, "__esModule", {
  value: true
});
layoutForm_component_css_ngstyle.styles = void 0;
var styles$3 = [""];
layoutForm_component_css_ngstyle.styles = styles$3;

Object.defineProperty(layoutForm_component_ngfactory, "__esModule", {
  value: true
});
layoutForm_component_ngfactory.LayoutFormComponentNgFactory = layoutForm_component_ngfactory.View_LayoutFormComponent_Host_0 = layoutForm_component_ngfactory.View_LayoutFormComponent_0 = layoutForm_component_ngfactory.RenderType_LayoutFormComponent = void 0;
const i0$7 = layoutForm_component_css_ngstyle;
const i1$7 = require$$0$1;
const i2$7 = require$$14;
const i3$6 = require$$26;
const i4$5 = layoutForm_component.exports;
const i5$5 = authentication_service;
const i6$4 = language_service;
const i7$4 = layout_service;
const i8$4 = loading_service;
const i9$4 = require$$25;
const i10$3 = skin_service;
var styles_LayoutFormComponent = [i0$7.styles];
var RenderType_LayoutFormComponent = i1$7.ɵcrt({
  encapsulation: 2,
  styles: styles_LayoutFormComponent,
  data: {}
});
layoutForm_component_ngfactory.RenderType_LayoutFormComponent = RenderType_LayoutFormComponent;

function View_LayoutFormComponent_0(_l) {
  return i1$7.ɵvid(0, [(_l()(), i1$7.ɵeld(0, 0, null, null, 12, "div", [["class", "layout"], ["id", "layout"]], null, null, null, null, null)), i1$7.ɵdid(1, 278528, null, 0, i2$7.NgClass, [i1$7.IterableDiffers, i1$7.KeyValueDiffers, i1$7.ElementRef, i1$7.Renderer2], {
    klass: [0, "klass"],
    ngClass: [1, "ngClass"]
  }, null), i1$7.ɵpod(2, {
    "scroll-top": 0,
    "scroll-bottom": 1
  }), (_l()(), i1$7.ɵted(-1, null, ["\n    "])), (_l()(), i1$7.ɵeld(4, 0, null, null, 7, "div", [["class", "content-wrap content-wrap-form"], ["id", "content-wrap"]], null, null, null, null, null)), (_l()(), i1$7.ɵted(-1, null, ["\n        "])), (_l()(), i1$7.ɵeld(6, 0, null, null, 4, "main", [["class", "content view-animate fade-up"], ["id", "content"], ["role", "main"]], null, null, null, null, null)), (_l()(), i1$7.ɵted(-1, null, ["\n            "])), (_l()(), i1$7.ɵeld(8, 16777216, null, null, 1, "router-outlet", [], null, null, null, null, null)), i1$7.ɵdid(9, 212992, null, 0, i3$6.RouterOutlet, [i3$6.ChildrenOutletContexts, i1$7.ViewContainerRef, i1$7.ComponentFactoryResolver, [8, null], i1$7.ChangeDetectorRef], null, null), (_l()(), i1$7.ɵted(-1, null, ["\n        "])), (_l()(), i1$7.ɵted(-1, null, ["\n    "])), (_l()(), i1$7.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = "layout";

    var currVal_1 = _ck(_v, 2, 0, _co.scrollPercentage <= 1 || _co.scrollPercentage === null, _co.scrollPercentage >= 99 || _co.scrollPercentage === null);

    _ck(_v, 1, 0, currVal_0, currVal_1);

    _ck(_v, 9, 0);
  }, null);
}

layoutForm_component_ngfactory.View_LayoutFormComponent_0 = View_LayoutFormComponent_0;

function View_LayoutFormComponent_Host_0(_l) {
  return i1$7.ɵvid(0, [(_l()(), i1$7.ɵeld(0, 0, null, null, 1, "layout-form-cmp", [], null, [["window", "scroll"]], function (_v, en, $event) {
    var ad = true;

    if ("window:scroll" === en) {
      var pd_0 = i1$7.ɵnov(_v, 1).OnScroll($event) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, View_LayoutFormComponent_0, RenderType_LayoutFormComponent)), i1$7.ɵdid(1, 245760, null, 0, i4$5.LayoutFormComponent, [i3$6.ActivatedRoute, i5$5.AuthenticationService, i6$4.LanguageService, i7$4.LayoutService, i8$4.LoadingService, i9$4.NotificationsService, i3$6.Router, i10$3.SkinService], null, null)], function (_ck, _v) {
    _ck(_v, 1, 0);
  }, null);
}

layoutForm_component_ngfactory.View_LayoutFormComponent_Host_0 = View_LayoutFormComponent_Host_0;
var LayoutFormComponentNgFactory = i1$7.ɵccf("layout-form-cmp", i4$5.LayoutFormComponent, View_LayoutFormComponent_Host_0, {}, {}, []);
layoutForm_component_ngfactory.LayoutFormComponentNgFactory = LayoutFormComponentNgFactory;

var dropdownCombo_component_ngfactory = {};

var dropdownCombo_css_shim_ngstyle = {};

Object.defineProperty(dropdownCombo_css_shim_ngstyle, "__esModule", {
  value: true
});
dropdownCombo_css_shim_ngstyle.styles = void 0;
var styles$2 = [".input-group[_ngcontent-%COMP%]{position:relative}.input-group-addon[_ngcontent-%COMP%]{position:absolute;right:0;top:0;bottom:0;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-align-items:center;-ms-flex-align:center;align-items:center;padding:0 10px;cursor:pointer}.input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]{font-size:13px;position:-webkit-sticky;position:sticky;z-index:3;color:#333}.form-control[_ngcontent-%COMP%]:hover + .input-group-addon[_ngcontent-%COMP%], .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]:hover{color:#039}.fa-angle-up[_ngcontent-%COMP%], .form-control[_ngcontent-%COMP%]:active + .input-group-addon[_ngcontent-%COMP%], .form-control[_ngcontent-%COMP%]:focus + .input-group-addon[_ngcontent-%COMP%], .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]:active   .far[_ngcontent-%COMP%]:focus{color:#06c!important}.dropdown-menu[_ngcontent-%COMP%]{right:0;left:0;font-size:.9rem}.dropdown-menu[_ngcontent-%COMP%]   .dropdown-item[_ngcontent-%COMP%]{padding-left:1rem}.input-group-btn[_ngcontent-%COMP%]   .btn-secondary[_ngcontent-%COMP%]{margin-left:0!important}.category-style-dropdown[_ngcontent-%COMP%], .category-style-dropdown[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%], .category-style-dropdown[_ngcontent-%COMP%]   input.form-control.form-control-sm[_ngcontent-%COMP%]{min-height:24px!important;height:24px!important}"];
dropdownCombo_css_shim_ngstyle.styles = styles$2;

Object.defineProperty(dropdownCombo_component_ngfactory, "__esModule", {
  value: true
});
dropdownCombo_component_ngfactory.DropdownComboComponentNgFactory = dropdownCombo_component_ngfactory.View_DropdownComboComponent_Host_0 = dropdownCombo_component_ngfactory.View_DropdownComboComponent_0 = dropdownCombo_component_ngfactory.RenderType_DropdownComboComponent = void 0;
const i0$6 = dropdownCombo_css_shim_ngstyle;
const i1$6 = require$$0$1;
const i2$6 = require$$14;
const i3$5 = require$$54;
const i4$4 = require$$45;
const i5$4 = dropdownCombo_component.exports;
var styles_DropdownComboComponent = [i0$6.styles];
var RenderType_DropdownComboComponent = i1$6.ɵcrt({
  encapsulation: 0,
  styles: styles_DropdownComboComponent,
  data: {}
});
dropdownCombo_component_ngfactory.RenderType_DropdownComboComponent = RenderType_DropdownComboComponent;

function View_DropdownComboComponent_1(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵeld(1, 0, null, null, 4, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i1$6.ɵeld(3, 0, null, null, 1, "a", [["class", "dropdown-item"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_co.emptyOption) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i1$6.ɵted(4, null, ["", "\n\t\t\t\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.emptyOption.description || " ";

    _ck(_v, 4, 0, currVal_0);
  });
}

function View_DropdownComboComponent_2(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵeld(1, 0, null, null, 0, "li", [["class", "divider dropdown-divider"]], null, null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"]))], null, null);
}

function View_DropdownComboComponent_4(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵeld(0, 0, null, null, 4, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i1$6.ɵeld(2, 0, null, null, 1, "a", [["class", "dropdown-item"]], [[8, "title", 0], [8, "innerHTML", 1]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_v.context.$implicit) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i1$6.ɵted(3, null, ["", ""])), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i1$6.ɵinlineInterpolate(1, "", _v.context.$implicit.title, "");
    var currVal_1 = _v.context.$implicit.icon ? _v.context.$implicit.icon + " " + _co.GetOptionLabel(_v.context.$implicit) : _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 2, 0, currVal_0, currVal_1);

    var currVal_2 = _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 3, 0, currVal_2);
  });
}

function View_DropdownComboComponent_3(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵand(16777216, null, null, 1, null, View_DropdownComboComponent_4)), i1$6.ɵdid(2, 278528, null, 0, i2$6.NgForOf, [i1$6.ViewContainerRef, i1$6.TemplateRef, i1$6.IterableDiffers], {
    ngForOf: [0, "ngForOf"]
  }, null), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.filteredList;

    _ck(_v, 2, 0, currVal_0);
  }, null);
}

function View_DropdownComboComponent_0(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵeld(0, 0, null, null, 38, "div", [["class", "input-group input-group-sm"], ["ngbDropdown", ""]], [[2, "show", null]], [[null, "openChange"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("openChange" === en) {
      var pd_0 = (_co.optionsDropdownOpened = $event) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i1$6.ɵdid(1, 1720320, null, 2, i3$5.NgbDropdown, [i1$6.ChangeDetectorRef, i3$5.NgbDropdownConfig, i2$6.DOCUMENT, i1$6.NgZone, i1$6.ElementRef, i1$6.Renderer2, [2, i3$5.NgbNavbar]], {
    autoClose: [0, "autoClose"],
    _open: [1, "_open"]
  }, {
    openChange: "openChange"
  }), i1$6.ɵqud(603979776, 1, {
    _menu: 0
  }), i1$6.ɵqud(603979776, 2, {
    _anchor: 0
  }), (_l()(), i1$6.ɵted(-1, null, ["\n\t"])), (_l()(), i1$6.ɵeld(5, 0, null, null, 18, "button", [["class", "input-group input-group-sm dropdown-toggle btn-outline border-0 p-0 m-0 dropdown-toggle"], ["ngbDropdownToggle", ""]], [[8, "disabled", 0], [1, "aria-expanded", 0]], [[null, "click"], [null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = i1$6.ɵnov(_v, 6).dropdown.toggle() !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowUp" === en) {
      var pd_1 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_2 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_3 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.End" === en) {
      var pd_4 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_5 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_6 = i1$6.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    return ad;
  }, null, null)), i1$6.ɵdid(6, 16384, null, 0, i3$5.NgbDropdownToggle, [i3$5.NgbDropdown, i1$6.ElementRef], null, null), i1$6.ɵprd(2048, [[2, 4]], i3$5.NgbDropdownAnchor, null, [i3$5.NgbDropdownToggle]), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵeld(9, 0, null, null, 5, "input", [["class", "form-control form-control-sm"], ["type", "text"]], [[8, "placeholder", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;

    if ("input" === en) {
      var pd_0 = i1$6.ɵnov(_v, 10)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i1$6.ɵnov(_v, 10).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i1$6.ɵnov(_v, 10)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i1$6.ɵnov(_v, 10)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    return ad;
  }, null, null)), i1$6.ɵdid(10, 16384, null, 0, i4$4.DefaultValueAccessor, [i1$6.Renderer2, i1$6.ElementRef, [2, i4$4.COMPOSITION_BUFFER_MODE]], null, null), i1$6.ɵprd(1024, null, i4$4.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i4$4.DefaultValueAccessor]), i1$6.ɵdid(12, 671744, null, 0, i4$4.NgModel, [[8, null], [8, null], [8, null], [6, i4$4.NG_VALUE_ACCESSOR]], {
    isDisabled: [0, "isDisabled"],
    model: [1, "model"]
  }, null), i1$6.ɵprd(2048, null, i4$4.NgControl, null, [i4$4.NgModel]), i1$6.ɵdid(14, 16384, null, 0, i4$4.NgControlStatus, [[4, i4$4.NgControl]], null, null), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵeld(16, 0, null, null, 6, "span", [["class", "input-group-btn"]], null, null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵeld(18, 0, null, null, 3, "button", [["class", "btn btn-secondary btn-sm"], ["type", "button"]], [[8, "disabled", 0]], null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t\t"])), (_l()(), i1$6.ɵeld(20, 0, null, null, 0, "span", [["class", "fa fa-caret-down"]], null, null, null, null, null)), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\n\t"])), (_l()(), i1$6.ɵeld(25, 0, null, null, 12, "ul", [["aria-labelledby", "simple-btn-keyboard-nav"], ["class", "dropdown-menu scrollable-menu"], ["ngbDropdownMenu", ""], ["role", "menu"]], [[2, "dropdown-menu", null], [2, "show", null], [1, "x-placement", 0]], [[null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Enter"], [null, "keydown.Space"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("keydown.ArrowUp" === en) {
      var pd_0 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_1 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_2 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.End" === en) {
      var pd_3 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.Enter" === en) {
      var pd_4 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Space" === en) {
      var pd_5 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_6 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_7 = i1$6.ɵnov(_v, 26).dropdown.onKeyDown($event) !== false;
      ad = pd_7 && ad;
    }

    return ad;
  }, null, null)), i1$6.ɵdid(26, 16384, [[1, 4]], 1, i3$5.NgbDropdownMenu, [i3$5.NgbDropdown, i1$6.ElementRef], null, null), i1$6.ɵqud(-1543503872, 3, {
    menuItems: 1
  }), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵand(16777216, null, null, 1, null, View_DropdownComboComponent_1)), i1$6.ɵdid(30, 16384, null, 0, i2$6.NgIf, [i1$6.ViewContainerRef, i1$6.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵand(16777216, null, null, 1, null, View_DropdownComboComponent_2)), i1$6.ɵdid(33, 16384, null, 0, i2$6.NgIf, [i1$6.ViewContainerRef, i1$6.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$6.ɵted(-1, null, ["\n\t\t"])), (_l()(), i1$6.ɵand(16777216, null, null, 1, null, View_DropdownComboComponent_3)), i1$6.ɵdid(36, 16384, null, 0, i2$6.NgIf, [i1$6.ViewContainerRef, i1$6.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$6.ɵted(-1, null, ["\n\t"])), (_l()(), i1$6.ɵted(-1, null, ["\n\n"])), (_l()(), i1$6.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_1 = true;
    var currVal_2 = _co.optionsDropdownOpened;

    _ck(_v, 1, 0, currVal_1, currVal_2);

    var currVal_13 = _co.disabled;

    var currVal_14 = _co.GetOptionLabel(_co.value);

    _ck(_v, 12, 0, currVal_13, currVal_14);

    var currVal_19 = _co.showEmptyItem;

    _ck(_v, 30, 0, currVal_19);

    var currVal_20 = _co.showEmptyItem && _co.filteredList.length > 0;

    _ck(_v, 33, 0, currVal_20);

    var currVal_21 = _co.optionsList.length > 0;

    _ck(_v, 36, 0, currVal_21);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i1$6.ɵnov(_v, 1).isOpen();

    _ck(_v, 0, 0, currVal_0);

    var currVal_3 = _co.disabled;
    var currVal_4 = i1$6.ɵnov(_v, 6).dropdown.isOpen();

    _ck(_v, 5, 0, currVal_3, currVal_4);

    var currVal_5 = i1$6.ɵinlineInterpolate(1, "", _co.placeholder, "");
    var currVal_6 = i1$6.ɵnov(_v, 14).is("untouched");
    var currVal_7 = i1$6.ɵnov(_v, 14).is("touched");
    var currVal_8 = i1$6.ɵnov(_v, 14).is("pristine");
    var currVal_9 = i1$6.ɵnov(_v, 14).is("dirty");
    var currVal_10 = i1$6.ɵnov(_v, 14).is("valid");
    var currVal_11 = i1$6.ɵnov(_v, 14).is("invalid");
    var currVal_12 = i1$6.ɵnov(_v, 14).is("pending");

    _ck(_v, 9, 0, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12);

    var currVal_15 = _co.disabled;

    _ck(_v, 18, 0, currVal_15);

    var currVal_16 = true;
    var currVal_17 = i1$6.ɵnov(_v, 26).dropdown.isOpen();
    var currVal_18 = i1$6.ɵnov(_v, 26).placement;

    _ck(_v, 25, 0, currVal_16, currVal_17, currVal_18);
  });
}

dropdownCombo_component_ngfactory.View_DropdownComboComponent_0 = View_DropdownComboComponent_0;

function View_DropdownComboComponent_Host_0(_l) {
  return i1$6.ɵvid(0, [(_l()(), i1$6.ɵeld(0, 0, null, null, 2, "dropdown-combo-cmp", [], null, null, null, View_DropdownComboComponent_0, RenderType_DropdownComboComponent)), i1$6.ɵprd(5120, null, i4$4.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i5$4.DropdownComboComponent]), i1$6.ɵdid(2, 114688, null, 0, i5$4.DropdownComboComponent, [i1$6.ElementRef], null, null)], function (_ck, _v) {
    _ck(_v, 2, 0);
  }, null);
}

dropdownCombo_component_ngfactory.View_DropdownComboComponent_Host_0 = View_DropdownComboComponent_Host_0;
var DropdownComboComponentNgFactory = i1$6.ɵccf("dropdown-combo-cmp", i5$4.DropdownComboComponent, View_DropdownComboComponent_Host_0, {
  className: "className",
  optionsList: "optionsList",
  disabled: "disabled",
  maxElements: "maxElements",
  showValueInLabel: "showValueInLabel",
  labelValuePrefix: "labelValuePrefix",
  labelValueSufix: "labelValueSufix",
  showEmptyItem: "showEmptyItem",
  emptyOptionValue: "emptyOptionValue",
  emptyOptionDescription: "emptyOptionDescription",
  placeholder: "placeholder"
}, {
  optionChanged: "optionChanged",
  focusOut: "focusOut",
  focusIn: "focusIn"
}, []);
dropdownCombo_component_ngfactory.DropdownComboComponentNgFactory = DropdownComboComponentNgFactory;

var searchCombo_component_ngfactory = {};

var searchCombo_css_shim_ngstyle = {};

Object.defineProperty(searchCombo_css_shim_ngstyle, "__esModule", {
  value: true
});
searchCombo_css_shim_ngstyle.styles = void 0;
var styles$1 = [".input-group.input-group-sm.dropdown[_ngcontent-%COMP%]{border:none}.input-group[_ngcontent-%COMP%]{position:relative}.input-group[_ngcontent-%COMP%]   input[type=text][_ngcontent-%COMP%]{transition:color .3s}.input-group[_ngcontent-%COMP%]   input[type=text][_ngcontent-%COMP%]:hover + .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]{color:#039}.input-group[_ngcontent-%COMP%]   input[type=text][_ngcontent-%COMP%]:active + .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%], .input-group[_ngcontent-%COMP%]   input[type=text][_ngcontent-%COMP%]:focus + .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]{color:#06c!important}.input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%]{position:absolute;right:0;top:0;bottom:0;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-align-items:center;-ms-flex-align:center;align-items:center;padding:0;width:44px;cursor:pointer}.input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]{font-size:12px;position:-webkit-sticky;position:sticky;z-index:3;padding-left:13px;transition:color .3s}.form-control[_ngcontent-%COMP%]:hover + .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%], .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]:hover{color:#039}.form-control[_ngcontent-%COMP%]:active + .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%], .form-control[_ngcontent-%COMP%]:focus + .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%], .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]:active, .input-group[_ngcontent-%COMP%]   .input-group-addon[_ngcontent-%COMP%]   .far[_ngcontent-%COMP%]:focus{color:#06c!important}.input-group.dropdown-toggle[_ngcontent-%COMP%]   input[_ngcontent-%COMP%]{border-top-right-radius:6px!important;border-bottom-right-radius:6px!important}.dropdown-menu[_ngcontent-%COMP%]{right:0;left:0;font-size:.9rem}.dropdown-menu[_ngcontent-%COMP%]   .dropdown-item[_ngcontent-%COMP%]{padding-left:1rem}.btn-add-combo[_ngcontent-%COMP%]{font-size:12px;margin-left:8px;margin-top:0}.input-group-btn[_ngcontent-%COMP%]   .btn-secondary[_ngcontent-%COMP%]{margin-left:0!important}"];
searchCombo_css_shim_ngstyle.styles = styles$1;

Object.defineProperty(searchCombo_component_ngfactory, "__esModule", {
  value: true
});
searchCombo_component_ngfactory.SearchComboComponentNgFactory = searchCombo_component_ngfactory.View_SearchComboComponent_Host_0 = searchCombo_component_ngfactory.View_SearchComboComponent_0 = searchCombo_component_ngfactory.RenderType_SearchComboComponent = void 0;
const i0$5 = searchCombo_css_shim_ngstyle;
const i1$5 = require$$0$1;
const i2$5 = require$$24;
const i3$4 = require$$22;
const i4$3 = require$$52;
const i5$3 = require$$48;
const i6$3 = require$$47;
const i7$3 = require$$23;
const i8$3 = require$$14;
const i9$3 = require$$54;
const i10$2 = require$$45;
const i11$1 = searchCombo_component.exports;
var styles_SearchComboComponent = [i0$5.styles];
var RenderType_SearchComboComponent = i1$5.ɵcrt({
  encapsulation: 0,
  styles: styles_SearchComboComponent,
  data: {}
});
searchCombo_component_ngfactory.RenderType_SearchComboComponent = RenderType_SearchComboComponent;

function View_SearchComboComponent_2(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["                    \n            "])), (_l()(), i1$5.ɵeld(1, 16777216, null, null, 4, "button", [["class", "btn btn-secondary mr-8 ml-8 mat-tooltip-trigger"], ["matTooltipClass", "right"], ["matTooltipPosition", "right"], ["tabindex", "0"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.AddOption() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(2, 4341760, null, 0, i2$5.MatTooltip, [i3$4.Overlay, i1$5.ElementRef, i4$3.ScrollDispatcher, i1$5.ViewContainerRef, i1$5.NgZone, i5$3.Platform, i6$3.AriaDescriber, i6$3.FocusMonitor, i2$5.MAT_TOOLTIP_SCROLL_STRATEGY, [2, i7$3.Directionality], [2, i2$5.MAT_TOOLTIP_DEFAULT_OPTIONS], i8$3.DOCUMENT], {
    position: [0, "position"],
    message: [1, "message"],
    tooltipClass: [2, "tooltipClass"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(4, 0, null, null, 0, "i", [], [[8, "className", 0]], null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = "right";
    var currVal_1 = i1$5.ɵinlineInterpolate(1, "", _co.addOptionButtonText, "");
    var currVal_2 = "right";

    _ck(_v, 2, 0, currVal_0, currVal_1, currVal_2);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_3 = _co.addOptionButtonIcon;

    _ck(_v, 4, 0, currVal_3);
  });
}

function View_SearchComboComponent_3(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["                    \n            "])), (_l()(), i1$5.ɵeld(1, 0, null, null, 0, "button", [["class", "btn btn-text-outlined h-100 ml-2"], ["tabindex", "0"]], [[8, "innerHTML", 1], [8, "disabled", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.AddOption() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.addOptionButtonText;
    var currVal_1 = _co.isButtonEnabled;

    _ck(_v, 1, 0, currVal_0, currVal_1);
  });
}

function View_SearchComboComponent_1(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵeld(0, 0, null, null, 7, "div", [], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_2)), i1$5.ɵdid(3, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_3)), i1$5.ɵdid(6, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n    "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.showButtonIcon;

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = !_co.showButtonIcon;

    _ck(_v, 6, 0, currVal_1);
  }, null);
}

function View_SearchComboComponent_4(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(1, 0, null, null, 4, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(3, 0, null, null, 1, "a", [["class", "dropdown-item"], ["href", "#"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_co.emptyOption) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i1$5.ɵted(4, null, ["", ""])), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.emptyOption.description || " ";

    _ck(_v, 4, 0, currVal_0);
  });
}

function View_SearchComboComponent_5(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(1, 0, null, null, 0, "li", [["class", "divider dropdown-divider"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], null, null);
}

function View_SearchComboComponent_6(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(1, 0, null, null, 4, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(3, 0, null, null, 1, "a", [["class", "dropdown-item"], ["href", "#"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_co.inputOption) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i1$5.ɵted(4, null, ["", ""])), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.inputOption.description || " ";

    _ck(_v, 4, 0, currVal_0);
  });
}

function View_SearchComboComponent_7(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(1, 0, null, null, 0, "li", [["class", "divider dropdown-divider"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], null, null);
}

function View_SearchComboComponent_9(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵeld(0, 0, null, null, 5, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(2, 16777216, null, null, 2, "a", [["class", "dropdown-item mat-tooltip-trigger"], ["href", "#"], ["matTooltipClass", "right"], ["matTooltipPosition", "right"]], [[1, "disabled", 0], [8, "innerHTML", 1]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_v.context.$implicit) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(3, 4341760, null, 0, i2$5.MatTooltip, [i3$4.Overlay, i1$5.ElementRef, i4$3.ScrollDispatcher, i1$5.ViewContainerRef, i1$5.NgZone, i5$3.Platform, i6$3.AriaDescriber, i6$3.FocusMonitor, i2$5.MAT_TOOLTIP_SCROLL_STRATEGY, [2, i7$3.Directionality], [2, i2$5.MAT_TOOLTIP_DEFAULT_OPTIONS], i8$3.DOCUMENT], {
    position: [0, "position"],
    message: [1, "message"],
    tooltipClass: [2, "tooltipClass"]
  }, null), (_l()(), i1$5.ɵted(4, null, ["", ""])), (_l()(), i1$5.ɵted(-1, null, ["\n            "]))], function (_ck, _v) {
    var currVal_2 = "right";
    var currVal_3 = i1$5.ɵinlineInterpolate(1, "", _v.context.$implicit.title ? _v.context.$implicit.title : "", "");
    var currVal_4 = "right";

    _ck(_v, 3, 0, currVal_2, currVal_3, currVal_4);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _v.context.$implicit.status;
    var currVal_1 = _v.context.$implicit.icon ? _v.context.$implicit.icon + " " + _co.GetOptionLabel(_v.context.$implicit) : _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 2, 0, currVal_0, currVal_1);

    var currVal_5 = _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 4, 0, currVal_5);
  });
}

function View_SearchComboComponent_8(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_9)), i1$5.ɵdid(2, 278528, null, 0, i8$3.NgForOf, [i1$5.ViewContainerRef, i1$5.TemplateRef, i1$5.IterableDiffers], {
    ngForOf: [0, "ngForOf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(4, 0, null, null, 0, "li", [["class", "divider dropdown-divider"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.favOptionsList;

    _ck(_v, 2, 0, currVal_0);
  }, null);
}

function View_SearchComboComponent_11(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵeld(0, 0, null, null, 5, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(2, 16777216, null, null, 2, "a", [["class", "dropdown-item mat-tooltip-trigger"], ["matTooltipClass", "right"], ["matTooltipPosition", "right"]], [[1, "disabled", 0], [8, "innerHTML", 1]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SelectOption(_v.context.$implicit) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(3, 4341760, null, 0, i2$5.MatTooltip, [i3$4.Overlay, i1$5.ElementRef, i4$3.ScrollDispatcher, i1$5.ViewContainerRef, i1$5.NgZone, i5$3.Platform, i6$3.AriaDescriber, i6$3.FocusMonitor, i2$5.MAT_TOOLTIP_SCROLL_STRATEGY, [2, i7$3.Directionality], [2, i2$5.MAT_TOOLTIP_DEFAULT_OPTIONS], i8$3.DOCUMENT], {
    position: [0, "position"],
    message: [1, "message"],
    tooltipClass: [2, "tooltipClass"]
  }, null), (_l()(), i1$5.ɵted(4, null, ["", ""])), (_l()(), i1$5.ɵted(-1, null, ["\n            "]))], function (_ck, _v) {
    var currVal_2 = "right";
    var currVal_3 = i1$5.ɵinlineInterpolate(1, "", _v.context.$implicit.title ? _v.context.$implicit.title : "", "");
    var currVal_4 = "right";

    _ck(_v, 3, 0, currVal_2, currVal_3, currVal_4);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = !_v.context.$implicit.status;
    var currVal_1 = _v.context.$implicit.icon ? _v.context.$implicit.icon + " " + _co.GetOptionLabel(_v.context.$implicit) : _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 2, 0, currVal_0, currVal_1);

    var currVal_5 = _co.GetOptionLabel(_v.context.$implicit);

    _ck(_v, 4, 0, currVal_5);
  });
}

function View_SearchComboComponent_10(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_11)), i1$5.ɵdid(2, 278528, null, 0, i8$3.NgForOf, [i1$5.ViewContainerRef, i1$5.TemplateRef, i1$5.IterableDiffers], {
    ngForOf: [0, "ngForOf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.filteredList;

    _ck(_v, 2, 0, currVal_0);
  }, null);
}

function View_SearchComboComponent_0(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵeld(0, 0, null, null, 52, "div", [["class", "input-group input-group-sm"], ["ngbDropdown", ""]], [[2, "show", null]], [[null, "openChange"], [null, "focusin"], [null, "focusout"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("openChange" === en) {
      var pd_0 = (_co.optionsDropdownOpened = $event) !== false;
      ad = pd_0 && ad;
    }

    if ("openChange" === en) {
      var pd_1 = (_co.isDropdownOpen = _co.optionsDropdownOpened) !== false;
      ad = pd_1 && ad;
    }

    if ("focusin" === en) {
      var pd_2 = _co.OnFocusIn() !== false;
      ad = pd_2 && ad;
    }

    if ("focusout" === en) {
      var pd_3 = _co.OnFocusOut($event) !== false;
      ad = pd_3 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(1, 1720320, null, 2, i9$3.NgbDropdown, [i1$5.ChangeDetectorRef, i9$3.NgbDropdownConfig, i8$3.DOCUMENT, i1$5.NgZone, i1$5.ElementRef, i1$5.Renderer2, [2, i9$3.NgbNavbar]], {
    autoClose: [0, "autoClose"],
    _open: [1, "_open"]
  }, {
    openChange: "openChange"
  }), i1$5.ɵqud(603979776, 1, {
    _menu: 0
  }), i1$5.ɵqud(603979776, 2, {
    _anchor: 0
  }), (_l()(), i1$5.ɵted(-1, null, ["\n    "])), (_l()(), i1$5.ɵeld(5, 0, null, null, 20, "div", [["class", "input-group input-group-sm dropdown-toggle dropdown-toggle"], ["ngbDropdownToggle", ""]], [[1, "aria-expanded", 0]], [[null, "click"], [null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = i1$5.ɵnov(_v, 6).dropdown.toggle() !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowUp" === en) {
      var pd_1 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_2 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_3 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.End" === en) {
      var pd_4 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_5 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_6 = i1$5.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(6, 16384, null, 0, i9$3.NgbDropdownToggle, [i9$3.NgbDropdown, i1$5.ElementRef], null, null), i1$5.ɵprd(2048, [[2, 4]], i9$3.NgbDropdownAnchor, null, [i9$3.NgbDropdownToggle]), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵeld(9, 0, null, null, 5, "input", [["class", "form-control form-control-sm search-combo-input"], ["type", "text"]], [[8, "id", 0], [8, "placeholder", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"], [null, "keyup"], [null, "focusin"], [null, "focusout"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("input" === en) {
      var pd_0 = i1$5.ɵnov(_v, 10)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i1$5.ɵnov(_v, 10).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i1$5.ɵnov(_v, 10)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i1$5.ɵnov(_v, 10)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_4 = (_co.textValue = $event) !== false;
      ad = pd_4 && ad;
    }

    if ("keyup" === en) {
      var pd_5 = _co.OnKeyUp() !== false;
      ad = pd_5 && ad;
    }

    if ("focusin" === en) {
      var pd_6 = _co.OnFocusIn() !== false;
      ad = pd_6 && ad;
    }

    if ("focusout" === en) {
      var pd_7 = _co.OnFocusOut($event) !== false;
      ad = pd_7 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(10, 16384, null, 0, i10$2.DefaultValueAccessor, [i1$5.Renderer2, i1$5.ElementRef, [2, i10$2.COMPOSITION_BUFFER_MODE]], null, null), i1$5.ɵprd(1024, null, i10$2.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i10$2.DefaultValueAccessor]), i1$5.ɵdid(12, 671744, null, 0, i10$2.NgModel, [[8, null], [8, null], [8, null], [6, i10$2.NG_VALUE_ACCESSOR]], {
    isDisabled: [0, "isDisabled"],
    model: [1, "model"]
  }, {
    update: "ngModelChange"
  }), i1$5.ɵprd(2048, null, i10$2.NgControl, null, [i10$2.NgModel]), i1$5.ɵdid(14, 16384, null, 0, i10$2.NgControlStatus, [[4, i10$2.NgControl]], null, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵeld(16, 0, null, null, 8, "div", [["class", "input-group-addon"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵeld(18, 0, null, null, 5, "button", [["class", "btn input-group-text dropdown-toggle"]], null, null, null, null, null)), (_l()(), i1$5.ɵted(-1, null, ["\n                "])), (_l()(), i1$5.ɵeld(20, 0, null, null, 2, "span", [["class", "far fa-fw"]], null, null, null, null, null)), i1$5.ɵdid(21, 278528, null, 0, i8$3.NgClass, [i1$5.IterableDiffers, i1$5.KeyValueDiffers, i1$5.ElementRef, i1$5.Renderer2], {
    klass: [0, "klass"],
    ngClass: [1, "ngClass"]
  }, null), i1$5.ɵpod(22, {
    "fa-angle-up": 0,
    "fa-angle-down": 1
  }), (_l()(), i1$5.ɵted(-1, null, ["\n            "])), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵted(-1, null, ["\n    "])), (_l()(), i1$5.ɵted(-1, null, ["\n    "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_1)), i1$5.ɵdid(28, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n    \n    "])), (_l()(), i1$5.ɵeld(30, 0, null, null, 21, "ul", [["aria-labelledby", "simple-btn-keyboard-nav"], ["class", "dropdown-menu scrollable-menu"], ["ngbDropdownMenu", ""], ["role", "menu"]], [[2, "dropdown-menu", null], [2, "show", null], [1, "x-placement", 0]], [[null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Enter"], [null, "keydown.Space"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("keydown.ArrowUp" === en) {
      var pd_0 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_1 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_2 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.End" === en) {
      var pd_3 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.Enter" === en) {
      var pd_4 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Space" === en) {
      var pd_5 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_6 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_7 = i1$5.ɵnov(_v, 31).dropdown.onKeyDown($event) !== false;
      ad = pd_7 && ad;
    }

    return ad;
  }, null, null)), i1$5.ɵdid(31, 16384, [[1, 4]], 1, i9$3.NgbDropdownMenu, [i9$3.NgbDropdown, i1$5.ElementRef], null, null), i1$5.ɵqud(-1543503872, 3, {
    menuItems: 1
  }), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_4)), i1$5.ɵdid(35, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_5)), i1$5.ɵdid(38, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_6)), i1$5.ɵdid(41, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_7)), i1$5.ɵdid(44, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_8)), i1$5.ɵdid(47, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n        "])), (_l()(), i1$5.ɵand(16777216, null, null, 1, null, View_SearchComboComponent_10)), i1$5.ɵdid(50, 16384, null, 0, i8$3.NgIf, [i1$5.ViewContainerRef, i1$5.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$5.ɵted(-1, null, ["\n    "])), (_l()(), i1$5.ɵted(-1, null, ["\n"])), (_l()(), i1$5.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_1 = true;
    var currVal_2 = _co.optionsDropdownOpened;

    _ck(_v, 1, 0, currVal_1, currVal_2);

    var currVal_13 = _co.disabled;
    var currVal_14 = _co.textValue;

    _ck(_v, 12, 0, currVal_13, currVal_14);

    var currVal_15 = "far fa-fw";

    var currVal_16 = _ck(_v, 22, 0, _co.isDropdownOpen, !_co.isDropdownOpen);

    _ck(_v, 21, 0, currVal_15, currVal_16);

    var currVal_17 = _co.addOptionFormVisible;

    _ck(_v, 28, 0, currVal_17);

    var currVal_21 = _co.showEmptyItem;

    _ck(_v, 35, 0, currVal_21);

    var currVal_22 = _co.showEmptyItem && (_co.showInputOption && _co.inputOption && _co.inputOption.value || _co.filteredList.length > 0);

    _ck(_v, 38, 0, currVal_22);

    var currVal_23 = _co.showInputOption && _co.inputOption && _co.inputOption.value;

    _ck(_v, 41, 0, currVal_23);

    var currVal_24 = _co.showInputOption && _co.inputOption && _co.inputOption.value && _co.filteredList.length > 0;

    _ck(_v, 44, 0, currVal_24);

    var currVal_25 = _co.favOptionsList.length > 0;

    _ck(_v, 47, 0, currVal_25);

    var currVal_26 = _co.filteredList.length > 0;

    _ck(_v, 50, 0, currVal_26);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i1$5.ɵnov(_v, 1).isOpen();

    _ck(_v, 0, 0, currVal_0);

    var currVal_3 = i1$5.ɵnov(_v, 6).dropdown.isOpen();

    _ck(_v, 5, 0, currVal_3);

    var currVal_4 = i1$5.ɵinlineInterpolate(1, "", _co.textBoxId, "");
    var currVal_5 = _co.placeholder;
    var currVal_6 = i1$5.ɵnov(_v, 14).is("untouched");
    var currVal_7 = i1$5.ɵnov(_v, 14).is("touched");
    var currVal_8 = i1$5.ɵnov(_v, 14).is("pristine");
    var currVal_9 = i1$5.ɵnov(_v, 14).is("dirty");
    var currVal_10 = i1$5.ɵnov(_v, 14).is("valid");
    var currVal_11 = i1$5.ɵnov(_v, 14).is("invalid");
    var currVal_12 = i1$5.ɵnov(_v, 14).is("pending");

    _ck(_v, 9, 0, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12);

    var currVal_18 = true;
    var currVal_19 = i1$5.ɵnov(_v, 31).dropdown.isOpen();
    var currVal_20 = i1$5.ɵnov(_v, 31).placement;

    _ck(_v, 30, 0, currVal_18, currVal_19, currVal_20);
  });
}

searchCombo_component_ngfactory.View_SearchComboComponent_0 = View_SearchComboComponent_0;

function View_SearchComboComponent_Host_0(_l) {
  return i1$5.ɵvid(0, [(_l()(), i1$5.ɵeld(0, 0, null, null, 2, "search-combo-cmp", [], null, null, null, View_SearchComboComponent_0, RenderType_SearchComboComponent)), i1$5.ɵprd(5120, null, i10$2.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i11$1.SearchComboComponent]), i1$5.ɵdid(2, 114688, null, 0, i11$1.SearchComboComponent, [i1$5.ElementRef], null, null)], function (_ck, _v) {
    _ck(_v, 2, 0);
  }, null);
}

searchCombo_component_ngfactory.View_SearchComboComponent_Host_0 = View_SearchComboComponent_Host_0;
var SearchComboComponentNgFactory = i1$5.ɵccf("search-combo-cmp", i11$1.SearchComboComponent, View_SearchComboComponent_Host_0, {
  optionsList: "optionsList",
  favOptionsList: "favOptionsList",
  disabled: "disabled",
  maxElements: "maxElements",
  showValueInLabel: "showValueInLabel",
  labelValuePrefix: "labelValuePrefix",
  labelValueSufix: "labelValueSufix",
  showEmptyItem: "showEmptyItem",
  emptyOptionValue: "emptyOptionValue",
  emptyOptionDescription: "emptyOptionDescription",
  placeholder: "placeholder",
  showInputOption: "showInputOption",
  inputOptionPrefix: "inputOptionPrefix",
  inputOptionSuffix: "inputOptionSuffix",
  allowInsert: "allowInsert",
  addOptionButtonText: "addOptionButtonText",
  showButtonIcon: "showButtonIcon",
  allowInsertIncluded: "allowInsertIncluded",
  addOptionButtonIcon: "addOptionButtonIcon"
}, {
  optionChanged: "optionChanged",
  optionAdded: "optionAdded",
  focusIn: "focusIn",
  focusOut: "focusOut",
  click: "click"
}, []);
searchCombo_component_ngfactory.SearchComboComponentNgFactory = SearchComboComponentNgFactory;

var search_component_ngfactory = {};

Object.defineProperty(search_component_ngfactory, "__esModule", {
  value: true
});
search_component_ngfactory.SearchComponentNgFactory = search_component_ngfactory.View_SearchComponent_Host_0 = search_component_ngfactory.View_SearchComponent_0 = search_component_ngfactory.RenderType_SearchComponent = void 0;
const i0$4 = require$$0$1;
const i1$4 = require$$54;
const i2$4 = require$$14;
const i3$3 = require$$45;
const i4$2 = index_ngfactory;
const i5$2 = require$$50;
const i6$2 = require$$47;
const i7$2 = require$$17;
const i8$2 = language_pipes;
const i9$2 = language_service;
const i10$1 = search_component.exports;
const i11 = require$$26;
const i12 = datetime_service;
var styles_SearchComponent = [];
var RenderType_SearchComponent = i0$4.ɵcrt({
  encapsulation: 2,
  styles: styles_SearchComponent,
  data: {
    "animation": [{
      type: 7,
      name: "sectionExpand",
      definitions: [{
        type: 1,
        expr: ":enter",
        animation: [{
          type: 6,
          styles: {
            "height": "0",
            "paddingBottom": "0",
            "paddingTop": "0",
            "opacity": "0",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "*",
              "paddingBottom": "*",
              "paddingTop": "*",
              "opacity": "1",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "500ms ease-in"
        }],
        options: null
      }, {
        type: 1,
        expr: ":leave",
        animation: [{
          type: 6,
          styles: {
            "height": "*",
            "paddingBottom": "*",
            "paddingTop": "*",
            "opacity": "1",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "0",
              "paddingBottom": "0",
              "paddingTop": "0",
              "opacity": "0",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "500ms ease-out"
        }],
        options: null
      }],
      options: {}
    }, {
      type: 7,
      name: "sectionExpand",
      definitions: [{
        type: 1,
        expr: ":enter",
        animation: [{
          type: 6,
          styles: {
            "height": "0",
            "paddingBottom": "0",
            "paddingTop": "0",
            "opacity": "0",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "*",
              "paddingBottom": "*",
              "paddingTop": "*",
              "opacity": "1",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "200ms ease-in"
        }],
        options: null
      }, {
        type: 1,
        expr: ":leave",
        animation: [{
          type: 6,
          styles: {
            "height": "*",
            "paddingBottom": "*",
            "paddingTop": "*",
            "opacity": "1",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "0",
              "paddingBottom": "0",
              "paddingTop": "0",
              "opacity": "0",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "200ms ease-out"
        }],
        options: null
      }],
      options: {}
    }, {
      type: 7,
      name: "routerTransition",
      definitions: [{
        type: 0,
        name: "void",
        styles: {
          type: 6,
          styles: {
            "position": "fixed",
            "display": "contents"
          },
          offset: null
        },
        options: undefined
      }, {
        type: 0,
        name: "*",
        styles: {
          type: 6,
          styles: {
            "position": "inherit",
            "display": "inherit"
          },
          offset: null
        },
        options: undefined
      }, {
        type: 1,
        expr: "void => true",
        animation: [{
          type: 6,
          styles: {
            "position": "fixed",
            "display": "contents",
            "opacity": "0.7"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "position": "fixed",
              "display": "contents",
              "opacity": "1"
            },
            offset: null
          },
          timings: "100ms 100ms ease-in"
        }],
        options: null
      }, {
        type: 1,
        expr: "true => void",
        animation: [{
          type: 6,
          styles: {
            "position": "fixed",
            "display": "contents",
            "opacity": "1"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "position": "fixed",
              "display": "contents",
              "opacity": "0.7"
            },
            offset: null
          },
          timings: "100ms ease-out"
        }],
        options: null
      }],
      options: {}
    }]
  }
});
search_component_ngfactory.RenderType_SearchComponent = RenderType_SearchComponent;

function View_SearchComponent_2(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 4, "li", [["role", "menuitem"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(2, 0, null, null, 1, "span", [["class", "dropdown-item"], ["role", "button"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.SetCustomFieldSearchCriteria(_v.context.$implicit) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(3, null, ["", ""])), (_l()(), i0$4.ɵted(-1, null, ["\n          "]))], null, function (_ck, _v) {
    var currVal_0 = _v.context.$implicit.description;

    _ck(_v, 3, 0, currVal_0);
  });
}

function View_SearchComponent_1(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 23, "span", [["class", "input-group-btn"], ["ngbDropdown", ""]], [[2, "show", null]], null, null, null, null)), i0$4.ɵdid(1, 1720320, null, 2, i1$4.NgbDropdown, [i0$4.ChangeDetectorRef, i1$4.NgbDropdownConfig, i2$4.DOCUMENT, i0$4.NgZone, i0$4.ElementRef, i0$4.Renderer2, [2, i1$4.NgbNavbar]], null, null), i0$4.ɵqud(603979776, 1, {
    _menu: 0
  }), i0$4.ɵqud(603979776, 2, {
    _anchor: 0
  }), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵeld(5, 0, null, null, 9, "button", [["class", "btn btn-secondary dropdown-toggle btn-with-dropdown-beforeinput dropdown-toggle"], ["ngbDropdownToggle", ""], ["type", "button"]], [[1, "aria-expanded", 0]], [[null, "click"], [null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = i0$4.ɵnov(_v, 6).dropdown.toggle() !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowUp" === en) {
      var pd_1 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_2 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_3 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.End" === en) {
      var pd_4 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_5 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_6 = i0$4.ɵnov(_v, 6).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵdid(6, 16384, null, 0, i1$4.NgbDropdownToggle, [i1$4.NgbDropdown, i0$4.ElementRef], null, null), i0$4.ɵprd(2048, [[2, 4]], i1$4.NgbDropdownAnchor, null, [i1$4.NgbDropdownToggle]), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(9, 0, null, null, 1, "span", [["class", "hidden-md-down"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(10, null, ["", "\u00A0"])), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(13, 0, null, null, 0, "span", [["class", "fa fa-caret-down"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵeld(16, 0, null, null, 6, "ul", [["aria-labelledby", "simple-btn-keyboard-nav"], ["class", "dropdown-menu"], ["ngbDropdownMenu", ""], ["role", "menu"]], [[2, "dropdown-menu", null], [2, "show", null], [1, "x-placement", 0]], [[null, "keydown.ArrowUp"], [null, "keydown.ArrowDown"], [null, "keydown.Home"], [null, "keydown.End"], [null, "keydown.Enter"], [null, "keydown.Space"], [null, "keydown.Tab"], [null, "keydown.Shift.Tab"]], function (_v, en, $event) {
    var ad = true;

    if ("keydown.ArrowUp" === en) {
      var pd_0 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.ArrowDown" === en) {
      var pd_1 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.Home" === en) {
      var pd_2 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_2 && ad;
    }

    if ("keydown.End" === en) {
      var pd_3 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_3 && ad;
    }

    if ("keydown.Enter" === en) {
      var pd_4 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_4 && ad;
    }

    if ("keydown.Space" === en) {
      var pd_5 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keydown.Tab" === en) {
      var pd_6 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_6 && ad;
    }

    if ("keydown.Shift.Tab" === en) {
      var pd_7 = i0$4.ɵnov(_v, 17).dropdown.onKeyDown($event) !== false;
      ad = pd_7 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵdid(17, 16384, [[1, 4]], 1, i1$4.NgbDropdownMenu, [i1$4.NgbDropdown, i0$4.ElementRef], null, null), i0$4.ɵqud(-1543503872, 3, {
    menuItems: 1
  }), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_2)), i0$4.ɵdid(21, 278528, null, 0, i2$4.NgForOf, [i0$4.ViewContainerRef, i0$4.TemplateRef, i0$4.IterableDiffers], {
    ngForOf: [0, "ngForOf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵted(-1, null, ["\n      "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_6 = _co.searchCriteriaOptions;

    _ck(_v, 21, 0, currVal_6);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$4.ɵnov(_v, 1).isOpen();

    _ck(_v, 0, 0, currVal_0);

    var currVal_1 = i0$4.ɵnov(_v, 6).dropdown.isOpen();

    _ck(_v, 5, 0, currVal_1);

    var currVal_2 = _co.searchCriteria.description;

    _ck(_v, 10, 0, currVal_2);

    var currVal_3 = true;
    var currVal_4 = i0$4.ɵnov(_v, 17).dropdown.isOpen();
    var currVal_5 = i0$4.ɵnov(_v, 17).placement;

    _ck(_v, 16, 0, currVal_3, currVal_4, currVal_5);
  });
}

function View_SearchComponent_3(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 3, "button", [["class", "btn btn-small-search"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.ClearSearch() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵeld(2, 0, null, null, 0, "i", [["class", "far fa-times"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "]))], null, null);
}

function View_SearchComponent_6(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 0, "div", [["class", "custom-overlay"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = i0$4.ɵnov(_v.parent, 3).close() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null))], null, null);
}

function View_SearchComponent_9(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵand(0, null, null, 0))], null, null);
}

function View_SearchComponent_8(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 4, "div", [["class", "col"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_9)), i0$4.ɵdid(3, 540672, null, 0, i2$4.NgTemplateOutlet, [i0$4.ViewContainerRef], {
    ngTemplateOutlet: [0, "ngTemplateOutlet"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n              "]))], function (_ck, _v) {
    var currVal_0 = i0$4.ɵnov(_v.parent.parent.parent.parent, 37);

    _ck(_v, 3, 0, currVal_0);
  }, null);
}

function View_SearchComponent_10(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 47, "div", [["class", "col"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                "])), (_l()(), i0$4.ɵeld(2, 0, null, null, 21, "div", [["class", "form-group"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵeld(4, 0, null, null, 2, "label", [["for", "filterStartDate"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(5, null, ["", ""])), i0$4.ɵppd(6, 2), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵeld(8, 0, [["filterStartDateWrapper", 1]], null, 14, "div", [["class", "input-with-icon"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                    "])), (_l()(), i0$4.ɵeld(10, 16777216, null, null, 9, "input", [["class", "form-control form-control-sm"], ["id", "filterStartDate"], ["maxlength", "10"], ["name", "filterStartDate"], ["ngbDatepicker", ""], ["placeholder", "yyyy-mm-dd"]], [[1, "maxlength", 0], [8, "disabled", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"], [null, "click"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "change"], [null, "focus"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("input" === en) {
      var pd_0 = i0$4.ɵnov(_v, 12)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$4.ɵnov(_v, 12).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$4.ɵnov(_v, 12)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$4.ɵnov(_v, 12)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    if ("input" === en) {
      var pd_4 = i0$4.ɵnov(_v, 14).manualDateChange($event.target.value) !== false;
      ad = pd_4 && ad;
    }

    if ("change" === en) {
      var pd_5 = i0$4.ɵnov(_v, 14).manualDateChange($event.target.value, true) !== false;
      ad = pd_5 && ad;
    }

    if ("focus" === en) {
      var pd_6 = i0$4.ɵnov(_v, 14).onFocus() !== false;
      ad = pd_6 && ad;
    }

    if ("blur" === en) {
      var pd_7 = i0$4.ɵnov(_v, 14).onBlur() !== false;
      ad = pd_7 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_8 = _co.SetFilterStartDate($event) !== false;
      ad = pd_8 && ad;
    }

    if ("click" === en) {
      var pd_9 = _co.ToggleDatePicker(i0$4.ɵnov(_v, 14), i0$4.ɵnov(_v, 37)) !== false;
      ad = pd_9 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵprd(6144, null, i1$4.NgbDatepickerConfig, null, [i1$4.NgbInputDatepickerConfig]), i0$4.ɵdid(12, 16384, null, 0, i3$3.DefaultValueAccessor, [i0$4.Renderer2, i0$4.ElementRef, [2, i3$3.COMPOSITION_BUFFER_MODE]], null, null), i0$4.ɵdid(13, 540672, null, 0, i3$3.MaxLengthValidator, [], {
    maxlength: [0, "maxlength"]
  }, null), i0$4.ɵdid(14, 671744, [["filterStartDate", 4]], 0, i1$4.NgbInputDatepicker, [i1$4.NgbDateParserFormatter, i0$4.ElementRef, i0$4.ViewContainerRef, i0$4.Renderer2, i0$4.ComponentFactoryResolver, i0$4.NgZone, i1$4.NgbCalendar, i1$4.NgbDateAdapter, i2$4.DOCUMENT, i0$4.ChangeDetectorRef, i1$4.NgbInputDatepickerConfig], {
    firstDayOfWeek: [0, "firstDayOfWeek"],
    maxDate: [1, "maxDate"],
    startDate: [2, "startDate"]
  }, null), i0$4.ɵprd(1024, null, i3$3.NG_VALIDATORS, function (p0_0, p1_0) {
    return [p0_0, p1_0];
  }, [i3$3.MaxLengthValidator, i1$4.NgbInputDatepicker]), i0$4.ɵprd(1024, null, i3$3.NG_VALUE_ACCESSOR, function (p0_0, p1_0) {
    return [p0_0, p1_0];
  }, [i3$3.DefaultValueAccessor, i1$4.NgbInputDatepicker]), i0$4.ɵdid(17, 671744, null, 0, i3$3.NgModel, [[8, null], [6, i3$3.NG_VALIDATORS], [8, null], [6, i3$3.NG_VALUE_ACCESSOR]], {
    name: [0, "name"],
    model: [1, "model"]
  }, {
    update: "ngModelChange"
  }), i0$4.ɵprd(2048, null, i3$3.NgControl, null, [i3$3.NgModel]), i0$4.ɵdid(19, 16384, null, 0, i3$3.NgControlStatus, [[4, i3$3.NgControl]], null, null), (_l()(), i0$4.ɵted(-1, null, ["\n                    "])), (_l()(), i0$4.ɵeld(21, 0, null, null, 0, "span", [["class", "far fa-calendar-alt"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.ToggleDatePicker(i0$4.ɵnov(_v, 14), i0$4.ɵnov(_v, 37)) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵted(-1, null, ["\n                "])), (_l()(), i0$4.ɵted(-1, null, ["\n                "])), (_l()(), i0$4.ɵeld(25, 0, null, null, 21, "div", [["class", "form-group"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵeld(27, 0, null, null, 2, "label", [["for", "filterEndDate"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(28, null, ["", ""])), i0$4.ɵppd(29, 2), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵeld(31, 0, [["filterEndDateWrapper", 1]], null, 14, "div", [["class", "input-with-icon"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                    "])), (_l()(), i0$4.ɵeld(33, 16777216, null, null, 9, "input", [["class", "form-control form-control-sm"], ["id", "filterEndDate"], ["maxlength", "10"], ["name", "filterEndDate"], ["ngbDatepicker", ""], ["placeholder", "yyyy-mm-dd"]], [[1, "maxlength", 0], [8, "disabled", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"], [null, "click"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "change"], [null, "focus"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("input" === en) {
      var pd_0 = i0$4.ɵnov(_v, 35)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$4.ɵnov(_v, 35).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$4.ɵnov(_v, 35)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$4.ɵnov(_v, 35)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    if ("input" === en) {
      var pd_4 = i0$4.ɵnov(_v, 37).manualDateChange($event.target.value) !== false;
      ad = pd_4 && ad;
    }

    if ("change" === en) {
      var pd_5 = i0$4.ɵnov(_v, 37).manualDateChange($event.target.value, true) !== false;
      ad = pd_5 && ad;
    }

    if ("focus" === en) {
      var pd_6 = i0$4.ɵnov(_v, 37).onFocus() !== false;
      ad = pd_6 && ad;
    }

    if ("blur" === en) {
      var pd_7 = i0$4.ɵnov(_v, 37).onBlur() !== false;
      ad = pd_7 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_8 = _co.SetFilterEndDate($event) !== false;
      ad = pd_8 && ad;
    }

    if ("click" === en) {
      var pd_9 = _co.ToggleDatePicker(i0$4.ɵnov(_v, 37), i0$4.ɵnov(_v, 14)) !== false;
      ad = pd_9 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵprd(6144, null, i1$4.NgbDatepickerConfig, null, [i1$4.NgbInputDatepickerConfig]), i0$4.ɵdid(35, 16384, null, 0, i3$3.DefaultValueAccessor, [i0$4.Renderer2, i0$4.ElementRef, [2, i3$3.COMPOSITION_BUFFER_MODE]], null, null), i0$4.ɵdid(36, 540672, null, 0, i3$3.MaxLengthValidator, [], {
    maxlength: [0, "maxlength"]
  }, null), i0$4.ɵdid(37, 671744, [["filterEndDate", 4]], 0, i1$4.NgbInputDatepicker, [i1$4.NgbDateParserFormatter, i0$4.ElementRef, i0$4.ViewContainerRef, i0$4.Renderer2, i0$4.ComponentFactoryResolver, i0$4.NgZone, i1$4.NgbCalendar, i1$4.NgbDateAdapter, i2$4.DOCUMENT, i0$4.ChangeDetectorRef, i1$4.NgbInputDatepickerConfig], {
    firstDayOfWeek: [0, "firstDayOfWeek"],
    minDate: [1, "minDate"],
    startDate: [2, "startDate"]
  }, null), i0$4.ɵprd(1024, null, i3$3.NG_VALIDATORS, function (p0_0, p1_0) {
    return [p0_0, p1_0];
  }, [i3$3.MaxLengthValidator, i1$4.NgbInputDatepicker]), i0$4.ɵprd(1024, null, i3$3.NG_VALUE_ACCESSOR, function (p0_0, p1_0) {
    return [p0_0, p1_0];
  }, [i3$3.DefaultValueAccessor, i1$4.NgbInputDatepicker]), i0$4.ɵdid(40, 671744, null, 0, i3$3.NgModel, [[8, null], [6, i3$3.NG_VALIDATORS], [8, null], [6, i3$3.NG_VALUE_ACCESSOR]], {
    name: [0, "name"],
    model: [1, "model"]
  }, {
    update: "ngModelChange"
  }), i0$4.ɵprd(2048, null, i3$3.NgControl, null, [i3$3.NgModel]), i0$4.ɵdid(42, 16384, null, 0, i3$3.NgControlStatus, [[4, i3$3.NgControl]], null, null), (_l()(), i0$4.ɵted(-1, null, ["\n                    "])), (_l()(), i0$4.ɵeld(44, 0, null, null, 0, "span", [["class", "far fa-calendar-alt"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.ToggleDatePicker(i0$4.ɵnov(_v, 37), i0$4.ɵnov(_v, 14)) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n                  "])), (_l()(), i0$4.ɵted(-1, null, ["\n                "])), (_l()(), i0$4.ɵted(-1, null, ["\n              "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_10 = "10";

    _ck(_v, 13, 0, currVal_10);

    var currVal_11 = 1;
    var currVal_12 = _co.selectedFilterEndDate;
    var currVal_13 = _co.selectedFilterStartDate;

    _ck(_v, 14, 0, currVal_11, currVal_12, currVal_13);

    var currVal_14 = "filterStartDate";
    var currVal_15 = _co.selectedFilterStartDate;

    _ck(_v, 17, 0, currVal_14, currVal_15);

    var currVal_26 = "10";

    _ck(_v, 36, 0, currVal_26);

    var currVal_27 = 1;
    var currVal_28 = _co.selectedFilterStartDate;
    var currVal_29 = _co.selectedFilterEndDate;

    _ck(_v, 37, 0, currVal_27, currVal_28, currVal_29);

    var currVal_30 = "filterEndDate";
    var currVal_31 = _co.selectedFilterEndDate;

    _ck(_v, 40, 0, currVal_30, currVal_31);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$4.ɵunv(_v, 5, 0, _ck(_v, 6, 0, i0$4.ɵnov(_v.parent.parent.parent.parent, 0), "STARTDATE", _co.translateCategory));

    _ck(_v, 5, 0, currVal_0);

    var currVal_1 = i0$4.ɵnov(_v, 13).maxlength ? i0$4.ɵnov(_v, 13).maxlength : null;
    var currVal_2 = i0$4.ɵnov(_v, 14).disabled;
    var currVal_3 = i0$4.ɵnov(_v, 19).is("untouched");
    var currVal_4 = i0$4.ɵnov(_v, 19).is("touched");
    var currVal_5 = i0$4.ɵnov(_v, 19).is("pristine");
    var currVal_6 = i0$4.ɵnov(_v, 19).is("dirty");
    var currVal_7 = i0$4.ɵnov(_v, 19).is("valid");
    var currVal_8 = i0$4.ɵnov(_v, 19).is("invalid");
    var currVal_9 = i0$4.ɵnov(_v, 19).is("pending");

    _ck(_v, 10, 0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9);

    var currVal_16 = i0$4.ɵunv(_v, 28, 0, _ck(_v, 29, 0, i0$4.ɵnov(_v.parent.parent.parent.parent, 0), "ENDDATE", _co.translateCategory));

    _ck(_v, 28, 0, currVal_16);

    var currVal_17 = i0$4.ɵnov(_v, 36).maxlength ? i0$4.ɵnov(_v, 36).maxlength : null;
    var currVal_18 = i0$4.ɵnov(_v, 37).disabled;
    var currVal_19 = i0$4.ɵnov(_v, 42).is("untouched");
    var currVal_20 = i0$4.ɵnov(_v, 42).is("touched");
    var currVal_21 = i0$4.ɵnov(_v, 42).is("pristine");
    var currVal_22 = i0$4.ɵnov(_v, 42).is("dirty");
    var currVal_23 = i0$4.ɵnov(_v, 42).is("valid");
    var currVal_24 = i0$4.ɵnov(_v, 42).is("invalid");
    var currVal_25 = i0$4.ɵnov(_v, 42).is("pending");

    _ck(_v, 33, 0, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22, currVal_23, currVal_24, currVal_25);
  });
}

function View_SearchComponent_7(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵeld(1, 0, null, null, 35, "div", [["class", "filterToggle"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(3, 0, null, null, 5, "div", [["class", "popover-header"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(5, 0, null, null, 2, "span", [["class", "title"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(6, null, ["", ""])), i0$4.ɵppd(7, 2), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(10, 0, null, null, 13, "div", [["class", "popover-body"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(12, 0, null, null, 10, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n              "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_8)), i0$4.ɵdid(15, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n              "])), (_l()(), i0$4.ɵeld(17, 16777216, null, null, 1, null, null, null, null, null, null, null)), i0$4.ɵdid(18, 540672, null, 0, i2$4.NgTemplateOutlet, [i0$4.ViewContainerRef], {
    ngTemplateOutlet: [0, "ngTemplateOutlet"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n              "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_10)), i0$4.ɵdid(21, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵted(-1, null, ["\n\n          "])), (_l()(), i0$4.ɵeld(25, 0, null, null, 10, "div", [["class", "popover-footer"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(28, 0, null, null, 3, "button", [["class", "btn btn-secondary btn-small"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      _co.ClearSerachPopUp();

      var pd_0 = i0$4.ɵnov(_v.parent, 3).close() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n              "])), (_l()(), i0$4.ɵeld(30, 0, null, null, 0, "span", [["class", "far fa-eraser"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(33, 0, null, null, 1, "button", [["class", "btn btn-primary"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      _co.RefreshSearch();

      var pd_0 = i0$4.ɵnov(_v.parent, 3).close() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n              Filtrar\n            "])), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵted(-1, null, ["\n      "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_1 = _co.disabled !== undefined;

    _ck(_v, 15, 0, currVal_1);

    var currVal_2 = _co.templateAdditional;

    _ck(_v, 18, 0, currVal_2);

    var currVal_3 = _co.selectedFilterStartDate !== undefined && _co.selectedFilterEndDate !== undefined;

    _ck(_v, 21, 0, currVal_3);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$4.ɵunv(_v, 6, 0, _ck(_v, 7, 0, i0$4.ɵnov(_v.parent.parent.parent, 0), "SELECT_OPTION", _co.translateCategory));

    _ck(_v, 6, 0, currVal_0);
  });
}

function View_SearchComponent_5(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 18, "div", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵeld(2, 16777216, null, null, 10, "button", [["autoClose", "true"], ["class", "btn btn-secondary dropdown-toggle btn-with-dropdown"], ["placement", "bottom-right"], ["type", "button"]], null, null, null, null, null)), i0$4.ɵdid(3, 737280, [["filterPopover", 4]], 0, i1$4.NgbPopover, [i0$4.ElementRef, i0$4.Renderer2, i0$4.Injector, i0$4.ComponentFactoryResolver, i0$4.ViewContainerRef, i1$4.NgbPopoverConfig, i0$4.NgZone, i2$4.DOCUMENT, i0$4.ChangeDetectorRef, i0$4.ApplicationRef], {
    autoClose: [0, "autoClose"],
    ngbPopover: [1, "ngbPopover"],
    placement: [2, "placement"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n\n        "])), (_l()(), i0$4.ɵeld(5, 0, null, null, 6, "div", [["class", "d-flex filtertext"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(7, 0, null, null, 0, "i", [["class", "fas fa-sliders-h"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n          "])), (_l()(), i0$4.ɵeld(9, 0, null, null, 1, "span", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["Filtrar"])), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_6)), i0$4.ɵdid(15, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵand(0, [["filterPopOver", 2]], null, 0, null, View_SearchComponent_7)), (_l()(), i0$4.ɵted(-1, null, ["\n    "]))], function (_ck, _v) {
    var currVal_0 = "true";
    var currVal_1 = i0$4.ɵnov(_v, 17);
    var currVal_2 = "bottom-right";

    _ck(_v, 3, 0, currVal_0, currVal_1, currVal_2);

    var currVal_3 = i0$4.ɵnov(_v, 3).isOpen();

    _ck(_v, 15, 0, currVal_3);
  }, null);
}

function View_SearchComponent_12(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵand(0, null, null, 0))], null, null);
}

function View_SearchComponent_11(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 4, "div", [["class", "card card-block switch form-group"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_12)), i0$4.ɵdid(3, 540672, null, 0, i2$4.NgTemplateOutlet, [i0$4.ViewContainerRef], {
    ngTemplateOutlet: [0, "ngTemplateOutlet"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n    "]))], function (_ck, _v) {
    var currVal_0 = i0$4.ɵnov(_v.parent.parent, 37);

    _ck(_v, 3, 0, currVal_0);
  }, null);
}

function View_SearchComponent_14(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 7, "span", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(2, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(3, null, [" ", ""])), (_l()(), i0$4.ɵted(4, null, [" \n                | ", "\n            "])), i0$4.ɵppd(5, 2), (_l()(), i0$4.ɵeld(6, 0, null, null, 0, "i", [["class", "fa fa-times"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.ClearStartDate() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n        "]))], null, function (_ck, _v) {
    var _co = _v.component;

    var currVal_0 = _co.SetDate(_co.selectedFilterStartDateBadge);

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = i0$4.ɵunv(_v, 4, 0, _ck(_v, 5, 0, i0$4.ɵnov(_v.parent.parent.parent, 0), "CHIP_START_DATE", "general"));

    _ck(_v, 4, 0, currVal_1);
  });
}

function View_SearchComponent_15(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 7, "span", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n            "])), (_l()(), i0$4.ɵeld(2, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), i0$4.ɵted(3, null, ["", ""])), (_l()(), i0$4.ɵted(4, null, [" | \n                ", "\n            "])), i0$4.ɵppd(5, 2), (_l()(), i0$4.ɵeld(6, 0, null, null, 0, "i", [["class", "fa fa-times"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.ClearEndDate() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n        "]))], null, function (_ck, _v) {
    var _co = _v.component;

    var currVal_0 = _co.SetDate(_co.selectedFilterEndDateBadge);

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = i0$4.ɵunv(_v, 4, 0, _ck(_v, 5, 0, i0$4.ɵnov(_v.parent.parent.parent, 0), "CHIP_END_DATE", "general"));

    _ck(_v, 4, 0, currVal_1);
  });
}

function View_SearchComponent_13(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 7, "div", [["class", "list-filters-custom"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_14)), i0$4.ɵdid(3, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_15)), i0$4.ɵdid(6, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n       \n    "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.selectedFilterStartDateBadge;

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = _co.selectedFilterEndDateBadge;

    _ck(_v, 6, 0, currVal_1);
  }, null);
}

function View_SearchComponent_4(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 10, "div", [["class", "flexCondition justify-content-end"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_5)), i0$4.ɵdid(3, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n\n    "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_11)), i0$4.ɵdid(6, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_13)), i0$4.ɵdid(9, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n  "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.popOverFilter;

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = _co.disabled !== undefined && !_co.popOverFilter;

    _ck(_v, 6, 0, currVal_1);

    var currVal_2 = _co.selectedFilterStartDateBadge || _co.selectedFilterEndDateBadge;

    _ck(_v, 9, 0, currVal_2);
  }, null);
}

function View_SearchComponent_16(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵeld(1, 0, null, null, 7, "mat-slide-toggle", [["class", "mat-slide-toggle"], ["id", "disabled"]], [[8, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [2, "mat-checked", null], [2, "mat-disabled", null], [2, "mat-slide-toggle-label-before", null], [2, "_mat-animation-noopable", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("ngModelChange" === en) {
      var pd_0 = (_co.disabled = $event) !== false;
      ad = pd_0 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_1 = _co.DisabledChange($event) !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, i4$2.View_MatSlideToggle_0, i4$2.RenderType_MatSlideToggle)), i0$4.ɵdid(2, 1228800, null, 0, i5$2.MatSlideToggle, [i0$4.ElementRef, i6$2.FocusMonitor, i0$4.ChangeDetectorRef, [8, null], i5$2.MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS, [2, i7$2.ANIMATION_MODULE_TYPE]], {
    id: [0, "id"]
  }, null), i0$4.ɵprd(1024, null, i3$3.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i5$2.MatSlideToggle]), i0$4.ɵdid(4, 671744, null, 0, i3$3.NgModel, [[8, null], [8, null], [8, null], [6, i3$3.NG_VALUE_ACCESSOR]], {
    model: [0, "model"]
  }, {
    update: "ngModelChange"
  }), i0$4.ɵprd(2048, null, i3$3.NgControl, null, [i3$3.NgModel]), i0$4.ɵdid(6, 16384, null, 0, i3$3.NgControlStatus, [[4, i3$3.NgControl]], null, null), (_l()(), i0$4.ɵted(7, 0, ["\n        ", "\n    "])), i0$4.ɵppd(8, 2), (_l()(), i0$4.ɵted(-1, null, ["\n  "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_15 = "disabled";

    _ck(_v, 2, 0, currVal_15);

    var currVal_16 = _co.disabled;

    _ck(_v, 4, 0, currVal_16);
  }, function (_ck, _v) {
    var currVal_0 = i0$4.ɵnov(_v, 2).id;
    var currVal_1 = i0$4.ɵnov(_v, 2).disabled ? null : -1;
    var currVal_2 = null;
    var currVal_3 = null;
    var currVal_4 = i0$4.ɵnov(_v, 2).checked;
    var currVal_5 = i0$4.ɵnov(_v, 2).disabled;
    var currVal_6 = i0$4.ɵnov(_v, 2).labelPosition == "before";

    var currVal_7 = i0$4.ɵnov(_v, 2)._noopAnimations;

    var currVal_8 = i0$4.ɵnov(_v, 6).is("untouched");
    var currVal_9 = i0$4.ɵnov(_v, 6).is("touched");
    var currVal_10 = i0$4.ɵnov(_v, 6).is("pristine");
    var currVal_11 = i0$4.ɵnov(_v, 6).is("dirty");
    var currVal_12 = i0$4.ɵnov(_v, 6).is("valid");
    var currVal_13 = i0$4.ɵnov(_v, 6).is("invalid");
    var currVal_14 = i0$4.ɵnov(_v, 6).is("pending");

    _ck(_v, 1, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14]);

    var currVal_17 = i0$4.ɵunv(_v, 7, 0, _ck(_v, 8, 0, i0$4.ɵnov(_v.parent, 0), "DISABLED", "general"));

    _ck(_v, 7, 0, currVal_17);
  });
}

function View_SearchComponent_0(_l) {
  return i0$4.ɵvid(0, [i0$4.ɵpid(0, i8$2.TranslateMessagePipe, [i9$2.LanguageService]), (_l()(), i0$4.ɵeld(1, 0, null, null, 38, "div", [["class", "row forFilters align-items-center justify-content-between"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n  "])), (_l()(), i0$4.ɵeld(3, 0, null, null, 29, "div", [["class", "flexCondition justify-content-between"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵeld(5, 0, null, null, 17, "div", [["class", "input-group custom-input-group"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_1)), i0$4.ɵdid(8, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵeld(10, 0, null, null, 8, "input", [["class", "form-control filterField"], ["maxlength", "50"], ["type", "text"]], [[8, "placeholder", 0], [1, "maxlength", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"], [null, "keyup.enter"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("input" === en) {
      var pd_0 = i0$4.ɵnov(_v, 11)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$4.ɵnov(_v, 11).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$4.ɵnov(_v, 11)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$4.ɵnov(_v, 11)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_4 = (_co.searchExpression = $event) !== false;
      ad = pd_4 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_5 = _co.searchExpressionChange.emit($event) !== false;
      ad = pd_5 && ad;
    }

    if ("keyup.enter" === en) {
      var pd_6 = _co.RefreshSearch() !== false;
      ad = pd_6 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵdid(11, 16384, null, 0, i3$3.DefaultValueAccessor, [i0$4.Renderer2, i0$4.ElementRef, [2, i3$3.COMPOSITION_BUFFER_MODE]], null, null), i0$4.ɵdid(12, 540672, null, 0, i3$3.MaxLengthValidator, [], {
    maxlength: [0, "maxlength"]
  }, null), i0$4.ɵprd(1024, null, i3$3.NG_VALIDATORS, function (p0_0) {
    return [p0_0];
  }, [i3$3.MaxLengthValidator]), i0$4.ɵprd(1024, null, i3$3.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i3$3.DefaultValueAccessor]), i0$4.ɵdid(15, 671744, null, 0, i3$3.NgModel, [[8, null], [6, i3$3.NG_VALIDATORS], [8, null], [6, i3$3.NG_VALUE_ACCESSOR]], {
    model: [0, "model"]
  }, {
    update: "ngModelChange"
  }), i0$4.ɵprd(2048, null, i3$3.NgControl, null, [i3$3.NgModel]), i0$4.ɵdid(17, 16384, null, 0, i3$3.NgControlStatus, [[4, i3$3.NgControl]], null, null), i0$4.ɵppd(18, 2), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_3)), i0$4.ɵdid(21, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵeld(24, 0, null, null, 7, "div", [["class", "box-icon"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵeld(26, 0, null, null, 4, "a", [["class", "btn btn-secondary btn-small"], ["data-placement", "bottom"], ["data-toggle", "tooltip"], ["type", "button"]], [[8, "title", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.RefreshSearch() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i0$4.ɵppd(27, 2), (_l()(), i0$4.ɵted(-1, null, ["\n        "])), (_l()(), i0$4.ɵeld(29, 0, null, null, 0, "i", [["class", "far fa-fw fa-search"]], null, null, null, null, null)), (_l()(), i0$4.ɵted(-1, null, ["\n      "])), (_l()(), i0$4.ɵted(-1, null, ["\n    "])), (_l()(), i0$4.ɵted(-1, null, ["\n  "])), (_l()(), i0$4.ɵted(-1, null, ["\n\n  "])), (_l()(), i0$4.ɵand(16777216, null, null, 1, null, View_SearchComponent_4)), i0$4.ɵdid(35, 16384, null, 0, i2$4.NgIf, [i0$4.ViewContainerRef, i0$4.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$4.ɵted(-1, null, ["\n  \n  "])), (_l()(), i0$4.ɵand(0, [["showDisabled", 2]], null, 0, null, View_SearchComponent_16)), (_l()(), i0$4.ɵted(-1, null, ["\n  "])), (_l()(), i0$4.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.searchCriteria && _co.searchCriteriaOptions.length;

    _ck(_v, 8, 0, currVal_0);

    var currVal_10 = "50";

    _ck(_v, 12, 0, currVal_10);

    var currVal_11 = _co.searchExpression;

    _ck(_v, 15, 0, currVal_11);

    var currVal_12 = _co.searchExpression == null ? null : _co.searchExpression.trim();

    _ck(_v, 21, 0, currVal_12);

    var currVal_14 = _co.visibilityPopOverFilter;

    _ck(_v, 35, 0, currVal_14);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_1 = i0$4.ɵinlineInterpolate(1, "", i0$4.ɵunv(_v, 10, 0, _ck(_v, 18, 0, i0$4.ɵnov(_v, 0), "SEARCH_PLACEHOLDER", _co.translateCategory)), "");
    var currVal_2 = i0$4.ɵnov(_v, 12).maxlength ? i0$4.ɵnov(_v, 12).maxlength : null;
    var currVal_3 = i0$4.ɵnov(_v, 17).is("untouched");
    var currVal_4 = i0$4.ɵnov(_v, 17).is("touched");
    var currVal_5 = i0$4.ɵnov(_v, 17).is("pristine");
    var currVal_6 = i0$4.ɵnov(_v, 17).is("dirty");
    var currVal_7 = i0$4.ɵnov(_v, 17).is("valid");
    var currVal_8 = i0$4.ɵnov(_v, 17).is("invalid");
    var currVal_9 = i0$4.ɵnov(_v, 17).is("pending");

    _ck(_v, 10, 0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9);

    var currVal_13 = i0$4.ɵinlineInterpolate(1, "", i0$4.ɵunv(_v, 26, 0, _ck(_v, 27, 0, i0$4.ɵnov(_v, 0), "SEARCH", _co.translateCategory)), "");

    _ck(_v, 26, 0, currVal_13);
  });
}

search_component_ngfactory.View_SearchComponent_0 = View_SearchComponent_0;

function View_SearchComponent_Host_0(_l) {
  return i0$4.ɵvid(0, [(_l()(), i0$4.ɵeld(0, 0, null, null, 1, "search", [], null, null, null, View_SearchComponent_0, RenderType_SearchComponent)), i0$4.ɵdid(1, 4308992, null, 0, i10$1.SearchComponent, [i11.Router, i12.DatetimeService], null, null)], function (_ck, _v) {
    _ck(_v, 1, 0);
  }, null);
}

search_component_ngfactory.View_SearchComponent_Host_0 = View_SearchComponent_Host_0;
var SearchComponentNgFactory = i0$4.ɵccf("search", i10$1.SearchComponent, View_SearchComponent_Host_0, {
  templateAdditional: "templateAdditional",
  disabled: "disabled",
  searchExpression: "searchExpression",
  searchCriteria: "searchCriteria",
  searchCriteriaOptions: "searchCriteriaOptions",
  selectedFilterStartDate: "selectedFilterStartDate",
  selectedFilterEndDate: "selectedFilterEndDate",
  translateCategory: "translateCategory",
  step: "step",
  popOverFilter: "popOverFilter",
  visibilityPopOverFilter: "visibilityPopOverFilter"
}, {
  refreshSearchParent: "refreshSearchParent",
  clearSearchParent: "clearSearchParent",
  disabledChangeParent: "disabledChangeParent",
  searchExpressionChange: "searchExpressionChange",
  SetCustomFieldSearchCriteriaParent: "SetCustomFieldSearchCriteriaParent",
  SetFilterStartDateParent: "SetFilterStartDateParent",
  SetFilterEndDateParent: "SetFilterEndDateParent"
}, []);
search_component_ngfactory.SearchComponentNgFactory = SearchComponentNgFactory;

var modal_component_ngfactory = {};

var fileBrowser_component_ngfactory = {};

var fileBrowser_component_css_ngstyle = {};

Object.defineProperty(fileBrowser_component_css_ngstyle, "__esModule", {
  value: true
});
fileBrowser_component_css_ngstyle.styles = void 0;
var styles = [".tree{margin-top:20px}.tree ul{list-style:none;padding-left:5px}.tree ul li{padding-left:16px;position:relative;box-sizing:border-box}.tree ul li:before{height:1px;width:10px;top:10px;margin:auto}.tree ul li:after,.tree ul li:before{content:\"\";background-color:#333;position:absolute;left:0}.tree ul li:after{width:1px;height:100%;top:0;bottom:0}.tree ul li:last-child:after{height:10px}.tree ul .link{cursor:pointer}.tree ul .link:hover{border:none;color:#333;background-color:#e9e9e9;text-decoration:none}"];
fileBrowser_component_css_ngstyle.styles = styles;

var fileTree_component_ngfactory = {};

Object.defineProperty(fileTree_component_ngfactory, "__esModule", {
  value: true
});
fileTree_component_ngfactory.FileTreeComponentNgFactory = fileTree_component_ngfactory.View_FileTreeComponent_Host_0 = fileTree_component_ngfactory.View_FileTreeComponent_0 = fileTree_component_ngfactory.RenderType_FileTreeComponent = void 0;
const i0$3 = require$$0$1;
const i1$3 = require$$14;
const i2$3 = fileTree_component.exports;
var styles_FileTreeComponent = [];
var RenderType_FileTreeComponent = i0$3.ɵcrt({
  encapsulation: 2,
  styles: styles_FileTreeComponent,
  data: {
    "animation": [{
      type: 7,
      name: "sectionExpand",
      definitions: [{
        type: 1,
        expr: ":enter",
        animation: [{
          type: 6,
          styles: {
            "height": "0",
            "paddingBottom": "0",
            "paddingTop": "0",
            "opacity": "0",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "*",
              "paddingBottom": "*",
              "paddingTop": "*",
              "opacity": "1",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "200ms ease-in"
        }],
        options: null
      }, {
        type: 1,
        expr: ":leave",
        animation: [{
          type: 6,
          styles: {
            "height": "*",
            "paddingBottom": "*",
            "paddingTop": "*",
            "opacity": "1",
            "overflow": "hidden"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "height": "0",
              "paddingBottom": "0",
              "paddingTop": "0",
              "opacity": "0",
              "overflow": "hidden"
            },
            offset: null
          },
          timings: "200ms ease-out"
        }],
        options: null
      }],
      options: {}
    }]
  }
});
fileTree_component_ngfactory.RenderType_FileTreeComponent = RenderType_FileTreeComponent;

function View_FileTreeComponent_2(_l) {
  return i0$3.ɵvid(0, [(_l()(), i0$3.ɵeld(0, 0, null, null, 1, "span", [["class", "float-left m-1"]], null, null, null, null, null)), i0$3.ɵdid(1, 278528, null, 0, i1$3.NgClass, [i0$3.IterableDiffers, i0$3.KeyValueDiffers, i0$3.ElementRef, i0$3.Renderer2], {
    klass: [0, "klass"],
    ngClass: [1, "ngClass"]
  }, null)], function (_ck, _v) {
    var currVal_0 = "float-left m-1";
    var currVal_1 = _v.parent.context.$implicit.show ? "far fa-folder-open" : "far fa-folder";

    _ck(_v, 1, 0, currVal_0, currVal_1);
  }, null);
}

function View_FileTreeComponent_3(_l) {
  return i0$3.ɵvid(0, [(_l()(), i0$3.ɵeld(0, 0, null, null, 5, "div", [], [[24, "@sectionExpand", 0]], null, null, null, null)), (_l()(), i0$3.ɵted(-1, null, ["\n            "])), (_l()(), i0$3.ɵeld(2, 0, null, null, 2, "file-tree-cmp", [], null, [[null, "itemSelected"], [null, "itemSubmit"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("itemSelected" === en) {
      var pd_0 = _co.OnItemSelected($event) !== false;
      ad = pd_0 && ad;
    }

    if ("itemSubmit" === en) {
      var pd_1 = _co.OnItemSubmit($event) !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, View_FileTreeComponent_0, RenderType_FileTreeComponent)), i0$3.ɵdid(3, 49152, null, 0, i2$3.FileTreeComponent, [], {
    treeData: [0, "treeData"],
    allowedExtensions: [1, "allowedExtensions"]
  }, {
    itemSelected: "itemSelected",
    itemSubmit: "itemSubmit"
  }), (_l()(), i0$3.ɵted(-1, null, ["\n            "])), (_l()(), i0$3.ɵted(-1, null, ["\n        "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_1 = _v.parent.context.$implicit.children;
    var currVal_2 = _co.allowedExtensions;

    _ck(_v, 3, 0, currVal_1, currVal_2);
  }, function (_ck, _v) {
    var currVal_0 = _v.parent.context.$implicit.children && _v.parent.context.$implicit.show;

    _ck(_v, 0, 0, currVal_0);
  });
}

function View_FileTreeComponent_1(_l) {
  return i0$3.ɵvid(0, [(_l()(), i0$3.ɵeld(0, 0, null, null, 16, "li", [], null, null, null, null, null)), (_l()(), i0$3.ɵted(-1, null, ["\n        "])), (_l()(), i0$3.ɵeld(2, 0, null, null, 10, "div", [["class", "row col"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = (_v.context.$implicit.type === "directory" && (_v.context.$implicit.show = !_v.context.$implicit.show)) !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), i0$3.ɵdid(3, 278528, null, 0, i1$3.NgStyle, [i0$3.ElementRef, i0$3.KeyValueDiffers, i0$3.Renderer2], {
    ngStyle: [0, "ngStyle"]
  }, null), i0$3.ɵpod(4, {
    "font-weight": 0
  }), (_l()(), i0$3.ɵted(-1, null, ["\n            "])), (_l()(), i0$3.ɵand(16777216, null, null, 1, null, View_FileTreeComponent_2)), i0$3.ɵdid(7, 16384, null, 0, i1$3.NgIf, [i0$3.ViewContainerRef, i0$3.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$3.ɵted(-1, null, ["\n            "])), (_l()(), i0$3.ɵeld(9, 0, null, null, 2, "div", [], null, [[null, "click"], [null, "dblclick"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = (_v.context.$implicit.type === "file" && _co.IsExtensionAllowed(_v.context.$implicit.extension) && _co.OnItemSelected(_v.context.$implicit.relativePath)) !== false;
      ad = pd_0 && ad;
    }

    if ("dblclick" === en) {
      var pd_1 = (_v.context.$implicit.type === "file" && _co.IsExtensionAllowed(_v.context.$implicit.extension) && _co.OnItemSubmit(_v.context.$implicit.relativePath)) !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, null, null)), i0$3.ɵdid(10, 278528, null, 0, i1$3.NgClass, [i0$3.IterableDiffers, i0$3.KeyValueDiffers, i0$3.ElementRef, i0$3.Renderer2], {
    ngClass: [0, "ngClass"]
  }, null), (_l()(), i0$3.ɵted(11, null, ["", ""])), (_l()(), i0$3.ɵted(-1, null, ["\n        "])), (_l()(), i0$3.ɵted(-1, null, ["\n        "])), (_l()(), i0$3.ɵand(16777216, null, null, 1, null, View_FileTreeComponent_3)), i0$3.ɵdid(15, 16384, null, 0, i1$3.NgIf, [i0$3.ViewContainerRef, i0$3.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$3.ɵted(-1, null, ["\n    "]))], function (_ck, _v) {
    var _co = _v.component;

    var currVal_0 = _ck(_v, 4, 0, _v.context.$implicit.selected ? "bold" : "initial");

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = _v.context.$implicit.type === "directory";

    _ck(_v, 7, 0, currVal_1);

    var currVal_2 = _v.context.$implicit.type === "directory" || _co.IsExtensionAllowed(_v.context.$implicit.extension) ? "link" : "";

    _ck(_v, 10, 0, currVal_2);

    var currVal_4 = _v.context.$implicit.children && _v.context.$implicit.show;

    _ck(_v, 15, 0, currVal_4);
  }, function (_ck, _v) {
    var currVal_3 = _v.context.$implicit.name;

    _ck(_v, 11, 0, currVal_3);
  });
}

function View_FileTreeComponent_0(_l) {
  return i0$3.ɵvid(0, [(_l()(), i0$3.ɵeld(0, 0, null, null, 4, "ul", [], null, null, null, null, null)), (_l()(), i0$3.ɵted(-1, null, ["\n    "])), (_l()(), i0$3.ɵand(16777216, null, null, 1, null, View_FileTreeComponent_1)), i0$3.ɵdid(3, 278528, null, 0, i1$3.NgForOf, [i0$3.ViewContainerRef, i0$3.TemplateRef, i0$3.IterableDiffers], {
    ngForOf: [0, "ngForOf"]
  }, null), (_l()(), i0$3.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.treeData;

    _ck(_v, 3, 0, currVal_0);
  }, null);
}

fileTree_component_ngfactory.View_FileTreeComponent_0 = View_FileTreeComponent_0;

function View_FileTreeComponent_Host_0(_l) {
  return i0$3.ɵvid(0, [(_l()(), i0$3.ɵeld(0, 0, null, null, 1, "file-tree-cmp", [], null, null, null, View_FileTreeComponent_0, RenderType_FileTreeComponent)), i0$3.ɵdid(1, 49152, null, 0, i2$3.FileTreeComponent, [], null, null)], null, null);
}

fileTree_component_ngfactory.View_FileTreeComponent_Host_0 = View_FileTreeComponent_Host_0;
var FileTreeComponentNgFactory = i0$3.ɵccf("file-tree-cmp", i2$3.FileTreeComponent, View_FileTreeComponent_Host_0, {
  treeData: "treeData",
  allowedExtensions: "allowedExtensions"
}, {
  itemSelected: "itemSelected",
  itemSubmit: "itemSubmit"
}, []);
fileTree_component_ngfactory.FileTreeComponentNgFactory = FileTreeComponentNgFactory;

Object.defineProperty(fileBrowser_component_ngfactory, "__esModule", {
  value: true
});
fileBrowser_component_ngfactory.FileBrowserComponentNgFactory = fileBrowser_component_ngfactory.View_FileBrowserComponent_Host_0 = fileBrowser_component_ngfactory.View_FileBrowserComponent_0 = fileBrowser_component_ngfactory.RenderType_FileBrowserComponent = void 0;
const i0$2 = fileBrowser_component_css_ngstyle;
const i1$2 = require$$0$1;
const i2$2 = language_pipes;
const i3$2 = language_service;
const i4$1 = require$$14;
const i5$1 = fileTree_component_ngfactory;
const i6$1 = fileTree_component.exports;
const i7$1 = fileBrowser_component.exports;
const i8$1 = template_service;
const i9$1 = require$$25;
var styles_FileBrowserComponent = [i0$2.styles];
var RenderType_FileBrowserComponent = i1$2.ɵcrt({
  encapsulation: 2,
  styles: styles_FileBrowserComponent,
  data: {}
});
fileBrowser_component_ngfactory.RenderType_FileBrowserComponent = RenderType_FileBrowserComponent;

function View_FileBrowserComponent_1(_l) {
  return i1$2.ɵvid(0, [(_l()(), i1$2.ɵeld(0, 0, null, null, 4, "span", [["class", "badge badge-primary"]], null, null, null, null, null)), (_l()(), i1$2.ɵted(1, null, ["", ":\u00A0"])), i1$2.ɵppd(2, 2), (_l()(), i1$2.ɵeld(3, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), i1$2.ɵted(4, null, ["", ""]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i1$2.ɵunv(_v, 1, 0, _ck(_v, 2, 0, i1$2.ɵnov(_v.parent, 0), "SELECTED_ELEMENT", _co.translateCategory));

    _ck(_v, 1, 0, currVal_0);

    var currVal_1 = _co.selectedFilePath;

    _ck(_v, 4, 0, currVal_1);
  });
}

function View_FileBrowserComponent_0(_l) {
  return i1$2.ɵvid(0, [i1$2.ɵpid(0, i2$2.TranslateMessagePipe, [i3$2.LanguageService]), (_l()(), i1$2.ɵand(16777216, null, null, 1, null, View_FileBrowserComponent_1)), i1$2.ɵdid(2, 16384, null, 0, i4$1.NgIf, [i1$2.ViewContainerRef, i1$2.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i1$2.ɵted(-1, null, ["\n"])), (_l()(), i1$2.ɵeld(4, 0, null, null, 11, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), i1$2.ɵted(-1, null, ["\n    "])), (_l()(), i1$2.ɵeld(6, 0, null, null, 8, "div", [["class", "col mt-1"]], null, null, null, null, null)), (_l()(), i1$2.ɵted(-1, null, ["\n        "])), (_l()(), i1$2.ɵeld(8, 0, null, null, 5, "div", [["class", "tree"]], null, null, null, null, null)), (_l()(), i1$2.ɵted(-1, null, ["\n            "])), (_l()(), i1$2.ɵeld(10, 0, null, null, 2, "file-tree-cmp", [], null, [[null, "itemSelected"], [null, "itemSubmit"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("itemSelected" === en) {
      var pd_0 = _co.OnItemSelected($event) !== false;
      ad = pd_0 && ad;
    }

    if ("itemSubmit" === en) {
      var pd_1 = _co.OnItemSubmit($event) !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, i5$1.View_FileTreeComponent_0, i5$1.RenderType_FileTreeComponent)), i1$2.ɵdid(11, 49152, null, 0, i6$1.FileTreeComponent, [], {
    treeData: [0, "treeData"],
    allowedExtensions: [1, "allowedExtensions"]
  }, {
    itemSelected: "itemSelected",
    itemSubmit: "itemSubmit"
  }), (_l()(), i1$2.ɵted(-1, null, ["\n            "])), (_l()(), i1$2.ɵted(-1, null, ["\n        "])), (_l()(), i1$2.ɵted(-1, null, ["\n    "])), (_l()(), i1$2.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.selectedFilePath;

    _ck(_v, 2, 0, currVal_0);

    var currVal_1 = _co.folderTree;
    var currVal_2 = _co.allowedExtensions;

    _ck(_v, 11, 0, currVal_1, currVal_2);
  }, null);
}

fileBrowser_component_ngfactory.View_FileBrowserComponent_0 = View_FileBrowserComponent_0;

function View_FileBrowserComponent_Host_0(_l) {
  return i1$2.ɵvid(0, [(_l()(), i1$2.ɵeld(0, 0, null, null, 1, "file-browser-cmp", [], null, null, null, View_FileBrowserComponent_0, RenderType_FileBrowserComponent)), i1$2.ɵdid(1, 4243456, null, 0, i7$1.FileBrowserComponent, [i3$2.LanguageService, i8$1.TemplateService, i9$1.NotificationsService], null, null)], null, null);
}

fileBrowser_component_ngfactory.View_FileBrowserComponent_Host_0 = View_FileBrowserComponent_Host_0;
var FileBrowserComponentNgFactory = i1$2.ɵccf("file-browser-cmp", i7$1.FileBrowserComponent, View_FileBrowserComponent_Host_0, {
  folderName: "folderName",
  isTemporal: "isTemporal",
  selectedValue: "selectedValue",
  allowedExtensions: "allowedExtensions"
}, {
  itemSelected: "itemSelected",
  itemSubmit: "itemSubmit"
}, []);
fileBrowser_component_ngfactory.FileBrowserComponentNgFactory = FileBrowserComponentNgFactory;

Object.defineProperty(modal_component_ngfactory, "__esModule", {
  value: true
});
modal_component_ngfactory.ModalComponentNgFactory = modal_component_ngfactory.View_ModalComponent_Host_0 = modal_component_ngfactory.View_ModalComponent_0 = modal_component_ngfactory.RenderType_ModalComponent = void 0;
const i0$1 = require$$0$1;
const i1$1 = fileBrowser_component_ngfactory;
const i2$1 = fileBrowser_component.exports;
const i3$1 = language_service;
const i4 = template_service;
const i5 = require$$25;
const i6 = require$$45;
const i7 = require$$14;
const i8 = modal_component.exports;
const i9 = modal_service;
const i10 = require$$1;
var styles_ModalComponent = [];
var RenderType_ModalComponent = i0$1.ɵcrt({
  encapsulation: 2,
  styles: styles_ModalComponent,
  data: {
    "animation": [{
      type: 7,
      name: "modalAnimation",
      definitions: [{
        type: 1,
        expr: "hide => show",
        animation: [{
          type: 6,
          styles: {
            "top": "-100%",
            "opacity": "0"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "top": "0",
              "opacity": "1"
            },
            offset: null
          },
          timings: "300ms ease-in"
        }],
        options: null
      }, {
        type: 1,
        expr: "show => hide",
        animation: [{
          type: 6,
          styles: {
            "top": "0",
            "opacity": "1"
          },
          offset: null
        }, {
          type: 4,
          styles: {
            type: 6,
            styles: {
              "top": "100%",
              "opacity": "0"
            },
            offset: null
          },
          timings: "300ms ease-out"
        }],
        options: null
      }],
      options: {}
    }]
  }
});
modal_component_ngfactory.RenderType_ModalComponent = RenderType_ModalComponent;

function View_ModalComponent_1(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 1, "h4", [["class", "modal-title"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(1, null, ["", ""]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.formTitle;

    _ck(_v, 1, 0, currVal_0);
  });
}

function View_ModalComponent_2(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 3, "button", [["class", "close"], ["data-dismiss", "modal"], ["type", "button"]], [[1, "aria-label", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.cancel() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                    "])), (_l()(), i0$1.ɵeld(2, 0, null, null, 0, "span", [["aria-hidden", "true"], ["class", "far fa-times"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                "]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.cancelButtonLabel || "Close";

    _ck(_v, 0, 0, currVal_0);
  });
}

function View_ModalComponent_3(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 5, "div", [], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                    "])), (_l()(), i0$1.ɵeld(2, 0, null, null, 2, "file-browser-cmp", [], null, [[null, "itemSelected"], [null, "itemSubmit"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("itemSelected" === en) {
      var pd_0 = _co.OnItemSelected($event) !== false;
      ad = pd_0 && ad;
    }

    if ("itemSubmit" === en) {
      var pd_1 = _co.OnItemSubmit($event) !== false;
      ad = pd_1 && ad;
    }

    return ad;
  }, i1$1.View_FileBrowserComponent_0, i1$1.RenderType_FileBrowserComponent)), i0$1.ɵdid(3, 4243456, null, 0, i2$1.FileBrowserComponent, [i3$1.LanguageService, i4.TemplateService, i5.NotificationsService], {
    folderName: [0, "folderName"],
    isTemporal: [1, "isTemporal"],
    selectedValue: [2, "selectedValue"],
    allowedExtensions: [3, "allowedExtensions"]
  }, {
    itemSelected: "itemSelected",
    itemSubmit: "itemSubmit"
  }), (_l()(), i0$1.ɵted(-1, null, ["\n                    "])), (_l()(), i0$1.ɵted(-1, null, ["\n                "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.folderName;
    var currVal_1 = _co.isTemporal;
    var currVal_2 = _co.selectedValue;
    var currVal_3 = _co.allowedExtensions;

    _ck(_v, 3, 0, currVal_0, currVal_1, currVal_2, currVal_3);
  }, null);
}

function View_ModalComponent_4(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 1, "div", [["class", "text-break"], ["style", "overflow-wrap: break-word;"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(1, null, ["", ""]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.formBody;

    _ck(_v, 1, 0, currVal_0);
  });
}

function View_ModalComponent_5(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 0, "div", [], [[8, "innerHTML", 1]], null, null, null, null))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.htmlBody;

    _ck(_v, 0, 0, currVal_0);
  });
}

function View_ModalComponent_6(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 14, "div", [["class", "row mt-3"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                    "])), (_l()(), i0$1.ɵeld(2, 0, null, null, 11, "div", [["class", "col-9"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                        "])), (_l()(), i0$1.ɵeld(4, 0, null, null, 8, "div", [["class", "form-group"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                            "])), (_l()(), i0$1.ɵeld(6, 0, null, null, 5, "input", [["class", "form-control form-control-sm"], ["id", "modal_input"], ["type", "text"]], [[8, "placeholder", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("input" === en) {
      var pd_0 = i0$1.ɵnov(_v, 7)._handleInput($event.target.value) !== false;
      ad = pd_0 && ad;
    }

    if ("blur" === en) {
      var pd_1 = i0$1.ɵnov(_v, 7).onTouched() !== false;
      ad = pd_1 && ad;
    }

    if ("compositionstart" === en) {
      var pd_2 = i0$1.ɵnov(_v, 7)._compositionStart() !== false;
      ad = pd_2 && ad;
    }

    if ("compositionend" === en) {
      var pd_3 = i0$1.ɵnov(_v, 7)._compositionEnd($event.target.value) !== false;
      ad = pd_3 && ad;
    }

    if ("ngModelChange" === en) {
      var pd_4 = (_co.inputValue = $event) !== false;
      ad = pd_4 && ad;
    }

    return ad;
  }, null, null)), i0$1.ɵdid(7, 16384, null, 0, i6.DefaultValueAccessor, [i0$1.Renderer2, i0$1.ElementRef, [2, i6.COMPOSITION_BUFFER_MODE]], null, null), i0$1.ɵprd(1024, null, i6.NG_VALUE_ACCESSOR, function (p0_0) {
    return [p0_0];
  }, [i6.DefaultValueAccessor]), i0$1.ɵdid(9, 671744, null, 0, i6.NgModel, [[8, null], [8, null], [8, null], [6, i6.NG_VALUE_ACCESSOR]], {
    model: [0, "model"]
  }, {
    update: "ngModelChange"
  }), i0$1.ɵprd(2048, null, i6.NgControl, null, [i6.NgModel]), i0$1.ɵdid(11, 16384, null, 0, i6.NgControlStatus, [[4, i6.NgControl]], null, null), (_l()(), i0$1.ɵted(-1, null, ["\n                        "])), (_l()(), i0$1.ɵted(-1, null, ["\n                    "])), (_l()(), i0$1.ɵted(-1, null, ["\n                "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_8 = _co.inputValue;

    _ck(_v, 9, 0, currVal_8);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.inputPlaceholder;
    var currVal_1 = i0$1.ɵnov(_v, 11).is("untouched");
    var currVal_2 = i0$1.ɵnov(_v, 11).is("touched");
    var currVal_3 = i0$1.ɵnov(_v, 11).is("pristine");
    var currVal_4 = i0$1.ɵnov(_v, 11).is("dirty");
    var currVal_5 = i0$1.ɵnov(_v, 11).is("valid");
    var currVal_6 = i0$1.ɵnov(_v, 11).is("invalid");
    var currVal_7 = i0$1.ɵnov(_v, 11).is("pending");

    _ck(_v, 6, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7);
  });
}

function View_ModalComponent_8(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 1, "button", [["class", "btn btn-secondary btn-medium"], ["data-dismiss", "modal"], ["type", "button"]], null, [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.cancel() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$1.ɵted(1, null, ["", ""]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.cancelButtonLabel;

    _ck(_v, 1, 0, currVal_0);
  });
}

function View_ModalComponent_9(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 1, "button", [["type", "button"]], [[8, "className", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("click" === en) {
      var pd_0 = _co.submit() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$1.ɵted(1, null, ["", ""]))], null, function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = i0$1.ɵinlineInterpolate(1, "btn ", _co.submitButtonClass, "");

    _ck(_v, 0, 0, currVal_0);

    var currVal_1 = _co.submitButtonLabel;

    _ck(_v, 1, 0, currVal_1);
  });
}

function View_ModalComponent_7(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 7, "div", [["class", "modal-footer space-horizontal"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_8)), i0$1.ɵdid(3, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_9)), i0$1.ɵdid(6, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n            "]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = _co.cancelButtonLabel;

    _ck(_v, 3, 0, currVal_0);

    var currVal_1 = _co.submitButtonLabel;

    _ck(_v, 6, 0, currVal_1);
  }, null);
}

function View_ModalComponent_0(_l) {
  return i0$1.ɵvid(0, [i0$1.ɵqud(671088640, 1, {
    modalContentElement: 0
  }), i0$1.ɵqud(402653184, 2, {
    modalBodyViewContainer: 0
  }), (_l()(), i0$1.ɵted(-1, null, ["\n"])), (_l()(), i0$1.ɵeld(3, 0, null, null, 41, "div", [["class", "modal"], ["role", "dialog"], ["style", "z-index: 1051"], ["tabindex", "-1"]], null, [[null, "keydown.esc"], [null, "keydown.enter"], [null, "keydown.space"], [null, "click"]], function (_v, en, $event) {
    var ad = true;
    var _co = _v.component;

    if ("keydown.esc" === en) {
      var pd_0 = (_co.closeOnEscape ? _co.cancel() : 0) !== false;
      ad = pd_0 && ad;
    }

    if ("keydown.enter" === en) {
      var pd_1 = _co.submit() !== false;
      ad = pd_1 && ad;
    }

    if ("keydown.space" === en) {
      var pd_2 = (_co.closeOnSpace ? _co.submit() : 0) !== false;
      ad = pd_2 && ad;
    }

    if ("click" === en) {
      var pd_3 = (_co.closeOnOutsideClick ? _co.cancel() : 0) !== false;
      ad = pd_3 && ad;
    }

    return ad;
  }, null, null)), i0$1.ɵdid(4, 278528, null, 0, i7.NgClass, [i0$1.IterableDiffers, i0$1.KeyValueDiffers, i0$1.ElementRef, i0$1.Renderer2], {
    klass: [0, "klass"],
    ngClass: [1, "ngClass"]
  }, null), i0$1.ɵpod(5, {
    show: 0
  }), i0$1.ɵdid(6, 278528, null, 0, i7.NgStyle, [i0$1.ElementRef, i0$1.KeyValueDiffers, i0$1.Renderer2], {
    ngStyle: [0, "ngStyle"]
  }, null), i0$1.ɵpod(7, {
    display: 0,
    opacity: 1
  }), (_l()(), i0$1.ɵted(-1, null, ["\n    "])), (_l()(), i0$1.ɵted(-1, null, ["\n    "])), (_l()(), i0$1.ɵeld(10, 0, null, null, 33, "div", [["role", "document"]], [[8, "className", 0], [24, "@modalAnimation", 0]], [[null, "click"]], function (_v, en, $event) {
    var ad = true;

    if ("click" === en) {
      var pd_0 = $event.stopPropagation() !== false;
      ad = pd_0 && ad;
    }

    return ad;
  }, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n        "])), (_l()(), i0$1.ɵeld(12, 0, [[1, 0], ["modalContent", 1]], null, 30, "div", [["class", "modal-content"], ["tabindex", "0"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n            "])), (_l()(), i0$1.ɵeld(14, 0, null, null, 7, "div", [["class", "modal-header"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_1)), i0$1.ɵdid(17, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_2)), i0$1.ɵdid(20, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n            "])), (_l()(), i0$1.ɵted(-1, null, ["\n            "])), (_l()(), i0$1.ɵeld(23, 0, null, null, 15, "div", [["class", "modal-body"]], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_3)), i0$1.ɵdid(26, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_4)), i0$1.ɵdid(29, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_5)), i0$1.ɵdid(32, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_6)), i0$1.ɵdid(35, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n                "])), (_l()(), i0$1.ɵeld(37, 16777216, [[2, 3], ["modalBodyContainer", 1]], null, 0, "div", [], null, null, null, null, null)), (_l()(), i0$1.ɵted(-1, null, ["\n            "])), (_l()(), i0$1.ɵted(-1, null, ["\n            "])), (_l()(), i0$1.ɵand(16777216, null, null, 1, null, View_ModalComponent_7)), i0$1.ɵdid(41, 16384, null, 0, i7.NgIf, [i0$1.ViewContainerRef, i0$1.TemplateRef], {
    ngIf: [0, "ngIf"]
  }, null), (_l()(), i0$1.ɵted(-1, null, ["\n        "])), (_l()(), i0$1.ɵted(-1, null, ["\n    "])), (_l()(), i0$1.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = "modal";

    var currVal_1 = _ck(_v, 5, 0, _co.isOpened);

    _ck(_v, 4, 0, currVal_0, currVal_1);

    var currVal_2 = _ck(_v, 7, 0, _co.isOpened ? "block" : "none", _co.isOpened ? 1 : 0);

    _ck(_v, 6, 0, currVal_2);

    var currVal_5 = _co.formTitle;

    _ck(_v, 17, 0, currVal_5);

    var currVal_6 = _co.showCloseButton;

    _ck(_v, 20, 0, currVal_6);

    var currVal_7 = _co.showFileBrowser;

    _ck(_v, 26, 0, currVal_7);

    var currVal_8 = _co.formBody && !_co.isHtml;

    _ck(_v, 29, 0, currVal_8);

    var currVal_9 = _co.htmlBody && _co.isHtml;

    _ck(_v, 32, 0, currVal_9);

    var currVal_10 = _co.showInput;

    _ck(_v, 35, 0, currVal_10);

    var currVal_11 = _co.showFooter;

    _ck(_v, 41, 0, currVal_11);
  }, function (_ck, _v) {
    var _co = _v.component;
    var currVal_3 = "modal-dialog " + _co.modalClass;
    var currVal_4 = _co.isOpenedAnimation;

    _ck(_v, 10, 0, currVal_3, currVal_4);
  });
}

modal_component_ngfactory.View_ModalComponent_0 = View_ModalComponent_0;

function View_ModalComponent_Host_0(_l) {
  return i0$1.ɵvid(0, [(_l()(), i0$1.ɵeld(0, 0, null, null, 1, "modal-cmp", [], null, null, null, View_ModalComponent_0, RenderType_ModalComponent)), i0$1.ɵdid(1, 114688, null, 0, i8.ModalComponent, [i9.ModalService, i10.DomSanitizer, i5.NotificationsService], null, null)], function (_ck, _v) {
    _ck(_v, 1, 0);
  }, null);
}

modal_component_ngfactory.View_ModalComponent_Host_0 = View_ModalComponent_Host_0;
var ModalComponentNgFactory = i0$1.ɵccf("modal-cmp", i8.ModalComponent, View_ModalComponent_Host_0, {}, {
  onLoaded: "onLoaded"
}, []);
modal_component_ngfactory.ModalComponentNgFactory = ModalComponentNgFactory;

var loading_component_ngfactory = {};

Object.defineProperty(loading_component_ngfactory, "__esModule", {
  value: true
});
loading_component_ngfactory.LoadingComponentNgFactory = loading_component_ngfactory.View_LoadingComponent_Host_0 = loading_component_ngfactory.View_LoadingComponent_0 = loading_component_ngfactory.RenderType_LoadingComponent = void 0;
const i0 = require$$0$1;
const i1 = require$$14;
const i2 = loading_component.exports;
const i3 = loading_service;
var styles_LoadingComponent = [];
var RenderType_LoadingComponent = i0.ɵcrt({
  encapsulation: 2,
  styles: styles_LoadingComponent,
  data: {}
});
loading_component_ngfactory.RenderType_LoadingComponent = RenderType_LoadingComponent;

function View_LoadingComponent_0(_l) {
  return i0.ɵvid(0, [(_l()(), i0.ɵeld(0, 0, null, null, 0, "div", [["class", "modal-overlay"]], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n"])), (_l()(), i0.ɵeld(2, 0, null, null, 48, "div", [["class", "modal"], ["tabindex", "-1"]], null, null, null, null, null)), i0.ɵdid(3, 278528, null, 0, i1.NgClass, [i0.IterableDiffers, i0.KeyValueDiffers, i0.ElementRef, i0.Renderer2], {
    klass: [0, "klass"],
    ngClass: [1, "ngClass"]
  }, null), i0.ɵpod(4, {
    show: 0,
    fade: 1
  }), i0.ɵdid(5, 278528, null, 0, i1.NgStyle, [i0.ElementRef, i0.KeyValueDiffers, i0.Renderer2], {
    ngStyle: [0, "ngStyle"]
  }, null), i0.ɵpod(6, {
    display: 0
  }), (_l()(), i0.ɵted(-1, null, ["\n    "])), (_l()(), i0.ɵeld(8, 0, null, null, 41, "div", [["class", "spin-loader-css white"], ["style", "-webkit-transform:scale(0.75)"]], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(10, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(12, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(15, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(17, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(20, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(22, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(25, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(27, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(30, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(32, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(35, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(37, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(40, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(42, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵeld(45, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n            "])), (_l()(), i0.ɵeld(47, 0, null, null, 0, "div", [], null, null, null, null, null)), (_l()(), i0.ɵted(-1, null, ["\n        "])), (_l()(), i0.ɵted(-1, null, ["\n    "])), (_l()(), i0.ɵted(-1, null, ["\n"]))], function (_ck, _v) {
    var _co = _v.component;
    var currVal_0 = "modal";

    var currVal_1 = _ck(_v, 4, 0, _co.opened, _co.opened);

    _ck(_v, 3, 0, currVal_0, currVal_1);

    var currVal_2 = _ck(_v, 6, 0, _co.opened ? "block" : "none");

    _ck(_v, 5, 0, currVal_2);
  }, null);
}

loading_component_ngfactory.View_LoadingComponent_0 = View_LoadingComponent_0;

function View_LoadingComponent_Host_0(_l) {
  return i0.ɵvid(0, [(_l()(), i0.ɵeld(0, 0, null, null, 1, "loading-cmp", [], null, null, null, View_LoadingComponent_0, RenderType_LoadingComponent)), i0.ɵdid(1, 114688, null, 0, i2.LoadingComponent, [i3.LoadingService], null, null)], function (_ck, _v) {
    _ck(_v, 1, 0);
  }, null);
}

loading_component_ngfactory.View_LoadingComponent_Host_0 = View_LoadingComponent_Host_0;
var LoadingComponentNgFactory = i0.ɵccf("loading-cmp", i2.LoadingComponent, View_LoadingComponent_Host_0, {}, {
  onLoaded: "onLoaded"
}, []);
loading_component_ngfactory.LoadingComponentNgFactory = LoadingComponentNgFactory;

export { genericQuery_component as $, genericQuery_model as A, genericQuery_service as B, nlu_service as C, entity_service as D, localStorageHelper as E, stringsHelper as F, group_service as G, subgroup_service as H, customField_service as I, evaluationPlan_service as J, adItem_model as K, evaluationFormat_model as L, group_model as M, subgroup_model as N, genericQueryHelper as O, checklistCombo_component as P, contenteditable_directive as Q, dropdownCombo_component as R, fileBrowser_component as S, fileTree_component as T, jwt_interceptor as U, loading_component as V, modal_component as W, pagination_component as X, searchCombo_component as Y, toggleSwitch_component as Z, cancelForm_component as _, loading_service as a, genericQuerySelect_component as a0, ad_directive as a1, modalGeneric_component as a2, search_component as a3, skin_service as a4, platform_service as a5, user_service as a6, object_pipes as a7, datetime_pipes as a8, language_pipes as a9, datetime_service as aa, searchCombo_component_ngfactory as ab, dropdownCombo_component_ngfactory as ac, modal_component_ngfactory as ad, loading_component_ngfactory as ae, login_component_ngfactory as af, layoutForm_component_ngfactory as ag, search_component_ngfactory as ah, language_service as b, authentication_service as c, comboData_model as d, evaluationFormat_service as e, authGuard_service as f, layoutForm_component as g, login_component as h, modalGeneric_service as i, collapse_animation as j, guid_module as k, layout_service as l, modal_service as m, navigateGuard_service as n, arraysHelper as o, keysHelper as p, intent_service as q, router_animation as r, score_model as s, tipification_model as t, tipification_service as u, shared_validator as v, ability_model as w, ability_validator as x, ability_service as y, genericQuery_validator as z };
